extends KinematicBody


var force_sync = true
onready var gsvar = get_node("/root/gamestate")
onready var net = get_node("/root/net")
onready var me = gsvar.me
onready var pfb_rico = load("res://prefabs/ricochet.tscn");
onready var global = get_node("/root/global")
onready var g = get_node("/root/global")
#onready var ball_area = get_node("/root/world/env/Ball2")
var last_collider;
var last_collision_time = 0;
var owner = -1
var last_owner = -1
var last_lv = Vector3()
var pending_motion = null
var is_new_throw = false
var input_throw_pressed = []
var throw_press_start = -1
var throw_ui
var throw_indicator
var throw_deviation_ui
var throw_duration = 0
var throw_deviation = 0
var s_data = []
var last_sync = [0, Vector3()]
var velocity = Vector3()
var last_path = []
var dead_ball = false
var resting = false
var queue_resting = false
var resting_reason = null
var wait_ack = -1
var local_catch = false
var event_times = {"last_own_throw":0, "last_catch":0, "prev_throw":0, "last_bang_basket":0, "last_pre_bang_basket":0, "last_bang_pass":0}
var scorers = {}
var in_2pt = false
var charge_sound = 0
var forbidden_players = []
onready var rad_circle_mat = get_node('Circle').get_material_override()
#onready var ball_mat = get_node('body').get_mesh().surface_get_material(0)
onready var camera = get_node("Camera")
onready var bounds_area = get_node("/root/world/env/BoundsArea")
#var pending_impulse = null
var indicator_hide_timer
var ball_area

var ball_vel_per_iter = 1/100.0;
var ball_gravity = Vector3(0,-9.8,0);
#var ball_h_slowdown = 1/6.0
var ball_h_slowdown = 0.09 # 0.15
var ball_realisitc = true

var paused = false
var red_score = 0
var green_score = 0
var ball_reset_pending = false

var out_of_bounds_pending = false
var out_of_bounds_pos = Vector3()
var ball_hit_floor_out = false
var spindir = 1
var cancel_pending = false
var simulation = false
var leader_ball
var real_ball
var motion_start = -1
var motion_path = []
var remote_motion_path = []
var next_motion
var prev_throw
var last_motion
# var last_pos = Vector3()
var ignore_next_col = false
var ball_net_rel_pos = Vector3()
#var is_current = false
var st
var net_shader_ignore = false
var throw_low=false
var throw_high=false
var pass_far=false
var pass_near=false
var just_caught = false
var comblag = 1050
var queue_throw
var temp_ignore_server_motion = false
var temp_ignore_server_motion_start = -1
# var skip
var motion_cast_res
var mute_next_catch=false
var wahoo = false
var motion_path_cursor = -1
var fixed_func_queue = []
var in_fixed = false
var motion_reason = "unknown"
var mini_catch = false
var ball_ripple_scene = load("res://prefabs/ball_ripple.tscn");
var is_dribbling = false
var last_catch = [Vector3(), 0]
var power_max = 130.0
var dribbling = false
var rolling = false
var just_scored = false
onready var sounds = get_node("sounds")
export (Color) var color1 = Color()
export (Color) var color2 = Color()



func _ready():
  st = g.store_get("score_table", {"scorers":{},"red_score":0,"green_score":0})
  if get_name().begins_with("leader_ball"):
    simulation = true
    real_ball = get_node("/root/world/env/Ball" + get_name().split("leader_ball")[1])
    real_ball.leader_ball = self

#    get_parent().leader_ball = self
  set_collision_margin(0.001) # 0.001
  # set_collision_margin(0.1)
  net.path_ht[String(get_path()).hash()] = get_path()
  g.report("ball ready", [], 0 ,0)
  adjust_ball_params()
  set_fixed_process(!paused);
  if simulation:
    return
  g.store_get("balls", []).append(self)
  g.store_set("recent_ball", self)
  set_process(!paused);
  set_process_input(!paused);
#  gsvar.connect("own_player_ready", self, "player_ready")
#  var throw_meter = load("res://scenes/ThrowMeter.tscn")
#  throw_ui = throw_meter.instance()
  throw_ui = get_node("/root/world/gui/ThrowMeter")
#  get_node("/root/world/gui").add_child(throw_ui)
  throw_indicator = throw_ui.get_node("indicator")
  throw_deviation_ui = throw_ui.get_node("deviation")
  #throw_indicator.hide()
  throw_ui.hide()
  indicator_hide_timer = Timer.new()
  indicator_hide_timer.set_wait_time(1)
  indicator_hide_timer.set_one_shot(true)
  indicator_hide_timer.connect("timeout",self,"hide_indicator")
  add_child(indicator_hide_timer)
  ball_area = get_node("Ball2")
  ball_area.connect("area_enter",self, "ball_area_enter")
  var bounds = get_node("/root/world/env/BoundsArea")
  bounds.connect("area_exit", self, "exit_bounds_area")
  bounds.connect("area_enter", self, "enter_bounds_area")
  gsvar.connect("own_player_ready",self, "set_me")
  if not net.is_primary:
    net.rpc_id(net.primary_server, self,"ball_state_update", [true])
    request_scores()
  g.object_timer("update_path", self, "update_path", false, 0.1)
#    net.connect("client_connected", self, "sync_ball")


func _process(delta):
  if paused:
    return
  if owner == net.uid and not mini_catch and gsvar.player_by_id(owner).phys.resting:
    if (get_translation() - last_catch[0]).length() > 60:
      # owner = -1
      get_node("/root/world/env/carry_radius").hide()
      mini_catch = true
      ball_follow(owner)
  if gsvar.active_game_mode == "basketball":
    update_net_shader(get_node("/root/world/env/hoopsouth"))
    update_net_shader(get_node("/root/world/env/hoopnorth"))
  var td = g.time_elapsed(self, "last_pre_bang_basket")
  # gsvar.announce("basket td:" + str(td), 2)
  var sc
  if td < 30:
    sc = 1.4
    throw_ui.set_scale(Vector2(sc,sc))
  else:
    var sc_a = max(0,1 - abs(g.sg("bang_diff", 0))/500 )
    var sc_cur = throw_ui.get_scale().x
    if sc_cur > 1:
      sc = lerp(sc_cur, sc_a, delta*5)
    else:
      sc = sc_a
    throw_ui.set_scale(Vector2(sc,sc))

  if last_path.size() > 3:
    var avg_spd = (last_path[-1] - last_path[-4]).length()
    g.scrn_dbg("avg_speed", [avg_spd/4])
  if net.is_primary and out_of_bounds_pending and !simulation:
    var is_out
    if gsvar.active_game_mode == "basketball":
      is_out = rolling or ball_hit_floor_out or (owner != -1 and gsvar.player_by_id(owner).phys.resting)
    else:
      is_out = true
    if is_out and not just_scored:
      g.report("out of bounds reset ball", [get_name()], 0 , -1, {"only":false})
      announce_out_of_bounds()
      # ball_follow(gsvar.me.pid,1000)
      var pos = get_translation()
      pos.x = sign(pos.x) * min(abs(pos.x), 200)
      pos.z = sign(pos.z) * min(abs(pos.z), 375)
      pos.y = 0
      ball_reset(g.xnz(out_of_bounds_pos*0.95))
      if gsvar.game_running:
        forbidden_players = [last_owner]
        g.countdown(5,g,null,{"args":["you can catch the ball"]})
        g.object_timer("expire_forbidden", self, "set", true, 5,  ["forbidden_players", []])
      else:
        g.eval_context().ball_follow_pass(last_owner, 300)
        # ball_follow(last_owner, 400)
#      ball_reset_pending = true
      out_of_bounds_pending = false
    # if is_out:
    #   just_scored = false

#  if owner != -1 and owner != net.uid:
  if owner != -1:
    if g.is_null(gsvar.player_by_id(owner)):
      uncatch()
      return
    var ownedball = gsvar.player_by_id(owner).get_node("body/ownball")
    # var finalobpos = Vector3(0,16.59,-8.73)
    # var finalobpos = Vector3(0,10.59,-3.73)
    var finalobpos = g.store_get("obpos", Vector3(0,10.59,-3.73))
    ownedball.set_translation(ownedball.get_translation().linear_interpolate( finalobpos, 20*delta) )
    if not mini_catch:
      ownedball.show()
  if wait_ack > -1 and g.t() > wait_ack:
    local_catch = false
    ball_state_update()
    wait_ack = -1
  if throw_press_start > -1:
    throw_duration = OS.get_ticks_msec() - throw_press_start
    throw_deviation = calc_deviation(throw_duration)
    var power = dur_to_power(throw_duration)
    var fac = 1 - abs(throw_deviation)/2.0
    var modcol
    # var power_max = 100.0
    if throw_duration < g.store_get("releasepassduration" ,110) and not Input.is_action_pressed("jump"):
      modcol = Color("#e4ff8f00")
    elif power > power_max:
      modcol = Color("#dc7e00c5")
    else:
      modcol = Color("#6b00ff09").linear_interpolate( Color("#6bff0000"), power/power_max )
    throw_deviation_ui.set_scale(Vector2(fac,fac))

    throw_deviation_ui.get_node("deviation2").set_modulate(modcol)
    throw_indicator.set_value(1 * round(power/1))
    if !simulation and throw_press_start > -1 and owner == net.uid:
      g.eval_context().throw_vis(power)
    if power > power_max + 10:
      pass_ball(true)
      indicator_hide_timer.start()
      throw_press_start = -1

func cur_power():
  return dur_to_power(throw_duration)



# called inside leader_ball
func append_motion(motion, src=0):
  if motion_path.empty() and motion[0] > 10000:
    return
  if net.is_primary and src==0:
    net.rpc(self, "append_motion", [motion], {'reliable':true})
  # else:
  #   append_motion(m)
  if queue_fixed_func("append_motion", [motion, src]):
    return
  # gsvar.announce(["new mo", src], 1)
  # if g.xz(motion[2]).length() < 1 and ((abs(motion[2].y) + motion[1].y < 1)):
  #   gsvar.announce(["thatgoo"],1)
  #   return
  if real_ball.is_new_throw:
    breakpoint
    gsvar.announce("whyyyy",1)
    # motion_path=[]
    # return
  var localonly = net.is_primary or ((real_ball.temp_ignore_server_motion or real_ball.last_owner == gsvar.me.pid) and not real_ball.wahoo)
  if src == 0 and localonly: # local motion
    # gsvar.announce("weeeet", 1)
    motion_path.append(motion)
  if src==1:
    remote_motion_path.append(motion)
    var idx = remote_motion_path.size() - 1
    var welp = false
    if localonly:
      if not motion_path.size() > idx:
        print(["missing idx", idx, motion_path])
        # welp = true
      else:
        var lmotion = motion_path[idx]
        if (lmotion[1] - motion[1]).length() > 20:
          # check it's a garbage first motion issue
          if idx == 0:
            remote_motion_path = []
            # gsvar.announce("remove garbage motion0", 1, "2")
            return
          elif idx == 1:
            if (motion_path[0][1] - motion[1]).length() < 5:
              # gsvar.announce("remove garbage motion1", 1, "2")
              remote_motion_path.pop_front()
              return
          gsvar.announce(["wide gap", idx], 1, "2")
          print(["wide gap"])
          welp = true
    if welp:
      gsvar.announce("wwelp", 1, "2")
      resync_motion()
    if not localonly:
      print(["moootch", real_ball.wahoo])
      motion_path.append(motion)

func resync_motion():
  if not simulation:
    leader_ball.resync_motion()
    return
  if queue_fixed_func("resync_motion"):
    return
  # var transform = get_transform()
  # transform.orign = remote_motion_path[-1][1]
  # set_transform(transform)
  # velocity = remote_motion_path[-1][2]
  # pending_motion = [remote_motion_path[-1][1], remote_motion_path[-1][2]]
  # real_ball.ball_reset(get_translation() - Vector3(0,7,0), true)
  real_ball.wahoo = true
  velocity=Vector3()
  real_ball.velocity = Vector3()
  motion_path = []
  # real_ball.resting=false
  # var motion = [remote_motion_path[-1][1], remote_motion_path[-1][2]]
  print(["lalala", remote_motion_path[-1], g.t()])
  # g.callv_later(real_ball, "start_throw", motion, 0.035, false, "resync_motion")
  # return
  real_ball.set_pending_motion([remote_motion_path[-1][1], remote_motion_path[-1][2]], "resync")
  # set_pending_motion([remote_motion_path[-1][1], remote_motion_path[-1][2]], "resync")
  # motion_path = [] + remote_motion_path
  motion_path = []
  motion_path_cursor = remote_motion_path.size() - 1
  return
  real_ball.wahoo = true
  motion_path = [] + remote_motion_path

func set_pending_motion(motion, reason="unknown"):

  pending_motion = motion
  motion_reason = reason

func queue_fixed_func(fn, args=[]):
  if in_fixed:
    # gsvar.announce("ucc as", 1)
    return false
  if not fixed_func_queue.has([fn, args]):
    # gsvar.announce("thats right", 1)
    fixed_func_queue.append([fn, args])
  return true
  # return false

  # if src==1:
  #   # return
  #   if real_ball.temp_ignore_server_motion:
  #     if real_ball.temp_ignore_server_motion_start > -1:
  #       if g.t() - real_ball.temp_ignore_server_motion_start > ((2 *net.server_simulation_delay)):
  #         gsvar.announce("hoho", 1, "2")
  #         real_ball.temp_ignore_server_motion_start = -1
  #         real_ball.temp_ignore_server_motion = false
  #       else:
  #         # gsvar.announce("ignore motion", 0.5)
  #         return
  #   if g.xz(motion[2]).length() < 2:
  #     return
  #   # gsvar.announce("append motion from out there", 1)
  #   motion[0] = motion[0]
  #   if (real_ball.last_owner != gsvar.me.pid) or not temp_ignore_server_motion:
  #     motion_path.append(motion)
  #   remote_motion_path.append(motion)

  #   # gsvar.announce(["append motion", g.xz(motion[2]).length()],1)
  # elif net.is_primary or (temp_ignore_server_motion and ((real_ball.last_owner == gsvar.me.pid) or remote_motion_path.empty())):
  #   # gsvar.announce("append motion from over here", 1)
  #   motion_path.append(motion)
  # else:
  #   print("weirdness")
  # if src==0:
  #   gsvar.announce(["newm", motion[0],src], 2,{'group':'2'})
  # motion_path.append(motion)

#func throw(power=1.0, pos=Vector3(), src=0):
# Motion starts here!
# Function is called by both client and server
#
func throw(pos=Vector3(), throw=Vector3(), src=0):
  if  g.is_null(queue_throw): # also check this pos,throw pair is identical to queue
    queue_throw = [ pos, throw,src]
    return
  queue_throw = null
  if simulation:
    gsvar.announce("that even possible?!", 1)
  g.report("an throw", [pos, throw],0,0)
  if src == 0:
    g.time_since_up(self, "last_own_throw")
    g.eval_context().reset_mod_throw()
  if src == 0 and not net.is_primary:
    net.rpc_id(net.primary_server,self, "throw", [pos, throw], {"channel":4, 'reliable':true})
  # if net.is_primary and src == 0:
  #   src = 1
  if net.is_primary:
    if validate_throw(src) or true:
      if owner != -1:
        last_owner = owner
      var thrower = gsvar.player_by_id(last_owner)
      in_2pt = thrower.in_2pts_area
      net.rpc(self, "throw", [pos, throw], {"channel":4, 'reliable':true})
    else:
      g.chreport("force ball state update after fail throw", [], 0 , 0, {"only":false})
      ball_state_update(true,src)
      return
# start a new throw, either local prediction or official server instruction
  if true or net.is_primary or net.check_perms(self, ["primary"], src):
    g.time_since_up(self, "prev_throw")
    if owner != -1 or true:
      # if !simulation:
      if leader_ball.is_colliding():
        leader_ball.ignore_next_col = true
      uncatch()
      # if !simulation:
      if pos.y > 30 and throw.length() > 100 and last_owner == me.pid:
        me.shake_camera(0.1)
      start_new_throw(pos,throw,src)
  if src == net.primary_server:
    # gsvar.announce("server throw", 1)
    g.report("got throw call from server", [], 0 , 0, {"only":false})

# if src is server then we need to assume throw started earlier to compensate for lag

func start_new_throw(pos,throw,src=0):
  rolling = false
  leader_ball.rolling = false
  if src == 0:
    wahoo = false
    start_new_local_throw(pos,throw)
  elif src != 1:
    server_start_client_throw(pos, throw)
  elif src == 1:
    client_start_server_throw(pos,throw)

func start_new_local_throw(pos,throw):
  # gsvar.announce("immm", 1)
  temp_ignore_server_motion = true
  temp_ignore_server_motion_start = g.t()
  reset_motion()
  start_throw(pos,throw)

func server_start_client_throw(pos, throw):
  reset_motion()
  start_throw(pos,throw)

func reset_motion():
  leader_ball.motion_path = []
  leader_ball.remote_motion_path = []

func client_start_server_throw(pos,throw):
  if last_owner == me.pid and prev_throw == [pos,throw]:
    # gsvar.announce("ignore server", 1)
    temp_ignore_server_motion = false
    temp_ignore_server_motion_start = -1
    is_new_throw=false
    return
  elif last_owner != me.pid:
    reset_motion()
    start_throw(pos,throw)
  else:
    gsvar.announce("blip", 1, "2")
    start_throw(pos,throw)
    # resync_motion()

func start_throw(pos,throw):
  leader_ball.motion_start = g.t()
  motion_start = g.t()
  motion_path_cursor = 0
  # pending_motion = [pos, throw]
  set_pending_motion([pos,throw], "throw")
  prev_throw = [pos, throw]
  # leader_ball.pending_motion = [pos, throw]
  leader_ball.set_pending_motion([pos,throw], "throw(sim)")


#   # last_owner = owner

#   # is_new_throw=true
#   wahoo = false
#   if src == 0:
#     temp_ignore_server_motion = true
#     temp_ignore_server_motion_start = g.t()
#     leader_ball.remote_motion_path = []
#   # gsvar.announce(["throw src", src], 1, "2")
#   if src != 1:
#     is_new_throw=true
#     # gsvar.announce(["that works!! indeed", src],3, "2")
#     motion_path_cursor = 0
#     pending_motion = [pos, throw]

#     prev_throw = [pos, throw]
#     leader_ball.pending_motion = [pos, throw]
#     print("peding 1")
#     # leader_ball.ignore_next_col = true
#     # is_new_throw=true
#     g.report("new motion start", [g.t()], 0 , -1, {"only":false})
#   var skip=0
#   if src==1:
#     # skip=500
#     # var comblag = 1200#get_target_latency(1)
#     if last_owner == me.pid:
#       comblag = 1050
#       comblag =  net.server_simulation_delay * 2
#     else:
#       comblag = 0
#     var new_motion = g.eval_context().calc_ball_motion([pos, throw],false, comblag/1000.0)
#     # gsvar.announce(["new server motion",new_motion], 3)
#     print(["compare new throw to cur state",(new_motion[0]-get_translation()).length(), (new_motion[1]-velocity).length()] )
#     # if (new_motion[0]-get_translation()).length() < 5:
#     if last_owner == me.pid and prev_throw == [pos,throw]:
#       gsvar.announce("ignore server", 1)
#       temp_ignore_server_motion = false
#       temp_ignore_server_motion_start = -1
#       is_new_throw=false
#       return
#     else:
#       print([leader_ball.motion_path, leader_ball.remote_motion_path, new_motion, [pos,throw]])
#       # g.eval_context().p()

#     if new_motion[0].y < 0:
#       gsvar.announce("OMG",1)
#       return
#     motion_path_cursor = 0
#     move_to(new_motion[0])
#     velocity=new_motion[1]
#     update_motion([pos,throw], g.t()-comblag)
#     # last_motion = [pos, throw]
#     # last_motion.append(g.t()-comblag)
#     pending_motion = new_motion
#     leader_ball.pending_motion = new_motion
#     skip = comblag
#   leader_ball.motion_start = g.t()-skip
#   motion_start = g.t()-skip
# #        leader_ball.motion_path = [[0, pos, throw]]
#   leader_ball.motion_path = []
  # leader_ball.remote_motion_path = []


func update_motion(motion, t=g.t()):
  last_motion = motion
  last_motion.append(t)

func check_collision(delta):
  if real_ball.is_new_throw:
    return
  var lv = velocity;
  var transform = get_transform();
  var lvn = lv.normalized();
  if  is_colliding():
    # gsvar.announce(["collllll"], 0.1 ,"2")
    if g.sg("ignore_next_col_count", -1) > 3:
      # gsvar.announce("ahhh", 1,"2")
      ignore_next_col = false
    if ignore_next_col:
      # gsvar.announce("ignoore", 1)
      g.si("ignore_next_col_count")
      print(["deep col" , get_translation().y])
    else:
      var collider = get_collider()
      lv = handle_collision_kin(collider, 0)
      # if lv.length() > 5:
        # gsvar.announce(["after col lv", lv],5,"2")
        # print(["after col lv", lv])
      # if lv != velocity:
      #   velocity = lv
      #   update_motion([get_translation(), velocity])
      #   if motion_start > -1 and (net.is_primary or (real_ball.last_owner == gsvar.me.pid)):
      #     var m = [(g.t() - motion_start) * 2, get_translation(), lv]
      #     if g.xz(m[2]).length() > 1:
      #       if net.is_primary:
      #         net.rpc_sync(self, "append_motion", [m], {'reliable':true})
      #       else:
      #         append_motion(m)
      #     g.report("sim motion path update", [m], 0 , 0, {"only":false})
  else:
    g.ss("ignore_next_col_count", -1)
    ignore_next_col = false
    # check soccer goal
    if gsvar.active_game_mode == "football" and g.time_since(self,"last_net_col", 150):
      var goingin = velocity.dot(get_translation()) > 0
      goingin = goingin and abs(get_translation().x) < 100 and abs(get_translation().z) > 506
      if goingin:
        # gsvar.announce(["ball in", get_path()], 1, "2")
        lv = lvn * pow(lv.length(), 0.75)
        g.time_since_up(self, "last_net_col")
    if gsvar.active_game_mode == "basketball" and g.time_since(self,"last_net_col", 150):
      var hs3 = get_node("/root/world/env/hoopsouth/Torus3/StaticBody")
      var hn3 = get_node("/root/world/env/hoopnorth/Torus3/StaticBody")
      var hs4 = get_node("/root/world/env/hoopsouth/Torus6/StaticBody")
      var hn4 = get_node("/root/world/env/hoopnorth/Torus6/StaticBody")

      for h in [hs3, hn3]:
        if h.overlaps_body(self):
          g.time_since_up(self, "last_net_col")
          var d = (h.get_parent().get_parent().get_translation() -  get_translation())
          var deflect = d.normalized()
          if d.length() < 12:
            deflect.y = min(1, 2/g.xz(d).length())
            deflect = deflect.normalized() * (0.2 + 0.3)
            lv = velocity * deflect
          else:
            deflect.y = min(1, 2/g.xz(d).length())
            deflect.y = -0.5
            deflect = deflect.normalized() * (0.2 + 0.3)
            lv = velocity * (-deflect*2)
          # lv = d + Vector3(0,-5,0)
          lv = g.xnz(d)*4 + Vector3(0,velocity.y/3,0)
          # gsvar.announce(["brego", d.length()],1,"2")
          print(["brego", h.get_path(), h.get_parent().get_parent().get_translation() -  get_translation()])
  if lv != velocity:
    velocity = lv
    update_motion([get_translation(), velocity])
    if motion_start > -1 and (net.is_primary or (real_ball.last_owner == gsvar.me.pid)):
      var m = [(g.t() - motion_start) * 2, get_translation(), lv]
      if g.xz(m[2]).length() > 1 or ((abs(m[2].y) + m[1].y > 30)):
        append_motion(m)
        # print("dsfdf")

      # g.report("sim motion path update", [m], 0 , 0, {"only":false})

func _fixed_process_real(delta):
  if paused or g.is_null(leader_ball):
    return



func up_rad_circle_mat():
  g.scrn_dbg("ball velocity", velocity)
  var maxy = 50.0
  var newcol = color1.linear_interpolate(color2, min(get_translation().y, maxy) / maxy)
  g.report("ball circle color", [newcol], 1, 5000)
  rad_circle_mat.set_parameter(0, newcol.linear_interpolate(Color(), 0.3))

func rotate_ball():
  g.eval_context().rotate_ball()
  return
  var rmod
  if velocity.y == 0:
    rmod = 0.001 * pow(velocity.length(), 0.8)
  else:
    rmod = spindir * min(pow(velocity.length(), 0.7), 500) / (5 * 270)
  var axis = Vector3(0,1,0).cross(velocity).normalized().rotated(Vector3(0,0,1), PI)
  get_node("body").rotate(velocity.normalized(),PI*rmod)
  # get_node("body").rotate_y(PI*rmod)
  # get_node("body").rotate_z(PI*rmod)

func update_vis():
  up_rad_circle_mat()
  if not resting:
    rotate_ball()
  if camera.is_current():
    update_camera()

func _fixed_process(delta):
  if g.is_null(gsvar.me):
    return
  in_fixed = true
  update_vis()
  if net.is_primary and ball_reset_pending:
    g.report("req ball reset", [], 0 , -1, {"only":false})
    net.rpc_sync(self, "ball_reset", [])
    return
  if not g.is_null(queue_throw):
    callv("throw", queue_throw)
    return
  for fun in fixed_func_queue:
    callv(fun[0], fun[1])
  fixed_func_queue = []

  # use incoming rset s_data from server if any
  # if not net.is_primary :
  #   net_sync_kin()

  if simulation:
    check_collision(delta)
  else:
    # if ball_area.overlaps_area(g.eval_context().hs().get_node("Area")):
    #   print("there ya go")
    # _fixed_process_real(delta)
    check_cached_motion(delta)
  apply_pending_motion()
  fixed_ball_motion()
  in_fixed = false

func check_cached_motion(delta):
  if not g.is_null(pending_motion):
    return
  if  is_new_throw:
    call_deferred("set", "is_new_throw",false)
  # set up new motion
  elif owner == -1  and leader_ball.motion_start > -1 and  leader_ball.motion_path.size() > (motion_path_cursor):
    var time_passed = g.t() - leader_ball.motion_start + 100
    g.report("real ball col time passed", [time_passed], 0 , 1000, {"only":false})
    var motion = leader_ball.motion_path[motion_path_cursor]
    if motion[1].y < 8:
      g.create_mark({"pos":motion[1] - Vector3(0,1.2,0), "arrow":false, "label":"ball goes here"}, "ball_next_land", true)
      # found a new motion
    if motion[0]  < time_passed:
      # gsvar.announce(["oom", motion], 5, "2")
      g.report("found cached col!", [motion], 0 , -1, {"only":false})
      # pending_motion = [motion[1], motion[2]]
      # print((get_translation() - motion[1]).length())
      # if (get_translation() - motion[1]).length() > velocity.length()*delta*2:
      #   return
      if (get_translation() - motion[1]).length() > 0.5:
        # print(["ddddd", (get_translation() - motion[1]).length()])
        # print(["ddddd", velocity.length()*delta])
        set_pending_motion([motion[1], motion[2]], "cached coll")
      else:
        set_pending_motion([get_translation(), motion[2]], "cached coll")
      g.ss("lastsimpt", [g.t(), pending_motion[1]])
      motion = null
      play_col_sound(pending_motion, velocity)
      motion_path_cursor += 1
      g.scrn_dbg("motcurs", [motion_path_cursor, leader_ball.motion_path.size()])

func apply_pending_motion():
  var transform = get_transform()
  if not g.is_null(pending_motion):
    # gsvar.announce(["motion reason", motion_reason], 1, "2")
    # print(["motion reason", motion_reason, pending_motion[0]])
    if not simulation:
      spindir = g.randsign()
      # if pending_motion[0].y < (get_scale().y * 2.4 + 1) and out_of_bounds_pending:
      if  out_of_bounds_pending and (motion_path_cursor > 0):
        # gsvar.announce(["cursormp", motion_path_cursor],1)
        ball_hit_floor_out = true
        # gsvar.announce(["apply motion", pending_motion[0]],5,"2")
    update_motion(pending_motion) # change last_motion
    velocity = pending_motion[1]
    transform.origin = pending_motion[0]
    set_transform(transform)
    # get_node("sparks").show()
    resting = false
  # if not g.is_null(pending_motion):
    pending_motion = null

func fixed_ball_motion():
  # if not simulation and owner != -1:
  # if not simulation:
  #   return
  if not simulation and owner != -1 and not mini_catch: # move ball along owner
    # gsvar.announce("horra", 1,"2")
    var plus = Vector3(0,5.59,-3.73).rotated(Vector3(0,1,0), -me.body_rotation) # Vector3(0,0,0)
    set_translation(gsvar.player_by_id(owner).get_translation() + plus)
    return
  if  not resting and not g.is_null(last_motion) :
    # outsource motion calculation to eval_context for rapid dev
    var new_motion = g.eval_context().calc_ball_motion(last_motion,simulation)
    if new_motion[1].length() < 3 and new_motion[0].y < 8:
      # g.scrn_dbg("")
      gsvar.announce("stopping ball", 1, "2")
      resting = true
      return
    # actual motion
    if not can_teleport_to(new_motion[0]) and velocity.length() > 50:
      motion_cast_res = sphere_cast((new_motion[0] - get_transform().origin))
    else:
      motion_cast_res = null
      # gsvar.announce("oppa", 3, "2")
    # if new_motion[0].y < -10:
    #   # gsvar.announce("oppa", 3, "2")
    #   return
    # g.scrn_dbg("moveto difF", (get_translation() - new_motion[0]).length())
    var rem = move_to(new_motion[0])
    # if simulation:

    #   var rem = move_to(new_motion[0]) # !!
    # else:
    #   var movec = new_motion[0]-get_translation()
    #   var moveclen = movec.length()
    #   if moveclen > 10:
    #     gsvar.announce("move too myc", 2, "2")
    #     # movec = movec.normalized() * 10

    #   move(movec)
    # if rem.length() > 6:
    #   print(rem.length()) # !!
    #   return
    velocity = new_motion[1]
    velocity = velocity.normalized() * min(500, velocity.length())
    g.ss("lastmotion", [g.t(), get_transform().origin, velocity])


func handle_collision_kin( collider, col_idx=null):
  var lv = velocity;
  var transform = get_transform();
  var lvn = lv.normalized();
  var is_rb_collider = collider.get_type() == "RigidBody"
  var is_char_collider = is_rb_collider and collider.get_mode() == RigidBody.MODE_CHARACTER
  if not is_char_collider:
    spindir = -spindir
    var skip_dead_check = false
    if is_hoop_col(collider):
      skip_dead_check = true
      if ball_realisitc: # false
        lv = lv * 1.1
      else:
        # gsvar.announce("2hoppa", 1)
        # lv -= Vector3(0,10,0)
        lv *= (1.12-0.3)
    if "/root/world/env/Plane4/StaticBody" == collider.get_path() or "/root/world/env/Plane8/StaticBody" == collider.get_path() :
      if ball_realisitc: # false
        lv = lv * 1.2
      else:
        lv = lv * g.store_get("bboard_damp", 0.8) # 1.4
      skip_dead_check = true
    if is_hoop3_col(collider):
      skip_dead_check = true
    if dead_ball and not skip_dead_check:
      dead_ball = false
    var ln
    var lp
    if true or last_collider != collider:
      last_collider = collider;
      g.report("reflect ball collider", [collider], 1 , -1, {"only":false})
      ln = get_collision_normal()
      lp = get_collision_pos()
      var lpd = Vector3()
      if not g.is_null(motion_cast_res):
        # gsvar.announce(["that was quick", (motion_cast_res.point - get_translation()).length(), simulation, ln], 1, "2")
        ln = motion_cast_res.normal
        lpd = lp - motion_cast_res.point
        lp = motion_cast_res.point
      # transform.origin = lp + (5.4 * ln)
      # set_transform(transform)
      last_collision_time = OS.get_ticks_msec()
      if typeof(ln) == TYPE_VECTOR3:
        if (is_hoop3_col(collider)):
          print("hoop3col")
          # return velocity
          # gsvar.announce("donha", 1)
          if g.time_since(self,"last_net_col", 200, true):
            return Vector3(-lv.x,-abs(lv.y)*1.0,-lv.z) * g.store_get("ball_col_net_slow_factor", 0.2)
          # return Vector3(-lv.x,abs(lv.y)*100.0,-lv.z) * g.store_get("ball_col_net_slow_factor", 0.2)
          return velocity
        g.report("kincol", [ln,lv], 0 , 1000, {"only":false})
        # print("isf", lv)
        # print(["ln dot velocity", ln.dot(velocity)])
        if not is_hoop3_col(collider) and ln.dot(velocity) > 0:
          return velocity
        # var newlv = ((ln.reflect(lv) * g.store_get("ball_col_slow_factor", 0.65)) - Vector3(0,-lv.y/(13.0 - 9),0))
        var newlv = ((ln.reflect(lv) * g.store_get("ball_col_slow_factor", 0.65)) - Vector3(0,-lv.y * g.sg("vvcoldamp",0.25),0))
        # print("new lv", velocity,ln,newlv)
        # if abs(get_translation().z) > 500 and get_translation().y > 6:
        #   gsvar.announce(["col after score", get_translation().y], 2,"2")
        #   newlv *= 0.2
        return newlv
  return velocity

func is_hoop_col(collider):
  var hoopsouth_col = "/root/world/env/hoopsouth/Torus2/StaticBody" == collider.get_path()
  var hoopnorth_col = "/root/world/env/hoopnorth/Torus2/StaticBody" == collider.get_path()
  if hoopsouth_col or hoopnorth_col:
    return true
  return false

func is_hoop3_col(collider):
  var hoopsouth_col3 = "/root/world/env/hoopsouth/Torus3/StaticBody" == collider.get_path() or "/root/world/env/hoopsouth/Torus5/StaticBody" == collider.get_path()
  var hoopnorth_col3 = "/root/world/env/hoopnorth/Torus3/StaticBody" == collider.get_path() or "/root/world/env/hoopnorth/Torus5/StaticBody" == collider.get_path()
  if hoopsouth_col3 or hoopnorth_col3:
    return true
  return false



  # if not g.is_null(queue_throw):
  #   callv("throw", queue_throw)
  # fixed ball motion start
  # var lv = velocity;
  # var transform = get_transform();
  # var lvn = lv.normalized();
  # # check motion path for new motion
  # if   not simulation and is_new_throw:
  #   call_deferred("set", "is_new_throw",false)
  # # set up new motion
  # elif owner == -1 and not simulation and leader_ball.motion_start > -1 and  leader_ball.motion_path.size() > (motion_path_cursor):
  #   var time_passed = g.t() - leader_ball.motion_start + 50
  #   g.report("real ball col time passed", [time_passed], 0 , 1000, {"only":false})
  #   var motion = leader_ball.motion_path[motion_path_cursor]
  #   if motion[1].y < 8:
  #     g.create_mark({"pos":motion[1] - Vector3(0,1.2,0), "arrow":false, "label":"ball goes here"}, "ball_next_land", true)
  #     # found a new motion
  #   if motion[0]  < time_passed:
  #     if false:
  #       pass
  #     else:
  #       g.report("found cached col!", [motion], 0 , -1, {"only":false})
  #       pending_motion = [motion[1], motion[2]]
  #       g.ss("lastsimpt", [g.t(), pending_motion[1]])
  #       motion = null
  #       play_col_sound(pending_motion, velocity)
  #       motion_path_cursor += 1
  #       # leader_ball.motion_path.pop_front()

  # apply new motion
  # if not g.is_null(pending_motion):
  #   # if simulation:
  #     # gsvar.announce(["pppqweqw",g.t(), simulation], 1,"2")
  #   if true or  pending_motion[1].length() > 10:
  #     update_motion(pending_motion) # change last_motion
  #     g.report("pending throw", [pending_motion], 0 , -1, {"only":false})
  #     # WHAT IS THIS?
  #     # gsvar.announce("we got here indeed", 1)
  #     transform.origin = pending_motion[0]
  #     set_transform(transform)
  #     # velocity = pending_motion[1]
  #     # lv = velocity
  #     resting = false
#    force_sync = true
  # if net.is_primary and force_sync and get_transform().origin.distance_to(last_sync[1]) > 1:
  #   force_sync = false
  #   last_sync = [OS.get_ticks_msec(), get_transform().origin]
  #   g.report("sync ball", [],5 , 1000)
  #   net.rset(self, "s_data", {"p":get_transform().origin, "lv":velocity, "o":owner})
  # return after applying new motion
  # if not g.is_null(pending_motion):
  #   pending_motion = null
  #   return
  # # resting or no owner, nothing to do
  # if owner != -1:
  #   return
  # if resting:
  #   return
  # if queue_resting:
  #   resting = true
  #   if !simulation:
  #     g.report("rest", [resting_reason], 0 , -1, {"only":false})
  #   queue_resting = false
  #   if !simulation:
  #     motion_start = -1
  #     leader_ball.motion_start = -1
  #   velocity = Vector3()
  #   return
  # # # fixed ball motion
  # apply_pending_motion()
  # fixed_ball_motion()
  # if not g.is_null(lv):
  #   if not resting:
  #     if  not resting and not g.is_null(last_motion):
  #       # outsource motion calculation to eval_context for rapid dev
  #       var new_motion = g.eval_context().calc_ball_motion(last_motion,simulation)
  #       # actual motion
  #       if not can_teleport_to(new_motion[0]) and lv.length() > 50:
  #         motion_cast_res = sphere_cast((new_motion[0] - get_transform().origin))
  #       else:
  #         motion_cast_res = null
  #         # gsvar.announce("oppa", 3, "2")
  #       move_to(new_motion[0]) # !!
  #       if true or  not is_colliding():
  #         velocity = new_motion[1]
  #         velocity = velocity.normalized() * min(500, velocity.length())
  #         g.ss("lastmotion", [g.t(), get_transform().origin, velocity])
  #       else:
  #         gsvar.announce(velocity,0.1)
  #     # periodic sync from server
  #     if net.is_primary and OS.get_ticks_msec() - last_sync[0] >  1000  and get_transform().origin.distance_to(last_sync[1]) > 1:
  #       last_sync = [OS.get_ticks_msec(), get_transform().origin]
  #       g.report("sync ball by time", [],1 , 1000)
  #       net.rset(self, "s_data", {"p":get_transform().origin, "lv":velocity, "o":owner})
  # else:
  #   g.report("lv null!", [], 0 , -1, {"only":false})


func play_col_sound(motion, curvel):
  g.eval_context().play_ball_col_sound(motion, curvel)
  return
  # if hoopsouth_col or hoopnorth_col:
  #   if !simulation:
  #     g.sounds.play("hit")
  # if "/root/world/env/Plane4/StaticBody" == collider.get_path() or "/root/world/env/Plane8/StaticBody" == collider.get_path() :
  #   if !simulation:
  #     var voice = g.sounds.play("bboard")
  #     g.sounds.voice_set_volume_scale_db(voice, -9)
  if get_translation().y < 5:
    g.sounds.play("bounce")

func sphere_cast(offset):
  # return
  # gsvar.announce(offset, 3)
  var origin = get_transform().origin
  var radius = 4.96158
  var space = get_world().get_direct_space_state()

  var shape = SphereShape.new()
  shape.set_radius(radius)

  var params = PhysicsShapeQueryParameters.new()
  params.set_shape(shape)
  # params.set_transform(get_transform())
  params.set_transform(Transform(Matrix3(),origin))
  # params.transform.origin = origin
  params.set_layer_mask(1)
  params.set_exclude([self.get_rid()])

  var cast_result = space.cast_motion(params, offset)

  var result = {"hit_distance":null, "hit_position":null, "hit_normal":null}
  # print(["hit res", cast_result])
  # return
  if cast_result.empty() or (cast_result[1] == 1):
    return
  result.hit_distance = cast_result[0] * offset.length()
  result.hit_position = origin + offset * cast_result[0] # needs null check in godot physics

  # params.get_transform().origin = origin +  offset * cast_result[1]
  params.set_transform(Transform(Matrix3(),origin +  offset * cast_result[1]))
  var collision = space.get_rest_info(params)

  result.hit_normal = collision
  g.ss("last_norm", collision)
  # print(["hit res2", result])
  # print("hit pos", result.hit_position)
  # print("col pos", collision.point)
  if not collision.has("normal"):
    return
  # print("col norm", collision.normal)
  var t_tot = (g.t() - motion_start) + (1000*result.hit_distance/velocity.length())
  # print("t_tot " , [g.t() - motion_start, (result.hit_distance/velocity.length()*1000), t_tot])
  # print("t difff", g.t() - last_motion[2])
  return collision

func _input(ie):
  if paused:
    return
  if gsvar.sv_dedicated:
    return;
#  if gsvar.focus[-1] == "game" :
  if gsvar.active_focus == "GC" :
    if [InputEvent.MOUSE_BUTTON, InputEvent.KEY, InputEvent.JOYSTICK_BUTTON].has(ie.type):
      var owner_is_master = (owner == net.uid)
      # if ie.is_action_pressed('switch_ball_cam'):
      #   g.eval_context().toggle_freecam()
        # switch_cam();
#      if ie.is_action_pressed('throw') or (ie.is_action_pressed('shoot') and owner == net.uid):
      if ie.is_action_pressed('throw'):
        # g.eval_context().impu()
        input_throw_pressed.append(gsvar.me.pid)
        throw_press(true);
#      if ie.is_action_released('throw') or (ie.is_action_released('shoot') and owner == net.uid):
      if ie.is_action_released('throw'):
        input_throw_pressed.erase(gsvar.me.pid)
#        g.report("in input", [OS.get_ticks_msec()], 0 , 0, {"only":true})
        if just_caught:
          just_caught = false
        else:
          throw_release(true);
#      if ie.is_action_pressed('pass_ball') and owner_is_master:
##        g.report("in input", [OS.get_ticks_msec()], 0 , 0, {"only":true})
#        pass_ball(true);
      if ie.is_action_pressed('cancel_throw'):
#        g.report("in input", [OS.get_ticks_msec()], 0 , 0, {"only":true})
        throw_cancel(true);



func ball_area_enter(a):
  # if owner != -1:
  #   return
  if simulation:
    return
  if g.is_null(gsvar.me):
    return
  # g.report("area catch", [a.get_path()], -1 , 0, {})
  # gsvar.announce("fetching ball..", 1, "2")
  # gsvar.announce(str([a.get_name() , a.get_path()]), 3, "2")
  # gsvar.announce(["ball enter area", a.get_path()], 3,"2")
#  g.report("area_enter", [a.get_path()],0,0, {"only":false})
#  if String(a.get_path()) == String(gsvar.me.get_node("Area").get_path()):
#  if a.get_name() == "Area" and str(a.get_path()).match("*/players/*") and a.get_parent().is_node_master:
  # print(["area enter ball", a.get_name(), a.get_path()])
  if  a.get_name() == "Area" and str(a.get_path()).match("*/players/*") and gsvar.is_local_player(a.get_parent().pid) and owner != a.get_parent().pid:
    # g.chreport("area catch", [a.get_path()], -1 , 0, {"only":false})
#    catch(net.uid)
    # gsvar.announce("fetching ball2..", 1, "2")
    # print("catch this!!")
    # if Input.is_action_pressed("throw") or not a.get_parent().phys.resting:
    # if Input.is_action_pressed("throw") and not a.get_parent().phys.resting:
    # gsvar.announce(["ara enter", randi(), owner],3, "2")
    # if Input.is_action_pressed("throw"):
    var pid = a.get_parent().pid
    if a.get_parent().is_dying:
      return
    if forbidden_players.has(pid):
      gsvar.announce(["can't touch it yet", ceil(g.object_timer_timeleft("expire_forbidden", self))], 2, "2")
      return
    # if not a.get_parent().phys.resting and not input_throw_pressed.has(pid):
    var do_catch = false
    # if gsvar.active_game_mode == "basketball":
    #   if is_dribbling:
    #     do_catch = input_throw_pressed.has(pid)
    #   else:
    #     if input_throw_pressed.has(pid):
    #       is_dribbling = true
    #     else:
    #       do_catch = true

    # else:
    #   do_catch = input_throw_pressed.has(pid)
    # do_catch = input_throw_pressed.has(pid) or (not dribbling and gsvar.active_game_mode == "basketball")
    do_catch = input_throw_pressed.has(pid)
    if do_catch:
    # if not a.get_parent().phys.resting or  input_throw_pressed.has(pid):
      catch(a.get_parent().pid)
      dribbling = false
      # if Input.is_action_pressed("throw"):
      if input_throw_pressed.has(pid):
        just_caught = true
    else:
      dribbling = true
      last_owner = a.get_parent().pid
      ball_follow(a.get_parent().pid)
  if not net.is_primary:
    return
  # gsvar.announce(a.get_path(), 1, "2")

  var hoopsouth_in = a.get_parent().get_name() == "hoopsouth" # red
  var hoopnorth_in = a.get_parent().get_name() == "hoopnorth"# greeb
  if owner == -1 and (hoopsouth_in or hoopnorth_in):
    # gsvar.announce("goaaal", 1, "2")
    var bad_d = check_bad_dunk()
    if velocity.y < 0 and not dead_ball and not bad_d and get_translation().y > 30:
      # gsvar.announce(["bybyby", get_translation().y ],1)
      g.report("rpc score goal", [], 0 , 1000, {"only":false})
#      score_goal(a.get_path())
      net.rpc_sync(self, "score_goal", [a.get_path()], {'reliable':true, 'channel':4})
#      score_goal(a)

#    else:
    if not bad_d:
      dead_ball = true

func check_bad_dunk():
  # if prev_throw[1].y < 0 and prev_throw[0].y < 38: #38.5:
  # if prev_throw[1].y < 0 and prev_throw[0].y < 36: #38.5:
  # if prev_throw[1].y < 0 and prev_throw[0].y < 35: #38.5:
  if prev_throw[1].y < 0 and prev_throw[0].y < 37: #38.5:
    # gsvar.announce("miss", 2)
    # ball_follow(true)
    # ball_follow(last_owner,50)
    # pending_motion = [get_translation() + Vector3(0,50,0), Vector3(0,100,0)]
    # ball_reset(get_translation() - Vector3(0,7,0), true)
    # reset_motion()
    # if net.is_primary:
    #   # pending_motion = [prev_throw[0] + Vector3(0,10,0), prev_throw[1]*-1]
    #   g.callv_later(self, "throw", [prev_throw[0] + Vector3(0,10,0), prev_throw[1]*-1],0.5 + 0.035, false, "bad_dunk")
    return true
  return false
# TAST
func update_net_shader(hoop):
  var bpos = get_translation()
  var hpos = hoop.get_translation()
  var rel_pos = (hpos - bpos) / 14
  rel_pos.y *= 1.6 + 3.9 + 2
  rel_pos *= g.store_get("netshaderparam", Vector3(0.5,-0.25 ,0.5))

  if g.xz(rel_pos).length() >0.3 or rel_pos.y > 0:

    if net_shader_ignore:
      return
    # print(rel_pos.length())
    ball_net_rel_pos = ball_net_rel_pos.linear_interpolate(Vector3(0,-5,0), 1/40.0)
    if ball_net_rel_pos.y < -3.59 :
      net_shader_ignore = true
#    return
#    rel_pos = Vector3()
  else:
    net_shader_ignore = false
    ball_net_rel_pos = rel_pos
    g.scrn_dbg("net_ball_rel_pos", rel_pos)
  hoop.get_node("Basketball Hoop/Hoop2").get_material_override().set_shader_param("ball_pos", ball_net_rel_pos)

func score_goal(a_path, cid = 0):
  if not (net.is_primary or cid == 1):
    return
  var a = get_node(a_path)
  g.report("fnc score goal", [], 0 , 1000, {"only":false})
  var hoopsouth_in = a.get_parent().get_name() == "hoopsouth" # red
  var hoopnorth_in = a.get_parent().get_name() == "hoopnorth"# greeb
  a.get_parent().get_node("fireworks").set_emitting( true )
  var rel_pos
  if hoopsouth_in:
    rel_pos = get_node("/root/world/env/hoopsouth").get_translation() - me.get_translation()
  else:
    rel_pos = get_node("/root/world/env/hoopnorth").get_translation() - me.get_translation()
  var d = rel_pos.length()
  var imp = rel_pos * -1
  imp.y = - imp.y
  imp = 10 * imp / d
  imp.y = imp.y - me.get_linear_velocity().y
#    imp.y = - imp.y
  me.apply_impulse(Vector3(0,0,0), Vector3(0,5,0))
#    me.apply_impulse(Vector3(0,0,0), imp)
#      me.pending_impulse = [Vector3(0,5,0), imp]
  me.pending_impulse = [Vector3(0,5,0)]
  g.store_set("last_goal_time", g.t())
  g.store_get("goal_times", []).append(g.t())
  if net.is_primary and  last_owner > -1:
    var scorer = gsvar.player_by_id(last_owner)
    var scorer_name = scorer.get_object_name()
    var pts = 2
    if not in_2pt:
      pts = 3
    if not st.scorers.has(scorer_name):
      st.scorers[scorer_name] = 0
    if hoopnorth_in:
      g.report("green score", [], 0 , 1000, {"only":false})
      st.green_score += pts
  #    get_node("/root/world/gui/game_info/score_green/count").set_text(str(green_score))
    else:
      st.red_score += pts
      g.report("red score", [], 0 , 1000, {"only":false})

    st.scorers[scorer_name] += pts
  #    get_node("/root/world/gui/game_info/score_red/count").set_text(str(red_score))
    var dunk = false
    if prev_throw[0].y > 30 and prev_throw[1].y < -80:
      dunk = true

    net.rpc_sync(self, "update_scores", [st.red_score, st.green_score])
    net.rpc_sync(self, "announce_goal", [scorer_name, pts, st.scorers[scorer_name], dunk])
#    g.object_timer( 'reset_ball', self, "set_ball_reset_pending", true, 2 , [true])
#    g.object_timer( 'ball_reset', self, "ball_reset", true, 2 , [])
#    ball_reset_pending = true
    pass

func set_ball_reset_pending(v=true):
  ball_reset_pending = v

func announce_goal(scorer_name, pts, total_score, dunk=false, cid=0):
  if net.is_primary:
    net.rpc(self, "announce_goal", [scorer_name, total_score], {'reliable':true, 'channel':4})
#    net.rpc_sync(gsvar, "announce", ["Out of Bounds", 5], {'reliable':true, 'channel':4})
  if net.is_primary or cid == 1:
    just_scored = true
    g.object_timer("just_scored_expire", self, "set",true,2, ["just_scored", false])
    gsvar.announce(scorer_name + " | +" + str(pts) + " PTS " + str(total_score), 5)
    g.sounds.play("cheer")
    if dunk:
      me.shake_camera(0.5)
#    get_node("SpatialSamplePlayer").play("whistle")

func update_scores(r,green, initial=false, cid=0):
  if not initial:
    g.report("cheer", [], 0 , -1, {"only":false})
  else:
    g.report("init scores", [r,green], 0 , -1, {"only":false})
#  g.sounds.play("cheer")
#  gsvar.announce("Goal", 5)
  st.red_score = r
  st.green_score = green
  get_node("/root/world/gui/game_info/score_green/count").set_text(str(st.green_score))
  get_node("/root/world/gui/game_info/score_red/count").set_text(str(st.red_score))

func request_scores(cid=0):
  if not net.is_primary and cid == 0:
    net.rpc_id(1, self, "request_scores", [])
  else:
    net.rpc_id(cid, self, "update_scores", [st.red_score, st.green_score, true])


func update_path():
  if resting:
    return
  if last_path.size() > 10:
    last_path.pop_front()
  last_path.append(get_translation())

func exit_bounds_area(area):
  if simulation:
    return
  if area.get_parent() != self or area.get_parent().get_name() == "leader_ball":
#    g.report("simulation ball out of bounds", [], 0 , -1, {"only":false})
    return
  var area_n = area.get_name()
  # gsvar.announce([area_n], 1)
  if area_n == "Ball2":
    out_of_bounds_pending = true
    out_of_bounds_pos = get_translation()
  elif area_n == "hit_area" and area.get_parent().get_name() == str(owner):
    out_of_bounds_pending = true
  g.report("out of bounds", [area.get_name()], 1 , -1, {"only":false})
#  catch(net.uid, true)

func enter_bounds_area(area):
  if simulation:
    return
  if area.get_parent() != self or area.get_parent().get_name() == "leader_ball":
    return
  var area_n = area.get_name()
  if area_n == "Ball2":
    out_of_bounds_pending = false
  elif area_n == "hit_area" and area.get_parent().get_name() == str(net.uid):
    out_of_bounds_pending = false
  g.report("inside of bounds", [area.get_name()], 1 , -1, {"only":false})
#  catch(net.uid, true)

func set_me():
  g.report("set me", [], 0 , 1000, {"only":false})
  me = gsvar.me
  leader_ball.me = gsvar.me

func ball_state_update(force_owner=false, cid=0):
  if local_catch:
    return
#  g.report("got req", [cid], 0 , 1000, {"only":true})
  if cid == 0:
    net.rpc_id(net.primary_server, self,"ball_state_update", [force_owner])
  else:
    var v = {"p":get_transform().origin, "lv":velocity}
#    if force_owner:
    v['o'] = owner
    net.rpc_id(cid,self,"set_s_data", [v] )
#    if owner == -1:
#      var v = {"p":get_transform().origin, "lv":velocity, 'o':owner}
#      net.rpc_id(cid,self,"set_s_data", [v] )
#    else:
#      net.rpc_id(cid,self, "catch", [owner,true])


func set_s_data(value, cid=0):
  gsvar.announce("set_sd", 1, "2")
  gsvar.announce(str(value), 1, "2")
#  g.report("set s_data", [], 0 , 1000, {"only":true})
  if cid == net.primary_server:
    g.report("receive s_data rpc", [value], 0 , -1, {"only":false})
    s_data = value

func player_ready():
  me = gsvar.me
  g.report("ball got me", [me], 0,0)
#  me.connect("player_got_hit", self, "got_hit",[])

func hide_indicator():
  #throw_indicator.hide()
  throw_ui.hide()


func player_got_hit(pid, pos, mid, killed_pid):
  g.eval_context().player_got_hit(pid, pos, mid, killed_pid)
  return
#  if gsvar.me.pid != killed_pid:
  if ! gsvar.is_local_player(killed_pid):
    return
  g.sounds.play("boss_hit")
#  if gsvar.me.pid != owner:
  if killed_pid != owner:
    return
  var shooter = gsvar.player_by_id(pid)
#  var throw = shooter.get_translation()
  var lv
  var killed = gsvar.player_by_id(killed_pid)
  if pid == killed_pid:
    lv = Vector3() - killed.get_translation()
  else:
    lv = shooter.get_translation() - killed.get_translation()
#  var lv = Vector3() - gsvar.me.get_translation()
  g.report("hit diff", [pid, killed,shooter.get_translation(), killed.get_translation(), lv],1,0, {"only":false})
  var throw = lv
#  var throw = Vector3(lv.x + p_dir.x * power , lv.y + 2 + power / 3.0, lv.z + p_dir.z * power)
  g.sounds.play("ball_taken")
  throw(killed.get_translation() + Vector3(0,10,0), throw)


func announce_out_of_bounds(cid=0):
  if net.is_primary:
    net.rpc(self, "announce_out_of_bounds", [], {'reliable':true, 'channel':4})
#    net.rpc_sync(gsvar, "announce", ["Out of Bounds", 5], {'reliable':true, 'channel':4})
  if net.is_primary or cid == 1:
    gsvar.announce("Out of Bounds", 5)
#    get_node("SpatialSamplePlayer").play("whistle")
    g.sounds.play("whistle")

func get_avg_speed():
  if resting:
    return 0
  if last_path.size() > 1:
    var avg_spd = (last_path[-1] - last_path[-2]).length()
    g.scrn_dbg("avg_speed", [avg_spd])
    return avg_spd
  else:
    return 1000

func ball_reset(pos=Vector3(),force=false,cid=0):
  if net.is_primary:
    net.rpc(self, "ball_reset", [pos])
  if not (cid == 1 or net.is_primary or force):
    return
  # if gsvar.tutorial:
  #   ball_follow(last_owner, 150)
  #   return
  if !simulation:
    motion_start = -1
    leader_ball.velocity=Vector3()
    leader_ball.motion_start = -1
    leader_ball.resting = true
  g.report("reset ball", [], 0 , -1, {"only":false})
  var t = get_transform()
  t.origin = Vector3(0,7,0) + pos
  set_transform(t)
  # self.move(Vector3(0,10,0))
  # velocity = Vector3()
  g.report("reset rest", [], 0 , -1, {"only":false})
  queue_resting("ball reset")
  resting = true
  get_node("sparks").hide()
  uncatch()
#  var v = {"p":get_transform().origin, "lv":velocity}
#  v['o'] = owner
#  net.rpc(self,"set_s_data", [v] , {"channel":4, "reliable":true})
  ball_reset_pending = false


func rest_ball(reason=null):
  gsvar.announce(["resting", reason],3)
  if resting:
    return
  g.report("new rest", [reason], 0 , -1, {"only":false})
  motion_start = -1
  if !simulation:
    leader_ball.rest_ball(reason)
#    motion_start = -1
#    leader_ball.motion_start = -1
#    leader_ball.resting = true
  resting_reason = reason
  var b = self
  var t = b.get_transform()
  var o = t.origin
  o.y = 2.5
  t.origin = o
  b.set_transform(t)
  move(Vector3(0,1,0))
  b.velocity = Vector3()
  b.resting = true
#  if !simulation and owner == -1:
#    g.object_timer("ball_follow", self, "ball_follow", true, 1)
#  b.uncatch()

# func ball_follow(up=false,src=0):
func ball_follow(pid,max_power=-1,src=0):
  if src == 0:
    if  not g.time_since(self, "last_own_throw", 65+160):
      gsvar.announce("cooldown!", 0.2, "2")
      g.chreport("in throw cool down period", [], 0 , 0, {"only":false})
      return
  dribbling = true
  dead_ball = false
  g.eval_context().ball_follow(pid,max_power)
  return

func camera_available(cn):
  # return true
  if owner == -1:
    return true
  return false

func update_camera():
  g.eval_context().update_ball_camera()
  return
  var p = gsvar.me
  var b = self
  var pos = p.get_translation()
  var ball_pos = b.get_translation()
  var dir = (ball_pos - pos).normalized()
  var from = pos - dir*10
  camera.look_at_from_pos(from, ball_pos, Vector3(0,1,0))

func queue_resting(reason):
  return
  queue_resting = true
  resting_reason = reason



func adjust_ball_params():
  ball_realisitc = false
  if ball_realisitc:
    ball_vel_per_iter = 1/130.0;
    ball_gravity = Vector3(0,-9.8,0);
    ball_h_slowdown = 1/6.0
  else:
#    ball_vel_per_iter = 1/210.0;
    ball_vel_per_iter = 1/150.0;
#    ball_gravity = Vector3(0,-15.8,0);
    ball_gravity = Vector3(0,-9.8,0);
#    ball_h_slowdown = 1/5.0
    ball_h_slowdown = 0.09 # 0.15


func switch_cam():
#  var ball = get_node("/root/world/env/Ball")
  if owner != net.uid and not get_node("Camera").is_current():
    get_node("Camera").make_current()
    gsvar.me.get_node('body/Tank').set_hidden(false)
  else:
    gsvar.me.camera.get_node("cam").make_current()
    gsvar.me.switch_cam()



func dur_to_power(duration):
  duration -= g.store_get("releasepassduration" ,110)
  duration = max(duration, 5)
  return g.store_get("d2pmul", 0.9) * (duration) / (6.0 )#8.0 # 6.0 #10.0 #12.0
#  return (duration + randi()%5) / 12.0


func throw_press(user=false):
#  if net.is_primary and net.uid != owner and  velocity.length() < 2000:
  if net.is_primary and not gsvar.is_local_player(owner)  and  gsvar.active_game_mode == "basketball":
    var dist = (gsvar.me.get_translation() - get_translation()).length()
    if ( not (gsvar.game_running or gsvar.tutorial)) and dist > 80:
      g.eval_context().cb()
      return
  elif net.is_primary and not gsvar.is_local_player(owner)  and  velocity.length() < 2000:
    var dist = (gsvar.me.get_translation() - get_translation()).length()
    if ( not (gsvar.game_running or gsvar.tutorial)) and dist > 50:
      # gsvar.announce("we found the culorit",1)
      ball_follow(gsvar.me.pid, 180)
#      catch(net.uid, true)
      return
  if mini_catch:
    return
  if user and owner != net.uid:
    return
  if throw_press_start > -1:
    return
#  if net.uid == owner:
  if gsvar.is_local_player(owner):
    #throw_indicator.show()
    throw_duration = 0
    throw_deviation = 0
    throw_indicator.set_value(0)
    throw_ui.show()
    throw_press_start = OS.get_ticks_msec()
    # charge_sound = g.sounds.play("486885__4udiopony__bubbles-rise")
    charge_sound = g.sounds.play("197969__thejoshuachang__scale")
    g.sounds.voice_set_pitch_scale ( charge_sound, g.store_get("charge_voice_pitch", 1.4))
#
#
#
func calc_deviation(duration):
#  return sin((duration + randf()/3)/15.0)
  return g.eval_context().calc_deviation(duration)
#  return sin((duration + randf()/3)/150.0)

func throw_cancel(user=false):
  if user and owner != net.uid:
    return
  if throw_press_start != -1:
    g.report("cancel throw", [], 0 , -1, {"only":false})
    throw_ui.hide()
    throw_press_start = -1
    cancel_pending = true


func throw_release(user=false,power=null,deviation=0):
  if cancel_pending:
    cancel_pending = false
    return
  if user and owner != net.uid:
    return
#  if net.is_primary and net.uid != owner and  velocity.length() < 2000:
#    if not gsvar.game_running:
#      ball_follow()
##      catch(net.uid, true)
#      return
  var td = g.time_elapsed(self, "last_bang_basket")
  # gsvar.announce("basket td:" + str(td), 2)
  # if td < 30:

  # if td < 30:
  g.scrn_dbg("throw dury", [td, throw_duration])
  if throw_duration > 300:
    if td < 30:
      # throw_duration = throw_duration - 10
      throw_duration = throw_duration - (td * 0.62) + 7
      throw_deviation_ui.get_node("deviation2").set_modulate(Color("#ff0000ff"))
    # elif td < 60:
    #   throw_duration = throw_duration - td + 20
    #   throw_deviation_ui.get_node("deviation2").set_modulate(Color("#ff0000AA"))
    elif td < throw_duration * 0.2 and td < 45:
      # gsvar.announce(["good shot", td, throw_duration], 2, "2")
      g.scrn_dbg("good throw", [td, throw_duration])
      throw_duration = throw_duration - (td * (0.6+0.3)) + 10 +4
      throw_deviation_ui.get_node("deviation2").set_modulate(Color("#ff006622"))

  #   gsvar.announce(['good',td], 1)
#  if net.uid != owner:
  if not gsvar.is_local_player(owner):
#    var td = g.t() - last_motion[2]
    return
#  throw_indicator.hide()
  indicator_hide_timer.start()
  if g.is_null(power):
    throw_press_start = -1
    var duration = throw_duration
    if duration < g.store_get("releasepassduration" ,110):
      pass_ball()
      g.sounds.stop_voice(charge_sound)
      return
    deviation = throw_deviation
    power = dur_to_power(duration)
    # var power_max = 100.0
    power = min(power, power_max)
    var dunkin = false
    var mepos = me.get_translation()
    if  abs(mepos.x) < 20 and abs(abs(mepos.z) - 334) < 20 and mepos.y > 17 :
      dunkin = true
      gsvar.announce(["dunkin"], 1,"2")
    if dunkin or power == power_max:
      pass_ball(true)
      return
      power += randf() * 20
  g.sounds.stop_voice(charge_sound)
  var throw = calc_my_throw(power)
  # gsvar.announce("throw release throw", 1, "2")
  throw(throw[0], throw[1])
  return


func calc_my_throw(power):
  return g.eval_context().calc_my_throw(power)

func calc_throw(v0, pos0,  dir0, power, high=false, low=false):
  return g.eval_context().calc_throw(v0, pos0, dir0, power, high, low)

func pass_ball(charged=false):
  if not gsvar.is_local_player(owner):
    return
  var p = gsvar.player_by_id(owner)
  me = gsvar.me
  var lv = p.get_linear_velocity()
  var p_rot = p.body_rotation
  var p_dir = Vector3(sin(p_rot),0,cos(p_rot))
  var p_pos = p.get_global_transform().origin
  var t_pos = p_pos+ Vector3(0,18,0)  #+ Vector3(0,18.6,0)# Vector3(0,20,0)
  var base_strength = 50 - 30 # 150 # 100

  if p_pos.y > 5 and not charged:
    base_strength = 70 - 40 - 20
  if charged:
    base_strength = 100 - 30
  base_strength *= 3
  var ypos_param = 0
  charged = false
  if not (charged or pass_far):
    ypos_param = pow(min(p_pos.y, 14), 2) * 6 / 12
  else:
    ypos_param = g.sg("down_ypos_param", 10)
  # var throw =  p_dir*base_strength + Vector3(0,-28,0) + lv + Vector3(0, lv.y * 2, 0) #- Vector3(0,ypos_param,0)
  var throw =  p_dir*base_strength + Vector3(0,-28 - p_pos.y / 1.4,0) + lv + Vector3(0, lv.y , 0) #- Vector3(0,ypos_param,0)


  if throw.length() > 160:
#    get_node("Particles").show()
    throw = throw.normalized() * 160
  g.eval_context().mod_throw_input()
  # if not charged and Input.is_action_pressed("slowmo2"):
  if not charged and pass_far:
    throw = g.eval_context().mod_pass(throw)
#    throw /= 2.5
#    throw.y = 3.5 * pow(max(abs(throw.y), 0.1), 0.7) * sign(throw.y)
  g.report("throw length", [throw, throw.length()], 0 , 1000, {"only":false})
  g.report("pass throw", [throw], 0 , -1, {"only":false})
  if throw_low:
    throw *= 1.3
  if throw.length() > 150:
    g.sounds.play("DM-CGS-46")
  get_node("/root/world/gui/ThrowMeter2/deviation/dunkstar").show()
  g.object_timer("hide_dunk_star", self, "hide_dunk_star", true, 1)
  gsvar.announce(["pass that ball", throw], 3)
  # gsvar.announce("pass the ball", 1, "2")
  throw(t_pos, throw)
  pass

func hide_dunk_star():
  get_node("/root/world/gui/ThrowMeter2/deviation/dunkstar").hide()

func validate_throw(player):
  if owner > 100:
    return true
  # if player != owner:
  if player != last_owner and player != owner:
    g.report("player tried to throw without owning the ball", [player],0,0, {"only":false})
    return false
  return true

func uncatch():
#  g.chreport("uncatch this", [], 0 , 0, {"only":false})
  if gsvar.active_game_mode == "basketball":
    get_node("/root/world/env/carry_radius").hide()
  # print("uncatching")
  if owner != -1: # if there is an existing owner
    # print("uncatching2",owner)
#    if not gsvar.player_by_id(owner).is_dying:
#      gsvar.player_by_id(owner).max_speed_mod = 1.0
    if not g.is_null(gsvar.player_by_id(owner)):
      g.w_unset(gsvar.player_by_id(owner), "max_speed_mod", "own_ball")
      get_node("ui").hide()
      gsvar.player_by_id(owner).get_node("body/ownball").hide()
    set_layer_mask_bit(3,1)
    owner = -1
    show()


func catch(player, force = false,mini=false, src=0):
  # gsvar.announce(["caaaaatch", player,force,mini], 4,"2")
  if simulation:
    gsvar.announce("prrrr", 1)
#  if typeof(player) == 2:
#    player = [net.uid, player]
  # print_stack()
  var check = false
  # if owner != -1:
  #   gsvar.announce(["that is lit"],1)
  #   g.report("tried to catch owned ball", [player, owner], 0, 0)
  #   return false
  if owner == player:
    # gsvar.announce(["good bah"], 2)
    # gsvar.announce(["that is lit"],1)
    # g.report("tried to catch owned ball", [player, owner], 0, 0)
    return false
  if not force and gsvar.player_by_id(player).is_dying:
    return false
  # uncatch()
  if src == 0:
    # print(g.timers[self].delayed_throw.get_time_left()>0, " time left!!")
    # if (player == last_owner) and not g.time_since(self, "last_own_throw", 500-300+100):
    # gsvar.announce(["lasts", g.time_elapsed(self, "last_own_throw")], 5,"2")
    if (player == last_owner) and not mini and not g.time_since(self, "last_own_throw", 250):
      # gsvar.announce(["good cool"], 2)
      g.chreport("in throw cool down period", [], 0 , 0, {"only":false})
      # gsvar.announce("cooldown thrw", 1,"2")
      return false
    g.store_set("recent_ball", self)

  # uncatch()
  if src == 0 and not net.is_primary:
#    if not g.time_since(self, "last_own_throw", 1500):
#      g.chreport("in throw cool down period", [], 0 , 0, {"only":false})
#      return
#    wait_ack = g.t() + 1000
    # dribbling = false
    local_catch = true
    check = true
    wait_ack = g.t() + 2000 + 2 * net.get_target_latency(net.primary_server)
#    wait_ack = -1
#    net.rpc_id(net.primary_server, self, "catch", [net.uid,force], {"channel":4})
    net.rpc_id(net.primary_server, self, "catch", [player,force,mini], {"channel":4})
#  if net.is_primary:
#    net.rpc(self, "catch", [player])
#  if net.is_primary and src == 0:
#    src = 1
  if net.is_primary:
    force = force and owner == -1
    if force or validate_catch(player):
      net.rpc(self, "catch", [player,force,mini], {"channel":4, 'reliable':true})
    else:
      g.report("force ball state update", [], 0 , 0, {"only":false})
      ball_state_update(true,player)
      return
  if src == net.primary_server:
    g.report("got catch call from server", [], 0 , 0, {"only":false})
    if player == net.uid:
      return
  if net.is_primary or src == net.primary_server :
    local_catch = false
  if net.is_primary or src == net.primary_server or src==0:
#  if net.is_primary or src == net.primary_server:
    if player == -1:
      # gsvar.announce("uncatch -1", 1)
      # uncatch()
      return
    if get_node("Camera").is_current() and player == net.uid:
      switch_cam()
      pass

    dead_ball = false
    get_node("ui").hide()
    mini_catch = false
    if player == net.uid and not mini:
      get_node("ui").show()
    g.report("catch", [player],3,0)
    set_layer_mask_bit(3,0)
    ball_hit_floor_out = false
    if not mini:
      dribbling = false
      mini_catch = false
      last_catch = [get_translation(), g.t()]
      get_node("/root/world/env/carry_radius").set_translation(g.xnz(get_translation()))
      get_node("/root/world/env/carry_radius").show()
      hide()
    else:
      mini_catch = true
    owner = player
    last_owner = owner
    var ownedball = gsvar.player_by_id(owner).get_node("body/ownball")
    ownedball.set_translation((get_translation() - gsvar.player_by_id(owner).get_translation())*0.5)
    # ownedball.hide()
    # pending_motion = null
    # leader_ball.pending_motion = null
    # is_new_throw=true
    # leader_ball.motion_path = []
    # leader_ball.resting=true
    # gsvar.announce("angryy", "1")
#    gsvar.player_by_id(owner).max_speed_mod = 0.75
#    gsvar.player_by_id(owner).max_speed_mod = 0.6
    # g.w_set(gsvar.player_by_id(owner), "max_speed_mod", "own_ball", 0.4, 1)
    g.w_set(gsvar.player_by_id(owner), "max_speed_mod", "own_ball", 0.5, 1)
    if owner == net.uid and not mute_next_catch:
      # g.sounds.play("grab")
      # g.sounds.play("cheer")
      # g.sounds.play("DM-CGS-18")
      # g.sounds.play("DM-CGS-04")
      # g.sounds.play("DM-CGS-26")
      g.sounds.play(g.sg("catchsound", "DM-CGS-26"))
      # g.sounds.play("Explosion15")
      # g.sounds.play("Retro Impact Metal 05")
    mute_next_catch=false

func validate_catch(player):
  return true
#  pass
  # check player is near ball
  # check ball has no owner
#  if owner != -1:
#    g.report("tried to catch owned ball", [player, owner], 0, 0)
#    return false
  var pl = gsvar.player_by_id(player)
  var d = pl.get_translation().distance_to(get_translation())
  if  d > 20 :
    g.report("tried to catch ball that is too far away", [player, d],0,0)
    return false
  if pl.is_dying:
    g.report("dead tanks cant catch ball", [], 0 , -1, {"only":false})
    return false
  return true


# func handle_collision_kin( collider, col_idx=null):
#   var lv = velocity;
#   var transform = get_transform();
#   var lvn = lv.normalized();
#   var is_rb_collider = collider.get_type() == "RigidBody"
#   var is_char_collider = is_rb_collider and collider.get_mode() == RigidBody.MODE_CHARACTER
#   if true:
#     if is_char_collider:
#       pass
# #       g.report("collider char", [collider.get_name()], 1 , 0, {"only":false})
# #       var not_direct_self_hit = last_collider or (collider != gsvar.player_by_id(owner))
# #       var self_is_hit = collider == gsvar.player_by_id(net.uid)
# #       if not_direct_self_hit and self_is_hit:
# #         print("catch that")
# #         catch(net.uid)
# # #        net.rpc_sync_id(net.primary_server, self, "catch", [net.uid])
#     else:
#       # print("here")
#       spindir = -spindir
#       # var rest_speed = 0.4
#       # if simulation:
#       #   rest_speed = 10
#       # if (lv.length() < rest_speed and get_translation().y < 12):
#       #   g.report("rest slow ball", [lv], 0 , -1, {"only":false})
#       #   queue_resting("slow ball")
#       var skip_dead_check = false
#       var hoopsouth_col = "/root/world/env/hoopsouth/Torus2/StaticBody" == collider.get_path()
#       var hoopnorth_col = "/root/world/env/hoopnorth/Torus2/StaticBody" == collider.get_path()
#       var hoopsouth_col3 = "/root/world/env/hoopsouth/Torus3/StaticBody" == collider.get_path() or "/root/world/env/hoopsouth/Torus5/StaticBody" == collider.get_path()
#       var hoopnorth_col3 = "/root/world/env/hoopnorth/Torus3/StaticBody" == collider.get_path() or "/root/world/env/hoopnorth/Torus5/StaticBody" == collider.get_path()
#       if hoopsouth_col or hoopnorth_col:
#         if !simulation:
#           g.sounds.play("hit")
#         skip_dead_check = true
#         if ball_realisitc: # false
#           lv = lv * 1.1
#         else:
# #          lv = lv * 1.6
#           lv = lv #* 1.1
#           lv -= Vector3(0,5,0)
#       if "/root/world/env/Plane4/StaticBody" == collider.get_path() or "/root/world/env/Plane8/StaticBody" == collider.get_path() :
#         if !simulation:
#           var voice = g.sounds.play("bboard")
#           g.sounds.voice_set_volume_scale_db(voice, -9)
#         if ball_realisitc: # false
#           lv = lv * 1.2
#         else:
#           lv = lv * g.store_get("bboard_damp", 0.8) # 1.4
#         skip_dead_check = true
#       if hoopsouth_col3 or hoopnorth_col3:
#         skip_dead_check = true
#       if dead_ball and not skip_dead_check:
#         dead_ball = false
#       var ln
#       var lp
#       if true or last_collider != collider:
#         last_collider = collider;
#         g.report("reflect ball collider", [collider], 1 , -1, {"only":false})
#         # if not g.is_null(motion_cast_res):
#         #   # gsvar.announce(["that was quick", motion_cast_res.normal - get_collision_normal()], 1, "2")
#         #   gsvar.announce(["that was quick", motion_cast_res.point - get_collision_pos()], 1, "2")
#         ln = get_collision_normal()
#         gsvar.announce(["that was quick2",  simulation, ln], 1, "2")
#         lp = get_collision_pos()
#         var lpd = Vector3()
#         # print("poa")
#         if not g.is_null(motion_cast_res):
#           # gsvar.announce(["that was quick", motion_cast_res.normal - get_collision_normal()], 1, "2")
#           gsvar.announce(["that was quick", (motion_cast_res.point - get_translation()).length(), simulation, ln], 1, "2")
#           ln = motion_cast_res.normal
#           lpd = lp - motion_cast_res.point
#           lp = motion_cast_res.point
#         transform.origin = lp + (5.4 * ln)
#         set_transform(transform)
#         # if lv.length() > 150:
#         #   gsvar.announce(["coll dist from center", (lp - get_translation()).length()], 3)
#         # elif lv.length() > 50:
#         #   gsvar.announce(["coll dist from center slow", (lp - get_translation()).length()], 1, "2")
#         if (hoopsouth_col or hoopnorth_col):
#           # gsvar.announce(["coll pos", lp], 1)
#           # print(["coll pos", lp])
#           print(["coll norm", ln])
#         last_collision_time = OS.get_ticks_msec()
#         if typeof(ln) == TYPE_VECTOR3:
#           # print("ds")
#           if !simulation:
#             gsvar.announce("oppa",1, "2")
#             if get_translation().y < 5:
#               g.sounds.play("bounce")
#               ball_hit_floor_out = true
#               if not bounds_area.overlaps_area( get_node("Ball2")):
#                 ball_hit_floor_out = true
#           if (hoopsouth_col3 or hoopnorth_col3) and g.time_since(self,"last_net_col", 40, true):
#             # print("netcol")
#             return Vector3(-lv.x,-abs(lv.y)*1.0,-lv.z) * g.store_get("ball_col_net_slow_factor", 0.2)
#           g.report("kincol", [ln,lv], 0 , 1000, {"only":false})
#           # print("isf", lv)
#           var newlv = ((ln.reflect(lv) * g.store_get("ball_col_slow_factor", 0.65)) - Vector3(0,lv.y/20.0,0))
#           # newlv.y *= -1
#           return newlv

#   if simulation:
#     gsvar.announce(["new lv", lv], 1,"2")
#     return lv
#   else:
#     # return velocity.normalized() * min(100, velocity.length())
#     return velocity


func net_sync_kin():
  if not s_data.empty():
    resting = false
    g.report("got sync ball", [s_data],0,-1)
    gsvar.announce("got s_data", 1)
    update_motion([s_data.p, s_data.lv])
    var transform = get_transform();
    transform.origin = s_data['p']
    set_transform(transform)
#    set_transform(Transform(Matrix3(), s_data['p']))
    velocity = s_data['lv']
    if velocity == Vector3():
      g.report("SYNC resting", [], 0 , 1000, {"only":false})
      rest_ball("remote ball stationary")
      queue_resting("remote ball stationary")
    if s_data.has('o'):
      g.report("has o", [s_data], 0 , -1, {"only":false})
      if s_data["o"] == -1:
        if not local_catch:
          uncatch()
      elif owner != s_data["o"]:
        g.report("set catch", [], 0 , -1, {"only":false})
        uncatch()
        g.report("s_data!", [s_data], 0 , -1, {"only":false})
        catch(s_data["o"], true)
    s_data = []

func _on_Area_body_enter( body ):
	print("yah")

func pause():
  paused = !paused

func create_ball_ripple(sc=1):
  # var dir = get_linear_velocity()
  # if dir.length() < 3:
  #   return
  var inst
  var numpool = 10
  if g.store_get("brpool", []).size() < numpool:
    inst = ball_ripple_scene.instance()
    inst.set_name("bripple");
    gsvar.world.env.add_child(inst, true);
    g.store_get("brpool").append(inst)
    # inst.get_node("Circle").set_scale(Vector3(10,1,10))
    # inst.set_scale(Vector3(10,1,10))
  else:
    inst = g.store_get("brpool")[g.store_inc('brpoolnext', 1, numpool)]
    inst.reset()
  inst.modsc = sc
  inst.set_global_transform(Transform(Matrix3(), g.xnz(get_translation(),2)));
  inst.activate()
  return inst