extends Node

class BotActionManager:
  extends Node
  var g = Globals.g
  var gsvar = Globals.gsvar
  var bot
  var control
  var common_state = {}
  var force_assess = false
  onready var cs = common_state
  onready var ball = bot.get_node("/root/world/env/Ball")
  onready var balls = g.store_get("balls", [])
  var col_cache = {}
  # bs -> bot situation
  var cache = {"col":{}, "bs":{}, "bullets":{}}
  var current = null # the current action
  var actions = { "K_chase":null, "K_chase_ball":null,
    "A_default":null, "K_face":null ,"K_trap2":null,"K_trap":null, "K_trap_chase":null, "K_cut":null, "K_threat":null, "K_thwart":null, "K_catch":null, "K_surround":null, "K_guard":null, "K_spread":null,
    "D_default":null, "D_Elude":null, "D_DodgeCommon":null, "D_Dodge_1":null, "D_deobstruct":null, "D_reenter":null,
    "A_Basket":null, "A_BallGrab": null, "A_BallWait": null, "A_BallPass":null,
    "A_BallWander":null, "A_BallRun":null, "A_BallSteal":null,
    "C_threat_level":null
  }
  var action_groups = {"dodge":[]}
  var debug = true
  var danger = false

#  var actions = {"A_default":null, "A_trap2":null,"A_trap":null, "A_trap_chase":null}
  var ordered_actions = []
  var roles = []
  # func _ready():
  #   bot.control.update_target(gsvar.me)
    # print("!!!",bot.control.situation.P)

  func _init(b): # b for control
    bot = b.tank
    select_team()
    # gsvar.announce("oom", 1)
    # bot.control.update_target(gsvar.me)
    # print("!!!",bot.control.situation.P)

    var bot_event_times = {"last_reverse":0,"last_reverse_x":0, "last_evade_align":0, "last_escape_align":0, "last_evade_kill_intent":0, "last_chasing":0, "last_shoot":OS.get_ticks_msec() + 5000, "last_vary":0, "wait_instruction":0, "last_p_moving":0, 'last_calc_move':0, "last_jump":0, "last_action_select":0}
    g.mergedicts(bot.event_times, bot_event_times)

    g.report("this bot", [bot.event_times], 0 , 1000, {"only":false})
    bot.event_times["last_fire"] = 0
    bot.event_times["last_ammo"] = 0
    g.report("bot", [bot], 0 , 1000, {"only":false})
    var bot_action = load("res://scripts/bot_action.gd")
    for an in actions:
      if an.begins_with("D_Dodge_"):
        action_groups.dodge.append(an)
    for an in actions:
      add_action(an, bot_action.get(an).new())
    ordered_actions = actions.keys()
    ordered_actions.sort_custom(self, "action_order")

  func debug(msg, duration):
    if debug:
      gsvar.announce(msg, duration, "2")

  func add_action(an, inst):
    inst.name = an
    actions[an] = inst
    actions[an].manager = self
    actions[an].set_name(an)
    self.add_child(actions[an])
    actions[an].bot = bot
    actions[an].control = bot.control

  func action_order(a,b):
#    g.report("a,b", [a,b], 0 , -1, {"only":false})
    return actions[a].order < actions[b].order

  func has_target():
    return not g.is_null(bot.control.target_player)

  func should_reassess(s):
    if g.is_null(current) :
      return true
    if  force_assess:
      force_assess = false
      return true
    if not current_action().validate(s):
      return true
    if has_target() and bot.control.target_player.is_dying:
      return true
    if g.time_since(bot, "last_action_select", 200):
      return true
    if balls.empty():
      if current.begins_with("A_"):
        # print("bboya")
       return true
    return false

  func select_team():
    # var teamcols = [ "red", "green"]
    var hoops = {}
    common_state["hoops"] = hoops
    # hoops["south"] = bot.get_node("/root/world/env/hoopsouth")
    hoops["red"] = bot.get_node("/root/world/env/hoopsouth")
    # hoops["north"] = bot.get_node("/root/world/env/hoopnorth")
    hoops["green"] = bot.get_node("/root/world/env/hoopnorth")
    var other = "green"
    # var col = gsvar.players[bot.pid].tank_color
    var col = bot.tank_color
    # print("opppa", col, get_path())
    # team_color = col
    # var hoop
    if col == "green":
      other = "red"
    #   hoop = hoops["north"]
    # else:
    #   hoop = hoops["south"]
    var team = gsvar.teams[col]
    var vteam = gsvar.teams[other]
    common_state['team'] = team
    common_state['vteam'] = vteam
    common_state['hoop'] = hoops[col]
    common_state['vhoop'] = hoops[other]


  func update_common_state(s):
    upcs_bclosest(s)
    upcs_target(s)
    upcs_target_intent(s)

    pass

  func upcs_target(s):
    # target intents : brun, bthrow, bpass, threat, bsteal
    if cs.bclosest == cs.vtbclosest:
      cs["target"] = cs.vtbclosest
    else:
      cs["target"] = find_threat(cs.tbclosest)
    if cs.target != bot.control.target_player:
      bot.control.update_target(cs.target)
      force_assess = true

  func upcs_target_intent(s):
    if g.is_null(cs.target):
      cs["target_intent"] = null
      cs["target_intent_level"] = 0
    elif cs.target == cs.bclosest:
      if get_d(cs.target, cs.vhoop) < 400:
        cs["target_intent"] = "bthrow"
        cs["target_intent_level"] = 5 - (get_d(cs.target, cs.vhoop) / 100)
      else:
        cs["target_intent"] = "brun"
        cs["target_intent_level"] = (get_d(cs.target, cs.vhoop) / 150)
    else:
      if get_d(cs.target, cs.tbclosest) < 100:
        cs["target_intent"] = "bsteal"
        cs["target_intent_level"] = 5 - (get_d(cs.target, cs.tbclosest) / 20)
      else:
        cs["target_intent"] = "threat"
        cs["target_intent_level"] = 5 - (get_d(cs.target, cs.tbclosest) / 100)
    # v team has ball and bot is closest  => vtbclosest
    # bot has ball and vt player is threat => threat
    #
  func find_threat(tank):
    var d = 1000
    var min_d = 1000
    var res
    for vt in cs.vteam.values():
      d = get_d(vt, tank)
      if not vt.is_dying and d < min_d:
        res = vt
        min_d = d
    return res

  func upcs_bclosest(s):
    cs["tbclosest"] = find_closest_to_ball(cs.team.values())
    cs["vtbclosest"] = find_closest_to_ball(cs.vteam.values())
    cs["bclosest"] = find_closest_to_ball([cs["tbclosest"],cs["vtbclosest"]])

  func find_closest_to_ball(players):
    if balls.empty():
      return
    # return gsvar.me
    var d
    var min_ = 100000
    var res
    for player in players:
      if g.is_null(player):
        continue
      d = get_d(player, balls[0])
    #   # var player = gsvar.player_by_id(p)
      if not player.is_dying and  d < min_:
        min_ = d
        res = player
    return res

  func get_d(o1,o2):
    if typeof(o1) == 18: #Object
      o1 = o1.get_translation()
    if typeof(o2) == 18:
      o2 = o2.get_translation()
    return (o1 - o2).length()

  func select_action(s=null, group=null):
    # print("!!!!!",s.P.empty())
    # print("A")
    # if s.P.empty():
    #   return "A_Basket"
    var action
    update_common_state(s)
    g.scrn_dbg("situationz", s)
    if  should_reassess(s):
      # return current
      g.time_since_up(bot, "last_action_select")
#    print("aokw")
      var ratings = {}
      var sel
      cache.col = {}
      var select_from
      if g.is_null(group):
        select_from = actions
      else:
        select_from = action_groups[group]
      var skip
      for an in select_from:
        skip = false
        if not g.is_null( bot.control) and not g.is_null( bot.control.target_player):
          # print("bboyaq")
          # if bot.control.target_player.tank_color == bot.tank_color:
          #   if an.begins_with("K_"):
          #     # print("bboya")
          #     skip = true
          if not actions[an].validate(s):
            skip = true
          if balls.empty():
            if an.begins_with("A_"):
              # print("bboya")
              skip = true
        # if not skip and not g.is_null(action) and not action.validate(s):
        #   skip = true
        if skip:
          ratings[an] = 0
        else:
          action = actions[an]
          action.assess(s)
    #      if action.rating > 9999999.0:
    #        sel = an
    #        break
          ratings[an] = action.rating
      g.ss("action_ratings",ratings)
      if g.is_null(sel):
        var idx = _max(ratings.values())
        sel = ratings.keys()[idx]
      if sel != current and not g.is_null(current):
        actions[current].exit()
        # debug(sel, 1.5)
      # print("B")
      current = sel
      actions[current].enter()
    # print("C")
    action = actions[current]
#    var retarget = action.move_retarget(s)
    var retarget = false
    g.scrn_dbg("retarget", retarget)
    if not retarget:
      action.move(s)
      action.stabilize()
      action.fire(s)
    g.scrn_dbg("curact", current)
    #g.report("current action", [current], 0 , 1000, {"only":false})
    return current

  func force_action(action, hard=false):
    if hard or not current_action().dominant :
      current = action.get_name()

  func current_action():
    return actions[current]

  # return index of highest value
  func _max(ary):
    if ary.size() == 0:
      return null
    var idx = 0
    for i in range(ary.size()):
      if ary[i] > ary[idx]:
        idx = i
    return idx


# the current action should be reachable from all other actions

class BotAction:
  extends Node
  var name = ""
  var g = Globals.g
  var gsvar = Globals.gsvar
  var bot
  var control
  var select = [] # expected output. can include "speed", "turn" and "fire"
  var overrides = [] # list other actions which this one can override. always check this action's assess if any listed action is in progress
  var hints = []
  var success = null # null undefined - true success - false fail
  var current = false
  var rating = 0.0
  var manager
  var speed = 0.0
  var turn = 0.0
  var last_speed = 0.0
  var last_turn = 0.0
  var fire = false
  var delayed_fire = false
  var jump = false
  var move_map = {}
  var event_times = {"last_fire":0, "last_ammo":0, "last_reverse":0}
  var event_delays = {"last_fire":150}
  var last_col_check
  var basket_pos = Vector3(0,0,330)
  var fire_move = false
  var shot_limit = 3
  var order = 10
  var dominant = false
  var hoops = {}
  var team_color
  var team = []
  var vteam = []
  onready var ball = bot.get_node("/root/world/env/Ball")
  onready var balls = g.store_get("balls", [])
  onready var hoop
  onready var common = manager.common_state

  func _init():
    pass

  func _ready():
    if get_name().begins_with("K_"):
      hints.append("kill")
    hoops["south"] = bot.get_node("/root/world/env/hoopsouth")
    hoops["north"] = bot.get_node("/root/world/env/hoopnorth")
    # select_team()
    pass

  func validate(s):
    return true

  func assess(s=null):
    rating = 0.0

  func fire(s):
    if not s.P.has("inst"):
      return true
    var shots = bot.ammo.size()
    if shots > shot_limit-1:
      bot.ammo = []
      g.time_since_up(bot,"last_ammo")
    if s.P.inst.is_dying or not g.time_since(bot, "last_ammo", 3500):
      bot.ammo = []
      return true
    pass

  func delegate_move(an, s):
    manager.actions[an].move(s)
    speed = manager.actions[an].speed
    turn = manager.actions[an].turn

  func exit():
    pass

  func enter():
    pass

  func angle_to_point(tank, point):
    var v2 = g.xz(point - tank.control.situation.B.pos)
    return g.uniform_angle(tank.control.situation.B.dir2.angle_to(v2))

  func find_mate_id(player=bot):
    var t = gsvar.teams[player.tank_color]
    var ids = t.keys()
    ids.erase(player.pid)
    return ids[0]

  # func select_team():
  #   # var teamcols = [ "red", "green"]
  #   var other = "green"
  #   var col = gsvar.players[bot.pid].tank_color
  #   print("opppa", col, get_path())
  #   team_color = col
  #   if col == "green":
  #     other = "red"
  #     hoop = hoops["north"]
  #   else:
  #     hoop = hoops["south"]
  #   team = gsvar.teams[col]
  #   vteam = gsvar.teams[other]
  #   # team.remove(bot)


  # func get_teammates():
  #   var own_col = gsvar.players[bot.pid].tank_color
  #   team = g.store_get(own_col + "_team", [])
  #   if team.empty():
  #     for p in gsvar.players:
  #       if gsvar.players[p].tank_color == own_col:
  #         # team.append(gsvar.player_by_id(p))
  #         team.append(p)
  #   return team

  func get_d(o1,o2):
    if typeof(o1) == 18: #Object
      o1 = o1.get_translation()
    if typeof(o2) == 18:
      o2 = o2.get_translation()
    return (o1 - o2).length()

  func check_facing(dir, pos):
    if typeof(pos) == 18: #Object
      pos = pos.get_translation()
    return dir.dot(pos) > 0

  # func find_closest_to_balls(players):
  #   return gsvar.me
  #   var d
  #   var min_ = 100000
  #   var res
  #   for player in players:
  #     d = get_d(player, balls[0])
  #     # var player = gsvar.player_by_id(p)
  #     if not player.is_dying and  d < min_:
  #       min_ = d
  #       res = player
  #   return res

  func find_closest_to_ball(players):
    # return gsvar.me
    var d
    var min_ = 100000
    var res
    for player in players:
      if g.is_null(player):
        continue
      d = get_d(player, balls[0])
    #   # var player = gsvar.player_by_id(p)
      if not player.is_dying and  d < min_:
        min_ = d
        res = player
    return res

  func check_can_fire(s):
    if s.P.inst.is_dying or not g.time_since(bot, "last_ammo", 3500):
      return false
    else:
      return true

  func set_fire(ye):
    g.report("on set fire speed", [speed], 0 , -1, {"only":false})

    g.report("calling set fire", [g.t()], 0 , -1, {"only":false})
    fire = ye

  func set_delayed_fire(t=0.1):
    #gsvar.pause(true)
    delayed_fire = true
    g.object_timer("delayed_fire", self, "set_fire", true , t, [true])

  func fired(success=true):
    delayed_fire = false
    fire = false
    fire_move = false
    if success:
      g.time_since_up(bot, "last_fire")

  func move(s):
    pass

  func stabilize():
    if sign(speed) != sign(last_speed):
      g.time_since_up(self, "last_reverse")
      last_speed = speed
    if not g.time_since(self, "last_reverse", 200):
      speed *= 0.5
#    else:
##    if sign(turn) != sign(last_turn):
##      turn *= 0.5
#      last_speed = speed
#    last_turn = turn

  func move_close_in(s, ranges = [150,100,70]):
    var too_far_range = s.B2P.length() > ranges[0]
    var far_range = s.B2P.length() > ranges[1]
    var close_range = s.B2P.length() < ranges[2]
    if too_far_range:
  #    turn_to_shot_colliding(s, -0.3)
      speed = 1.0
    elif far_range:
  #    turn_to_shot_colliding(s, -0.2)
      # speed = 0.5
      speed = pow((abs(s.B2P.length() - ranges[1])) /  float(ranges[1]), 0.7)
    elif close_range:
  #    turn_to_shot_colliding(s, -0.5)
      # speed = -1.0
      speed = -pow((abs(s.B2P.length() - ranges[2])) /  float(ranges[2]), 0.7)
  #    stick_x = -stick_x
    else:
      speed = 0.0
    g.scrn_dbg("chase speed", [speed, randi()])


  func move_retarget(s):
    # if angle diff is bigger than threshold, then back off and turn till diff is within acceptable range
    var player_heading_goal = min(abs(s.P.rot), PI-abs(s.P.rot)) < PI/4
    if abs(s.B.ang) > PI/8 and s.dist < 110 and player_heading_goal:
      turn_to_pside(s,1)
      speed = -1
      return true
    return false

  func move_default_close_in(s):
    var shots = bot.ammo.size()
    if shots == 0 or shots == 2:
      move_lock(s, 0.0)
      move_close_in(s, [100,80,50])
    elif shots == 1:
      move_lock(s, 0.5)
      move_close_in(s, [100,80,50])
    pass

  func move_guard(s,guard_pos=Vector3(0,0,330)):
#    var target_pos = guard_pos
    var target_pos = bot.get_node("/root/world/env/Ball").get_translation()
    if s.P.has("pos"):
      target_pos = s.P.pos
    var target_dist = (target_pos - guard_pos).length()
    var middle_point = (target_pos - guard_pos) / 2.5 + guard_pos
    var mark = g.create_mark({ "pos":middle_point, "color":Color(1,1,0,0.2)}, "guard_point", true, false)
  #  g.colorify_object(mark, Color(1,1,0,0.2))
    move_stay_close_to(s, middle_point , 50)
    var ang = g.uniform_angle(s.B.dir2.angle_to(g.xz(target_pos - guard_pos)))
    g.scrn_dbg("guard_ang", ang)
    if abs(ang) > 0.01:

      turn = -sign(ang)

  func move_stay_close_to(s, dest, max_dist, keep_orientation=true):
      var B2dest = (dest - s.B.pos)
      var dist = B2dest.length()
      if dist < max_dist:
        return
      var rot = s.B.rot
      var ang = g.uniform_angle(rot - g.vec3rot(B2dest))
      if abs(ang) > PI/2:
        speed = -1.0
      else:
        speed = 1.0
      if dist < 50:
        speed = speed * (dist/100)

  func air_turn(angle=PI, second=false):
    if not bot.in_key_area:
      try_jump()
      # turn = 1
      g.object_timer("air_turn" + str(bot.pid), bot, "air_turn", true, 0.05 + (PI - angle)/(PI))
      if second:
        g.object_timer("air_turn2" + str(bot.pid), bot, "air_turn", true, 0.15)

  func turn_to_point(s,point):
    var ang = g.uniform_angle(s.B.dir2.angle_to(g.xz(point - s.B.pos)))
    if abs(ang) > 1.6:
      # air_turn(abs(ang)>2.1)
      air_turn()
    if abs(ang) > 0.02:
      turn = -sign(ang) * min(abs(8*ang/PI), 1)
    else:
      turn = 0
    return ang

  func move_to_point(s, point):
    var v2 = g.xz(point - s.B.pos)
    var ang = g.uniform_angle(s.B.dir2.angle_to(v2))
    if abs(ang) > 0.01:
      # turn = -sign(ang)
      turn = -sign(ang) * min(abs(ang)*2, 1)
      g.scrn_dbg("thisturn", turn)
    if abs(ang) > 2 and v2.length() > 40:
      air_turn(ang)
    var res = s.B.dir2.dot(v2)
    g.scrn_dbg("dfdf", [res,ang])
    move_stay_close_to(s, point, 0)
    if abs( PI - 2*abs(ang)) < 1.8 and v2.length() < 100:
      g.scrn_dbg("dfdfi", g.t())
      speed = -1
    elif abs( PI - 2*abs(ang)) < 1:
      g.scrn_dbg("dfdfijj", g.t())
      speed = -1

  func move_lock(s, lead=0.5):
  #    var numshots = ammo.size()
  #    var map = move_map.lock.lead
#      var lead = map[move_cur][numshots]
#      var lead = 0.5
  #    g.scrn_dbg("lock_lead", lead)
      var col_check = turn_to_shot_colliding(s, lead)
      return col_check

  func move_lock_point(s, lead=0.0, point=Vector2(0,330)):
      var col_check = turn_to_shot_colliding(s, lead, {"point":point})
      return col_check

  func move_lock_maxvel(s,lead=0):
    var col_check = turn_to_shot_colliding(s, lead, {"maxvel":true})
    return col_check

  func update_col_check(s):
    var col_check = new_check_colliding(s.B.pos2,s.P.pos2 - s.P.dir2/4 ,s.B.dir2 * 100, s.P.vel2, 0.5, true)
    last_col_check = col_check

  func turn_to_shot_colliding(s,lead=-0.2, params={}):
    var defaults = {"point":null, "maxvel":false}
    params = g.mergedicts(defaults, params)
    var pvel = s.P.vel2
    var on_point_side = true
    if params.maxvel and true:
      pvel = pvel.normalized() * bot.max_speed
      if s.P.vel2.dot(s.P.dir2) < 0:
        pvel = pvel / 2
    if not g.is_null(params.point):
      if pvel.dot(params.point - s.P.pos2) < 0:
        on_point_side = false
        pvel = -pvel
  #  g.report("label", [s], 0 , 1000, {"only":false, "out_mode":"screen"})
  #  lead = -0.0
    var col_check = new_check_colliding(s.B.pos2,s.P.pos2 - s.P.dir2/4 ,s.B.dir2 * 100 + Vector2(s.B.vel2.x,s.B.vel2.y)/2, pvel, lead)
    col_check["on_point_side"] = on_point_side
    var speeding_side = sign(s.B.dir2.dot(pvel))
    speeding_side = -s.P.side
#    speeding_side = -sign(s.B2P.dot(s.P.vel2))
    var mark
    var color
    var label = ""
    # g.scrn_dbg("turn to col", randi())
    # g.scrn_dbg("situationz", s)

    if col_check.crossing:
      g.scrn_dbg("lost track", false)
      var cur_lead = col_check.ta - col_check.tb
      var mark_pos = g.v2tov3( col_check.point)
      if abs(cur_lead - lead) < 0.01:
        # we're good
        turn = 0.0
      elif cur_lead - lead < 0:
        turn = speeding_side
        # much lead
      else:
        turn = -speeding_side
      # much lag
    else:
      g.scrn_dbg("lost track", true)
      # manager.debug(["lost track", bot.stick_x], 1)
      color = Color(1,1,1,0.8)
      label = "lost track"
      if abs(s.B.ang) < 0.1:
        turn = -s.P.side
      else:
        turn = -s.P.side
    if s.B.absang > 1.2:
      speed = 0
      air_turn()
    last_col_check = col_check
    g.scrn_dbg("crossing", last_col_check.crossing)
    g.scrn_dbg("colliding", last_col_check.colliding)
    return col_check

# given points a,b velocities av,bv check if objects would collide
  func new_check_colliding(a,b,av,bv, t, any_leading=false):
    var hsh = hash([a,b,av,bv,t,any_leading])
    if manager.cache.col.has(hsh):
      g.report("cache hit", [hsh], 0 , 1000, {"only":false})
      return manager.cache.col[hsh]
    var r = {"colliding":false,"straight":false, "crossing":false, "ta":null, "tb":null, "td":null, "point":null}
    if true or bv.length() < 3:
      "compare _a speed to ab vector"
      var avrot = g.vec2rot(av)
      var abrot = g.vec2rot(b-a)
      if abs(avrot - abrot) < 0.05:
        # manager.debug("straight", 0.5)
        r.straight = true
        r.crossing = true
        r.colliding = true
        r.tb = (b-a).length() / av.length()
        r.ta = r.tb
        r.point = b
        r.td = 0
        return r
    if bv.length() < 20:
      bv = bv * 20/(bv.length()+1)
    var length = 3.0
    var intersection = Geometry.segment_intersects_segment_2d( a, a+av*length, b, b+bv*length)
    if typeof(intersection) == TYPE_VECTOR2:
      r.crossing = true
      r.ta = (intersection - a).length() / av.length()
      r.tb = (intersection - b).length() / bv.length()
      r.td = r.ta - r.tb
      r.point = intersection
#      if abs(r.ta - r.tb) < 0.1:
      if abs(r.ta - r.tb) < t:
        r.colliding = true
    manager.cache.col[hsh] = r
    return r

  func time_since(event, t=-1, update=false):
    if t == -1:
      t = event_delays[event]
    var times = event_times
    if OS.get_ticks_msec() - times[event] > t:
  #    g.report("trigger event", [event, t, times[event],OS.get_ticks_msec()], 0 , 0, {"only":true})
      if update:
        times[event] = OS.get_ticks_msec()
  #      time_since_up(event)
  #      event_times[event] = OS.get_ticks_msec()
      return true
    return false

  func time_since_up(event):
    var times = event_times
    event_times[event] = OS.get_ticks_msec()

  func turn_to_pside(s, ratio):
    turn = -ratio * s.P.side
    pass

  func try_jump():
    if g.time_since(bot, "last_jump", 1000, true) :

      g.chreport("turn/stick", [turn, bot.stick_x], 0 , -1, {"only":false})
      bot.try_jump_once = true

  func cache(key):
    return manager.cache[key]

  func cache_set(key, value):
    manager.cache[key] = value

  func has_target():
    return not g.is_null(control.target_player)
#D_ defence
#A_ attack
#N_ neutral


# D_deobstruct, D_

class D_deobstruct:
  extends BotAction
  var locked = false
  func _ready():
    bot.event_times["last_obstacle_locked"] = 0
    bot.event_times["last_obstacle"] = 0
    pass

  func assess(s):
    rating = -20
    if bot.control.cur_obstacles.size() > 0:
      var sealed = manager.current_action().speed != 0 and s.B.vel2.length() < 0.2
      if sealed:
        rating = 5000

    pass

  func fire(s):
    pass

  func move(s):
    if not g.time_since(bot, "last_obstacle_locked", 2000):
      return
    if not g.time_since(bot, "last_obstacle", 2000):
      return
    var obst_sum = [0,0]
    for o in bot.control.cur_obstacles:
      obst_sum[0] += o[0]
      obst_sum[1] += o[1]
    speed = -sign(obst_sum[0])
    turn = -sign(obst_sum[1]) * g.randsign()
    if speed == 0 and turn == 0:
      speed = 1
      g.time_since_up(bot, "last_obstacle_locked")
#    move_guard(s)
    pass

class D_reenter:
  extends BotAction
  var checkpoint1 = false
  var checkpoint2 = false
  var dest_point
  func _init():
    pass
#  func stabilize():
#    pass
  func assess(s):
    if (abs(s.B.pos2.x) > 240) or (checkpoint1 and not checkpoint2):
      rating = 3500
      if checkpoint1:
        rating = 5000
    else:
      checkpoint1 = false
      checkpoint2 = false
      rating = -20
    pass

  func fire(s):
    pass

  func move(s):
    if checkpoint1:
      dest_point = Vector3(200 * sign(s.B.pos2.x),0, 385)
      if (s.B.pos - dest_point).length() < 40:
        checkpoint2 = true
    else:
      dest_point = Vector3(320 * sign(s.B.pos2.x),0, 360)
      if (s.B.pos - dest_point).length() < 20:
        checkpoint1 = true
    move_to_point(s, dest_point)
    g.create_mark({"pos":dest_point, "arrow":false, "label":"reenter dest"}, "reenter_dest", true)


class A_default:
  extends BotAction
  func _init():
    pass

  func assess(s):
    rating = 20
    pass

  func fire(s):
    pass

  func move(s):
    turn = 1
#    move_guard(s)
    pass

class KillAction:
  extends BotAction
  func _init():
    pass

  func validate(s):
    # if not s.B.has('side'):
    if g.is_null(s.P):
      return false
    # print("valid kill act")
    return true

  func assess(s):
    rating = 20
    pass

  func fire(s):
    pass

  func move(s):
    turn = 1
#    move_guard(s)
    pass


class A_Basket:
  extends BotAction

  var press=false
  var thrown=false
  var owned = false


  func _ready():
    # hoops["south"] = bot.get_node("/root/world/env/hoopsouth")
    # hoops["north"] = bot.get_node("/root/world/env/hoopnorth")
    # select_team()
    pass


  func assess(s):
    # if get_d(bot, hoops["south"]) > get_d(bot, hoops["north"]):
    #   hoop = hoops["north"]
    # else:
    #   hoop = hoops["south"]

    var d = get_d(bot, common.hoop)
    var db = get_d(bot, balls[0])
    # if ((balls[0].owner == bot.pid) or (db < 100)) and d < 1350 and d > 150:
    if common.bclosest == bot and d < 1350 and d > 150:
      # manager.debug("omm", 1)
      rating = 3200
      if d < 300:
        rating += min(100 * (300.0/d), 500)
      if abs(s.B.hoopang) < 1:
        rating += 100
    else:
      rating = 0
    pass

  func fire(s):
    pass

  func catch(s):
    if balls[0].owner == bot.pid and owned:
      return false
    if not balls[0].owner == bot.pid :
      if owned:
        exit()
        return true
      input_press()
      delegate_move("A_BallGrab", s)
      # var grab = manager.actions.A_BallGrab
      # grab.move(s)
      # speed = grab.speed
      # turn = grab.turn
      return true
    elif not owned:
      # gsvar.announce(["reeelease"], 2,"2")
      input_release()
      owned = true
    return true

  func move(s):
    if catch(s):
      # catch(s)
      return
    # if owned and :

    var point = common.hoop.get_translation()
    var d = g.xz(point - s.B.pos).length()
    var a = turn_to_point(s,point)
    if (abs(a) < 0.02 and bot.phys.resting) or press:
      turn = 0
      if not press:
        try_jump()
      throw()
    if (bot.get_translation() - point).length() > 200:
      speed = 1
    else:
      speed = 0
    pass

  func throw(label="basket", target_point=null):
    if not press and not thrown:
      press = true
      balls[0].throw_press()
    # print(g.time_elapsed(balls[0], "last_bang_basket"))
    if press:
      g.eval_context().throw_vis(balls[0].cur_power(), label, target_point)
    if press and g.time_elapsed(balls[0], "last_bang_"+label) < 100 and balls[0].owner == bot.pid:
      balls[0].throw_release()
      press = false
      thrown = true
      # exit()

  func input_press():
    if not press and not thrown:
      press = true
      balls[0].input_throw_pressed.append(bot.pid)

  func input_release():
      balls[0].input_throw_pressed.erase(bot.pid)
      press = false

  func short_pass():
    if press and not thrown:
      balls[0].throw_release()
      press = false
      thrown = true
    if not press and not thrown:
      press = true
      balls[0].throw_press()
    # print(g.time_elapsed(balls[0], "last_bang_basket"))

  func exit():
    manager.debug("exit basket",1)
    input_release()
    thrown=false
    press=false
    owned = false

  # func enter():
  #   thrown=false
  #   press=false
  #   owned = false



class A_BallGrab:
#  extends BotAction
  extends A_Basket

  func _init():
    pass

  func assess(s):
    if balls[0].owner == -1 and common.bclosest == bot :
    # if balls[0].owner == -1 and closest_to_ball(true, -100):
      rating = 2000 #2100
    else:
      rating = 0
    pass

  func closest_to_ball(include_human=false, margin=0):
    var d = get_d(bot, balls[0])
    for p in gsvar.players:
      var player = gsvar.player_by_id(p)
      if not player.is_dying and p != bot.pid and get_d(player, balls[0]) - d < margin:
        if not include_human and p == 1:
          continue
        return false
    return true

  func fire(s):
    pass

  func move(s):
    var point
    if balls[0].resting:
      point = balls[0].get_translation()
    elif balls[0].leader_ball.motion_path.size() > 0:
      point = balls[0].leader_ball.motion_path[-1][1]
    else:
      point = balls[0].get_translation()
    var d = g.xz(point - s.B.pos).length()
    var a = turn_to_point(s,point)
    if abs(a) < 0.1:
      speed = 1
    else:
      # speed = 0.0 + (d/100.0)
      speed = -randf()#0.0
    # manager.actions.D_Elude.move(s)
    pass

class A_BallWait:
#  extends BotAction
  extends A_Basket

  func _init():
    pass

  func assess(s):
#    if balls[0].owner != bot.pid and not closest_to_ball(false):
    rating = 0
    return
    if balls[0].owner != bot.pid:
      rating = 1900
    else:
      rating = 0
    pass

  func fire(s):
    pass

  func move(s):
    var point = Vector3()
    var d = g.xz(point - s.B.pos).length()
    var a = turn_to_point(s,point)
    if abs(a) < 0.05:
      speed = 1
    else:
      speed = 0.1 + (d/200.0)
    if d < 1:
      speed = 0
    pass

class A_BallWander:
#  extends BotAction
  extends A_Basket
  var destination=Vector3()
  func _init():
    pass

  func assess(s):
#    if balls[0].owner != bot.pid and not closest_to_ball(false):
    if balls[0].owner != bot.pid:
      rating = 0#2000
    else:
      rating = 0
    pass

  func fire(s):
    pass

  func move(s):
    var d = g.xz(destination - s.B.pos).length()
    var a = turn_to_point(s,destination)
    if abs(a) < 0.05:
      speed = 1
    else:
      speed = 0.1 + (d/200.0)
    if d < 10:
      new_dest()
      speed = 0
    pass

  func new_dest():
    var r = 200
    destination = Vector3(0.5 * (g.randsi()%r),0,randi()%r)

class A_BallSteal:
#  extends BotAction
  extends A_Basket
  var destination=Vector3()
  func _init():
    pass

  func assess(s):
#    if balls[0].owner != bot.pid and not closest_to_ball(false):

    if balls[0].owner != bot.pid and balls[0].owner != -1:
      var same_team = (gsvar.players[balls[0].owner].tank_color == team_color)
      # if not same_team:
      #   control.update_target(gsvar.player_by_id(balls[0].owner))
      rating = 000
    else:
      rating = 0
    pass

  func fire(s):
    pass

  func move(s):
    var d = g.xz(destination - s.B.pos).length()
    var a = turn_to_point(s,destination)
    if abs(a) < 0.05:
      speed = 1
    else:
      speed = 0.1 + (d/200.0)
    if d < 10:
      new_dest()
      speed = 0
    pass

  func new_dest():
    var r = 200
    destination = Vector3(0.5 * (g.randsi()%r),0,g.randsi()%r)


class A_BallPass:
#  extends BotAction
  extends A_Basket
  var teammate
  var target

  func _init():
    pass
  func own_ball():
    return balls[0].owner == bot.pid

  func assess(s):
    rating = 0
    return
#    if balls[0].owner != bot.pid and not closest_to_ball(false):
    if own_ball() and teammate_in_position(s):
      rating = 3300
    else:
      rating = 0
    pass

  func fire(s):
    pass

  func move(s):
    # turn_to_shot_colliding(s, -5)
    # move_lock_maxvel(s)
    # var point = teammate.get_translation()
    # hoop = hoops["north"]
    # if not check_facing(s.P.dir, hoop):
    #   hoop = hoops["south"]
    var d
    if not press:
      # var point = calc_target_dest(s, 1.2, true)
      # var point = s.P.pos +(( g.xnz(hoop.get_translation()) - s.P.pos) * 0.5)
      var p_moving_to_b = false
      var pbvec = hoop.get_translation() - s.P.pos
      if s.P.vel.dot(pbvec) > 0 and s.P.vel.dot(s.P.dir) > 0 :
        p_moving_to_b = true
        # manager.debug("weead",1)
      var rndm
      if p_moving_to_b:
        rndm = 0.6 +(randf() * 0.3)
      else:
        rndm = (randf() * 0.5)
      var point = s.P.pos +(( g.xnz(hoop.get_translation()) - s.P.pos) * rndm)
      var d1 = g.xz(point - s.B.pos).length()
      # gsvar.announce([point, point * pow(d1/400.0, 0.8)], 1)
      point =  s.B.pos + ((point - s.B.pos) * (1-(d1/2400.0)))
      target = point
    var d = g.xz(target - s.B.pos).length()
    var a = turn_to_point(s,target)
    var d2b = get_d(target, hoop)
    var a2b = abs(s.P.dir2.angle_to(g.xz(hoop.get_translation()) - s.P.pos2))
    # print(a2b)
    # var facing = check_facing(s.P.dir, hoop)
    g.scrn_dbg("pass move", [d2b])
    # if press or (abs(a) < 0.1 and d2b < 200 and a2b < 0.1):
    if press or (bot.phys.on_floor and abs(a) < 0.1 and d2b < 2000 and a2b < 4):
      if d > 100:
        manager.debug("far!!", 0.5)
        balls[0].throw_low=true
      throw("pass", target)
      speed = 0.5
    else:
      speed = 0.1 + (d/100.0)
    pass

  func calc_target_dest(s, t=3, maxv=false):
    var v = s.P.vel
    if maxv:
      v = v.normalized() * gsvar.normal_max_speed
    var d = s.P.pos + t * v
    return d


  func teammate_in_position(s):
    # teammate = gsvar.me
    teammate = team[0]
    # var srel = s.rel[teammate.pid]
    var p = teammate.control.situation
    var pbvec = hoop.get_translation() - p.B.pos
    # if p.B.vel.dot(pbvec) > 0 and p.B.vel.dot(p.B.dir) > 0 :
    if p.B.dir.dot(pbvec) > 0 and pbvec.length() < 300:
      # p_moving_to_b = true
      # manager.debug("weead",1)
      return true
    return false

  # func enter():
  #   control.update_target(teammate)

  func exit():
    .exit()
    teammate=null
    target=null

class A_BallRun:
#  extends BotAction
  extends A_Basket
  var target = Vector3()
  var final_target = Vector3()
  func _init():
    pass
  func own_ball():
    return balls[0].owner == bot.pid

  func locate_safe_point(s):
    var own_color  = gsvar.players[bot.pid].tank_color
    for p in gsvar.players:
      if gsvar.players[p].tank_color != own_color:
        # check if they are in path to target, and if so find another target
        # if there are no safe routes, take on the nearest opponent by setting manager target
        pass
    # manager.debug(s.rel[1].dist, 1)
    pass

  func assess(s):
#    if balls[0].owner != bot.pid and not closest_to_ball(false):
    if own_ball():
      rating = 2200
    else:
      rating = 0
    pass

  func fire(s):
    pass

  func move(s):
    # turn_to_shot_colliding(s, -5)
    # move_lock_maxvel(s)
    # var point = teammate.get_translation()
    # hoop = hoops["north"]
    # if not check_facing(s.B.dir, hoop):
    #   hoop = hoops["south"]
    var target = common.hoop.get_translation()
    var dh = g.xz(target - s.B.pos).length()
    # final_target = point
    # locate_safe_point(s)
    if dh < 150:
      target = Vector3()
    var d = g.xz(target - s.B.pos).length()
    var a = turn_to_point(s,target)
    # var a2b = abs(s.P.dir2.angle_to(g.xz(hoop.get_translation()) - s.P.pos2))
    # print(a2b)
    # var facing = check_facing(s.P.dir, hoop)
    if (abs(a) < 0.1):
      manager.debug([press,thrown], 1)
      if d > 320:
        short_pass()
      speed = 1
    else:
      speed = 0.1 + (d/100.0)
    # manager.actions.D_Elude.move(s)
    pass


  func enter():
    pass

  func exit():
    .exit()
    pass

class K_surround:
  extends KillAction
  var obstacles = {"bots":{}}
  func _init():
    pass

  func stabilize():
    pass

  func assess(s):
    if not s.P.has("inst"):
      rating = 0
      return
    check_obstacles(s)
#    var clear_path = check_is_closest_tank_to_traget(s) or check_no_tank_obstructing(s)
    if not obstacles.bots.empty():
      g.report("surround", [bot.pid, obstacles], 2 , -1, {"only":false})
      rating = 0 # 1000
    else:
      rating = 0
      pass

  func check_obstacles(s):
    obstacles.bots = {}
    if not s.P.has("inst"):
      return false
    for b in gsvar.bots:
      if b.pid == bot.pid:
        continue
      var bs = b.control.situation
      if not bs.P.has("inst"):
        continue
      g.scrn_dbg("surround_check/" + str(bot.pid), [abs(s.BProt - bs.BProt) * bs.dist / 70 , bs.dist])
      if s.dist > bs.dist and abs(s.BProt - bs.BProt) * bs.dist / 70 < 0.3:
        obstacles.bots[b.pid] = bs



  func fire(s):
    pass

  func move(s):
    turn = 0
    speed = 0
#    return
    if obstacles.bots.empty():
      g.report("no obstacles found", [], 0 , 1000, {"only":false})
      turn = 1
      speed = 0
      return
    var side = sign(obstacles.bots.values()[0].B.rot - s.B.rot)
    if s.B.absang < 0.4:
      turn = side
      speed = 0.75
    else:
      turn = -side
      speed = 0.5
#    move_to_point(s, Vector3())
#    turn_to_pside(s, -1.0)
#    move_close_in(s, [180,150,100])
#    move_guard(s)
    pass

class D_default:
  extends BotAction
  func _init():
    pass

  # func enter():
  #   # var t = find_closest_to_ball(vteam.values())
  #   control.update_target(common.vtbclosest)

  func assess(s):
    rating = 30
    pass

  func fire(s):
    pass

  func move(s):
    turn = 1
#    move_guard(s)
    pass

class C_threat_level:
  extends BotAction
  var level = {}
  var other_team=""
  func _ready():
    if bot.tank_color == "red":
      other_team = "pink"
    else:
      other_team = "red"
    set_process(true)

  func opponent_team():
    return gsvar.teams[other_team]

  func _process(delta):
    # assign threat level to each player from opponent team
    for p in opponent_team():
      level[p] = 0
    # print(level)

class D_DodgeCommon:
  extends BotAction
#  var watched_bullets = {}
  var current_daner_rating = 0
  func _init():
    pass

  func _ready():
    set_process(true)

  func _process(delta):
    # if not control.situation.P.has("inst") :
    #   return
    update_bullets(control.situation)
    var watched_bullets = cache("bullets")
    manager.danger=false
    for b in watched_bullets:
      if not watched_bullets[b].safe:
#        manager.force_action(self)
        manager.danger=true
        print("uptarg")
        control.update_target(gsvar.player_by_id( watched_bullets[b].owner), "dodge")
        return
        manager.select_action(control.situation, "dodge")


  func update_bullets(s):
#    { bullet:{"safe":bool, "col":colcheck} }
    var new_dbs = {}
    var watched_bullets = cache("bullets")
    # for i in watched_bullets:
    #   if not gsvar.missiles.has(i):
    #     watched_bullets.erase(i)

    for i in gsvar.missiles:
      var bullet = gsvar.missiles[i]
      # skip own bullet
      if bullet.owner == bot.pid:
        continue
      # update known bullet
      if watched_bullets.has(i):
        new_dbs[i] = watched_bullets[i]
        # skip safe bullet
        if new_dbs[i].safe:
          continue
        # bullet heading away, mark it safe and continue
        if g.xz(bullet.get_linear_velocity()).dot(s.B.pos2 - g.xz(bullet.get_translation())) < 0:
          new_dbs[i].safe = true
          continue
      # evaluate danger of bullet
      var ang = -g.xz(bullet.get_linear_velocity()).angle_to(s.B.pos2 - g.xz(bullet.get_translation()))
      var dist = (s.B.pos2 - g.xz(bullet.get_translation())).length()
      var col_dist = sin(ang) * dist
      if abs(col_dist) < 30:
        var rel_p = s.rel[bullet.owner]
        if g.is_null(rel_p):
          print("how empty")

        new_dbs[i] = {"safe":false, "col_dist":col_dist*rel_p.P.side, "dist":dist, "vel":g.xz(bullet.get_linear_velocity()), "ang":ang, "owner":bullet.owner}
      else:
        new_dbs[i] = {"safe":true}
#      var start_point = -d along motion path
#      motion path s perpendicular to bullet_pos - B.pos and passing thru B.pos
#      var col = new_check_colliding(g.xz(bullet.get_translation()), s.B.pos2, g.xz(bullet.get_linear_velocity()), s.B.vel2, 10.1)
#      if col.crossing:
#        new_dbs[i] = {"safe":false}
    cache_set("bullets",  new_dbs)
    if not new_dbs.empty():
#      g.store_get(["tank_info_extra", bot.pid], {})["danger"] = new_dbs
      pass

class D_Dodge_1:
  extends BotAction
#  var watched_bullets = {}
  var current_daner_rating = 0
  func _init():
    pass

  func _ready():
    pass
#    set_process(true)

#  func _process(delta):
#    update_bullets(control.situation)
#    for b in watched_bullets:
#      if not watched_bullets[b].safe:
#        manager.force_action(self)

  func assess(s):
#    if g.is_null(control.target_player):
#      rating = 0
#      return
    if manager.danger:
      rating = 3000
    else:
      rating = 0
#    var watched_bullets = cache("bullets")
#    for b in watched_bullets:
#      if not watched_bullets[b].safe:
#        rating = 1000
#        return
#
#    rating = 10
    pass

  func fire(s):
    pass

  func move(s):
    # speed = 0
    # turn = 0
    var min_danger_rating= 10000
    var danger_rating = 0  # the higher the less dangerous
    var min_cd = 100
    var num = -1
    var watched_bullets = cache("bullets")
    for b in watched_bullets:
      var bi = watched_bullets[b]
      if bi.safe:
        continue
      # is it deadly close
      g.scrn_dbg("dang", PI - abs(g.uniform_angle(s.B.dir2.angle_to(bi.vel))))
      var head_ang = PI - abs(g.uniform_angle(s.B.dir2.angle_to(bi.vel)))
      var back_ang = PI - head_ang
      # manager.debug(["bul ang",head_ang,back_ang], 1)
      # manager.debug(["bul ",bi], 1)
      print(["bul ",bi.ang, bi.dist,head_ang,back_ang ])
      if bi.dist < 150 and abs(bi.ang) < 0.3 and (head_ang < 0.3 or back_ang < 0.3):
      # if bi.dist < 150 and abs(bi.ang) < 0.2:
        # manager.debug(["deadly"], 1)

        # turn = -sign(s.B.dir2.angle_to(bi.vel))
        turn = sign(bi.ang)
        speed = -1
        return
      # if abs(bi.col_dist) < 10 and (head_ang < 0.2 or back_ang < 0.2):
      #   turn = -sign(s.B.dir2.angle_to(bi.vel))
      #   speed = -1
      #   try_jump()
#        g.report("danger!!!", [], 0 , -1, {"only":false})
      danger_rating =  bi.col_dist * pow(bi.dist, 1.5)
      num += 1
#      return
#      if (num > 0 and bi.dist < 80) and bi.col_dist < min_cd:
      if danger_rating < min_danger_rating and has_target():
        min_danger_rating = danger_rating
        speed = -10.0 / bi.col_dist
        speed = sign(speed)
        # manager.debug(["escape speed", speed], 1)
        # turn_to_pside(s,5 * (abs(s.P.ang) - 0.1))
        turn_to_pside(s,1)
      # speed = 0
      # turn = 0
#    move_guard(s)
    pass



class D_Elude:
  extends BotAction
  var player
  func _init():
    pass

  func assess(s):
    player = gsvar.me
    rating = 0
    return
    for p in s.rel:
      if gsvar.teams[bot.tank_color].has(p):
        continue
      var rs = s.rel[p]
      # manager.debug([s.rel.keys(), rs.P.ang],2)
      # return
      var pinst = gsvar.player_by_id(p)
      if pinst.is_dying:
        continue
      var less_ang =  abs(rs.P.ang) < abs(rs.B.ang)
      var low_ang = abs(rs.P.ang) < 0.3
      var close = rs.dist < 100
      if low_ang and less_ang and close:
        rating = 2330
        player = pinst
        return
    rating = 0
    return
#    if s.P.has("inst") and not check_can_fire(s) and s.P.absang < s.B.absang:
    if s.P.has("inst")  and s.P.absang < s.B.absang and s.P.absang < 0.15 :
      rating = -500
#      rating = 0
    else:
      rating = 0
    pass

  # func enter():
  #   control.update_target(player)

  # func exit():
  #   player = null
  #   control.update_target(player)

  func fire(s):
    .fire(s)
    pass

  func move(s):
    if not s.P.has("inst"):
      return
    # control.update_target(gsvar.me)
    # manager.debug(s.P.keys(),1)
    # return
    speed = 0
    turn = 0
    # return
    # var less_ang = true or abs(s.P.ang) < abs(s.B.ang)
    # var low_ang = abs(s.P.ang) < 0.4
    # if low_ang and less_ang:
      # manager.debug(["cond met", s.P.ang, s.B.ang], 1)
    if  abs(s.B.ang) - abs(s.P.ang) < PI/4 :
      if abs(s.P.ang) > 0.2:
        turn_to_pside(s, 1.0)
      else:
        turn_to_pside(s, -1.0)
      # speed = -1
    # elif sign(s.B.ang) == sign(s.P.ang):
    #   speed = 1
    #   turn_to_pside(s, -1.0)
    # else:
    #   speed = -1
    #   turn_to_pside(s, 1.0)
#     return
#     if abs(s.P.ang) > 0.2:
#       turn_to_pside(s, 1.0)
#       move_close_in(s, [100,80,50])
# #      speed = 1
#     else:
#       turn_to_pside(s, -1.0)
#       move_close_in(s, [150,150,150])
#     if abs(s.B.ang) > PI/4:
#       turn = 0
#     if sign(s.P.ang) == sign(s.B.ang) and abs(s.P.ang) < 0.05 and abs(s.B.ang) < 0.3:
#       speed = 1
#       turn_to_pside(s, -1.0)
#       g.report("x", [], 0 , 100, {"only":false})
#     if control.rel_change("P", "absang") < 0:
#       speed = - speed
# #      turn = - turn

# #      speed = -1
# #    move_guard(s)
#     pass


class K_cut:
  # extends BotAction
  extends KillAction
  var target_angle_diff = 100
  var wait_for_0 = false
  func _init():
    order = 0
    pass

  func assess(s):
    rating = 0
    if s.P.empty():
      return
    # print(s.P)
    if min(abs(s.P.ang), PI - abs(s.P.ang)) > 0.55:
      # if not s.P.has("inst") or s.P.target_mode != "attack":
      #   control.update_target(gsvar.me)
      rating = 000 #-10
    return
    # if s.P.inst.is_dying:
    #   control.update_target(null)
    #   rating = 0
    #   return
#    rating = 500
#    return
    if abs(s.P.ang) > PI/8 and s.B.ang < PI/8:
      rating = 1000
    else:
      rating = 0
    pass

  func fire(s):
    # return
#    return
    if .fire(s) == true:
      return
    if wait_for_0:
      return
    if abs(target_angle_diff) < 0.01 and g.time_since(bot, "last_fire", 150, true):
      fire = true
    return
    # if bot.ammo.size() > 0:
    #   if abs(s.B.rot - bot.ammo[-1].meta.s.B.rot) < 0.03:
    #     manager.debug("narrow", 1.5)
    #     return
    #   if s.B.rot - bot.ammo[-1].meta.s.B.rot > 0.4:
    #     manager.debug("wide", 1.5)
    #     return
    # var shots = bot.ammo.size()
    # if shots == 0 and g.time_since(bot, "last_fire", 100, true) and last_col_check.crossing:
    #   fire = true
    #   manager.debug("1st", 1.5)
    # elif shots == 1 and g.time_since(bot, "last_fire", 20, true) and last_col_check.crossing:
    #   fire = true
    #   manager.debug("2nd", 1.5)
    # elif shots == 2 and not g.time_since(bot, "last_fire", 250, true) and last_col_check.crossing:
    #   manager.debug("3rd", 1.5)
    #   fire = true
    # if fire==true:
    #   speed=1
    # pass

  func move(s):
#    move_default_close_in(s)
#    return
    move_lock(s, 0)
    # return
    # turn = 0
    var shots = bot.ammo.size()
    if shots == 0:
      # manager.debug("back to zero", 1)
      move_lock(s, -0.2)
      wait_for_0 = false
      # move_close_in(s, [80,60,50])
      move_close_in(s, [150,120,100])
    elif shots == 1:
      # manager.debug("1", 1)
      move_lock(s, -0.75)
      # move_close_in(s, [70,60,60])
      move_close_in(s, [150,120,100])
    elif shots == 2:
      # manager.debug("2", 1)
      move_lock(s, -1.3)
    elif shots == 3:
      # manager.debug("wait til zero", 0.1)
      wait_for_0 = true
      # move_close_in(s, [70,60,60])
      move_close_in(s, [150,120,100])
#    stabilize()
    pass

  func move_lock(s, lead=null):
    if g.is_null(lead):
      lead =  g.store_get("lead", 0)
    var diviation = min(abs(s.P.ang), PI - abs(s.P.ang))
    lead = lead / clamp(diviation, 0.1, 1.1)
    # print(diviation)
    # if abs(s.P.ang) < 0.5 or PI - abs(s.P.ang) < 0.8:
    #   lead *= 2
    #   manager.debug("n angle", 1)
    # lead *= clamp(70.0 / s.dist, 0.1, 1)
    var r = (1+lead) * 70/180.0
    var adiff = s.B.ang - asin(sin(-s.P.ang)*r)
    turn = sign(adiff)
    if abs(adiff) > PI/3:
      air_turn()

    target_angle_diff = adiff
    # manager.debug([turn, bot.stick_x],1)
    # manager.debug([bot.stick_x,adiff, lead,g.store_get("lead", 0)],1)
    # s.P.ang
    # var d = s.P.dist
    # var t = d / gsvar.normal_max_speed
    # var point = s.P.pos + s.P.vel * lead

class K_chase:
  extends KillAction

  func _init():
    order = 0
    pass

  # func validate(s):
  #   if not s.B.has('side'):
  #     return false
  #   return true
  # func enter():
  #   # var t = find_closest_to_ball(vteam.values())
  #   control.update_target(common.vtbclosest)

  func assess(s):
    # if balls[0].owner == -1:
    if validate(s) and get_d(common.vtbclosest, common.vhoop) > 350:
      rating = 10000
    else:
      rating = 0

  func validate(s):
    if not .validate(s):
      return false
    if g.is_null(common.vtbclosest):
      return false
    return true

  func fire(s):
    pass

  func move(s):
    # move_guard(s)
    move_to_point(s, Vector3())
    # move_close_in(s, [200,100,100])
    # move_lock(s, -0.4)
    # move_lock_point(s, 0, g.xz((s.P.pos + common.vhoop.get_translation()) / 2.0))
    var d = common.vhoop.get_translation() - s.P.pos
    # turn_to_point(s, s.P.pos + g.vec3pow(d/30.0, 2))
    turn_to_point(s, s.P.pos + d.normalized()*80)

class K_chase_ball:
  extends KillAction

  func _init():
    order = 0
    pass

  # func validate(s):
  #   if not s.B.has('side'):
  #     return false
  #   return true
  # func enter():
  #   # var t = find_closest_to_ball(vteam.values())
  #   control.update_target(common.vtbclosest)

  func assess(s):
    # if balls[0].owner == -1:
    var shots = bot.ammo.size()
    if shots  == 2:
      pass
    if validate(s):
      rating = 2000
    else:
      rating = 0

  func validate(s):
    if not .validate(s):
      return false
    if g.is_null(common.vtbclosest):
      return false
    return true

  func fire(s):
    if common.target_intent == "bthrow" and  s.dist < 200 and s.B.absang < 0.3 and g.time_since(bot, "last_fire", 400, true):
      fire = true
    pass

  func get_aim(p=bot):
    return Vector3(sin(p.body_rotation),0,cos(p.body_rotation))

  func get_ball_rel(s):
    var rel = {}
    rel["point"] = balls[0].get_translation()
    rel["v3"] = rel.point - bot.get_translation()
    rel["d"] = rel.v3.length()
    rel["d2"] = g.xz(rel.v3).length()
    rel["dy"] = rel.v3.y
    rel["ball_leading"] = (rel.v3.dot(get_aim()) > 0) and rel.d2 > 17
    return rel

  func move(s):
    # move_guard(s)
    # speed = 0
    # turn = 0
    # return
    g.scrn_dbg("curspd", s.B.vel2.length())
    if not bot.phys.resting :
      # turn = 1
      return
    var rb = get_ball_rel(s)
    var point
    if balls[0].owner == -1:
      point = rb.point
      if (rb.d2 < 15 and abs(angle_to_point(bot, point)) < 0.5) or rb.d2  < 5:
        # point = point + 1 * v3.normalized
        # point =  get_dest(bot, 0.2)
        # point = get_dest_turning(common.bclosest,0.75, 0.2)
        # point = get_dest_turning(common.bclosest,10, 0.6)
        point = get_dest_turning(common.bclosest,10, 0.6)
        # speed = 0
        # g.create_mark({ "pos":point, "color":Color(1,1,0,0.2)}, "dest_point", true, false)
    else:
      point = get_dest(common.bclosest, 0.2)
    g.create_mark({ "pos":point, "color":Color(1,1,0,0.2)}, "dest_point", true, false)
    move_to_point(s, point)
    if balls[0].owner == -1:
      # var d = v3.length()
      # var d2 = g.xz(v3).length()
      # var dy = v3.y
      # var ball_leading = (v3.dot(get_aim()) > 0) and d2 > 17
      # g.scrn_dbg("relball", {"d":rb.d, "d2":rb.d2, "dy":rb.dy, "blead":rb.ball_leading})
      g.scrn_dbg("relball", rb)
      var approaching_limit = abs(point.x) > 100 or abs(point.z) > 250
      # if not approaching_limit:
      #   speed = sign(speed)
      speed = sign(speed)
      if approaching_limit:
        # if  (not ball_leading or (dy < 8 and d2 < 70)):
        if  (not rb.ball_leading) and rb.dy > 8.5 and rb.dy < 13 and rb.d2 < 10 and balls[0].velocity.y < 0:
          # get_tree().set_pause(not get_tree().is_paused())
          manager.debug("beep",1)
          # speed = -1
          speed = -1 * sign(s.B.dir.dot(s.B.pos))
          # air_turn()

    return
  #   if not g.is_null(v3):
  #     var d = v3.length()
  #     # if v3.length() > 17:
  #     if g.xz(v3).length() > 10:
  #       speed = sign(speed)
  #     # elif v3.y > 10 and (abs(point.x) > 100 or abs(point.z) > 300 )  and d < 100 and d > 40:
  #     elif  v3.y < 60  and (abs(point.x) > 100 or abs(point.z) > 200 )  and d < 110:
  #       # # speed = -0.5
  #       # # try_jump()
  #       # speed = -1 * sign(s.B.dir.dot(s.B.pos))
  #       # manager.debug(v3,1)
  #       manager.debug("oppo",1)
  #       # speed = sign(speed) * d/50.0
  #       speed = sign(speed)
  #       # turn = 1
  #       air_turn()
  #     # elif v3.y > 6 and d < 12:
  #     #   manager.debug("oppi",1)
  #     #   speed = sign(speed)
  #     #   turn = 0
  #     #   try_jump()
  #     else:
  #       speed = sign(speed) * max(abs(speed), 0.6)
  #     # if  bot.phys.resting and abs(angle_to_point(bot, point)) < 0.05 and d > 100 and d < 110:
  #     # if  bot.phys.resting and not bot.in_key_area and  abs(angle_to_point(bot, point)) < 0.1 and d < 100 and d > 40:
  #     #   manager.debug("oppa",1)
  #     #   speed = sign(speed) * d/50.0
  #     #   # turn = 1
  #     #   air_turn()
  #     #   # try_jump()


  #     # if abs(speed) < 0.51:
  #     #   speed = sign(speed)
  #     #   turn = 0
  #     #   try_jump()
  #   # speed = 0

  # # func get_aim(p=gsvar.me):
  # #   return Vector3(sin(p.body_rotation),0,cos(p.body_rotation))

  func get_dest(p=gsvar.me, t=0):
    # return p.get_translation() + d * Vector3(sin(p.body_rotation),0,cos(p.body_rotation))
    return p.get_translation() + t * p.get_linear_velocity()

  func get_dest_turning(p=gsvar.me,tp=0, t=0):
    # return p.get_translation() + d * Vector3(sin(p.body_rotation),0,cos(p.body_rotation))
    return p.get_translation() + t * p.get_linear_velocity().rotated(Vector3(0,1,0), -tp  * 0.01)


class K_spread:
  extends KillAction
  var target_angle_diff = 100
  var wait_for_0 = false
  func _init():
    order = 0
    pass

  # func validate(s):
  #   if not s.B.has('side'):
  #     return false
  #   return true

  func assess(s):
    rating = 0
    if s.P.empty():
      return
    # if not s.P.has("inst") or s.P.target_mode != "attack":
    #   control.update_target(gsvar.me)
    #   rating = 0
    #   return
    # rating = 4500 #-10
    # return
    # if s.P.inst.is_dying:
    #   control.update_target(null)
    #   rating = 0
    #   return
    if abs(s.P.ang) > PI/8 and s.B.ang < PI/8:
      rating = 000
    else:
      rating = 0
    pass

  func fire(s):
    if .fire(s) == true:
      return
    if wait_for_0:
      return
    var shots = bot.ammo.size()
    if shots == 0:
      if min(abs(s.P.ang), PI - abs(s.P.ang)) > 0.55:
        # manager.debug("too wide", 1)
        return
      # if s.P.vel.dot(s.P.dir) > 0:
      #   manager.debug("moving forwae", 1)
      #   return

    if abs(target_angle_diff) < 0.01 and g.time_since(bot, "last_fire", 100, true):
      fire = true
    return

  func move(s):
    var shots = bot.ammo.size()
    if shots == 0:
      wait_for_0 = false
    if wait_for_0 and g.time_elapsed(bot, "last_fire") < 1500:
      # try_jump()
      speed = -1
      # turn = -s.B.side
      turn = -s.P.side
      return
    move_lock(s, 0)
    if shots == 0:
      move_lock(s, -0.4)
      move_close_in(s, [150,120,100])
    elif shots == 1:
      # move_lock(s, -0.6)
      move_lock(s, -1.0)
      move_close_in(s, [150,120,100])
    # elif shots == 2:
    # elif shots == 1:
    #   # move_lock(s, -0.8)
    #   move_lock(s, -1.7)
    # elif shots == 3:
    elif shots == 2:
      wait_for_0 = true
      move_close_in(s, [150,120,100])

    pass

  func move_lock(s, lead=null):
    # var diviation = min(abs(s.P.ang), PI - abs(s.P.ang))
    # lead = lead / clamp(diviation, 0.1, 1.1)
    # var r = (1+lead) * 70/180.0
    var r = (1+lead) * ((s.P.vel.length()+s.P.inst.max_speed)/2.0)/180.0
    # r = 70/180.0
    var adiff = s.B.ang - asin(sin(-s.P.ang)*r)
    turn = sign(adiff)
    if abs(adiff) > PI/2:
      air_turn()
    target_angle_diff = adiff


class K_guard:
  extends KillAction
  func _init():
    order = 0
    pass

  func assess(s):
    if not s.P.has("inst") or not manager.roles.has("defender"):
      rating = -10
      return
    var far_from_zone = (bot.get_translation() - Vector3(0,0,330)).length() > 120
    var so_far_from_zone = (bot.get_translation() - Vector3(0,0,330)).length() > 300
    var far_from_target = (bot.get_translation() - s.P.inst.get_translation()).length() > 200
    var guard = so_far_from_zone or (far_from_zone and far_from_target)
    if guard:
      rating = 1200
    else:
      rating = 0


  func fire(s):
    if .fire(s) == true:
      return
    var shots = bot.ammo.size()
    if shots == 0 and g.time_since(bot, "last_fire", 500, true) and last_col_check.colliding:
      fire = true
    elif shots == 1 and g.time_since(bot, "last_fire", 500, true) and last_col_check.crossing:
      fire = true
    elif shots == 2 and g.time_since(bot, "last_fire", 500, true) and last_col_check.colliding:
      fire = true

  func move(s):
    move_guard(s)
#    turn_to_pside(s,1)
    turn_to_shot_colliding(s)
#    move_default_close_in(s)
    return



class K_catch:
  extends KillAction
  func _init():
    order = 000
    pass

  func assess(s):
    if not s.P.has("inst"):
      rating = -10
      return
    if abs(s.P.ang) > PI/2:
      rating = -1000
    else:
      rating = -10
    pass

  func fire(s):
    var shots = bot.ammo.size()
    if shots < 2 and g.time_since(bot, "last_fire", 500, true) and last_col_check.colliding:
      fire = true
    pass

  func move(s):
    move_default_close_in(s)
    return
    var shots = bot.ammo.size()
    if shots == 0:
      move_lock(s, 0.0)
      move_close_in(s, [80,50,30])
    elif shots == 1:
      move_lock(s, 0.9)
      move_close_in(s, [80,50,30])
    pass

class K_face:
  extends KillAction
  func _init():
    select = ["turn", "speed"]
    pass

  func assess(s):
    rating = 0
    if not s.P.has("inst"):
      rating = 0
      return
    if s.B.absang < s.P.absang and s.B.absang < 0.2 and s.P.absang < 0.2:
      rating = 100000
    pass

  func fire(s):
    if .fire(s) == true:
      return
#    if not s.P.has("inst"):
#      return
    var shots = bot.ammo.size()
#    if shots > 2:
#      bot.ammo = []
#      time_since_up("last_ammo")
#    if s.P.inst.is_dying or not time_since("last_ammo", 3500):
#      bot.ammo = []
#      return
    if not g.is_null(last_col_check) and  last_col_check.crossing and shots == 0 and abs(s.P.ang) < 0.6 and s.dist < 130:
      speed = -0.3
      fire = true
    if shots > 0 and g.time_since(bot, "last_fire", 200, true):
      var duplicate =  abs(bot.ammo[-1].meta.s.B.rot - s.B.rot) < (0.1 * s.dist / 80.0)
      var good_gap =  not duplicate and abs(bot.ammo[-1].meta.s.B.rot - s.B.rot) > (0.2 * s.dist / 80.0) and abs(bot.ammo[-1].meta.s.B.rot - s.B.rot) < (0.4 * s.dist / 80.0)
#      var deadly_close = s.dist < 60 and abs(s.P.ang) < 1.0
      var good_dist_angle = ((2 - shots)/10.0) + ( (40.0 / s.dist) * (0.4 / abs(s.P.ang))) > 1
#      var good_aim = ((abs(s.B.ang) < 0.25 and abs(s.B.ang) > 0.05 and last_col_check.crossing) or last_col_check.colliding)
      var good_aim = ((abs(s.B.ang) < 0.3  and last_col_check.crossing) or false)
      var deadly_close = good_dist_angle and good_aim

      if deadly_close:
        g.report("deadly", [s.dist, s.P.ang], 0 , 1000, {"only":false})
      if good_gap or deadly_close:
        speed = 0.3 * shots
        fire = true
        g.chreport("fire", {"shots":shots+1, "dup":duplicate, "deadly":deadly_close}, 0 , -1, {"only":false})
        if deadly_close and s.P.pos[1] > 0.1:
          turn = 0
          jump = true
#          bot.local_input[0] = true
      pass
    # this action never fires
    pass



  func move(s):
    if jump == true:
      call_deferred("try_jump")
      turn = 0.0
    elif bot.ammo.size() == 1:
      move_close_in(s, [100,75,60])
      move_lock_maxvel(s,0.5)
#      gsvar.missiles[bot.ammo[0].mid].get_translation()
#      gsvar.missiles[bot.ammo[0].mid].get_linear_velocity()
    elif bot.ammo.size() == 2:
      move_close_in(s, [100,80,60])
      move_lock_maxvel(s,0.2)
#      move_lock(s,0)
    elif not g.is_null(control.target_player):
      move_lock(s, 0.7)
#      move_lock_maxvel(s)
      move_close_in(s, [150,100,60])
    if s.B.pos[1] > 0.5:
      jump = false
      bot.local_input[0] = false
#    move_guard(s)
    # depends on relative positions of bot and opponent and basket, also depends on opponent direction and speed
#    stabilize()
    pass


# this is where a trap is in place, ignore almost everything and proceed
class K_trap:
  extends KillAction
  var ok0 = false
  var okx = false
  var shoot_side = 0
  func _init():
    dominant = true
    pass

  func assess(s):
    .assess(s)

    if not s.P.has('inst'):
      rating = 0
      return
    if s.P.inst.is_dying:
      ok0 = false
      return
    var power = 1.5
    var dist_mod = pow(s.dist, power) / pow(100, power)
    g.scrn_dbg("distmod", dist_mod)
#    dist_mod = clamp(dist_mod, 0.25, 4.0)
    var pa = abs(s.P.ang) * dist_mod
    var ba = abs(s.B.ang) * dist_mod
    var shots = bot.ammo.size()
    ok0 = (shots == 0) and ba < pa and ba < PI/10 and pa < PI/8

    if ok0:
      rating = 200
      pass
      return
#    p_rundist = s.P.pos2 - prev_p_pos
#    var ok1 = manager.current == "A_trap" and shots == 1 and p_rundist < 6



  func fire(s):
    var shots = bot.ammo.size()
    if shots == 3:
      okx = false
    if delayed_fire or .fire(s) == true:
      return
    pass
    var dist_mod = s.dist / 180.0

    if ok0:
#      gsvar.pause(true)
      ok0 = false
      okx = true
      shoot_side = -s.P.side
#      g.chreport("ok0", {"side":shoot_side, "dist":s.dist}, 0 , 0, {"only":false})
      fire = true
      speed = -0.0

    elif okx and g.time_since(bot, 'last_fire', (1-(randf()/4)) * (100/dist_mod),true):
      fire = true
      speed = 1.0
    if fire == true:
      g.report("setting delayed fire", [g.t()], 0 , -1, {"only":false})
      set_delayed_fire(randf()/500)
      fire = false
      fire_move = true

#    if fire == true:
#      speed = 1.0
#    else:
#      speed = 0.2


  func move(s):
    var shots = bot.ammo.size()
#    g.scrn_dbg("dist",s.dist)
    if fire_move == true:
      g.chreport("firing | override move", [speed, turn], 0 , 1000, {"only":false})
      return
    if shots == 0:
      shoot_side = -s.P.side
      move_close_in(s, [250,140,100])
      move_lock_maxvel(s,0.0)
    else:
      g.scrn_dbg("shoot side", shoot_side)
      move_close_in(s, [250,140,100])
      turn = shoot_side
    pass

class K_trap2:
  extends KillAction
  var ok0 = false
  var okx = false
  var shoot_side = 0
  func _init():
    shot_limit = 2
    dominant = true
    pass

  func assess(s):
    .assess(s)

    if not s.P.has('inst'):
      rating = 0
      return

    if s.P.inst.is_dying:
      ok0 = false
      return
    if s.dist < 120:
      rating = 300
    var power = 1.5
    var dist_mod = pow(s.dist, power) / pow(100, power)
    g.scrn_dbg("distmod", dist_mod)
#    dist_mod = clamp(dist_mod, 0.25, 4.0)
    var pa = abs(s.P.ang) * dist_mod
    var ba = abs(s.B.ang) * dist_mod
    var shots = bot.ammo.size()
    ok0 = (shots == 0) and ba < pa and ba < PI/10 and pa < PI/5

    if ok0:
      pass
      return
#    p_rundist = s.P.pos2 - prev_p_pos
#    var ok1 = manager.current == "A_trap" and shots == 1 and p_rundist < 6



  func fire(s):
    var shots = bot.ammo.size()
    if shots == 2:
      okx = false
    if delayed_fire or .fire(s) == true:
      return
    pass
    var dist_mod = s.dist / 240.0

    if ok0:
#      gsvar.pause(true)
      ok0 = false
      okx = true
      shoot_side = -s.P.side
#      g.chreport("ok0", {"side":shoot_side, "dist":s.dist}, 0 , 0, {"only":false})
      fire = true
      speed = 0.4

    elif okx and g.time_since(bot, 'last_fire', (1-(randf()/4)) * (100/dist_mod)):
      g.report("lastcol", [last_col_check], 0 , -1, {"only":false})
      g.time_since_up(bot, 'last_fire')
      fire = true
      speed = 1.0
    if fire == true:
      g.report("setting delayed fire", [g.t()], 0 , -1, {"only":false})
      set_delayed_fire(randf()/500)
      fire = false
      fire_move = true

#    if fire == true:
#      speed = 1.0
#    else:
#      speed = 0.2


  func move(s):
    var shots = bot.ammo.size()
#    g.scrn_dbg("dist",s.dist)
    if fire_move == true:
      update_col_check(s)
      g.chreport("firing | override move", [speed, turn], 0 , 1000, {"only":false})
      return
    if shots == 0:
      shoot_side = -s.P.side
      move_close_in(s, [150,90,70])
      move_lock_maxvel(s,0.2)
    else:
      g.scrn_dbg("shoot side", shoot_side)
      move_close_in(s, [150,90,70])
      turn = shoot_side
#    stabilize()
    pass


# this is where a trap is in place, ignore almost everything and proceed
class K_trap_chase:
  extends KillAction
  var ok0 = false
  var okx = false
  var shoot_side = 0
  func _init():
    pass

  func assess(s):
    .assess(s)
#    rating = 10000000
    if not s.P.has('inst'):
      rating = 0
      return
    if s.P.inst.is_dying:
      ok0 = false
      return
    if PI - abs(s.P.ang) < PI/2:
      rating = 200
    var power = 1.5
    var dist_mod = pow(s.dist, power) / pow(100, power)
    g.scrn_dbg("distmod", dist_mod)
#    dist_mod = clamp(dist_mod, 0.25, 4.0)
    var pa = (PI - abs(s.P.ang)) * dist_mod
    var ba = abs(s.B.ang) * dist_mod
    var shots = bot.ammo.size()
    ok0 = (shots == 0) and s.dist < 150 and ba < pa and ba < PI/10 and pa < PI/3

    if ok0:
      pass
      return
#    p_rundist = s.P.pos2 - prev_p_pos
#    var ok1 = manager.current == "A_trap" and shots == 1 and p_rundist < 6



  func fire(s):
    var shots = bot.ammo.size()
    if shots == 3:
      okx = false
    if delayed_fire or .fire(s) == true:
      return
    pass
    var dist_mod = s.dist / 180.0

    if ok0:
#      gsvar.pause(true)
      ok0 = false
      okx = true
      shoot_side = -s.P.side
      g.chreport("ok0", {"side":shoot_side, "dist":s.dist}, 0 , 0, {"only":false})
      fire = true
      speed = -0.0

    elif okx and g.time_since(bot, 'last_fire', (1-(randf()/4)) * (100/dist_mod),true):
      fire = true
      speed = 1.0
    if fire == true:
      g.report("setting delayed fire", [g.t()], 0 , -1, {"only":false})
      set_delayed_fire(randf()/500)
      fire = false
      fire_move = true

#    if fire == true:
#      speed = 1.0
#    else:
#      speed = 0.2


  func move(s):
    var shots = bot.ammo.size()
#    g.scrn_dbg("dist",s.dist)

    if fire_move == true:
      g.chreport("firing | override move", [speed, turn], 0 , 1000, {"only":false})
      return
    if shots == 0:
      shoot_side = -s.P.side
      move_close_in(s, [100,70,50])

      move_lock_maxvel(s,0.0)
    else:
      g.scrn_dbg("shoot side", shoot_side)
      move_close_in(s, [100,70,50])
      turn = shoot_side
    pass

class K_threat:
  extends KillAction
  func _init():
    pass

  func assess(s):
    if not s.P.has("inst"):
      rating = 0
      return
    # player is about to throw when distance to basket is less than 150 and the angle to the basket is less than 0.4 and player is turning to basket
    var d = (s.P.pos2 - Vector2(0,330)).length()
    var a = (Vector2(0,330) - s.P.pos2).angle_to(s.P.dir2)
    var behind_goal = s.P.pos2.x < 0
    var good_angle = abs(a) < PI/1.8
    var turning_to_goal = (sign(s.P.avel) != sign(a))
    var p_near_about_to_throw = (d < 400) and good_angle and turning_to_goal
    if p_near_about_to_throw:
      rating = 0
    else:
      rating = 0

    pass

  func fire(s):
    if .fire(s) == true:
      return
    var shots = bot.ammo.size()
    var approaching_goal = (last_col_check.point - g.xz(basket_pos)).length() < (s.P.pos2 - g.xz(basket_pos)).length()
    var td = abs(last_col_check.td)
    if shots == 0 and not g.is_null(last_col_check.td) and abs(last_col_check.td) < 0.5 and approaching_goal :
      fire = true
    elif shots == 1 and not g.is_null(last_col_check.td) and abs(last_col_check.td) < 0.2  and g.time_since(bot, "last_fire", 400, true):
      fire = true
    elif shots == 2 and g.time_since(bot, "last_fire", 300, true):
      fire = true
    if last_col_check.on_point_side == false:
      fire = false


  func move(s):
#    move_lock(s,0.0)
#    turn = 0
#    speed = 0
#    return
    if jump == true:
      call_deferred("try_jump")
      turn = 0.0
    elif bot.ammo.size() == 0:
      move_lock_point(s,0.0,Vector2(0,330))
#      move_lock(s, 0.0)
      move_close_in(s, [150,100,100])
    elif bot.ammo.size() == 1:
      move_close_in(s, [150,100,100])
      move_lock(s,0.2)
#      move_lock_point(s,0.4,Vector2(0,330))
#      gsvar.missiles[bot.ammo[0].mid].get_translation()
#      gsvar.missiles[bot.ammo[0].mid].get_linear_velocity()
    elif bot.ammo.size() == 2:
      move_close_in(s, [100,80,60])
      move_lock(s,0.0)
#      move_lock(s,0)
    if s.B.pos[1] > 0.5:
      jump = false
      bot.local_input[0] = false
#    move_guard(s)
    # depends on relative positions of bot and opponent and basket, also depends on opponent direction and speed
    pass


  func best_three(s):
    # 1 in front 1 on target and one behind
    pass


class K_thwart:
  extends KillAction
  var danger = 0
  func _init():
    pass

  func assess(s):
    if not s.P.has("inst"):
      rating = 0
      return
    # player is about to throw when distance to basket is less than 150 and the angle to the basket is less than 0.4 and player is turning to basket
    var d = (s.P.pos2 - Vector2(0,330)).length()
    var a = (Vector2(0,330) - s.P.pos2).angle_to(s.P.dir2)
    var behind_goal = s.P.pos2.x < 0
    var good_angle = abs(a) < PI/2
    var turning_to_goal = (sign(s.P.avel) != sign(a))
    var p_about_to_throw = (d < 200) and good_angle and turning_to_goal
    if p_about_to_throw:
      if d < 100:
        danger= 1
      else:
        danger=0
      rating = 500
    else:
      rating = 0
    pass
    if manager.roles.has("defender"):
      rating += 1000

  func fire(s):
    if .fire(s) == true:
      return
    var shots = bot.ammo.size()
    if shots == 0 and last_col_check.crossing:
      fire = true
    elif (last_col_check.colliding and shots > 0):
      fire = true
    pass

  func move(s):
    if danger > 0:
      move_lock_point(s,0.0)
    elif jump == true:
      call_deferred("try_jump")
      turn = 0.0
    elif bot.ammo.size() == 0:
#      move_lock(s, 0.0)
      move_lock_point(s,-1.0)
      move_close_in(s, [120,100,100])
    elif bot.ammo.size() == 1:
      move_close_in(s, [100,75,60])
#      move_lock_maxvel(s,0.5)
      move_lock_point(s,0.5)
#      gsvar.missiles[bot.ammo[0].mid].get_translation()
#      gsvar.missiles[bot.ammo[0].mid].get_linear_velocity()
    elif bot.ammo.size() == 2:
      move_close_in(s, [100,80,60])
      move_lock_maxvel(s,0.2)
#      move_lock(s,0)
    if s.B.pos[1] > 0.5:
      jump = false
      bot.local_input[0] = false
#    move_guard(s)
    # depends on relative positions of bot and opponent and basket, also depends on opponent direction and speed
    pass


  func best_three(s):
    # 1 in front 1 on target and one behind
    pass