class CameraManager:
  extends Node
  # name:{obj:obj, cam:cam, order:order}
  var cams = {}
  var ordered = []
  var active_toggle = false
  var toggle_back = null
  var current = null
  var last = null

  func _ready():
    pass

  func register_cam(name, node, cam, order):
    if cams.has(name):
      return
    cams[name] = {'node':node, 'order':order, 'camera':cam}
    # find the first higher cam and insert before it
    var i = -1
    for cn in ordered:
      i += 1
      if cams[cn].order < order:
        continue
      break
    ordered.insert(i, name)

  func cycle():
    if active_toggle:
      current = toggle_back
      active_toggle = false
    else:
      var i = ordered.find(current)
      if i > -1:
        var available = false
        var x = 0
        while not available
          x += 1
          current = ordered[i+x % ordered.size()]
          if cams[current].node.camera_available(current):
            break
          if x > ordered.size():
            g.report("no cams available!", [], 0 , 1000, {"only":false})
            return
    activate_current()

  func toggle(cn, on=true):
    if active_toggle:
      if cn == current and not on:
        current = toggle_back
        active_toggle = false
      else:
        g.report("camera toggle conflict", [cn, current], 0 , 0, {"only":false})
      return
    if cn == current:
      g.report("tried to toggle already active cam, ignoring", [current], 0 , 0, {"only":false})
      return
    active_toggle = true
    toggle_back = current
    current = cn
    activate_current()

  func activate_current():
    return
    last = current
    if not g.is_null(current):
      cams[current].camera.make_current()

  func activate_camera(cn):
    current = cn
    activate_current()