extends Node

var reported = {}
var report_only = []
var curlevel = -1
#onready var gsvar = get_node("/root/gamestate")
var gsvar
var _store = {"scrn_dbg":{}}
var avgr_vals = {}
var debug_entry_enabled = {"mark":{}, "scrn_dbg":{}, "report":{}}
var dbgentries
var timers = {}
var sounds
var release = true
var report_timestamps = true
var screen_report = true
var world_ready = false
var weighted_setters = {}
var jsenabled = true
var tweens = {"chgcol":{}}
var ev
# onready var ev = get_node("/root/world/console/evaluator_context")
# var explosion_scene = load("res://prefabs/explosion.tscn");
func _ready():
  Globals.set("g", self)
  # Globals.set("ec", get_node("/root/world/console/evaluator_context"))
  set_pause_mode(2)
  load_debug_entry_state()

func load_debug_entry_state():
    pass

func world_ready():
  ev = get_node("/root/world/console/evaluator_context")
  # log2f(ev.get_method_list())
  world_ready = true
  dbgentries = get_node("/root/world/gui/dbgentries")
  sounds = get_node("/root/world/SpatialSamplePlayer")
  # if release:
  dbgentries.hide()

func set_debug_entry_enabled(entry, enabled):
  debug_entry_enabled[entry.group][entry.name] = enabled

func replace_many(s, chars, by):
  var out = ""
  for i in range(s.length()):
    if chars.has(s[i]):
      out += by
    else:
      out += s[i]
#  var idx = -1
#  var out = s
#  for c in chars:
#    idx += 1
#    out = out.replace(c, by)
  return out

func sanitize_ini_name(v):
#  return (str(v).c_escape().replace(' ', '_'))
  return (replace_many(str(v), ["[", "]", " ", ",", ";"], "_" ))

func report(id,extra=[], level=1, intv=60000, params={}):
  if release:
    return
#  return
  if curlevel < level:
    return
  var dbg_id = sanitize_ini_name(id)
  if world_ready and  not is_null(dbgentries) and not debug_entry_enabled.report.has(dbg_id):
    dbgentries.add_entry("report",dbg_id)
#    debug_entry_enabled.report[dbg_id] = dbgentries.config.get_value("report", dbg_id, true)
  if debug_entry_enabled.report.has(dbg_id) and not debug_entry_enabled.report[dbg_id]:
    return
  var default_params = {"only":false, "changed":false, "array_lines":false, "out_mode":"print"}
  params = mergedicts(default_params, params)
  # print("oooooooooooooooad")
  if not params.has("out_mode"):
    params["out_mode"] = "chat"
  if params.only and not report_only.has(id):
    report_only.append(id)
  if not report_only.empty() and not report_only.has(id):
    return
  if params.has("array_lines") and params["array_lines"]:
    var out = []
    for e in extra:
      out.append(e)
      out.append("\n")
    extra = out
  # print("aaaaaaaaaaaaaaaaaaa")
  if reported.has(id):
    reported[id]["count"] = reported[id]["count"] + 1
    var last_extra = reported[id]["extra"]
#    reported[id]["extra"] = var2str(extra)
    if params.has("changed") and params["changed"]:
#      print("got changed opt")
      # if var2str(extra) != last_extra:
      if var2str(extra) != (last_extra):
        print("changed : ", id, " ", extra, "( was = " , last_extra , ")")
        reported[id] = {"count":1, "last_report":OS.get_ticks_msec(), "extra":var2str(extra)}
      return
#      else:
#        return
    if OS.get_ticks_msec() - reported[id]["last_report"] > intv:
      report_out({id:[extra, "(" + str(reported[id]["count"]) + ")"]},params.out_mode)
      reported[id]["count"] = 0
      reported[id]["last_report"] = OS.get_ticks_msec()
  else:
    reported[id] = {"count":1, "last_report":OS.get_ticks_msec(), "extra":var2str(extra)}
    report_out({id: extra}, params.out_mode)
  # print("eeeeeeeeeeeeeeeeeeeee")


func report_out(output, mode):
  if mode == "print":
    if report_timestamps:
      output = "[" + str(t()) + "]  " + str(output)
    print(output)
  elif mode == "chat":
    gsvar.chatmgr.add_message(str(output));
  elif mode == "screen" and world_ready:
    create_mark({"update":true, "label_pos":Vector2(40,30), "label":output.values()[0][0]}, "screen_marker", true, false)
#    _store["scrn_dbg"] = {}

func scrn_dbg(a,v=[t()],show=true):
  var dbg_id = sanitize_ini_name(a)
  if not show:
    _store["scrn_dbg"].erase(a)
    return
  if not is_null(dbgentries) and not debug_entry_enabled.scrn_dbg.has(dbg_id):
    dbgentries.add_entry("scrn_dbg",dbg_id)
#    debug_entry_enabled.report[dbg_id] = dbgentries.config.get_value("report", dbg_id, true)
  if debug_entry_enabled.scrn_dbg.has(dbg_id) and not debug_entry_enabled.scrn_dbg[dbg_id]:
    if _store.scrn_dbg.has(a):
      _store["scrn_dbg"].erase(a)
    return
  _store["scrn_dbg"][a] = v


func chchreport(id,extra=[], level=-1, intv=100, params={}):
  params = {"changed":true}
  chreport(id,extra, -1, -1, params)

func chreport(id,extra=[], level=-1, intv=100, params={}):
  params["out_mode"] = "chat"
  report(id,extra, level, intv, params)

func toggle_hidden(node):
  var state = node.is_hidden()
  node.set_hidden(not state)


func r(args):
  report(args, [], 0,0)

func deep(d, _keys, r=false):
  if _keys.empty():
    return d
  var out = d
#  if d.has(k0):
#    out = d[k0]
#  else:
#    return false
  for k in _keys:
    if (typeof(out) == TYPE_DICTIONARY and out.has(k)) or (typeof(out) == TYPE_OBJECT and not is_null(out.get(k))):
      out = out[k]
    elif typeof(out) == TYPE_ARRAY and typeof(k) == TYPE_INT and out.size() > k:
      out = out[k]
#    if typeof(out) == TYPE_DICTIONARY and out.has(k):
#      out = out[k]
    else:
      return r

  return out

func shallowcp(d):
  var cp = {}
  for k in d:
    if typeof(d[k]) == 5:
      cp[k] = Vector2(d[k])
    if typeof(d[k]) == 7:
      cp[k] = Vector3(d[k])
    else:
      cp[k] = d[k]
  return cp

func copyvar(v):
  return str2var(var2str(v))
  # return str2var(var2str(v))

func is_null(v):
  return (typeof(v) == 0) or (v == null)
#   or typeof(v) == 18


func randsign(n=1):
  var r = randi() % 2
  if r == 0:
    return -n
  else:
    return n

func randsi(mx=100000000000):
  return randsign(randi()%mx)

func randsf(mx=1.0):
  return randsign(fmod(randf(), mx))

#func uang(angle):
#  if angle < 0:
#    return fmod(2*PI + angle, 2*PI)
#  elif angle < 2 * PI:
#    return angle
#  else:
#    return fmod(angle, 2*PI)


func get_config_lines():
  var file = File.new()
  var fn = "user://config.json"
  if (!file.file_exists(fn)):
    new_config();
  file.open(fn, file.READ)
  var lines = []
  while (!file.eof_reached()):
    var currentline = {}
    currentline.parse_json(file.get_line())
    if !currentline.empty():
      lines.append(currentline)
  file.close()
  return lines


func new_config():
  var lines = get_default_config()
  var f = File.new();
  var fn  = "user://config.json"
  f.open(fn, f.WRITE);
  for i in lines:
    f.store_line(i.to_json())
  f.close()

func file_write(fn, contents):
  var f = File.new();
  f.open(fn, f.READ_WRITE);
  f.seek_end()
  f.store_string("\n")
  f.store_string(str(contents))
  f.close()

func log2f(text):
  file_write("user://logfile.log", text)

func file_read(fn):
  var file = File.new()
  if (!file.file_exists(fn)):
    return ""
  file.open(fn, file.READ)
  var lines = file.get_as_text()
  file.close()
  return lines


func eval_context():
  return get_node("/root/world/console/evaluator_context")

func get_default_config():
  var lines = [
  {"name":"config_ver", "value":0, "default":9,"group":"Personalization", "what":"enter your callsign", "require_restart": true, "hide":true},
  {"name":"callsign", "value":"your_callsign", "default":"your_callsign","group":"Personalization", "what":"enter your callsign", "require_restart": true},
  {"name":"tank_style", "value":"pink", "default":"red","group":"Personalization", "what":"select your prefered tank style", "setting_type":"select", "choices":["red", "pink", "green", "gold"], "require_restart": true},
  # {"name":"host_game_mode", "value":"hix", "default":"hix","group":"Personalization", "what":"select game mode to host", "setting_type":"select", "choices":["hix","basketball", "football"], "require_restart": true},
  {"name":"host_game_mode", "value":"hix", "default":"hix","group":"Personalization", "what":"select game mode to host", "setting_type":"select", "choices":["hix"], "require_restart": true},
 # {"name":"background_music", "value":false, "default":false,"group":"Personalization", "what":"control background music", "require_restart": false},
  # {"name":"game_speed", "value":100, "max":250, "default":100,"group":"Personalization", "what":"control speed of game physics", "require_restart": true},
#  {"name":"alt_tank_texture", "value":false, "default":false,"group":"Personalization", "what":"pink tank", "require_restart": false},
  {"name":"swap_tab_rmb", "value":false, "default":false,"group":"Controls", "what":"swap tab and right mouse button", "require_restart": false},
  {"name":"confine_mouse", "value":true, "default":true,"group":"Controls", "what":"confine mouse movement to mousebox boundaries", "require_restart": false},
  {"name":"mousebox_size", "value":120, "default":120,"min":70, "max":300, "group":"Controls", "what":"mousebox size affects sensitivity", "require_restart": false},
  {"name":"deadzone_size", "value":30,"default":30,"min":5, "max":60,"group":"Controls", "what":"deadzone size affects sensitivity ", "require_restart": false},
  {"name":"brightness", "value":1.1,"default":1.14,"min":0.014, "max":3.0,"group":"AV/Video", "what":"brightness", "require_restart": false, "step":0.05},
  {"name":"contrast", "value":1.22,"default":1.22,"min":0.01, "max":3.0,"group":"AV/Video", "what":"contrast", "require_restart": false, "step":0.05},
  {"name":"saturation", "value":1.18,"default":1.18,"min":0.01, "max":3.0,"group":"AV/Video", "what":"saturation", "require_restart": false, "step":0.05},
  {"name":"srgb", "value":false,"default":false,"group":"AV/Video", "what":"srgb", "require_restart": false, "step":0.1},
  {"name":"enabled_fx", "choices":["AMBIENT_LIGHT","FXAA","GLOW","DOF_BLUR","HDR","FOG","BCS","SRGB"],"value":[ 0, 1, 2, 6 ],"default":[ 0, 1, 2, 6 ] ,"group":"AV/Video", "what":"FX", "require_restart": false},
  {"name":"ground", "value":"custom","default":"custom","group":"AV/Colors", "what":"Ground color","setting_type":"select", "choices":["custom"] + sort_custom(opt_color_list().keys(),"sort_opt_cols"), "require_restart": false},

  {"name":"custom_ground", "value":Color( 0.507812,0.507812,0.507812,0.571451 ),"default":Color( 0.507812,0.507812,0.507812,0.571451 ),"group":"AV/Colors", "what":"Custom ground color", "require_restart": false, "requires":["AV/Colors", "ground", "custom"]}, # (0.146118, 0.65625, 0.261695, 0.458824), (0.146118, 0.65625, 0.625689, 0.46) teal
  # {"name":"mute_sound", "value":false,"default":false,"group":"Audio", "what":"Mute sound", "require_restart": false},
  # {"name":"input_jump", "value":"Tab","default":"Tab","group":"Input", "what":"Jump", "require_restart": false},
  ]
  var dconf = ConfigFile.new()
  var err = dconf.load("res://defaults.cfg")
  for l in lines:
    l.default = dconf.get_value(l.group, l.name, l.default)

  return lines

func conf_update(val, i):
  i.value = val
  print('CONF UODATE')
  print(val)
  print(i)
  print(world_ready)
  if world_ready:
    var funcname = "update_set_" + i.name
    if eval_context().has_method(funcname):
      eval_context().callv(funcname, [val,i])

func conf_update_item_list(val1,val2, control, i):
  i.value = Array(control.get_selected_items())
  print('CONF UODATE item list')
  # print(val1,val2,control)
  # print(i)
  # print(world_ready)
  if world_ready:
    var funcname = "update_set_" + i.name
    if eval_context().has_method(funcname):
      eval_context().callv(funcname, [i.value])

func conf_update_setting(s,val):
  if world_ready:
    var funcname = "update_set_" + s
    if eval_context().has_method(funcname):
      print("found")
      eval_context().callv(funcname, [val])

func sort_custom(ary, fn):
  ary.sort_custom(self,fn)
  return ary

func sort_opt_cols(a,b):
  var list = opt_color_list()
  return list[a][1] < list[b][1]

func opt_color_list():
  # var list = {
  # "sea":Color(0.079041,0.104859,0.273438,0.51702 ),
  # "desert":Color(0.703125,0.320449,0.041199,0.353765),
  # }
  var list = {
 # "another cool green": Color(0,0.40625,0.244385,0.476196),
 # "opaquegreen": Color(0.133362,0.296875,0.216396,0.843529),
 # "purple": Color(0.689575,0.299225,0.722656,0.353765),
 # "newbluetg": Color(0.299225,0.514249,0.722656,0.353765),
 # # "white": Color(1,1,1,0.353765),
 # # "darkertransorange": Color(0.703125,0.320449,0.041199,0.353765),
 # "moreorange": Color(0.804688,0.358337,0,0.435373),
 # "transblood": Color(0.808594,0.142136,0.142136,0.353765),
 # "blue good": Color(0.0985718, 0.124909, 0.296875, 0.571451),
 # "greydark": Color(0.273438,0.273438,0.273438,0.911569),
 # "black": Color(0.07515,0.097656,0.08025,0.666667),
 # # "t21": Color(0.133362,0.226226,0.371094,0.829922),
 "SeaGreen2": [Color(0,0.40625,0.244385,0.476196),1],
 "SeaGreen": [Color(0.133362,0.296875,0.216396,0.843529),0],
 "Purple": [Color(0.689575,0.299225,0.722656,0.353765),4],
 "SteelBlue": [Color(0.299225,0.514249,0.722656,0.353765),2],
 # "white": Color(1,1,1,0.353765),
 # "darkertransorange": Color(0.703125,0.320449,0.041199,0.353765),
 "DarkOrange": [Color(0.804688,0.358337,0,0.435373),5],
 "DarkRed": [Color(0.808594,0.142136,0.142136,0.353765),6],
 "Navy": [Color(0.0985718, 0.124909, 0.296875, 0.571451),7],
 "Gray": [Color(0.273438,0.273438,0.273438,0.911569),3],
 "Black": [Color(0.07515,0.097656,0.08025,0.666667),8],
 "LightBrown": [Color(0.704688,0.658337,0.4,0.235373),5],
 # "RoyalBlue": Color(0.133362,0.226226,0.371094,0.829922),

  }
  return list
  # if gsvar.active_game_mode == "basketball":
  #     list  =  {
  #    "SeaGreen2": [Color(0,0.40625,0.244385,0.476196),1],
  #    "SteelBlue": [Color(0.299225,0.514249,0.722656,0.353765),2],
  #    "LightBrown": [Color(0.704688,0.658337,0.4,0.235373),5],
  #     }




# func console_exec(cmd, src=-1):
func console_exec(cmd):
#  get_node("/root/world/console").process_command(cmd)
#  return get_node("/root/world/console").command_list.execute(cmd)
  return get_node("/root/world/console").process_command(cmd)

func time_elapsed(target, event):
  return OS.get_ticks_msec() - target.event_times[event]

func time_since(target, event, t, update=false):
  var times = target.event_times
  if not times.has(event):
    times[event] = 0
  if OS.get_ticks_msec() - times[event] > t:
#    report("trigger event", [event, t, times[event],OS.get_ticks_msec()], 0 , 0, {"only":true})
    if update:
      times[event] = OS.get_ticks_msec()
#      time_since_up(event)
#      event_times[event] = OS.get_ticks_msec()
    return true
  return false


func time_since_up(target, event):
#  var times = event_times
  target.event_times[event] = OS.get_ticks_msec()

func vec3reverse(v3):
  return Vector3(v3.z, v3.y, v3.x)

func array_range(array, start,end):
  if end < 0:
    end = array.size() + end
  end = end + 1
  if start < 0:
    start = array.size() + start
  if end < 0 or start < 0:
    return []
  start = clamp(start, 0 , array.size())
  end = clamp(end, 0 , array.size())
  var order = 1
#  if end <= start:
#    order = -1
##    start =  start - 1
#    end = end - 2
  var new_array = []
  for i in range(start,end, order):
    new_array.append(array[i])
  return new_array


func are_equal(args_ary):
  var arg = args_ary.front()
  args_ary.pop_front()
  for a in args_ary:
    if arg != a:
      return false
    arg = a
  return true

func avg(ary, default=null):
  if ary.empty():
    return default
  var sum = 0
  for i in ary:
    sum += i
  return float(sum) / ary.size()


func unify_angle(angle):
  if angle < 0:
    return fmod(2*PI + angle, 2*PI)
  elif angle < 2 * PI:
    return angle
  else:
    return fmod(angle, 2*PI)


func uang(angle):
  return unify_angle(angle)
#  if angle < 0:
#    return fmod(2*PI + angle, 2*PI)
#  elif angle < 2 * PI:
#    return angle
#  else:
#    return fmod(angle, 2*PI)


func abs_angle(angle):
  return unify_angle(angle)


func uniform_angle(angle, relative_to=0):
  angle = angle - relative_to
  angle = fmod(angle, 2*PI)
  if angle < 0 and angle < PI:
    angle = angle + 2*PI
  if angle > 0 and angle > PI:
    angle = angle - 2*PI
  return angle

func uniform_angle_deg(angle, relative_to=0):
  angle = angle - relative_to
  angle = fmod(angle, 2*180)
  if angle < 0 and angle < 180:
    angle = angle + 2*180
  if angle > 0 and angle > 180:
    angle = angle - 2*180
  return angle

func closest_angle_rep_deg(ang1,ang2):
  if abs(ang2 - ang1) < 180:
    return ang2
  # -178,  179 => -181
  # 179 - -178 == 357 == 360 + (-3) => -178 - 3
  #  178, -179 =>  181
  # -179 - 178 == -357 == -360 + (3)
  # abs diff -- 360 - fmod(((abs(a2 - a1) / 360) + 2) , 360)
  var d = ang2 - ang1
  d = fmod((d+7200), 360)
  if d > 180:
    d =  d - 360
  return ang1 + d

func vec3yrot(v3):
  return uniform_angle(-xz(v3).angle_to(Vector2(0,1)))


func xz(v3):
  return Vector2(v3.x, v3.z)

func xnz(v3, n=0):
  return Vector3(v3.x,n, v3.z)

func zy(v3):
  return Vector2(v3.z, v3.y)


func rot2dir3(rot):
  return Vector3(sin(rot),0,cos(rot))

func vec2rot(v2):
  return(uniform_angle(atan2(v2.x,v2.y)) )


func vec3rot(v3):
  return(vec2rot(xz(v3)) )

func vec3pow(v3,pwr):
  return(Vector3(pow(abs(v3.x) , pwr)*sign(v3.x),pow(abs(v3.y) , pwr)*sign(v3.y),pow(abs(v3.z) , pwr)*sign(v3.z)))

func vec3powv3(v3,pwr):
  return(Vector3(pow(abs(v3.x) , pwr.x)*sign(v3.x),pow(abs(v3.y) , pwr.y)*sign(v3.y),pow(abs(v3.z) , pwr.z)*sign(v3.z)))


func fixed_lerp(cur,targ,stp):
  if abs(targ - cur) < stp:
    return targ
  elif cur > targ:
    return cur - stp
  else:
    return cur + stp


func arytovec3(ary):
  return Vector3(float(ary[0]),float(ary[1]),float(ary[2]))


func new_pstor(cat,lines):
#  var lines = get_default_config()
#  var lines = [
#  {"name":"example", "value":"test", "slot":0}
#  ]
  var f = File.new();
  var fn  = "user://pstor_" + cat + ".json"
  f.open(fn, f.WRITE);
  for i in lines:
    f.store_line(i.to_json())
  f.close()




func get_pstor_lines(cat):
  var file = File.new()
  var fn = "user://pstor_" + cat + ".json"
  if (!file.file_exists(fn)):
    new_pstor(cat,[]);
  file.open(fn, file.READ)
  var lines = []
  while (!file.eof_reached()):
    var currentline = {}
    currentline.parse_json(file.get_line())
    if !currentline.empty():
      lines.append(currentline)
  file.close()
  return lines

func rangediv(dividend, divisor):
  var r = range(dividend / divisor)
  var remainder = fmod(dividend, divisor)
  if remainder > 0:
    r.append(remainder)
  return r

func rangediv2(dividend, divisor):
  var r = range(dividend / divisor)
  var remainder = fmod(dividend, divisor) / divisor
  if remainder > 0:
    r.append(remainder)
  return r

func gen_expected_destinations(position, angle, angular_velocity=0.001, speed=50, duration=2, step=0.2):
  if angular_velocity == 0:
    angular_velocity = 0.001
  var r = speed/angular_velocity
  if speed < 0:
    r = r / 2
#  var sign_ = 1
#  if reverse:
##    return
#    # v = wr -> v=v/2 === r = r/2
#    r = r/2
#    sign_ = -1
#  else:
#    pass
#    return []
#  var angular_velocity = 0.76829 # rad/sec
  var origin = Vector2(position.x + r * cos(angle), position.y - r * sin(angle))
  report("debug position y and angle", [position.y, r * sin(angle), position.y - r * sin(angle)], 1 , 1000, {"only":true})
  report("position is", [position], 1 , 1000, {"only":true})
  report("found origin", [origin], 1 , 1000, {"only":true})
  var RET_generated_points = []
  for i in rangediv(duration , step):
    var this_step = step
    if typeof(i) == TYPE_REAL:
      this_step = i
#  for i in range(num):
    angle =  angle +  this_step  * angular_velocity
    position = Vector2( origin.x  - r*cos(angle),  origin.y + r*sin(angle))
#    RET_generated_points.append([position, angle])
    RET_generated_points.append([Vector3(position.x, 0.4, position.y), angle])
  report("generated points", RET_generated_points, 1 , 1000, {"only":true, "array_lines":true})
  return RET_generated_points


func draw_destinations(locations, skip=0):
  if not gsvar.records.has("position_marks"):
    gsvar.records["position_marks"] = []
  var tank_trace_scene = preload("res://prefabs/tank_trace.tscn");
  for i in range(locations.size()):
    var inst = tank_trace_scene.instance()
    var position = locations[i][0]
    var rotation = locations[i][1]
    inst.set_name("ttrace");
#    inst.set_global_transform(Transform(Matrix3(), Vector3(position.x, 0, position.y)));
    inst.set_global_transform(Transform(Matrix3(), position));
    inst.set_rotation(Vector3(0,rotation + PI,0))
    inst.get_node("arrow").set_scale(Vector3(4.0,3.0,2.0) )
    inst.persist = true
    var arrow_cone = inst.get_node("arrow")
    var mat = arrow_cone.get_material_override().duplicate()
  #  var mat = FixedMaterial.new()
    var colors = [
    Color(1,1,0),
    Color(0,0,1),
    Color(1,0,0),
    Color(0,1,0),
#    Color(1,0,1),
    ]
    var change_color_after_num_steps = 4
    var color = colors[fmod((skip+i) / 4 , colors.size() )]
    var col = Color(0,0,0).linear_interpolate( color, 1.0/(1+fmod(i+skip,4)) )
#    if debug:
#      report("cone color", [col], 0 , 0, {"only":true})
    mat.set_parameter(0, col)
    arrow_cone.set_material_override(mat)
    gsvar.world.env.add_child(inst, true);
    gsvar.add_record("position_marks", inst)


func f2stick(fraction, deadzone=true):
  fraction = clamp(fraction, -1.0,1.0)
#  gsvar.motion_bounds
#  gsvar.deadzone_bounds
  var rang
  if deadzone:
    rang = gsvar.me.motion_bounds - gsvar.me.deadzone_bounds
  else:
    rang = gsvar.me.motion_bounds
  if deadzone:
    return fraction*rang + (sign(fraction) * gsvar.me.deadzone_bounds)
  else:
    return fraction*rang


func stick2f(s):
  var rang = gsvar.me.motion_bounds - gsvar.me.deadzone_bounds
  return (s - (sign(s) * gsvar.me.deadzone_bounds)) / float(rang)

func abs_stick(s):
  if abs(s) < gsvar.me.deadzone_bounds:
    return 0
  return abs(s) - gsvar.me.deadzone_bounds

func f2av(fraction):
  var maxav = -0.74351
  return fraction * maxav

func f2v(fraction):
  return gsvar.me.max_speed * fraction

#func randsign():
#  return sign(randf() - 0.5)

func is_between(v, mn, mx):
  return (abs(clamp(v, mn, mx) - v) < 0.0001)

func v2tov3(v2, y=0):
  return Vector3(v2.x, y, v2.y)

func t():
  return OS.get_ticks_msec()

func tst():
  return gsvar.timescale_adjusted_time * 1000

func rticks():
  return gsvar.running_time  * 1000

func mergedicts(d1,d2):
  for k in d2:
    d1[k] = d2[k]
  return d1

func ftrunc(f, zeroes=3):
  return floor(f * pow(10,zeroes))/pow(10,zeroes)

func store_inc(key,num=1, _max=-1):
  if not _store.has(key):
    _store[key] = -1
  _store[key] += num
  # if _max > -1 and _store[key] == _max :
  if _max > -1 and _store[key] > _max-1 :
    _store[key] = _store[key] % _max
  return _store[key]

func si(key, num=1, _max=-1):
  return store_inc(key, num,_max)

func store_set(key, value):
  _store[key] = value

func ss(key,value):
  store_set(key, value)
  return value

func store_get(key, default=null):
  if not _store.has(key):
    _store[key] = default
  return _store[key]

func sg(key, default=null):
  return store_get(key, default)

func make_unique_matover(obj):
  obj.set_material_override(obj.get_material_override().duplicate())

func color_obj(obj, color):
  var diffuse = obj.get("colors/diffuse")
  if not is_null(diffuse):
    obj.set("colors/diffuse", color)
    return true
  return false
#)
func color_mat_override(obj, color, params={}):
  params = mergedicts({"color_param":0, "unique":false}, params)
  var mat
  if obj.has_method("get_material_override"):
    mat = obj.get_material_override()
    if params.unique:
      mat = mat.duplicate()
      obj.set_material_override(mat)
    if not is_null(mat):
#      g._store["ni"] = mat
      mat.set_parameter(params.color_param, color)
      return true
  return false

func color_mesh(obj, color):
  var mesh
  var mat
  if obj.has_method("get_mesh"):
    mesh = obj.get_mesh()
    if not is_null(mesh):
      var new_mesh = mesh.duplicate()
      obj.set_mesh(new_mesh)
      var surfs = new_mesh.get_surface_count()
      if surfs > 0:
        mat = new_mesh.surface_get_material(0)
        if !is_null(mat):
          var new_mat = mat.duplicate()
          new_mesh.surface_set_material(0,new_mat)
          new_mat.set_parameter(0, color)
          report("ma vs new mat", [mat == new_mat], 0 , 0, {"only":false})
          return true
  return false

func get_color_mesh(obj):
  var mesh
  var mat
  if obj.has_method("get_mesh"):
    mesh = obj.get_mesh()
    if not is_null(mesh):
      var surfs = mesh.get_surface_count()
      if surfs > 0:
        mat = mesh.surface_get_material(0)
        if !is_null(mat):
          return [true, mat.get_parameter(0)]
  return [false]

# func change_color_mesh(obj, color, do_lerp=false,lerp_t=10000):
#   var mesh
#   var mat
#   var newcol = color
#   if obj.has_method("get_mesh"):
#     mesh = obj.get_mesh()
#     if not is_null(mesh):
# #      var new_mesh = mesh.duplicate()
# #      obj.set_mesh(new_mesh)
#       var surfs = mesh.get_surface_count()
#       if surfs > 0:
#         mat = mesh.surface_get_material(0)
#         if !is_null(mat):
# #          var new_mat = mat.duplicate()
# #          mesh.surface_set_material(0,new_mat)
#           if do_lerp:
#             var col = mat.get_parameter(0)
#             newcol = col.linear_interpolate(color, (t()%(lerp_t+1))/float(lerp_t))
# #            mat.set_parameter(0, newcol)
# #          else:
#           mat.set_parameter(0, newcol)
#           return [true, newcol]
#   return [false]

func change_color_mesh(obj, color, tween=false,tween_time=3, force=false):
  var mesh
  var mat
  var newcol = color
  if obj.has_method("get_mesh"):
    mesh = obj.get_mesh()
    if not is_null(mesh):
#      var new_mesh = mesh.duplicate()
#      obj.set_mesh(new_mesh)
      var surfs = mesh.get_surface_count()
      if surfs > 0:
        mat = mesh.surface_get_material(0)
        if !is_null(mat):
#          var new_mat = mat.duplicate()
#          mesh.surface_set_material(0,new_mat)
          if tween:
            var obj_tween
            if tweens.chgcol.has(obj.get_path()):
              obj_tween = tweens.chgcol[obj.get_path()]
            else:
              obj_tween = Tween.new()
              add_child(obj_tween)
              tweens.chgcol[obj.get_path()] = obj_tween
            if force or not obj_tween.tell() > 0:
              var col = mat.get_parameter(0)
              # newcol = col.linear_interpolate(color, (t()%(tween_time+1))/float(tween_time))
              obj_tween.interpolate_property ( mat, "params/diffuse", col, color, tween_time, 0, 1 )
              obj_tween.start()
  #            mat.set_parameter(0, newcol)
          else:
            mat.set_parameter(0, newcol)
          return [true, newcol]
  return [false]


func color_children(obj, color, all=true):
  for child in obj.get_children():
    if colorify_object(child, color):
      if !all:
        return true
  return false

func colorify_object(obj,color,all_children=true):
  # find existing material
  var success = false
  if obj.is_type("Spatial"):
    success = (color_obj(obj, color) or
    color_mat_override(obj, color) or
#    color_mat(obj, color) or
#    color_mesh(obj, color) or
    color_children(obj,color,all_children))
  return success

func hide_mark(group):
  if gsvar.records.has(group):
    for mark in gsvar.records[group]:
      mark.hide()

# create_mark({"pos":sidecol.point,"arrow_rot":vpoint, "arrow_shift":Vector3(0,60,0)}, "vpoint", true)
func create_mark(params, group, one_instance=false, delete_old=false):
  if release:
    return
  var defaults = {"pos":Vector3(),"arrow_vertical": false, "arrow" : true, "arrow_rot":PI/3.0, "update":false, "label":"label", "label_pos":null, "arrow_shift":Vector3(), "timeout":-1}
  params = mergedicts(defaults, params)
  var dbg_id = sanitize_ini_name(group)
  if not is_null(dbgentries) and not debug_entry_enabled.mark.has(dbg_id):
    dbgentries.add_entry("mark",dbg_id)
#    debug_entry_enabled.report[dbg_id] = dbgentries.config.get_value("report", dbg_id, true)
  if debug_entry_enabled.mark.has(dbg_id) and not debug_entry_enabled.mark[dbg_id]:
    if gsvar.records.has(group):
      for mark in gsvar.records[group]:
        mark.queue_free()
      gsvar.records.erase(group)
    return

  if delete_old && gsvar.records.has(group):
    for mark in gsvar.records[group]:
      mark.queue_free()
    gsvar.records[group] = []
  var inst
  var exists = false
  if one_instance:
    if gsvar.records.has(group):
      exists = true
      inst = gsvar.records[group][0]
#    else:
#      inst = gsvar.me.landing_mark_scene.instance();
#      gsvar.add_record(group, inst)
  if !exists:
    inst = gsvar.me.landing_mark_scene.instance();
    gsvar.add_record(group, inst)
  inst.show()
  inst.set_name("expl");
  if params.timeout > 0:
    callv_later(inst.get_node("Label"), "hide", [], params.timeout)
  if !is_null(params.label_pos):
    inst.label_pos = params.label_pos
  inst.set_global_transform(Transform(Matrix3(), params.pos));
  if !exists or params.update:
#    var label = str(params.label)
    var label = eval_context().pretty_str(params.label, 200)
#    if label.length() > 80:
#      label = label.replace("(", "\n(")
    inst.get_node("Label").set_text(label)
    inst.get_node("Label").show()
    inst.get_node("Label").set("custom_colors/font_color_shadow", Color(0,0,0,1))
    if params.arrow:
      inst.get_node("arrow").show()
      inst.get_node("arrow").set_rotation(Vector3(PI/2.0,0,-params.arrow_rot + PI))
      if params.arrow_vertical:
        inst.get_node("arrow").rotate_x(PI/2)
        inst.get_node("arrow").translate(params.arrow_shift)
    else:
      inst.get_node("arrow").hide()
    if params.has("color"):
      colorify_object(inst, params.color)
  if !exists:
#    inst.get_node("Label").hide()
    gsvar.world.env.add_child(inst);
  return inst


func pretty_str(v, line_max=10, indent=0):
  var ind = ""
  for i in range(indent):
    ind += "/"
  var out = str(v)
  if out.length() < line_max:
    return out
  else:
    out = "\n"
    if typeof(v) == TYPE_DICTIONARY:
      for i in v:
        out += ind + str(i) + " : "
        out += ind + "/" + pretty_str(v[i], line_max, indent+1) + "\n"
    elif typeof(v) == TYPE_ARRAY:
      for i in v:
        out += ind + pretty_str(i, line_max, indent) + "\n"
    else:
      out += ind + str(v) + "\n"
  return out

func pp(v, line_max=10, indent=0):
  pretty_str(v, line_max, indent)

func ball():
  # return store_get("recent_ball", get_node("/root/world/env/Ball"))
  return store_get("recent_ball", null)

func action_unbind(action, combos, type=InputEvent.KEY):
  if not InputMap.has_action(action):
    InputMap.add_action(action)
  for old_event in InputMap.get_action_list(action):
    if old_event.type == type:
      InputMap.action_erase_event(action, old_event)

func action_bind(action, combos, type=InputEvent.KEY):
  report("bind action", [action, combos, type], 0 , -1, {"only":false})
  if not InputMap.has_action(action):
    InputMap.add_action(action)
  for old_event in InputMap.get_action_list(action):
    if old_event.type == type:
      InputMap.action_erase_event(action, old_event)
  var event
  for combo in combos:
    event = InputEvent()
    event.type = type
    if type == InputEvent.KEY:
      event.scancode = combo[0]
      if combo.size() > 1:
        if combo.has("alt"):
          report("key binding with modifier", [], 0 , 1000, {"only":false})
          event.alt = true
        if combo.has("shift"):
          report("key binding with modifier", [], 0 , 1000, {"only":false})
          event.shift = true

    elif type == InputEvent.MOUSE_BUTTON:
      event.device = 0
      event.button_index = combo[0]
    elif type == InputEvent.JOYSTICK_BUTTON:
      event.device = 0
      event.button_index = combo[0]
#    event.scancode = combo[0]
#    if combo.size() > 1:
#      if combo.has("alt"):
#        report("key binding with modifier", [], 0 , 1000, {"only":false})
#        event.alt = true
    InputMap.action_add_event(action, event)

func action_bind_mouse(action, combos):
  action_bind(action, combos, InputEvent.MOUSE_BUTTON)
#  if not InputMap.has_action(action):
#    InputMap.add_action(action)
#  for old_event in InputMap.get_action_list(action):
#    if old_event.type == InputEvent.MOUSE_BUTTON:
#      InputMap.action_erase_event(action, old_event)
#  var event
#  for combo in combos:
#    event = InputEvent()
#    event.type = InputEvent.MOUSE_BUTTON
#    event.device = 0
#    event.button_index = combo[0]
#    InputMap.action_add_event(action, event)

func action_bind_joy(action, combos):
  action_bind(action, combos, InputEvent.JOYSTICK_BUTTON)

func swap_tab_rmb():
  report("swap tab rmb", [], 0 , 1000, {"only":false})
  action_bind("aim", [[KEY_TAB]])
  action_bind_mouse("aim", [])
  action_bind("jump", [])
  action_bind_mouse("jump", [[BUTTON_RIGHT]])

func avgr(label, cur, t=0.1):
  if not avgr_vals.has(label):
    avgr_vals[label] = []
  var tnow = t()
  avgr_vals[label].append([tnow, cur])
  var vals = []
  for v in avgr_vals[label]:
    if tnow - v[0] > t*1000:
      avgr_vals[label].pop_front()
    else:
      vals.append(v[1])
  return avg(vals)


func test(v):
  return v and true

func roundf(f, n=2, x=10): # can use stepify instead
    f *= (10.0/x)
    var r = round(pow(10,n)*f) * 1.0 / pow(10,n)
    r = r/(10.0/x)
    return r

func roundfvec3(vec,n=3,x=10): # can use snapped instead
  return Vector3(roundf(vec.x,n,x),roundf(vec.y,n,x),roundf(vec.z,n,x))

func s_pow(a,b):
  var s = sign(a)
  return s*pow(abs(a), b)

func deep_has(v, ary):
  for i in ary:
    if not v.has(i):
      return false
    v = v[i]
  return true

func stop_object_timer(tn,obj):
  if object_timer_active(tn, obj):
    var timer = timers[obj][tn]
    timer.stop()

func object_timer_active(tn, obj):
  if not timers.has(obj):
    timers[obj] = {}
  if not timers[obj].has(tn):
    return false
  var timer = timers[obj][tn]
  return timer.is_active()

func object_timer_timeleft(tn, obj):
  if not timers.has(obj):
    timers[obj] = {}
  if not timers[obj].has(tn):
    return -1
  var timer = timers[obj][tn]
  return timer.get_time_left()

func countdown(n=5,obj=self,fn=null,param={}):
  # var dparams = {"step":1.5, "args":[], "count":5}
  # params = g.mergedicts(dparams, params)
  param = mergedicts({"step":1.15, "args":[]}, param)
  if n == 0:
    if is_null(fn):
      fn = "default_countdown"
      # gsvar.announce(["cd func", fn], 3,"2")
    obj.callv(fn, param.args)
  else:
    # gsvar.announce(str(n), 0.6, "2")
    gsvar.announce(str(n), param.step - 0.35, "", {"top":false})
    n -= 1
    # g.object_timer("countdown", self, "countdown", true, param.step, [n, fn, param], false, true)
    object_timer_p("countdown", self, "countdown", {"one":true, "intv":param.step, "args" : [n,obj, fn, param], "replace":true,  "pause_mode":2})

func default_countdown(msg="countdown finished"):
  gsvar.announce(msg, 4, "2")

func callv_later(obj, fn, args=[], after=0.1, latch=false, tname=null):
  if is_null(tname):
    tname = fn + join_array(args,'_')
  object_timer(tname, obj, fn, true, after, args, latch,true,true)

func object_timer_p(tn, obj, fn, param={}):
  param = mergedicts({"one":false, "intv":3, "args" : [], "latch":false, "replace":false, "dispose":false, "pause_mode":0}, param)
  object_timer(tn, obj, fn, param.one, param.intv, param.args, param.latch, param.replace, param.dispose, param.pause_mode)

func object_timer(tn, obj, fn, one=false, intv=3, args = [], latch=false, replace=false, dispose=false, pause_mode=0):
  # report("tname", [tn],-1,-1)
  if not timers.has(obj):
    timers[obj] = {}
#  var obj_timers = timers[obj]
#  var existing = obj_timers.has(tn)
  var new = false
  var timer
  if timers[obj].has(tn) and not replace:
    timer = timers[obj][tn]
#    if one:
#      obj_timers[tn].queue_free()
#  if one or not existing:
  else:
    if timers[obj].has(tn):
     timers[obj][tn].stop()
     timers[obj][tn].set_name(tn+"_invalid")
     timers[obj][tn].queue_free()
    new = true
    timer = Timer.new()
#    timer.set_pause_mode(2)
    timer.set_name(tn)
    timer.set_one_shot(one)
    timer.set_timer_process_mode(0)
#  if new:
    timer.connect("timeout", obj, fn, args)
    if dispose:
      timer.connect("timeout", self, "free_timer" , [obj, tn])
    if latch:
      add_child(timer)
    else:
      obj.add_child(timer)
    timers[obj][tn] = timer
  timer.set_pause_mode(pause_mode)
  timer.set_wait_time(intv)
  timer.start()
  timer.set_active(true)

func free_timer(obj, tn):
  timers[obj][tn].queue_free()
  timers[obj].erase(tn)


func join_array(a, d=''):
  var s = ""
  var n = -1
  for i in a:
    n+=1
    s += str(i)
    if n < a.size()-1:
      s += d
  return s

func enable_w_set(obj, vars):
  weighted_setters[obj] = {}
  for v in vars:
    weighted_setters[obj][v] = {}

func w_set(obj, vari, setter=null, val=null, weight=null):
  var vs = weighted_setters[obj][vari]
  if not is_null(setter):
    vs[setter] = [weight, val]
  var chosen = null
  var max_weight = -1
  for s in vs:
    if vs[s][0] > max_weight:
      max_weight = vs[s][0]
      chosen = vs[s][1]
  obj.set(vari, chosen)

func w_unset(obj, vari, setter):
  weighted_setters[obj][vari].erase(setter)
  w_set(obj, vari)

func check_funcs(obj, reqs, all=true):
  var result
  var any = not all
  for r in reqs:
    result = obj.call(r)
    if all and not result:
      return false
    if any and result:
      return true
  return all

func allf(obj, reqs):
  return check_funcs(obj, reqs)

func anyf(obj, reqs):
  return check_funcs(obj, reqs, false)

func cb():
#  timer("catch ball", "cb", true, 0.2, [])
  ball().catch(Globals.net.uid, true)

#func ball():
#  return get_node("/root/world/env/Ball")


func setup_trap():
  gsvar.me.new_spawn = {'pos':Vector3(10,0,0), 'rot':0 }
  bot().new_spawn = {'pos':Vector3(0,0,100), 'rot':PI*0.5 }
  if not is_null(bot(1)):
    bot(1).new_spawn = {'pos':Vector3(100,0,100), 'rot':PI*-0.5 }

func bot(idx=0, xf=null):
  print(xf)
#  var bot = gsvar.add_bot(100)
  if idx > 2 :
    return
  var bot = bots()[idx]
  if not is_null(xf):
    bot.set_transform(xf)
  return bot

func bots(n=null):
  if is_null(n):
    n = 2
  if gsvar.bots.size() < n:
    add_bots(n - gsvar.bots.size())
  return gsvar.bots

func add_bots(n=1):
  for i in range(n):
    var inst = gsvar.add_bot()

func setup_bots():
#  setup_trap()
  cb()
  create_players(1, true)
#  for bot in bots(2):
#    activate_bot(bot)

func server_bot():
  activate_bot(gsvar.me)
#  var me = gsvar.me
#  report("alosad", [], 0 , -1, {"only":false})
#  var bot_action = load("res://scripts/bot_action.gd")
#  var manager = bot_action.BotActionManager.new(me)
#  manager.set_name("ActionManager")
#  get_node("/root/world").add_child(manager)
##  manager.g = g
#  var an = manager.select_action(me.build_situation())
#  me.action_manager = manager
#  var action = manager.actions[an]

func activate_bot(bot):
  if !net.is_primary:
    return
  if not is_null(bot.control):
    var oldc = bot.control
    bot.control=null
    bot.remove_child(oldc)
  var bot_control = load("res://scripts/bot_control.gd").new()
  bot_control.tank = bot
  bot.add_child(bot_control)
  bot.control = bot_control
  var bot_action = load("res://scripts/bot_action.gd")
  var manager = bot_action.BotActionManager.new(bot_control)
  manager.set_name("ActionManager")
#  get_node("/root/world").add_child(manager)
  bot_control.add_child(manager)
  # var an = manager.select_action(bot.control.situation)
  var an = manager.select_action(bot.control.build_situation())
  bot.control.action_manager = manager
  # var action = manager.actions[an]


func create_local_player(nid=3001, bot=false, name="test", pos=Vector3(0,10,0)):
  if (!net.is_primary):
    return;
  if not is_null(gsvar.player_by_id(nid)):
    report("existing player, not creating new one", [nid], 0 , -1, {"only":false})
    return gsvar.player_by_id(nid)
#  gsvar._peer_connected(nid); # add player id to players list
#  print("cl_name", "test")
#  gsvar.player_joined(nid, "test", gsvar.config.tank_style); # assign player data to id and rpc cal create_world
#  gsvar.player_ready(nid);
  var player = gsvar.add_local_player(nid, pos, name)
  if not bot:
    player.is_node_master = true
  else:
    player.is_bot = true
#    color_mat_override(player.get_node("body/TestCube"), Color(1,0,0,1), {"color_param":3, "unique":true})
    gsvar.bots.append(player)
    activate_bot(player)

  return gsvar.player_by_id(nid)
#  g.activate_bot(gsvar.player_by_id(nid))

func pf(ye):
  gsvar.pause_freeze = ye

func p(v=null):
  if is_null(v):
    v = not get_tree().is_paused()
  get_tree().set_pause(v)

func create_players(n, bot=false):
  var positions = [Vector3(50, 1, 150), Vector3(100,1,0),Vector3(0,1,100),Vector3(20,1,50),Vector3(60,1,20),Vector3(50,1,50),Vector3(50, 1, 150), Vector3(100,1,0),Vector3(0,1,100),Vector3(20,1,50),Vector3(60,1,20),Vector3(50,1,50),Vector3(50, 1, 150), Vector3(100,1,0),Vector3(0,1,100),Vector3(20,1,50),Vector3(60,1,20),Vector3(50,1,50),]
  var roles = [["tracker"], ["defender"],["tracker"], [""],[""], [""],[""], [""],[""], [""],[""], [""],[""], [""],[""], [""],[""], [""],[""], [""],[""]]
  if n > 50:
    return
  for i in range(n):
    var player = create_local_player(3001 + i, bot, roles[i][0], positions[i])
#      color_mat_override(player.get_node("body/TestCube"), Color(1,0,0,1), {"color_param":3, "unique":true})
    player.new_spawn = {"pos":positions[i], "rot":0}
    if roles.size() > i:
      player.control.action_manager.roles = roles[i]

func remove_bots():
  for b in gsvar.bots:
    gsvar.remove_player(b.pid)
  gsvar.bots = []

func array_slice(ary, start, end):
  if start < 0:
    start = max(0, ary.size() + start) + 1
  if end < 0:
    end = max(0, ary.size() + end) + 1
  var out = []
  for i in range(start, end):
    out.append(ary[i])
  return out

func get_string_lines(text, start, end):
  var out = ""
  var lines = text.split("\n")
  var slice = array_slice(lines, start, end)
  return join_array(slice, "\n")

func pivrot(obj, deg=PI, point=Vector3(), axis=Vector3(0,1,0)):
  pass
  var transform = obj.get_transform()
  # # var x_axis = Vector3(1, 0, 0)
  # # var pivot_point = get_node("../PivotBall").translation
  var vec = obj.get_translation() - point
  var pivot_transform = Transform(transform.basis, point)
  transform = pivot_transform.rotated(axis, deg).translated(vec/obj.get_scale())
  # transform = pivot_transform.rotated(axis, deg)
  obj.set_transform(transform)
  return [obj.get_translation(), transform.origin]

func create_effect(pos,name="balltouch", src=0):
  var effects = sg("effects", {
    "balltouch":load("res://prefabs/balltouch.tscn"),
    })
  var inst = effects[name].instance();
  inst.set_name(name);
  inst.set_global_transform(Transform(Matrix3(), pos));
  gsvar.world.env.add_child(inst, true);