extends RigidBody

var owner;
var models;
var run_time;
var max_time = 3.5 #0.75;
var shotline;
var shotline2
var shotline4
var missile_id;
var last_collider;
var last_collision_time = 0;
var ray_res = {}
var ray_res_valid = false
var speed = 0
var last_lv = Vector3()
var shotline_mat
var colliding_tanks = []
var inside_shooter_hit_area = false
var cur_state
var cur_collider
var bullet_speed = 150 + 150
var initial_velocity
var next_col_t = -1
var end_it = false
onready var tween = get_node("tween")
onready var gsvar = get_node("/root/gamestate")
onready var net = get_node("/root/net")
onready var me = gsvar.me
onready var pfb_rico = load("res://prefabs/ricochet.tscn");
onready var global = get_node("/root/global")
var g = Globals.g

signal missile_hit(owner, pos, mid)


func _init():
  owner = -1;
  missile_id = -1;
  run_time = 0.0;
  last_collider = null;


func _ready():
  net.path_ht[String(get_path()).hash()] = get_path()
  models = get_node("bullet");
  shotline = get_node("shotline3");
  shotline2 = get_node("shotline2");
  # shotline4 = get_node("shotline3/shotline4");
  last_lv = initial_velocity
  adjust_shotline(initial_velocity)
  # g.sounds.play("gunshot3")
  # gsvar.player_by_id(owner).sounds.play("gunshot3")
  # gsvar.player_by_id(owner).sounds.play("458669__jorgerosa__missile-launch")
  gsvar.player_by_id(owner).sounds.play(g.sg("fire_sound", "Explosion15"))
#  shotline2.set_hidden(false)
#  shotline2.call_deferred( "set_hidden", false)

  shotline.set_material_override(shotline.get_material_override().duplicate())
  shotline_mat = shotline.get_material_override()
  # g.ev.qann(["shotl mat", shotline_mat], 3)
  if me:
    me.connect("player_got_hit", self, "player_hit")
    set_process(true);
    set_fixed_process(true);
    # shotline_tween(shotline)
    # shotline_tween(shotline4)
    # tween.start()

func player_hit(shooter):
  g.report("missile acks player hit:" + String(missile_id), [shooter], 0 , 1000, {"only":false})


func _process(delta):
  run_time += delta;
  # if (run_time > 1.5):
  if (run_time > max_time) or end_it:
#    emit_signal("exploded", owner, get_global_transform().origin, missile_id);
    queue_free();
    gsvar.missiles.erase(missile_id);
    return;


func _fixed_process(delta):
  # predict_collision()
  pass
  # print("ohayo")
  # g.ev.sd("booomz", "AAA")
  # g.eval_context().qann("booomz")



func predict_collision(state):
#  if ray_res.empty() and (not last_collider or (OS.get_ticks_msec() - last_collision_time) > 10):
#  if ray_res.empty():
  # if not ray_res_valid and (not last_collider or (OS.get_ticks_msec() - last_collision_time) > 10):
  if not ray_res_valid :
    var bullet = self
    # var pos = bullet.get("transform/translation")
    var pos = state.get_transform().origin
    # var target = pos + bullet.get_linear_velocity().normalized() * 5000
    var target = pos + bullet.last_lv.normalized() * 5000
    # g.report("rayres not valid yo", [pos,target, bullet.get_linear_velocity().normalized()], 0 , -1, {"only":false})
    ray_res = get_world().get_direct_space_state().intersect_ray(pos, target, [], 2147483647, 1);
    # ray_res_valid = true
    if not ray_res.empty() and last_collider != ray_res.collider:
      ray_res_valid = true
      g.store_set("bul_ray", ray_res)
      g.report("rayres result", [ray_res], 1 , 1000, {"only":false})
      next_col_t = g.t() + 1000 * (ray_res.position - get_translation()).length() / last_lv.length()
      # g.ev.qann(["should col after ", (next_col_t - g.t())/1000], 5)
      g.create_mark({ "update":true,"pos":ray_res.position + Vector3(0,0.01,0),"arrow":true,"arrow_rot":atan2(ray_res.normal.x, ray_res.normal.z)}, "colpoint", true,false)
      # g.ev.qann(["col pos", ray_res.position], 3)
      # g.ev.pp(["col pos", ray_res.position,next_col_t - g.t()],2000)
      # g.chreport("should col after ",[ (next_col_t - g.t())/1000, ray_res.collider.get_path()])
      # last_lv = get_linear_velocity()
  else:
    g.report("rayresnotempty", [ray_res], 0 , 300, {"only":false})


func _integrate_forces(state):
  predict_collision(state)
  # g.eval_context()._shot_integrate_forces(self,state)
  var xf = state.get_transform()
  # qann("probz")
  var new_pos = xf.origin + state.get_step() * last_lv
  xf.origin = new_pos
  state.set_transform(xf)
  var shot = self
  if not shot.me:
    return
  # shot.adjust_shotline(state.get_linear_velocity())
  shot.adjust_shotline(last_lv)
  # shot.shotline2.set_hidden(false)
  shot.shotline.set_hidden(false)
  if not shot.colliding_tanks.empty():
    for t in shot.colliding_tanks:
      shot.hit_tank(state, t)
      pass
  shot.colliding_tanks = []
  # var lv = state.get_linear_velocity();
  var lv = last_lv;
  var missed_collision = lv.length() < 50
#  if (state.get_contact_count() > 0):
#    for i in range(state.get_contact_count()):
#      var collider = state.get_contact_collider_object(i);
#      if collider.get_type() == "StaticBody":
#        if handle_ricochet(state, collider, i):
#          return
#  if missed_collision and not ray_res.empty():
#    handle_ricochet(state,ray_res.collider )
  if not shot.ray_res.empty():
    # if (abs(get_translation().distance_to(shot.ray_res.position)) < g.store_get('bullet_col_margin')):
    if  g.t() > next_col_t:

    # if (abs(get_translation().distance_to(shot.ray_res.position)) < 30):
      # g.report("ricochet!", [ray_res, ray_res.collider.get_path()], 0 , -1, {"only":false})
      shot.handle_ricochet(state,shot.ray_res.collider )
      pass

func adjust_shotline(lv):
#  var lv = state.get_linear_velocity();
 # var lv = last_lv);
#  var transform = state.get_transform();
  var lvn = lv.normalized();
#  shotline.set_rotation(Vector3(0,  -Vector2(lvn.z,lvn.x).angle(),Vector2(lvn.y, PI/2.0).angle()));
#  g.report("shotline2", [shotline2], 0 , 1000, {"only":false})
  shotline2.set_rotation(Vector3(0,  -Vector2(lvn.z,lvn.x).angle(),Vector2(lvn.y, PI/2.0).angle()));
  shotline.set_rotation(Vector3(0,  -Vector2(lvn.z,lvn.x).angle(),Vector2(lvn.y, PI/2.0).angle()));
  # shotline.look_at_from_pos(get_translation(), get_translation() + lv, Vector3(0,1,0))

#  shotline.set_rotation(Vector3())
  if not g.is_null(shotline_mat):
    var vdist = abs(me.get_translation().y - get_translation().y)
    var colcomp = clamp(1 - pow(vdist,1.5) / 60.0, 0.4, 1)
    g.ev.sd("colcomp", colcomp)
    shotline_mat.set_shader_param( "colcomp" , colcomp * 15 )
#  g.report('radar range', sqrt(me.current_zoom), 5 ,500 )
    shotline_mat.set_shader_param( "scale" , pow(me.current_zoom, 0.8) * 1)

func shotline_tween(line):
  var t = max_time #1 #.5
  var d = 0.2
  # var l = 200
  # var l = 150
  var l = max_time * bullet_speed
  var trans = 0 #
  var eas = 0
  tween.interpolate_property( line, "quad/size", Vector2(0,100), Vector2(l,20), d, trans, eas,0 )
  tween.interpolate_property( line, "quad/size", Vector2(l,40), Vector2(0,40), t-d, trans, eas,d )
  tween.interpolate_property( line, "quad/offset", Vector2(0,0), Vector2(-l/2.0,0), d, trans, eas,0 )
  tween.interpolate_property( line, "quad/offset", Vector2(-l/2.0,0), Vector2(-0,0), t-d, trans,eas, d )

  # tween.interpolate_property ( self, "visibility/opacity", 1, 0, t, 0, 1 )

func handle_ricochet(state, collider, col_idx=null):
#  var lv = state.get_linear_velocity();
#  var transform = state.get_transform();
#  var lvn = lv.normalized();
#  var is_rb_collider = collider.get_type() == "RigidBody"
  #var is_char_collider = is_rb_collider and collider.get_mode() == MODE_CHARACTER
#  if is_char_collider:
  if collider.get_type() == "RigidBody":

#      g.report("missile hit character" + collider.get_name(), [collider], 0 , 1000, {"only":false})
    #var col_shape = state.get_contact_collider_shape(col_idx)
#      if col_shape != 0:
#        return false
    #var not_direct_self_hit = last_collider or (collider != gsvar.player_by_id(owner))
    #var self_is_hit = collider.is_node_master or collider.is_bot
#    if not_direct_self_hit and self_is_hit:
      #emit_signal("missile_hit", owner, get_global_transform().origin, missile_id);
      #collider.get_killed(owner, get_global_transform().origin, missile_id)
#      var impulse = lv;
      #collider.apply_impulse(state.get_contact_local_pos( col_idx ) , Vector3(lvn.x * 100, 5, lvn.z * 100));
#      collider.last_got_hit = OS.get_ticks_msec()
      return true
  else: # static body col
    var ln
    var lp
    if last_collider != collider and not ray_res.empty():

      if  true or (abs(get_translation().distance_to(ray_res.position)) < g.store_get("bullet_col_margin")):
        # g.ev.qann(1)
        var hit_back_arch = collider.get_path() == "/root/world/env/Plane8/Arch2/StaticBody"
        hit_back_arch = hit_back_arch and (sign(ray_res.normal.z) == sign(ray_res.position.z) )
        if not hit_back_arch:

          ln = ray_res.normal
          lp = ray_res.position
      else:
        return false
        if col_idx:
          print("exception")
          ln = state.get_contact_local_normal(col_idx)
          lp = state.get_contact_local_pos(col_idx )
      last_collision_time = OS.get_ticks_msec()
      if typeof(ln) == TYPE_VECTOR3:
        if get_translation().y > 20 and collider.get_path().get_name(3) == "worldwalls":
          # g.ev.qann(["h2i", get_translation().y], 2)
          end_it = true
        elif collider.get_parent().has_meta("links"):
          # g.ev.qann(["collider for bullet", collider.get_parent().has_meta("links")], 3)
          # state.set_linear_velocity(last_lv);
          teleport(state, collider)
          pass
        else:
          var xf = state.get_transform()
          xf.origin = ray_res.position
          state.set_transform(xf)
          last_lv = ln.reflect(last_lv).normalized() * speed
          # state.set_linear_velocity(last_lv);
          create_ricochect_effect(lp, ln)
          last_collider = collider;

#        ray_res = {}
        # g.report("invalidate ray res", [], 0 , 1000, {"only":false})
        ray_res_valid = false
        # predict_collision()
        # handle self propelling rico shot
        if inside_shooter_hit_area:
          hit_tank(state, me)
        return true


func teleport(state, collider):
  var telein = collider.get_parent()
  var telein_rot = telein.get_rotation().y
  var face_enter = max(-sign(ray_res.normal.dot(Vector3(cos(telein_rot), 0 ,sin(telein_rot)))), 0)
  # g.ev.qann(["enter ",face_enter ], 1)
  var telein_aabb = telein.get_transformed_aabb().size
  var telein_pos = telein.get_global_transform().origin - Vector3(0,telein_aabb.y*0.5,0)
  var telein_rel_enter_pos = (ray_res.position - telein_pos).rotated(Vector3(0,1,0), telein_rot)
  var out_tele_idx = -1
  var leave_face = -1
  for l in telein.get_meta("links"):
    if l[0] == face_enter:
      out_tele_idx = l[1]
      leave_face = l[2]
  if out_tele_idx > -1:
    var teleout = get_tree().get_nodes_in_group("bzw_teleporter")[out_tele_idx]
    var teleout_aabb = teleout.get_transformed_aabb().size
    var teleout_pos = teleout.get_global_transform().origin - Vector3(0,teleout_aabb.y*0.5,0)
    var tele_scale = teleout_aabb  / telein_aabb
    var out_pos = teleout_pos
    if face_enter == leave_face:
      var teleout_rel_pos = telein_rel_enter_pos.rotated(Vector3(0,1,0), -teleout.get_rotation().y) * tele_scale
      out_pos -= g.xnz(teleout_rel_pos, -teleout_rel_pos.y)
      last_lv = last_lv.rotated(Vector3(0,1,0), PI)
    else:
      out_pos += telein_rel_enter_pos.rotated(Vector3(0,1,0), -teleout.get_rotation().y) * tele_scale
    var xf = state.get_transform()
    xf.origin = out_pos
    state.set_transform(xf)
    # g.ev.qann("hi")
    last_collider = teleout.get_children()[0]
    # g.ev.qann(["out pos  ",out_pos ], 1)

func add_tank_collider(collider):
  colliding_tanks.append(collider)


func hit_tank(state, collider):
#  gsvar.pause(true)
  g.report("hit tank!!", [], 0 , -1, {"only":false})
  cur_state = state
  cur_collider = collider
  # var lv = state.get_linear_velocity();
  var lv = last_lv;
  var transform = state.get_transform();
  var lvn = lv.normalized();
  #var col_shape = state.get_contact_collider_shape(col_idx)
#      if col_shape != 0:
#        return false
  var not_direct_self_hit = last_collider or (collider != gsvar.player_by_id(owner))
  var self_is_hit = collider.is_node_master or collider.is_bot
  if not_direct_self_hit and self_is_hit:
    var rot = Vector3(0, atan2(lv.x, lv.z) ,0)
    create_tank_ricochect_effect(get_translation(), rot)
    emit_signal("missile_hit", owner, get_global_transform().origin, missile_id,collider.pid);
    collider.get_killed(owner, get_global_transform().origin, missile_id)

    var impulse = lv;
#    collider.apply_impulse(state.get_contact_local_pos( col_idx ) , Vector3(lvn.x * 100, 5, lvn.z * 100));
    # collider.apply_impulse(Vector3(0,0,0) , Vector3(lvn.x * 100, 5, lvn.z * 100));
    # collider.apply_impulse(Vector3(0,0,0) , Vector3(0, 5, 0));
    # collider.pending_impulse.append(Vector3(lvn.x * 0, 10, lvn.z * 0));
    collider.pending_impulse.append(Vector3(lvn.x * 0, 60, lvn.z * 0));
    # collider.pending_impulse.append(Vector3(lvn.x * 150, 5, lvn.z * 150));
    collider.last_got_hit = OS.get_ticks_msec()


func create_ricochect_effect(pos, norm,scale=1.0):
  g.report("rico", [], 0 , -1, {"only":false})
  var inst = pfb_rico.instance();
  inst.set_scale(Vector3(scale,scale,scale))
  inst.set_name("rico");
  inst.look_at_from_pos(pos, pos+norm, Vector3(0,1,0));
  gsvar.world.env.add_child(inst, true);
  # tween.reset_all( )
  # tween.start()

func create_tank_ricochect_effect(pos,rot):
  g.report("tank rico", [], 0 , -1, {"only":false})
  var inst = pfb_rico.instance();

  inst.set_name("rico");
  inst.look_at_from_pos(pos, Vector3(), Vector3(0,1,0));
  inst.set_scale(Vector3(10,10,10))
  inst.set_rotation(rot)
  gsvar.world.env.add_child(inst, true);

  return inst