extends Node

var solo = false
var tutorial = false
var bots = []
var sv_dedicated;
var is_proxy = false
var is_proxy2 = false
var cl_name;
var cl_chatting;

var players;
var local_players = [];
var missiles;
var mainmenu = null;
var world;
var chatmgr;

var prefab_player;
var prefab_freecam;

var spawn_points;
var spawn_delay;
var players_path;

var config = {}
var records = {}

var timescale_adjusted_time = 0
var tst_synced = false

var focus = [0, 4, 8]
var last_focus = ""
var active_focus = ""
var me

var load_test

var quitting = false
var quit_time = 0
var quit_to_menu = false


var timers = {}
var paused = false
var running_time = 0
var temp_pause = false
var pause_time = 0

var is_ready = false
var game_running = false
var game_start_time = 0
var time_left = 0
var game_timer = null

var announce_timer
var split_screen

var pause_freeze = false

var kb_bind_map = {}
var joy_bind_map = {}

var normal_max_speed = 90

var secondary_focus
var active_game_mode

var teams = {"red":{}, "green":{}, "pink":{}, "gold":{}}
onready var net = get_node("/root/net")
onready var g = get_node("/root/global")

#signal latency_change(pid, diff, direct)
signal own_player_ready()


func _notification(what):
  if what == MainLoop.NOTIFICATION_WM_QUIT_REQUEST:
    request_quit(false)
#        get_tree().quit()


func _init():
  sv_dedicated = false;
  cl_name = "";
  cl_chatting = false;
  spawn_points = [];
  spawn_delay = 2.0;
  players_path = "env/players/";

  reset_variables();
#  load_config()


func reset_variables():
  players = {};
  missiles = {};
  spawn_points = [];
  cl_chatting = false;
  focus = ["game"]
  me = null


func _ready():
  print(str(config))
  Globals.set("gsvar", self)
#  g.store_set('bullet_col_margin', 3.5)
  running_time = OS.get_ticks_msec()
  change_focus("")
  g.gsvar = self
  set_bind_maps()
  rebind()
  adjust_3rd_cam_params()
  get_tree().set_auto_accept_quit(false)
  net.connect("client_connected", self, "_peer_connected");
  net.connect("client_disconnected", self, "_peer_disconnected");
  net.connect("connected_to_server", self, "_client_success");
  net.connect("connection_failed", self, "_client_failed");
  net.connect("server_disconnected", self, "_client_disconnected");
  g.report("loading player prefab", [], 0 , 1000, {"only":false})
#  prefab_player = load("res://prefabs/player2.tscn");
#  prefab_freecam = load("res://prefabs/cam_free.tscn");
  announce_timer = Timer.new()
  announce_timer.set_one_shot(true)
  add_child(announce_timer)
  announce_timer.connect("timeout", self, "hide_announcement", [])
#  load_config()
  set_pause_mode(2)
  set_process_input(true);
  set_process(true)
  set_fixed_process(true)

func _conf_ready():
  var overrides = g.sg("override_config", {})
  for o in overrides:
    config[o] = overrides[o]
  print("CONFIG LOADED")
  print(str(config))
#  if config.has("is_server"):
#    OS.set_time_scale(config.game_speed / 100.0)

func _fixed_process(delta):
#  pass
  if not tst_synced:
    timescale_adjusted_time = g.t() / 1000.0
    g.report("t vs tst", [g.t(), timescale_adjusted_time], 0 , 1000, {"only":false})
    tst_synced = true
  else:
    timescale_adjusted_time += delta
#  timescale_adjusted_time += delta

func _process(delta):
  if is_ready:
    g.report("scrn_dbg", g.store_get("scrn_dbg"), 0 , 100, {"only":false, "out_mode":"screen"})
  if not paused:
    running_time += delta
  if quitting and (net.is_primary or (OS.get_ticks_msec() - quit_time > 5000)):
    g.report("local quitting", [quit_time, quit_to_menu], 0 , 1000, {"only":false})
    end_game()
#    quitting = false
#    if quit_to_menu:
#      end_game()
#      quit_to_menu = false
#    else:
#      get_tree().quit()


func _input(ie):
  if temp_pause and g.t() - pause_time > 300 and (ie.type == InputEvent.MOUSE_MOTION):
    pause(false)
  if [InputEvent.KEY].has(ie.type):
    if ie.is_action_pressed('fullscreen'):
      OS.set_window_fullscreen(not OS.is_window_fullscreen())
    if ie.is_action_pressed('vsync_toggle'):
      OS.set_use_vsync(not OS.is_vsync_enabled())
      get_node("/root/world/gui/fps/vs").set_hidden(not OS.is_vsync_enabled())
  if (ie.type == InputEvent.KEY && active_focus == "GC"):
    if (ie.pressed && ie.scancode == KEY_R):
#      end_game();#get_tree().quit();
      # g.eval_context().re_throw()
      g.countdown(3,g,null, {"step":0.5, "msg":"shoot!"})
      g.console_exec("/re_throw(true, 1.5)")
  if (ie.type == InputEvent.KEY && focus[-1] == "game"):
    if (ie.pressed && ie.scancode == KEY_F12):
#      end_game();#get_tree().quit();
      request_quit(true)
    if (ie.pressed && ie.scancode == KEY_F8):
#      end_game();#get_tree().quit();
      var g = get_node("/root/world/gui/on_screen_msg_group")
      g.dismiss_all()
#      mainmenu.raise()
#      if mainmenu.is_visible():
#        mainmenu.settings.save_settings()
#      mainmenu.set_hidden(mainmenu.is_visible())
  if [InputEvent.MOUSE_BUTTON, InputEvent.KEY, InputEvent.JOYSTICK_BUTTON].has(ie.type):
    if ie.is_action_pressed('switch_ball_cam'):
      g.eval_context().toggle_freecam()
#    if (ie.pressed && ie.scancode == KEY_ESCAPE):
    if ie.is_action_pressed('ui_cancel'):
      escape_pressed()
#      var mode_tog =  Input.MOUSE_MODE_CAPTURED
#      if Input.get_mouse_mode() != Input.MOUSE_MODE_VISIBLE:
#        mode_tog = Input.MOUSE_MODE_VISIBLE
#        control_overlay(true)
#      else:
#        control_overlay(false)
#      Input.set_mouse_mode(mode_tog);
#    if (ie.pressed && ie.scancode == KEY_O):
#      Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED);

func escape_pressed():
  if active_focus == "GC":
#        active_focus = "GNC"
    change_focus("GNC")
  elif active_focus == "GNC":
    if secondary_focus == null:
#        active_focus = "GC"
      change_focus("GC")

func adjust_3rd_cam_params():
  g.store_set('cam_dist', 30)
  g.store_set('cam_dist_mod', 0.5)
  g.store_set("cam_elevation", 28)
  g.store_set("cam_elevation_mod", 0.5)

# func restore_focus(force_primayy=false):
#   # if not force_primayy and notg.is_null(secondary_focus):

#   change_focus(last_focus)

func restore_focus(force_primary=false):
  # g.scrn_dbg("restorefocus", [g.t(), force_primary])
  if not force_primary and not g.is_null(secondary_focus):
    change_secondary_focus(secondary_focus)
  else:
    secondary_focus = null
    change_focus(last_focus)

func timer(tn, fn, one=false, intv=3, args = []):
  var existing = timers.has(tn)
  var timer
  if existing:
    timer = timers[tn]
    if one:
      timers[tn].queue_free()
  if one or not existing:
    timer = Timer.new()
    timer.set_pause_mode(2)
    timer.set_name(tn)
  timer.set_one_shot(one)
  timer.set_timer_process_mode(0)
  timer.set_wait_time(intv)
  timer.connect("timeout", self, fn, args)
  add_child(timer)
  timer.start()
  timers[tn] = timer


func temp_pause_after(delay,duration=0.5):
  timer("pause_timer", "pause", true, delay, [true, true])
  timer("unpause_timer", "pause", true, delay + duration, [false])

func pause_after(y,delay):
  timer("pause_timer", "pause", true, delay, [y])

func pause(y, temp=false):
  if y == paused:
    return
  g.report("pausing", [], 0 , -1, {"only":false})
  print_stack()
  if not y and active_focus == "GNC":
    return
  temp_pause = temp
  pause_time = g.t()
  if pause_freeze:
    get_tree().set_pause(y)
  if g.eval_context().has_method("test_settings"):
    g.eval_context().test_settings(y)
  paused = y

func change_secondary_focus(sec_focus=null):
  print(["OOOLALALA",last_focus,sec_focus])
  # last_focus = active_focus
  up_last_focus(sec_focus)
  active_focus = sec_focus
  secondary_focus = sec_focus

func up_last_focus(new_focus):
  if (active_focus == "GC" or active_focus == "GNC") and active_focus !=new_focus:
    last_focus = active_focus

func change_focus(new_focus):
#  if track_last:
#    last_focus = active_focus
  g.scrn_dbg("curmenufocus", new_focus)
  up_last_focus(new_focus)
  active_focus = new_focus
  if active_focus == "GC":
    Input.warp_mouse_pos(Vector2(200,200))
    control_overlay(false)
    pause(false)
  if active_focus == "GNC":
    if secondary_focus == null:
      control_overlay(true)
  #    pause_after(true, 0.5)
      pause(true)

func control_overlay(st):
#  if st:
#  var mouse_mode = {false:Input.MOUSE_MODE_CAPTURED, true:Input.MOUSE_MODE_VISIBLE}
  var mouse_mode = {false:Input.MOUSE_MODE_HIDDEN, true:Input.MOUSE_MODE_VISIBLE}
  Input.set_mouse_mode(mouse_mode[st])
  get_node("/root/world/gui/control_overlay").set_hidden(!st)

func load_config():
  var settings = ConfigFile.new()
  var err = settings.load("user://settings.cfg")
  var defaults = g.get_default_config()
  if err == OK:
    g.ss("defs", defaults)
    g.ss("sets", settings)

    for i in defaults:
      config[i.name] = settings.get_value(i.group, i.name, i.default)
#func load_config():
#  var conflines = g.get_config_lines()
#  for i in conflines:
#    config[i["name"]] = i["value"]
#
#
#func save_config():
#  var conflines = g.get_config_lines()
#  var f = File.new();
#  var fn  = "user://config.json"
#  f.open(fn, f.WRITE);
#  for i in conflines:
#    i["value"] = config[i["name"]]
#    f.store_line(i.to_json())
#  f.close();
  _conf_ready()

func host_game(port, max_clients):
  if not net.start_server("", port):
    return false
  if (sv_dedicated):
    print("Server hosted on port ", port, ".");
  create_world(config.host_game_mode);
  return true;


func join_game(ip, port):
  return net.connect_to_server(ip, port)


func _peer_connected(id):
  if (!net.is_primary):
# if (!net.is_server):
    return;
  players[id] = null;


func _peer_disconnected(id):
  if (!net.is_primary):
    return;
  g.report("player disconnected from server", [id], 0 , 1000, {"only":false})
  if (players.has(id)):
    player_disconnected(id);
    # players.erase(id);


func player_disconnected(id):
  chatmgr.broadcast_msg(str(players[id], " disconnected."));
  net.rpc_sync(self, "remove_player", [id]);



func remove_player(id, src=0):
#  net.check_perms(self, ["primary"], src)
  print("removing player", id)
  if not players.has(id):
    print("couldnt ind player")
    return
  teams[players[id].tank_color].erase(id)
  g.report(["-remove player", id], [], 0 ,0)
  var node = player_by_id(id);
  net.sync_table.erase(id)
  if (node == null):
    g.report(["!!Trying to remove player that does not exist", id])
    return;
  get_node("/root/world/gui/objectsname").remove_object(node)
  node.radar_player.queue_free();
  node.queue_free();
  players.erase(id);
#  get_node("/root/world/radarframe/players/" + str(id)).queue_free();

func team_players(color):
  return teams[color]

func _client_failed():
  mainmenu.set_message("Failed connecting to the server.");
  end_game();


func _client_disconnected():
  mainmenu.set_message("Disconnected from server.");
  end_game();


func end_game(exit_to_menu=true):
  if (world != null):
    g.world_ready = false
    records = {}
    g._store = {'scrn_dbg': {}}
#    if exit_to_menu:
#      mainmenu.show();
    world.get_parent().remove_child(world);
    world.call_deferred("free");
    world = null;
  reset_variables();
  net.close_connections()
  quitting = false
  if quit_to_menu:
#    end_game()
    quit_to_menu = false
    mainmenu.show();
    mainmenu.enable_control();
  else:
    get_tree().quit()
#  if exit_to_menu:
    #mainmenu.enable_control();

#  get_tree().call_deferred("set_network_peer", null);

func request_quit(to_menu=true,src=0):
  g.report("request quit", [to_menu,src], 0 , 1000, {"only":false})
  if net.is_primary:
    if src != 0:
      var peer = g.deep(net, ["connections", src, "cl", "peer"], null)
      g.report("player quitting", [src, peer], 0 , 1000, {"only":false})
      if peer != null:
        g.report("peer quitting", [peer], 0 , 1000, {"only":false})
        peer.disconnect_later()
        g.report("peer disconnected", [peer], 0 , 1000, {"only":false})
#        _peer_disconnected(src)
#    else:
#      end_game()
      return
  quitting = true
  quit_to_menu = to_menu
  quit_time = OS.get_ticks_msec()
  if not net.is_primary:
    net.rpc_id(net.primary_server , self , "request_quit", [to_menu])

func _client_success(s):
  g.report(["client success", s], [], 0)
  if s != net.primary_server:
    return
  print(["Player joining game"])
  g.report("config", [config.keys()], 0 , 1000, {"only":false})
  net.rpc(self, "player_joined", [net.uid, cl_name, config.tank_style,0]);
  if !g.is_null(mainmenu):
    mainmenu.hide();


func player_joined(id, name, tank_color, type=0, src=0):
  g.report(["player_joined", id, name], [["players", players]], 0)
  if (!players.has(id) || players[id] != null) :
    g.report(["!!New player was not set up properly", id, players])
    return;
  g.report("blahssd", [], 0 , -1, {"only":false})
  players[id] = {"name":name, "tank_color":tank_color, "type":type};
  player_connected(id);


func player_connected(id):
  if (id != net.primary_server):
    net.rpc_id(id, self, "create_world", [config.host_game_mode]);


func create_world(game_mode, src=0):
  # prefab_player = load("res://prefabs/player2_test.tscn");
  if game_mode == "hix":
    prefab_player = load("res://prefabs/player2_light.tscn");
    # prefab_player = load("res://testtest.tscn");
  else:
    prefab_player = load("res://prefabs/player2_test.tscn");
  prefab_freecam = load("res://prefabs/cam_free.tscn");
  g.store_set('bullet_col_margin', 3.5)
  g.store_set('scrn_dbg', {})
  print(["Creating world"])
  world = load("res://scenes/emptyworld.tscn").instance();
  load_env(game_mode)
  active_game_mode = game_mode
  # if net.is_primary:
  #   load_env(game_mode)
  # else:
  #   load_env(config.host_game_mode)
  world.set_name("world");
  get_tree().get_root().call_deferred("add_child", world);

func load_env(name="football"):
  var envinst
  if name == "basketball":
    envinst = load("res://scenes/env3d.tscn").instance();
  elif name == "football":
    envinst = load("res://scenes/env3d_football.tscn").instance();
  elif name == "hix":
    envinst = load("res://scenes/env3d_hix_light.tscn").instance();
    # envinst = load("res://scenes/env3d_sly.tscn").instance();
  envinst.set_name("env")
  world.add_child(envinst)

func world_ready():
  print("world ready")
  mainmenu.hide();
#  if net.is_primary:
#    g.release = false
  g.world_ready()
  if (!net.is_primary):
    net.rpc(self, "player_ready", [net.uid]);
    # g.log2f(["ooommmggg", net.uid])
#    if is_proxy2:
#      net.start_proxy('', 5000)
  else:
    setup_spawnpoints();
    if (!sv_dedicated):
      create_host_player()
    else:
      setup_freecam();


func create_host_player():
  print("create host player")
  if (!net.is_primary):
    return;
  _peer_connected(1);
  print("cl_name", cl_name)
  player_joined(1, cl_name, config.tank_style);
  player_ready(1);


func setup_freecam():
  var inst = prefab_freecam.instance();
  inst.set_name("camera");
  world.get_node("env").add_child(inst);


func player_ready(id, src=0):
  g.report("omg", [], -1)

  if id == net.uid:
    is_ready = true
  g.report(["Player ready", id], [], 0)
  if (!players.has(id) || players[id] == null || !net.is_primary):
    return;
#  if (id != 1):
  # if (id != net.primary_server):
  #   net.rpc_id(id, self, "clean_players", []);
  # print("zooook")
  for i in world.get_node(players_path).get_children():
    var pid = i.get_name().to_int();
    var pos = i.get_global_transform().origin;
    net.rpc_id(id, self, "add_player", [pid, players[pid].name ,pos, players[pid].tank_color]);
    if id != pid:
      net.rpc_id(pid,net, "ping", [id])

  var spawn_pos = get_random_spawnpoint();
#  add_player(id, players[id], spawn_pos)
  add_player(id, players[id].name, spawn_pos, players[id].tank_color)
  net.rpc(self, "add_player", [id, players[id].name, spawn_pos, players[id].tank_color]);

  print("WE GOT HERE")
  net.rpc_sync(g.eval_context(), 'sync_tmp', [])
  # tmp()
#  net.ping(id)
  net.rpc_sync(net, "ping", [id])
  net.rpc_id(id,net, "ping_all", [])
  net.rpc_id(id,net, "rpc_connect_servers", [])
  chatmgr.broadcast_msg(str(players[id].name, " connected."));
  # g.log2f(["ooommmggg", id, src])


#func send_existing_players(recipient):
#  for i in world.get_node(players_path).get_children():
#    var pid = i.get_name().to_int();
#    var pos = i.get_global_transform().origin;
#    net.rpc_id(recipient, self, "add_player", [pid, players[pid].name ,pos, players[pid].tank_color]);
#    if id != pid and not i.is_bot:
#      net.rpc_id(pid,net, "ping", [id])

func is_local_player(pid):
  return local_players.has(pid)


func add_player(id, name, pos , tank_color, src=0):
  # player types : 0 normal, 1 bot
  g.report(["Add player", id], [name], 0, 0)
# print("id", id)
  if src==1:
    players[id] = {"name":name, "tank_color":tank_color, "type":0};
  # if id != net.uid:
  g.callv_later(self, "announce", [name + " joined game",4,""], 0.1)
    # announce(name + " joined game",5,"")
  # return
  if (player_by_id(id) != null):
    return;
  var inst = prefab_player.instance();
#  if id > 3000 or (cl_name == "server" and id == 1):
#    g.report("yova", [], 0 , 1000, {"only":false})
##    var scrpt = load("scripts/netbot.gd")
##    inst.set_script(scrpt)
#    inst.set("is_bot", true)
  inst.set_name(str(id));
  inst.player_name = str(name);
  inst.pid = id
  inst.tank_color = tank_color

  var tank = inst.get_node("body/Tank/Tank")
#  tank_mat = tank.get_material_override()
  tank.set_material_override(tank.get_material_override().duplicate())
  var tank_mat = tank.get_material_override()
  print(tank_color)
  var tex = load("res://sprites/tanktex-" + tank_color + ".png")
  tank_mat.set_texture(0, tex)
  if (id == net.uid):
    local_players.append(id)
    me = inst
    emit_signal("own_player_ready")
  teams[tank_color][inst.pid] = inst
  if net.is_primary and id > 100:
    local_players.append(id)
  world.get_node(players_path).add_child(inst);
  if not net.master_nodes.has(id):
    net.master_nodes[id] = []
  net.master_nodes[id].append(inst.get_path())
  if id == net.uid:
    inst.is_node_master = true
  inst._config_master()
  var radcols = {"red":Color(1,0,0,1), "green":Color(0,1,0,1), "pink":Color(1,0.1,0.4,1), "gold":Color(1,0.8,0.1,1)}
  change_player_radar_color(inst, radcols[tank_color])
  # if id > 100:
  #   change_player_radar_color(inst)
  if (pos != null):
    inst.set_global_transform(Transform(Matrix3(), pos));
    inst.s_state["pos"] = pos
    inst.s_state["lv"] = Vector3()
    inst.s_state["av"] = 0
    inst.s_state["resting"] = true
  if solo:
    g.setup_bots()
    get_node("/root/world/gui/chatBox").hide()
  if tutorial:
    start_tutorial()
    # announce("Welcome to the crash course!", 0)
#    var bot = add_bot(100)
#    add_bot()
#    add_bot()
#    bot.set("stick_x", randi() % 120)
#    bot.set("stick_y", randi() % 120)
  else:
    get_node("/root/world/gui/chatBox").show()

func start_tutorial():
  var tut_scene = load("res://scenes/tutorial.tscn").instance();
  get_node("/root/world").add_child(tut_scene)
  # announce("Welcome to the crash course!", 0)

func add_bot(id=null,pos=null):
  g.report("adding new bot", [], 0 , -1, {"only":false})
  g.report(["Add bot"], [], 0, 0)
# print("id", id)
#  var id
  if g.is_null(id):
    if bots.empty():
      id = 101
    else:
      id = bots[-1].pid + 1
  if (player_by_id(id) != null):
    return player_by_id(id);
  var inst = prefab_player.instance();
  inst.set_name(str(id));
  inst.player_name = "botty";
#  var scrpt = load("scripts/newbot.gd")
#  inst.set_script(scrpt)
  inst.set("is_bot", true)
  inst.pid = id
#  inst._config_master_cam()
  var tank = inst.get_node("body/Tank/Tank")
#  tank_mat = tank.get_material_override()
  tank.set_material_override(tank.get_material_override().duplicate())
  var tank_mat = tank.get_material_override()
  var tex = load("res://sprites/tanktex-" + "green" + ".png")
  tank_mat.set_texture(0, tex)
  world.get_node(players_path).add_child(inst);
#  inst.set_global_transform(Transform(Matrix3(), me.get_translation()));
  inst.set_global_transform(Transform(Matrix3(), Vector3(0,10,0)));
  bots.append(inst)
  players[id] = {"name": "botty", "tank_color":"green"}
  return inst
#  if (pos != null):
#    inst.set_global_transform(Transform(Matrix3(), pos));

func add_local_player(id=null,pos=Vector3(0,10,0), name="test", color=null):
  g.report("adding new bot", [], 0 , -1, {"only":false})
  g.report(["Add bot"], [], 0, 0)
# print("id", id)
#  var id
  if g.is_null(id):
    if bots.empty():
      id = 101
    else:
      id = bots[-1].pid + 1
  if (player_by_id(id) != null):
    return player_by_id(id);
  var inst = prefab_player.instance();
  inst.set_name(str(id));
  inst.player_name = name;
#  var scrpt = load("scripts/newbot.gd")
#  inst.set_script(scrpt)
  inst.pid = id
#  inst._config_master_cam()
  var tank = inst.get_node("body/Tank/Tank")
#  tank_mat = tank.get_material_override()
  tank.set_material_override(tank.get_material_override().duplicate())
  var tank_mat = tank.get_material_override()
  if g.is_null(color):
    # var colors = ["red", "green"]
    # var colors = [ "green","red"]
    var colors = [ "green"]
    color = colors[(id+1)%colors.size()]
  inst.tank_color = color
  var tex = load("res://sprites/tanktex-" + color + ".png")
  tank_mat.set_texture(0, tex)
  world.get_node(players_path).add_child(inst);
#  inst.set_global_transform(Transform(Matrix3(), me.get_translation()));
  inst.set_global_transform(Transform(Matrix3(), pos));
  players[id] = {"name": name, "tank_color":color}
  if net.is_primary and id > 100:
    local_players.append(id)
  if net.is_primary:
    net.rpc(self, "add_player", [id, players[id].name, pos, players[id].tank_color]);
  # change_player_radar_color(inst)
  var radcols = {"red":Color(1,0,0,1), "green":Color(0,1,0,1), "pink":Color(1,0.1,0.4,1),"gold":Color(1,0.8,0.1,1)}
  change_player_radar_color(inst, radcols[color])
  teams[color][inst.pid] = inst
  return inst
#  if (pos != null):
#    inst.set_global_transform(Transform(Matrix3(), pos));

func change_player_radar_color(player, color=Color(1,0,0,1)):
  g.color_mat_override(player.get_node("body/TestCube"), color, {"color_param":3, "unique":true})

func clean_players(src=0):
  g.report("clean players", [], 0 , 1000, {"only":false})
  if (!world):
    return;
  print("clean players")
  for i in get_players():
    i.queue_free();


func player_by_id(id):
  var path = players_path+str(id);
  if (!world.has_node(path)):
    return null;
  var node = world.get_node(path)
  if node.is_queued_for_deletion():
    return null
  return node;

func all_players():
  return world.get_node(players_path).get_children()

func teleport_player(from, to):
  var p1 = player_by_id(from);
  var p2 = player_by_id(to);
  if (!p1 || !p2):
    return;
  p1.set_global_transform(p2.get_global_transform());


func setup_spawnpoints():
  spawn_points.clear();
# spawn_points.append(Vector3(0, 2, 0));
# spawn_points.append(Vector3(2, 2, -3));
# spawn_points.append(Vector3(1, 2, 4));
# spawn_points.append(Vector3(2, 2, 2));
# spawn_points.append(Vector3(3, 2, 1));
# spawn_points.append(Vector3(-20,5, -320))
# spawn_points.append(Vector3(-20,13, -300))
#  spawn_points.append(Vector3(0,2,0))
#  spawn_points.append(Vector3(125,1.8, 140))
#  spawn_points.append(Vector3(46,0, 50))
#  spawn_points.append(Vector3(35,10, 272))
  spawn_points.append(Vector3(0,10, 0))


func get_random_spawnpoint():
  return spawn_points[int(rand_range(0, spawn_points.size()))];


func get_players():
  var ret = [];
  for i in world.get_node(players_path).get_children():
#    if (!players.has(i.get_name().to_int())):
#      continue;
    ret.append(i);
  return ret;


func add_record(group, rec):
  if not records.has(group):
    records[group] = []
  records[group].append(rec)


func clear_records(group):
  if records.has(group):
    records[group].clear()

func set_bind_maps():
  kb_bind_map = {
    "slowmo":[[KEY_A ]],
    "radarzoom_close":[],
#    "slowmo2":[[KEY_A],[KEY_D]],
    "slowmo2":[ [KEY_TAB], [KEY_Q]],# [KEY_A]], #[[KEY_Q]],
#    "jump":[[KEY_TAB], [KEY_SHIFT]],

    "shoot":[[KEY_X], [KEY_W], [KEY_S]], #[KEY_S], [KEY_D] ],
    "repeat_shoot": [], # [[KEY_W]],
    # "aim":[[KEY_SPACE]],
#    "jump":[[KEY_TAB], [BUTTON_WHEEL_UP ] ],
    "jump":[[KEY_TAB], [KEY_SHIFT] ],
    "kb_step_motion": [[KEY_Z]],
    "throw": [[KEY_D]], # [[KEY_D], [KEY_L]],
    "pass_ball": [], #[[KEY_S]],
    "cancel_throw": [[KEY_ALT], [KEY_Z]],
    "kb_step_motion": []
  }
  joy_bind_map = {
    "jump" : [[1]], #[ [1], [7]],
    "shoot" : [ [0]], # [],
    "repeat_shoot" : [[3]], #[[2]],
    "aim" : [[2]], #[[6]],
    "throw" : [],# [ [0]],
    "pass_ball" : [], # [[3]],
    "slowmo" : [[7]], #[[3]] ,#[[4]],
    "slowmo2" : [[1]] #[[5], [7]],
  }

func rebind():
#  var bindmap = {
#    "slowmo":[[KEY_Q]],
##    "slowmo2":[[KEY_A],[KEY_D]],
##    "jump":[[KEY_TAB], [KEY_SHIFT]],
#    "jump":[[KEY_TAB]],
#    "shoot":[[KEY_W], [KEY_X] ],
#    "repeat_shoot":[[KEY_E]],
#    "aim":[[KEY_SPACE]],
#    "kb_step_motion": [[KEY_Z]],
#    "throw": [[KEY_A], [KEY_C]],
#    "pass_ball": [[KEY_S]],
#  }
  for a in kb_bind_map:
    g.action_bind(a, kb_bind_map[a])
# 0:x, 1:circle, 2:tri, 3:sq, 6:rl, 7:ll

  if g.jsenabled:
    for a in joy_bind_map:
      g.action_bind_joy(a, joy_bind_map[a])
  else:
    g.report("unbinding js", [], 0 , 1000, {"only":false})
    for a in joy_bind_map:
      g.action_unbind(a, joy_bind_map[a],InputEvent.JOYSTICK_BUTTON)

func match_start():
  # reset time - deps(game timer,)
  get_node("/root/world/gui/game_info/timer/count").set_text(str(600))
  get_node("/root/world/gui/game_info/score_red/count").set_text(str(0))
  get_node("/root/world/gui/game_info/score_green/count").set_text(str(0))
  game_running = true
  game_start_time = g.t()
  time_left = 600

  game_timer = Timer.new()
#    timer.set_pause_mode(2)
  game_timer.set_name("game_timer")
  game_timer.set_one_shot(false)
  game_timer.set_timer_process_mode(0)
#  if new:
  game_timer.connect("timeout", self, "time_tick")
  game_timer.set_wait_time(1)
  add_child(game_timer)
  game_timer.start()
  # reset scores
  # assign players to teams
  pass

func time_tick():
  if time_left > 0:
    time_left -= 1
    get_node("/root/world/gui/game_info/timer/count").set_text(str(time_left))
  else:
    game_running = false
    game_timer.stop()
    remove_child(game_timer)
    game_timer.free()
    game_timer = null


# func announce(text, timeout, cid=0):
#   text = str(text)
#   var label = get_node("/root/world/gui/announce_overlay/Label")
#   var time_left = 0
#   if announce_timer.get_time_left() > 0:
#     time_left = announce_timer.get_time_left()
#     announce_timer.stop()
#     var new_text = label.get_text() + "\n" + text
#     label.set_text(g.get_string_lines(label.get_text(), -4,-1) + "\n" + text)
#   else:
#     label.set_text(text)
#   get_node("/root/world/gui/announce_overlay").show()
#   announce_timer.set_wait_time(max(timeout, time_left))
#   announce_timer.start()

func announce(text, timeout, _group="",params={}, cid=0):
  # print("ooooooo")
  # print(text)
  # return
  params = g.mergedicts({"group":"", "top":true}, params)
  # print(["AAAA",_group])
  var group = get_node("/root/world/gui/on_screen_msg_group" + str(_group) + params.group)
  return group.add_msg(text, timeout, params.top)

  params = g.mergedicts({"overlay_str":""}, params)
  text = str(text)
  var overlay = get_node("/root/world/gui/announce_overlay" + params.overlay_str)
  var label = overlay.get_node("Label")
  var time_left = 0
  if announce_timer.get_time_left() > 0:
    time_left = announce_timer.get_time_left()
    announce_timer.stop()
    var new_text = label.get_text() + "\n" + text
    label.set_text(g.get_string_lines(label.get_text(), -4,-1) + "\n" + text)
  else:
    label.set_text(text)
  overlay.show()
  announce_timer.set_wait_time(max(timeout, time_left))
  announce_timer.start()


func hide_announcement(params={}):
  params = g.mergedicts({"overlay_str":""}, params)
  var overlay = get_node("/root/world/gui/announce_overlay" + params.overlay_str)
  g.report("hiding announcement", [], 0 , -1, {"only":false})
  overlay.hide()