extends Control

# class member variables go here, for example:
# var a = 2
# var b = "textvar"

var gsvar
var lines = []
onready var g = get_node("/root/global")

func _ready():
  gsvar = get_node("/root/gamestate")
	# Called every time the node is added to the scene.
	# Initialization here
  set_process_input(true)
  populate_settings()
  self.connect("hide", self, "_on_hide");

func _input(ie):
  if (ie.type == InputEvent.KEY):
    if (ie.pressed && ie.scancode == KEY_ESCAPE):
      get_node("close_button").emit_signal("pressed")

func populate_settings():
#  var lines = g.get_config_lines()
  var config = ConfigFile.new()
  var err = config.load("user://settings.cfg")
  lines = g.get_default_config()
  var conf_ver = config.get_value("Personalization", "config_ver", 0)
  if Array(OS.get_cmdline_args()).has("-defaults") or (conf_ver < lines[0].default):
    g.log2f("outdated conf!")
    var _config = ConfigFile.new()
    _config.set_value("Personalization", "callsign", config.get_value("Personalization", "callsign", "your_callsign"))
    config = _config

  var settings_grid= get_node("sc/gc")
  var groups = {}
  for i in lines:
#    if config.has_section_key(i.group, i.name):
    i.value = config.get_value(i.group, i.name, i.default)
    var groupcontainer
    var group_path = i.group.split("/")
    var parent_group = settings_grid
    if groups.keys().has(i.group):
      groupcontainer = groups[i.group]
    else:
      if group_path.size() > 1:
        var idx = 0
        for gc in group_path:
          # parent_group += gc
          idx += 1
          if idx == group_path.size():
            break
          if parent_group.has_node(gc):
            parent_group = parent_group.get_node(gc)
            continue
          var tab_container = TabContainer.new()
          tab_container.set_name(gc)
          tab_container.set_tab_align(0)
          parent_group.add_child(tab_container)
          parent_group = tab_container
        # create nested tab containers
      groupcontainer = VBoxContainer.new()
      # groupcontainer.set_margin(MARGIN_TOP, 200)
      # groupcontainer = TabContainer.new()
      # groupcontainer.set_name(i.group)
      groupcontainer.set_name(group_path[-1])
      var glabel = Label.new()
      var font = load("fonts/biglabel.fnt")
      glabel.add_font_override( "font", font )
      glabel.set_text("___________________________________")
      # glabel.set_text(i.group.to_upper())
      groupcontainer.add_child(glabel)
      # settings_grid.add_child(groupcontainer)
      parent_group.add_child(groupcontainer)
      groups[i.group] = groupcontainer
    var settingcontainer = HBoxContainer.new()
    settingcontainer.set_name(i.name)
    var stlabel = Label.new()
    stlabel.set_text(i.name)
    settingcontainer.add_child(stlabel)
    var stcontrol
    if i.has("setting_type") and i.setting_type == "select":
      stcontrol = OptionButton.new()
      stcontrol.connect('item_selected', g, 'conf_update', [i])
      for choice in i.choices:
        stcontrol.add_item ( choice )
      var idx = i.choices.find(i.value)
      stcontrol.select(idx)
    elif [TYPE_INT , TYPE_REAL].has(typeof(i.default)) :
      stcontrol = SpinBox.new()
      # stcontrol.set_ticks(10)
      stcontrol.set_editable(true)
      stcontrol.set_custom_minimum_size(Vector2(100,10))
      # stcontrol.set_ticks_on_borders(false)
      stcontrol.connect('value_changed', g, 'conf_update', [i])
      if i.has("min"):
        stcontrol.set_min(i["min"])
      if i.has("max"):
        stcontrol.set_max(i["max"])
      if i.has("step"):
        stcontrol.set_step(i.step)
      stcontrol.set_value(i.value)
    elif typeof(i.default) == TYPE_STRING:
      stcontrol = LineEdit.new()
      stcontrol.set_expand_to_text_length(true)
      stcontrol.set_custom_minimum_size( Vector2(100,0) )
      stcontrol.set_text(i.value)
    elif typeof(i.default) == TYPE_COLOR:
      stcontrol = ColorPicker.new()
      # stcontrol.set_expand_to_text_length(true)
      stcontrol.set_custom_minimum_size( Vector2(100,0) )
      stcontrol.set_color(i.value)
      stcontrol.connect('color_changed', g, 'conf_update', [i])
    elif typeof(i.default) == TYPE_BOOL:
      stcontrol = CheckBox.new()
      stcontrol.connect('toggled', g, 'conf_update', [i])
      stcontrol.set_pressed(i.value)
    elif typeof(i.default) == TYPE_ARRAY:
      stcontrol = ItemList.new()
      stcontrol.set_custom_minimum_size(Vector2(100,100))
      stcontrol.set_select_mode(1)
      stcontrol.set_allow_rmb_select ( true)
      # stcontrol.connect('item_selected', g, 'conf_update', [i])
      stcontrol.connect('multi_selected', g, 'conf_update_item_list', [stcontrol,i])
      # print("CHOOOICE")
      for choice in i.choices:
        print(i.choices)
        stcontrol.add_item( choice )
      # var idx = i.choices.find(i.value)
      for x in i.value:
        stcontrol.select(x, false)
      # stcontrol.set_pressed(i.value)

    stlabel.set_ignore_mouse(false)
    stlabel.set_tooltip(i.what)
    settingcontainer.add_child(stcontrol)
    groupcontainer.add_child(settingcontainer)
    if (i.has("hide") and i.hide):
      settingcontainer.hide()

func save_settings():
  var config = ConfigFile.new()
  var grid = get_node("sc/gc")
  for i in grid.get_children():
    save_settings_group(i, config, i.get_name())
  if not Array(OS.get_cmdline_args()).has("-defaults"):
    config.save("user://settings.cfg")
  gsvar._conf_ready()
#  gsvar.save_config()
#  gsvar.load_config()

func save_settings_group(group, config, _name=""):
  print(group.get_type())
  if group.get_type() == "TabContainer":
    for k in group.get_children():
      save_settings_group(k, config, _name + "/" + k.get_name())
    return
  for j in group.get_children():
    if !j.is_type("Container"):
      continue
    var setting_name = j.get_children()[0].get_text()
    var setting_value
    var stcontrol = j.get_children()[1]
    if stcontrol.get_type() == "LineEdit":
      setting_value = stcontrol.get_text()
    elif stcontrol.get_type() == "CheckBox":
      setting_value = stcontrol.is_pressed()
    elif stcontrol.get_type() == "SpinBox":
      setting_value = stcontrol.get_val()
    elif stcontrol.get_type() == "ColorPicker":
      setting_value = stcontrol.get_color()

    elif stcontrol.get_type() == "OptionButton":
      setting_value = stcontrol.get_item_text(stcontrol.get_selected())
    elif stcontrol.get_type() == "ItemList":
      setting_value = Array(stcontrol.get_selected_items())

    config.set_value( _name, j.get_name(), setting_value)
    print(["sdfsdfsdf", g.sg("override_config", {})])
    # if g.sg("override_config", {}).has(setting_name):
    # gsvar.config[setting_name] = g.sg("override_config", {})[setting_name]
    # else:
    gsvar.config[setting_name] = setting_value

func _on_hide():
  pass
#  save_settings()

#func _notification(what):
#  print(what)
