extends RigidBody

# last_lv, local_input, speed_percent force_jump body_rotation on_floor moving jumping yaw stick_x stick_y curs_posx  curs_posy turning_percent frozen_turn
var tank_color = ""
var tank_trace_scene = load("res://prefabs/tank_trace2.tscn");
var tank_ripple_scene = load("res://prefabs/tank_ripple.tscn");
var last_shot_params = []
var in_2pts_area = false
var in_key_area = false
var check_in_2pts_on_rest = false
var last_shot = -1
var event_times = {'last_trace':0, 'last_ping': 0, 'last_repeat_shoot':0, 'phys_keep':0, 'last_slave_sync':0, 'last_jump_press':0 }
var pid
var new_spawn = []
#var resting = false
var above_pyra = false
var sidetouch = false
var was_sidetouch = false
var sm = [0,0]
var pending_impulse = []
var last_impulse_t = 0
var cur_vel = Vector3()
var last_got_hit = 0
#var crossh_shift = 7.55
var last_state = {"on_floor":false, "on_pyra":false, "resting":false}
var ri_under
var elevation = 0.0
#var world_gravity=9.8
var world_gravity=9.8 * 2
var last_transform
var p_state = {}
var force_pause = false
var dir_ray = RayCast.new()
var accel = 1000.0 * 0.3 * 0.5;
# var deaccel = 1000.0 * 0.15 * 0.5;
var deaccel = 180 - 30 + 50
var jump_velocity = 12.5 * 1.2;
var normal_jump = 12.5 * 1.2;
var pad_jump = 18 * 1.3;
var shots_limit = 3#2#3
#var reload_time = 3.5
var reload_time = 3.5 #3.5 # 5.0
var ammo = []
#var last_lv
var local_dir = Vector3();
var local_input = [0, 0, 0];
var speed_percent = 0
var fixed_speed_percent = null
var force_jump = false
var last_s_update = [0,{"p":Vector3(), "r":Vector3(), "lv":Vector3(), "st":0}]
var last_s_sync = 0
#var request_sync = []
var sync_reqs = []
var body_rotation = 0.0;
var camera_aim = Vector3();
# p position, r rotation, sp speed_percent, tp turning percent, j jump, lv linear_velocity, st sync_time
var s_state = {"p":Vector3(), "r":0.0, "sp":0.0, "tp":0.0, "j":false, "lv":Vector3(), "st": 0, "av":0, "resting":false}
var state_log = []
slave var sup = {}
slave var sup2 = []
slave var s_local_dir = Vector3()
var upticks = 20
var syncticks = 250#400#5000
var max_speed = 50.0;
var max_turning = 1.05
var normal_max_speed = 50.0;
var max_speed_mod = 1.0
sync var on_floor = false;
#var onpyra = false;
var moving = false;
var jumping = false;
#var col_groups = {"StaticBody":{}}
var col_groups = {0:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}, 1:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}}
var last_touching = []
var is_node_master
var is_bot
var health = 0.0;
var is_dying = false;
var deaths = []
var player_name = "";
var dying_time = 0.0;
var spawn_time = 0.0;
var next_shoot = 0.0;
var next_update = 0.0;
var next_aim = 0.0;
var missile_scene = load("res://prefabs/bullet/bullet.tscn");
var explosion_scene = load("res://prefabs/explosion.tscn");
var landing_mark_scene = load("res://prefabs/landing_mark.tscn");
onready var sounds = get_node("sounds")
onready var engine_sound = get_node("engine_sound")
#var timer
var yaw = 0.0;
var dist = 40;
#onready var radar_cam = get_node("/root/world/radarframe/Viewport/MyCamera");
#onready var floorbodies = [get_node("/root/world/env/Plane/StaticBody")];
var radar_player
#var motion = { "cursor":Vector2(), "stick":Vector2()}
var stick_x = 0;
var stick_y = 0;
var turning_percent = 0.0
#var deadzone_bounds = 12.0;
var frozen_turn = 0.0;
var frozen_speed = 0.0;
var net_buffer = {"tp":[], "sp":[]}
var synced = false
#var shp = ConcavePolygonShape.new()
#var shp2 = ConcavePolygonShape.new()
var shot_detect_shape = BoxShape.new()
var pyra_detect_shape = BoxShape.new()
var last_close_shot_time = 0
var slowmo_f = 0.33
var speed_modifier = 1.0
var t_speed_modifier = 1.0
var s_speed_modifier = 1.0
var paused = false
var control
var try_jump_once = false
var jump_start = -1
var t_turning_percent = 0
var angvel = 0

#var base_turning_speed = 0.71
var base_turning_speed = 1.0
#var radarbox_shader = preload("res://sprites/radarbox_shader.tres");
onready var gsvar = get_node("/root/gamestate")
onready var net = get_node("/root/net")
onready var global = get_node("/root/global")
onready var g = get_node("/root/global")
onready var me = gsvar.me
onready var own_id = net.uid;
onready var motion_bounds = gsvar.config["mousebox_size"];
onready var deadzone_bounds = gsvar.config["deadzone_size"];
onready var phys = _phys
onready var phys_old = []
#onready var ball = get_node("/root/world/env/Ball")
onready var tank_size = get_node("col_capsule").get_scale() * get_node("col_capsule").get_shape().get_extents()
onready var touching_bodies = {'bottom':[], 'sides':[], 'top':[]};
onready var body = get_node("body");
onready var radar_camera = get_node("/root/world/radarframe/Viewport/MyCamera") # view world static objects on radar
onready var radar_camera2 = get_node("/root/world/radar_bg3/radarframe2/Viewport/MyCamera") # view moving objects on radar
# onready var ball = get_node("/root/world/env/Ball")
onready var balls = g.store_get("balls", [])

const _phys = {"lv":Vector3(), "av":0,"rotation":0,  "moving":false, "jumping":false,"falling":false,"jump_count":0, "in_air":false, "touching":false, "side_touching":false, "resting":false, "on_floor":false, "on_pyra":false, "top_touching":false, "above_pyra":false, "abilities":[], "tick":0, "turning_center":Vector3(), "touching_pyra":false, "just_jumped":false, "xform":null, "inside_obs":[], "is_inside":false}
signal player_got_hit(killer)

export (FixedMaterial) var trajectory_mat = null

func _init():
#  moving = false;
#  player_name = "";
#  health = 100.0;
#  is_dying = false;
#  is_aiming = true;
#  dying_time = 0.0;
#  next_shoot = 0.0;
#  next_aim = 0.0;
#  dir_ray = RayCast.new()
  add_child(dir_ray)

func obstacle_detected(body_id, body, body_shape, area_shape):
  g.report("o", [body,area_shape], 0 , -1, {"only":false})


func _ready():
#  get_node('body/obstacle_area').connect('body_enter_shape', self, 'obstacle_detected' )
  # phys_conf(5)
  g.enable_w_set(self, ["max_speed_mod"])
  g.w_set(self, "max_speed_mod", "default", 1.0, 0)
  g.report("label", [], 0 , 1000, {"only":false})
#  if int(get_name()) == 10:
#    is_bot = true
  net.path_ht[String(get_path()).hash()] = get_path()
  net.connect("latency_change", self, "_on_latency_change")
  for i in range(20):
    phys_old.append(phys)
#  camera_range = dist;
#  camera_pivot_range = 0.0;
#  create_timer()
  var radar_player_scene = load("res://prefabs/radarplayer.tscn");
  radar_player= radar_player_scene.instance();
  radar_player.set_name(str(own_id))
  get_node("/root/world/radarframe/players").add_child(radar_player)
  shot_detect_shape.set_extents(Vector3(200,12,200))
  pyra_detect_shape.set_extents(Vector3(tank_size.x, 200, tank_size.z))
  get_node("hit_area").connect("body_enter", self, "hit_area_collided")
  get_node("hit_area").connect("body_exit", self, "hit_area_uncollided")
  if gsvar.active_game_mode == "basketball":
    get_node("/root/world/env/jumppad/Area").connect("area_enter", self, "enter_jumppad")
    get_node("/root/world/env/jumppad/Area").connect("area_exit", self, "exit_jumppad")
    get_node("/root/world/env/jumppad2/Area").connect("area_enter", self, "enter_jumppad")
    get_node("/root/world/env/jumppad2/Area").connect("area_exit", self, "exit_jumppad")
    get_node("/root/world/env/3point_area").connect("area_enter", self, "enter_2points")
    get_node("/root/world/env/3point_area").connect("area_exit", self, "exit_2points")
    get_node("/root/world/env/3point_area2").connect("area_enter", self, "enter_2points")
    get_node("/root/world/env/3point_area2").connect("area_exit", self, "exit_2points")
  g.make_unique_matover(get_node("body/tank_treads/tracks"))
  g.make_unique_matover(get_node("body/tank_treads2/tracks"))
  get_node("body/tank_treads/tracks").get_material_override().set_shader_param("Dist", 0.0)
  get_node("body/tank_treads2/tracks").get_material_override().set_shader_param("Dist", 0.0)
  set_process(true);
  set_fixed_process(true);



func enter_jumppad(b):
#  g.report("enter jumppad", [b], 0 , 0, {"only":false})
  if b == get_node("hit_area"):
    in_key_area = true
    g.report("i enter jumppad", [], 0 , 0, {"only":false})
    jump_velocity = pad_jump

#    world_gravity = 35


func exit_jumppad(b):
#  g.report("exit jumppad", [b], 0 , 0, {"only":false})
  if b == get_node("hit_area"):
    in_key_area = false
    g.report("i exit jumppad", [], 0 , 0, {"only":false})
    jump_velocity = normal_jump

#    world_gravity = 9.8

func enter_2points(b):
#  g.report("enter jumppad", [b], 0 , 0, {"only":false})

  if b == get_node("hit_area"):
    g.report("i enter 2 points", [], 0 , 0, {"only":false})
    in_2pts_area = true
    check_in_2pts_on_rest = false
    # gsvar.announce("in area",1,"2")
#    world_gravity = 35


func exit_2points(b):
#  g.report("exit jumppad", [b], 0 , 0, {"only":false})
  # if tank exits area by jumping, then it's still inside. only when it touches ground outside that it gets out. so put a pending flag, and check next time the tank hits the floor
  if b == get_node("hit_area"):
    if in_2pts_area and not phys.on_floor:
      check_in_2pts_on_rest = true
    else:
      g.report("i exit 2 points", [], 0 , 0, {"only":false})
      in_2pts_area = false
      # gsvar.announce("out area",1,"2")
#    world_gravity = 9.8


func hit_area_collided(b):
  if not (gsvar.is_local_player(pid) or is_bot):
    return
#  if b.get_type() == "RigidBody":
  if b extends preload("res://scripts/newbullet.gd"):
    g.report("hit area collided", [pid], 0 , -1, {"only":false})
#    g.report("hit_area col", [b], 0 , 0, {"only":false})
    b.add_tank_collider(self)
    b.inside_shooter_hit_area = true


func hit_area_uncollided(b):
  if not (gsvar.is_local_player(pid) or is_bot):
    return
#  if b.get_type() == "RigidBody":
  if b extends preload("res://scripts/newbullet.gd"):
    b.inside_shooter_hit_area = false
#    g.report("hit_area uncol", [b], 0 , 0, {"only":false})

#func _config_master():
#  if is_node_master:
#    set_process_input(true);
#  if (!is_node_master):
#    var own_id = net.uid;
#    # don't let new players steal camera
#    if gsvar.player_by_id(own_id):
      #gsvar.player_by_id(own_id).camera_instance.make_current()
#    camera.queue_free();
#  else:
#    camera.set_active(true);
#    camera_instance.make_current()
#    get_node("projected_pos").hide()


func get_object_name():
  return player_name;


func _fixed_process(delta):
  pass
#   if paused:
#     return

# #  var vp = get_node("/root/world/radarframe/Viewport");
# #  var render = vp.get_render_target_texture();
#   #get_node("/root/world/radarframe_map").set_texture(render);
#   var elev = get_translation().y
#   # var scal = 1 - 0.6 + stepify((elev / (15.0)), 0.1)
#   var scal = 1 - 0.4 + stepify((elev / (14.0)), 0.1) - 0.2 -0.1 - 0.1
#   g.scrn_dbg("area scale", scal* g.sg("elev_area_scal", 1.1))
#   get_node("Area").set_scale(Vector3(1.28,scal * g.sg("elev_area_scal", 1.1),1.28))
#   body.set_rotation(Vector3(0,body_rotation,0))
#   get_node("Area").set_rotation(Vector3(0,body_rotation,0))
#   get_node("hit_area").set_rotation(Vector3(0,body_rotation,0))
#   g.scrn_dbg("dangfixed", g.t())
#  update_radar(delta)


func _process(delta):
  if paused:
    return
  # g.eval_context().t39(self, delta)
#  update_ammo()
  dying_think();
  if phys.on_floor:
      var spd=get_linear_velocity().length() / max_speed
      var tspd=angvel / base_turning_speed
      var d =  get_node("body/tank_treads/tracks").get_material_override().get_shader_param("Dist")
      get_node("body/tank_treads/tracks").get_material_override().set_shader_param("Dist", d + (spd*g.store_get("tank_tracks_spd", 0.14) - tspd/27)*delta*60)
      # get_node("body/tank_treads/tracks").get_material_override().set_shader_param("Dist", d + (speed_percent*g.store_get("tank_tracks_spd", 0.14) - turning_percent/27)*delta*60)
      d =  get_node("body/tank_treads2/tracks").get_material_override().get_shader_param("Dist")
      get_node("body/tank_treads2/tracks").get_material_override().set_shader_param("Dist", d + (spd*g.store_get("tank_tracks_spd", 0.14) + tspd/27)*delta*60)
      # get_node("body/tank_treads2/tracks").get_material_override().set_shader_param("Dist", d + (speed_percent*g.store_get("tank_tracks_spd", 0.14) + turning_percent/27)*delta*60)
      var ld = (g.store_get("last_tt_pos" + str(pid), get_translation()) - get_translation()).length()
      # var ldr = (g.store_get("last_tr_pos" + str(pid), get_translation()) - get_translation()).length()
      # var lr = (g.store_get("last_tt_rot", body_rotation) - body_rotation)
      # if ldr > 10:
      #   create_tank_ripple()
      #   g.store_set("last_tr_pos"+str(pid), get_translation())
      if ld > 3:

      # if g.time_since(self, 'last_trace', g.store_get("tracksdrawintv", 80), true) and phys_old[-4].on_floor  :
        var tt = create_tank_trace()

        g.store_set("last_tt_pos"+str(pid), get_translation())

        # g.store_set("last_tt_rot", body_rotation)


func _on_latency_change(pid, diff, direct):
  if int(get_name()) == pid:
    if net.sync_table.has(pid) and net.sync_table[pid].has("latency"):
      var sc = net.sync_table[pid]["latency"] / 300.0
    else:
      global.report(["missing player latency", pid],[], 0, 5000)

func create_tank_trace():
  g.eval_context().create_tank_trace(self)
  return
  var dir = phys.lv
  if dir.length() < 2:
    return
  var inst
  var numpool = 200
  if g.store_get("ttpool", []).size() < numpool:
    inst = tank_trace_scene.instance()
    inst.set_name("ttrace");
    gsvar.world.env.add_child(inst, true);
    g.store_get("ttpool").append(inst)
    inst.get_node("Plane").set_scale(Vector3(1.59,1.5,0.7) * g.sg("trace_scale", 1))
  else:
    inst = g.store_get("ttpool")[g.store_inc('ttpoolnext', 1, numpool)]
    inst.reset()

  inst.set_global_transform(Transform(Matrix3(), get_translation() - Vector3(0,tank_size.y - 0.2,0)));
  var aaa = g.store_get("trackdivisor", 100)
#  if dir.length() > (2*aaa/5.0):
#    inst.get_node("Quad3").show()
#    inst.get_node("Quad4").show()
#  if dir.length() > (3*aaa/5.0):
#    inst.get_node("Quad5").show()
#    inst.get_node("Quad6").show()
#  if dir.length() > (4*aaa/5.0):
#    inst.get_node("Quad5").show()
#    inst.get_node("Quad6").show()
  inst.activate()
#  inst.get_node("arrow").set_scale(Vector3(1.0,1.0* pow(dir.length()/25.0, 0.4),1.0) )
  if dir.length() == abs(dir.y):
#    g.report("vertical", [], 0 , 1000, {"only":true})
    inst.set_rotation(Vector3(sign(dir.y) * PI/2,0,0))
    return inst
#  inst.look_at(get_translation() - 3*dir.normalized(), Vector3(0,1,0))
#  g.report("tread rot", [inst.get_rotation()], 0 , 100, {"only":false})
  var physoldidx = round(g.store_get("physoldidx", -5) / max(abs(speed_percent),0.5))
  # inst.set_rotation(Vector3(0,phys_old[-1].rotation,0))
  inst.set_rotation(Vector3(0,body_rotation,0))
  inst.set_translation(inst.get_translation() - dir.normalized() * 7)
  return inst

func create_tank_ripple():
  # var dir = get_linear_velocity()
  # if dir.length() < 3:
  #   return
  var inst
  var numpool = 10
  if g.store_get("trpool", []).size() < numpool:
    inst = tank_ripple_scene.instance()
    inst.set_name("tripple");
    gsvar.world.env.add_child(inst, true);
    g.store_get("trpool").append(inst)
    # inst.get_node("Circle").set_scale(Vector3(10,1,10))
    # inst.set_scale(Vector3(10,1,10))
  else:
    inst = g.store_get("trpool")[g.store_inc('trpoolnext', 1, numpool)]
    inst.reset()
  inst.set_global_transform(Transform(Matrix3(), get_translation()));
  inst.activate()
  return inst

func mod_input(delta):
  pass
#  if (!is_node_master):
#    return;
#  local_input[0] = force_jump or (gsvar.focus[-1] == "game" and Input.is_action_pressed("jump"))
#  camera_aim = Vector3(sin(body_rotation),0,cos(body_rotation))


func update_elevation():
  return
  var lv = get_linear_velocity()
  if not g.is_null(gsvar.me):
    if lv.y != 0 or gsvar.me.current_zoom != gsvar.me.target_zoom :
      var sc = sqrt(abs(get_translation().y)) / 3.5 * (pow(gsvar.me.current_zoom, 0.8) / 100.0)
      get_node("body/radar_elevation").set_scale(Vector3(sc,1,sc));
      var shd = get_node("/root/world/env/mapcontainer/Spatial/BZBox56").get_mesh().surface_get_material(0)
      shd.set_shader_param( "elevation" , get_translation().y )
      elevation = get_translation().y

#
func update_ammo(fire=false):
  pass
#  g.report("tank", [], 0 , 1000, {"only":false})
  ##if not ammo.empty() and OS.get_ticks_msec() - ammo[0] > reload_time * 1000:
##    ammo.pop_front()
##    ui_ammo.set_text(str(shots_limit - ammo.size()) + "/" + str(shots_limit))
#

func update_turning_percent():
  if is_node_master or is_bot:
    var a = 0
    if not phys.resting:
      # g.scrn_dbg("frozed_t", frozen_turn)
      a = frozen_turn;
    else:
      if abs(stick_x) < deadzone_bounds:
        a = 0;
      else:
        if stick_x > 0:
          a = stick_x - deadzone_bounds
        else:
          a = stick_x + deadzone_bounds
        a = a / (motion_bounds - deadzone_bounds)
      frozen_turn = a
    if t_speed_modifier != 1.0:
      a = a * t_speed_modifier
      if phys.resting:
        frozen_turn = a
#    if Input.is_action_pressed("slowmo") and phys.resting:
#      a = a * slowmo_f
#      frozen_turn = a
#    turning_percent = a * -0.71
#    turning_percent = a * -1
    # turning_percent = a * -max_turning
    mod_turning_percent(a * -max_turning)

func mod_turning_percent(a):
  turning_percent = a


#func update_radar(delta):
#  if not is_node_master:
#    return
#  var vp = get_node("/root/world/radarframe/Viewport");
#  var render = vp.get_render_target_texture();
  #get_node("/root/world/radarframe_map").set_texture(render);
  #var r_pos = radar_camera.unproject_position(get_global_transform().origin)
#  r_pos.x -= (radar_player.get_size().x / 2.0 + 0.5)
#  r_pos.y -= (radar_player.get_size().y / 2.0 - 1)
#  radar_player.set_pos(r_pos)
  #var tankeye = get_node("body/shoot_pos").get_global_transform().origin;
#  var look_from_rad = tankeye;
  #if phys.above_pyra or (phys.on_pyra and not phys.on_floor):
#    radarzoom("close", false)
#  elif check_close_bullet():
#    radarzoom("dodge", false)
#  else:
#    radarzoom_restore()
  #if radar3d == false or  phys.above_pyra or (phys.on_pyra and not phys.on_floor) or check_close_bullet() :
    #radar_camera_range = lerp(radar_camera_range, 3, 20*delta);
#  else:
    #radar_camera_range = lerp(radar_camera_range, 100, 20*delta);
#  look_from_rad.x -= radar_camera_range*sin(deg2rad(yaw));
#  look_from_rad.z -= radar_camera_range*cos(deg2rad(yaw));
#  look_from_rad.y = 200 + (get_translation().y)
  #radar_camera.look_at_from_pos(look_from_rad, tankeye, Vector3(0,1,0))
  #radar_camera2.look_at_from_pos(look_from_rad, tankeye, Vector3(0,1,0))


func check_above_pyra():
  # return false
  ri_under = []
  var ret = false
#   var crnrs = [[0.5,1], [0.5,-1], [-1,-0.5], [-1,0.5],
# [0.3,0.3], [0.3,-0.3], [-0.3,-0.3], [-0.3,0.3],
# [0,0]
#   ]
  var crnrs = [[0,0]]
  for c in crnrs:
    var cpt = Vector3(tank_size.x * c[0],3, tank_size.z * c[1]) + get_translation()
    var ept = Vector3(cpt.x, cpt.y - 150, cpt.z)
    var hit = get_world().get_direct_space_state().intersect_ray(cpt, ept, [], 2147483647, 1 )
    if not hit.empty():
      if hit.collider.get_name().begins_with("BZPyr"):
        ret = true
      ri_under.append(hit)
  return ret


func setup_pyra_col_psq():
  var psq = PhysicsShapeQueryParameters.new()
  psq.set_shape(pyra_detect_shape)
  psq.set_object_type_mask( 1 )
  var t = psq.get_transform()
  t = t.rotated(Vector3(0,1,0), body_rotation)
  t.origin = get_transform().origin
  t.origin.y = t.origin.y - 90
  psq.set_transform(t)
  return psq


func check_close_bullet():
#  return false
  var spsq = setup_shot_col_psq()
  if not g._store.has("world"):
    g.store_set("world", get_world())
  var ri = get_world().get_direct_space_state().get_rest_info(spsq)
  if not ri.empty() and (ri["point"] - get_translation()).dot(ri["linear_velocity"]) < 0:
      var ang_perc = (ri["point"] - get_translation()).angle_to(ri["linear_velocity"]) / PI
      if ang_perc > 0.95:
        last_close_shot_time = OS.get_ticks_msec()
        return true
  if OS.get_ticks_msec() - last_close_shot_time < 250:
    return true
  return false


func setup_shot_col_psq():
  var spsq = PhysicsShapeQueryParameters.new()
  spsq.set_shape(shot_detect_shape)
  spsq.set_object_type_mask( 8 )
  spsq.set_exclude(get_node("/root/world/env/players").get_children())
  var t = spsq.get_transform()
  t = t.rotated(Vector3(0,1,0), -body_rotation)
  t.origin = get_transform().origin
  spsq.set_transform(t)
  return spsq


func update_speed_percent():
  if not g.is_null(fixed_speed_percent):
    speed_percent = fixed_speed_percent
    return
  var a = 0;
  if not phys.resting:
    return
    a = frozen_speed
  else:
    if abs(stick_y) < deadzone_bounds:
      a = 0
    else:
      if stick_y < 0:
        a = (stick_y + deadzone_bounds) / 2.0
      else:
        a = stick_y - deadzone_bounds
      a = a / (motion_bounds - deadzone_bounds)
    if s_speed_modifier != 1.0:
      a = a * s_speed_modifier
#    if Input.is_action_pressed("slowmo") and phys.resting:
#      a = a * slowmo_f
    frozen_speed = a
  mod_speed_percent(a)

func mod_speed_percent(a):
  speed_percent = a
  # speed_percent = lerp(speed_percent, a, 0.3)

func pause():
  set_sleeping(!paused)
  paused = !paused

func _integrate_forces(state):
  if paused:
    return
  g.report("__PHYS__", [phys], 1 , 1000, {"only":false})
  g.report("delta", [state.get_step()], 1 , 1000, {"only":false})
  if net.replay_state == net.REPLAY_PLAYING:
    replay_movement(state)
  elif (is_node_master or is_bot):
    if not new_spawn.empty():
      var t = Transform(Matrix3(), new_spawn.pos)
      state.set_transform(t)
      body_rotation = new_spawn.rot
      yaw = rad2deg(new_spawn.rot)
      phys.av = 0
      phys.lv = Vector3()
      phys.resting = false
      spawn_time = g.t()
      gsvar.announce("somthing wrong")
      # g.eval_context().sync_clients(self,state,true)
      # request_sync([9, "new_pos"])
      new_spawn = []
    else:
      master_movement(state)
  else:
    slave_movement(state)
  cur_vel = state.get_linear_velocity()


func replay_movement(state):
#  g.report("replay debug", [sm, sup], 0 , 1000, {"only":false})
  slave_movement(state)
  return

func master_movement(state):
  if not g.is_null(control):
    control.master_movement(state)
  mod_input(state.get_step())
  update_turning_percent()
  update_speed_percent()
  real_movement(state);

func slave_movement(state):
  mod_input(state.get_step())
#  if predict_landing_next_sync and synced:
#    predict_landing()
#    predict_landing_next_sync = false
  # synced = false
  # local_input[0] = false
  # var syncing = false
  # if sm[0] == null:
  #   g.report("faulty sm", [sm, sup], 0 , 100, {"only":false})
  # s_state['sp'] = sm[0] / 10000.0
  # s_state['tp'] = sm[1] / 10000.0
  # for i in sup:
  #   s_state[i] = sup[i]
  # if sup.has("st"):
  #   syncing = true
#    var player_sync = net.sync_table[int(get_name())]
#    var diff
#    if player_sync.has("latency"):
#      diff = OS.get_ticks_msec() - player_sync["rel_ticks"] - sup["st"] - player_sync["latency"]
#      if net.is_primary:
#        diff -= (net.server_simulation_delay - 2 * player_sync["latency"])
#    else:
#      global.report(["missing latency", int(get_name())] , [player_sync], 1000, 0, {"only":false})
#      diff = 0
##    predict_landing_next_sync = s_state["j"]
#    if abs(diff)  > 50:
#      g.chreport("ping sync out", [get_name(),diff], 0 , 1000, {"only":false})
##      global.report(["ping out of sync", get_name()], ["diff equals: ", diff], 0, 2000 )
#      net.ping(int(get_name()))
#   sup = {}
#   if phys.on_pyra:
#     s_state["sp"] = 0.0
#   speed_percent = s_state["sp"]
#   turning_percent = s_state["tp"]
#   if syncing:
#     var transform = state.get_transform();
# #   transform.origin = transform.origin.linear_interpolate(s_state["p"], 10*state.get_step())
#     transform.origin = s_state["p"]
#     state.set_transform(transform);
#     state.set_linear_velocity(s_state["lv"])
#     yaw = rad2deg(s_state["r"])
#     s_state["p"] = Vector3()
#     s_state["lv"] = Vector3()
#     s_state["r"] = 0.0
#     synced = true
#   else:
#     real_movement(state);

#func slave_movement(state):
#  if predict_landing_next_sync and synced:
#    predict_landing()
#    predict_landing_next_sync = false
#  synced = false
#  local_input[0] = false
#  var syncing = false
#  s_state['sp'] = sm[0] / 10000.0
#  s_state['tp'] = sm[1] / 10000.0
#  for i in sup:
#    s_state[i] = sup[i]
#  if sup.has("st"):
#    syncing = true
#    var player_sync = net.sync_table[int(get_name())]
#    var diff
#    if player_sync.has("latency"):
      #diff = OS.get_ticks_msec() - player_sync["rel_ticks"] - sup["st"] - player_sync["latency"]
#    else:
      #global.report(["missing latency", int(get_name())] , [player_sync], 0)
#      diff = 0
#    predict_landing_next_sync = s_state["j"]
#    if abs(diff)  > 50:
      #global.report(["ping out of sync", get_name()], ["diff equals: ", diff], 0, 2000 )
#      net.ping(int(get_name()))
#  sup = {}
#  if phys.on_pyra:
#    s_state["sp"] = 0.0
#  speed_percent = s_state["sp"]
#  turning_percent = s_state["tp"]
#  if syncing:
#    var transform = state.get_transform();
##   transform.origin = transform.origin.linear_interpolate(s_state["p"], 10*state.get_step())
#    transform.origin = s_state["p"]
#    state.set_transform(transform);
#    state.set_linear_velocity(s_state["lv"])
#    yaw = rad2deg(s_state["r"])
#    s_state["p"] = Vector3()
#    s_state["lv"] = Vector3()
#    s_state["r"] = 0.0
#    synced = true
#  else:
#    real_movement(state);


#func replay_record():
#  var replay_recording = true
  #var rec_cur = [[get_transform() , get_linear_velocity(), _phys, turning_percent, speed_percent]]
#
#
#func replay_stop_rec():
#  var replay_recording = false
#
#
#func replay_play():
#  var init_replay = true

func get_aim():
  return Vector3(sin(body_rotation),0,cos(body_rotation))

func real_movement(state):
  g.eval_context().real_movement(state,self)
  return
  if gsvar.cl_name == "server":
    g.report("moving", [stick_x, stick_y], 1 , 1000, {"only":false})
  #var s = {"lv":Vector3(), "rotation":0,  "moving":false, "jumping":false,"falling":false, "in_air":false, "touching":false, "side_touching":false, "touching_pyra":false, "resting":false, "on_floor":false, "on_pyra":false, "top_touching":false, "above_pyra":false}
  var s = _phys # empty state
  # var s = {}
  # s.parse_json( phys.to_json())
  # g.scrn_dbg("phys", phys)
  s.jumping = phys.jumping # init some state vars
  s.falling = phys.falling
  s.abilities = g.sg("abilities", [])
  s.jump_count = phys.jump_count
  if not pending_impulse.empty() and OS.get_ticks_msec() - last_impulse_t > 50:
    g.report("impulse", pending_impulse,0,0)
    last_impulse_t = OS.get_ticks_msec()
    state.apply_impulse(Vector3(),pending_impulse.pop_front())
  # change in angle = angular velocity * time
  var angle_diff = turning_percent * base_turning_speed * (state.get_step() * 60)
  var t_yaw = fmod(yaw+(angle_diff), 360.0);
  var t_body_rotation = deg2rad(t_yaw);
  var dir = Vector3();
  var aim = Vector3(sin(t_body_rotation),0,cos(t_body_rotation))
  dir += aim * speed_percent;
  dir.y = 0;
  dir = dir.normalized();
  g.report("dir vs aim vs basis z", [dir, aim.normalized(), body.get_transform().basis.z], 5, 4000)
  var lv = state.get_linear_velocity()
  var grav = Vector3(0,-world_gravity,0);
  var delta = state.get_step();
  var up = -grav.normalized() # (up is against gravity)
  var vv = up.dot(lv)
  # lv += grav*delta # Apply gravity
  # var up = -grav.normalized() # (up is against gravity)
  # var vv = up.dot(lv) # Vertical velocity
  # if phys.resting:
  #   vv = 0
  # if vv > 0:
  #   gsvar.announce("uppin", 0.1)
  # var hv = lv - up*vv # Horizontal velocity
  var hv = g.xnz(lv) # Horizontal velocity
  var hdir = hv.normalized() # Horizontal direction
  var hspeed = hv.length() # Horizontal speed
  var just_jumped = phys.just_jumped
  phys.just_jumped = false
  g.report('hspeed', hspeed, 5 , 1000)
  s.above_pyra = check_above_pyra()
  var tspeed = max_speed * abs(speed_percent);
  var col_groups0
  if (state.get_contact_count() > 0):
    col_groups = get_grouped_collisions(state)
    col_groups0 = col_groups[0]
    s.touching = not col_groups0["StaticBody"].empty()
    s.on_floor = is_on_floor(col_groups0)
    s.touching_pyra = is_touching_pyra(col_groups0)
    s.on_pyra = not s.on_floor and s.touching_pyra
    s.resting = s.on_floor or s.on_pyra
    s.top_touching = not s.resting and is_top_touching(col_groups0)
    s.side_touching = is_side_touching(col_groups0)
  else:
    col_groups = {0:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}, 1:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}}
  # s.resting = s.resting or s.abilities.has("W")
  # if s.jumping:
  #   try_jump_once = false
  # var jump_attempt = s.resting and (local_input[0] or try_jump_once) && !is_dying;
  # if phys.falling:
  #   try_jump_once = false


  if not s.resting:
    if not s.jumping:
      s.falling = true
      # s.resting = false
    set_axis_lock(0)
    lv += grav*delta # Apply gravity
    vv = up.dot(lv) # Vertical velocity
  elif not s.jumping:
    vv = 0
    set_axis_lock(2)
  elif s.touching_pyra and not phys.touching_pyra:
  # else:
    gsvar.announce("land on pyra", 0.5)
    vv = 0
    set_axis_lock(2)
  if local_input[0]:
    gsvar.announce("jaaa", 0.1)
  # var jump_attempt =  (local_input[0] or try_jump_once or (Input.is_action_pressed("jump") and s.resting and not s.jumping)) && !is_dying;
  var jump_attempt =  (local_input[0] or try_jump_once or (Input.is_action_pressed("jump") and s.resting and not just_jumped)) && !is_dying;
  var target_dir = dir
####  if s.touching:
####    # recompute landing marks??
####    for m in landing_marks:
####      m.queue_free()
####      landing_marks.clear()
  if check_in_2pts_on_rest and s.resting:
    check_in_2pts_on_rest = false
    in_2pts_area = false
  # if phys.resting or (phys.jump_count < 2  and not phys.falling) or s.abilities.has("W"):
  # make sure pressing jump while in the air doesn't lead to uintended jump after landing
  if not s.resting: # bug? does this stop double jumps? no, cause we already have jump_attempt set beforehand
    try_jump_once = false
  # if phys.resting or (phys.jump_count < g.sg("max_jump_count", 2)  ) or s.abilities.has("W"):
  if s.resting or (phys.jump_count < g.sg("max_jump_count", 2)  ) or s.abilities.has("W"):
  # if phys.resting or (phys.jump_count < 2 and in_key_area) or s.abilities.has("W"):
    if jump_attempt:
      # gsvar.announce(["cur jumps count", phys.jump_count], 2,"2")
      s.jump_count += 1
      # phys.jump_count += 1
      # gsvar.announce(["that jump consumed", s.jump_count ], 1, "2")
      try_jump_once = false
    # if (not s.jumping and jump_attempt):
    if ( jump_attempt):
      # g.sounds.play("jump")
      # t_turning_percent = sign(turning_percent) * clamp((g.t() - jump_start)/100.0, 0.25,6)
      # var voice = sounds.play("jump")
      var voice = sounds.play(g.sg("jump_sound", "jump"))
      sounds.voice_set_volume_scale_db(voice, g.store_get("jumpcoundvolsc", -9))
      sounds.voice_set_pitch_scale( voice, g.store_get("jumpcoundpchsc", 1.4))
      set_axis_lock(0)
      s.just_jumped = true
      if s.jump_count == 1: # full jump velocity on first jump

        vv = jump_velocity
      else: # add hald jump verlocity on each subsequent jump
        vv += jump_velocity*0.5
      s.jumping = true
  # if (true or s.resting):
  if (s.resting):
    # vv = 0
    if s.falling: # just rested
    # if s.falling or s.jumping:
      s.jump_count = 0
      s.jumping = false
      s.falling = false
    # if (dir.length() > 0):
    if g.sg("noacc", false):
      # gsvar.announce("um", 0.1)
      hspeed = tspeed;
      hdir = target_dir;
    else:

      if (dir.dot(lv) >= 0): # velocity dir same as input. ie, not sliding
        g.report(["accelerate"], [dir, dir.length()],5 , 3000)
        hdir = target_dir;
        if (hspeed < tspeed):
          hspeed = min(hspeed+(accel*delta), tspeed);
          # hspeed = tspeed;
        else:
          hspeed = tspeed;
  #      hspeed = tspeed
        s.moving = true;
      else:
        # print("moooos")
        # sounds.play("430626__juandamb__brake")
        var lvsnd = g.sg("brake_speed_sounds", [170,90,60])
        if lv.length() < lvsnd[2] or abs(lv.y) > 10:
          g.eval_context().stop_sound(sounds, "217542__medartimus__car-breaking-skid-01")
          g.eval_context().stop_sound(sounds, "430626__juandamb__brake")
        elif lv.length() > lvsnd[0]:
          g.eval_context().play_sound_one(sounds, "217542__medartimus__car-breaking-skid-01")
        elif lv.length() > lvsnd[1]:
          g.eval_context().play_sound_one(sounds, "430626__juandamb__brake")

        g.report(["deaccelerate"], [dir, dir.length()],5 , 3000)
        hspeed -= deaccel*delta;
        if (hspeed < 0):
          hspeed = 0;
      # hspeed = 0
    hv = hdir*hspeed;


  if (s.on_pyra and jump_attempt):
    vv = jump_velocity;
    gsvar.announce("inpyr jump", 0.2)
    g.report("jump attempt", [get_translation().y, vv, s.jumping, OS.get_ticks_msec()], 0 , 0)
    hv = Vector3(0,0,0);
  if s.top_touching:
    var xform = state.get_transform()
    hv = Vector3(0,0,0);
    t_turning_percent = 0.0
    turning_percent = 0.0
    frozen_turn = 0.0
    var lpos = xform.origin
    xform.origin = (Vector3(lpos.x, lpos.y - 0.1, lpos.z))
    # gsvar.announce(["errrz tio hit"], 1)
    state.set_transform(xform)
  if (s.jumping and vv < 0):
    # gsvar.announce(["errz", vv], 1)
    s.jumping = false;
    s.falling = true
  var sp_orig = speed_percent
  speed_percent = (hv.length() / max_speed) * sign(speed_percent)

  if s.on_pyra and not s.jumping:
  # if s.on_pyra and  s.resting and not phys.resting:
    vv = 0
  ## Side touching either block or pyra ##
  if s.side_touching:
    var xfrm = body.get_transform()
    var sidecol = get_body_collisions(touching_bodies['sides'][0])[0]
    var rel_norm = sidecol['norm'].rotated(Vector3(0,1,0), body_rotation)
    var normang = atan2(sidecol['norm'].x, sidecol['norm'].z)
    var turning_towards_obstacle = sign(turning_percent * sidecol['pos'].z * normang)

    if s.touching_pyra and phys.on_floor:
#      g.report("just touched pyra on floor", [], 0 , 1000, {"only":false})
      vv = -100
    if s.on_pyra and not jump_attempt:
#      g.report("lock movement on pyra touching side", [], 1 , 1000)
      if speed_percent == 0:
        hv = Vector3(0,0,0);
      elif abs(sidecol.norm.dot(body.get_transform().basis.z)) < 0.01:
      # elif abs(sidecol.norm.dot(body.get_transform().basis.z)) < 0.05:
        #g.report("pyra rel col", [sidecol.norm.dot(body.get_transform().basis.z)],0 , 1000)
        gsvar.announce("ucc1", 0.5)
        hv = hdir*hspeed;
      elif sign( rel_norm.z) == sign(speed_percent):
        gsvar.announce("ucc2", 0.5)
        hv = hdir*hspeed;
      else:
        gsvar.announce("ucc3", 0.5)
        # hv = hdir*hspeed;
        hv = Vector3(0,0,0);
        turning_percent = 0
    if sign(turning_percent) != sign((rel_norm.x + sidecol['pos'].normalized().x)* sidecol["pos"].z ):
      var old_ty = t_yaw
      if s.on_pyra:
        t_yaw = yaw
      else:
        t_yaw = yaw + (t_yaw - yaw) * speed_percent * (1 - abs(rel_norm.x + sidecol['pos'].normalized().x)) * sign(sidecol['pos'].z)
        g.report("change in ty", [t_yaw / old_ty],1,500)

    # if s.touching_pyra and not phys.resting:
    #   gsvar.announce(["angryy", s.resting], 2)
    #   # s.resting = true
    #   # s.jumping = false
    #   hv = Vector3(0,0,0);
    #   vv = 0
      if not s.resting:
        frozen_turn = 0.0
        t_turning_percent = frozen_turn
        # frozen_turn = -1 * (t_yaw - yaw) / (state.get_step() * 60)
        g.report("ft,fs", [frozen_turn,frozen_speed, t_yaw, yaw], 5 ,100)
      t_body_rotation = deg2rad(t_yaw);
  # if s.resting:
    if s.on_pyra and not phys.on_pyra:
      vv = 0
      hv = Vector3()
      speed_percent = 0.0
      # t_speed_percent = 0.0
  var yvel = get_linear_velocity().y
  # if get_linear_velocity().y > 10 or (yvel<-2 and yvel > -1*(randi()%30)):
  if get_linear_velocity().y > 5:
    var voice = g.sg("jump_jet_voice",-1)
    if not sounds.is_voice_active(voice):
      voice = sounds.play(g.sg("jump_jet_sound", "jump"))
    # sounds.voice_set_volume_scale_db(voice, g.store_get("jumpcoundvolsc", -9))
      sounds.voice_set_pitch_scale( voice, g.store_get("jumpjetcoundpchsc", 1.4))
      g.ss("jump_jet_voice", voice)
    get_node("body/wound_particles5").show()
  else:
    if g.sg("jump_jet_voice",-1) > -1:
      sounds.stop_voice(g.sg("jump_jet_voice"))
    get_node("body/wound_particles5").hide()
  lv = hv + up*vv;
  # g.scrn_dbg("tank_ang_vel", (t_yaw - yaw)/delta)
  # g.scrn_dbg("tank_path_radius", hv.length()/((t_yaw - yaw)/delta))
  # var path_r = hv.length()/(((t_yaw - yaw)/delta)*PI/180)
  # var aim_r = Vector3(sin(t_body_rotation),0,cos(t_body_rotation)).rotated(Vector3(0,1,0), -PI/2)
  # var turning_center = get_translation() + aim_r*min(100000, path_r)
  # g.create_mark({ "pos":turning_center, "color":Color(1,1,0,0.2)}, "center point", true, false)
  var t = OS.get_ticks_msec()
  # s.turning_center = turning_center
  s.tick = t
  s.lv = lv
  s.av = (t_yaw - yaw) * delta * 60
  if g.time_since(self,'phys_keep', 1,true):
    phys_old.pop_front()
    phys_old.append(phys)
#  var pts = [5000,4000,3000,2000,1000,500,400,300,200,100]
#  var y = false
#  for i in range(10):
#    if t - phys_old[i].tick > pts[i]:
#      phys_old.remove(i)
#      y = true
#      break
#  if not y:
#    phys_old.remove(10)
#  phys_old.append(phys)
  g.report("__S__", [s], 1 , 1000, {"only":false})
  phys = s
  g.report("__PHYS__", [s], 1 , 1000, {"only":false})
  g.scrn_dbg("rlmov_lv", lv)
  state.set_linear_velocity(lv);
  angvel = (t_yaw - yaw) * delta * 60
  yaw = t_yaw
  body_rotation = g.unify_angle(t_body_rotation)
  phys.rotation = body_rotation
  get_node("col_capsule").set_rotation(Vector3(0, body_rotation,0));
  if (phys_old.back().on_floor != phys.on_floor) and s.resting:
    g.eval_context().play_sound_one(sounds, "364690__alegemaate__human-impact-on-ground")
    create_tank_ripple()
  if (phys_old.back().on_floor != phys.on_floor) and s.jumping:
    g.report("on floor changed", [phys_old.back().on_floor,phys.on_floor], 1 , 0)
###    predict_landing_next_sync = true
  # === update slave info === #
  if (is_node_master or is_bot) and net.replay_state != net.REPLAY_PLAYING:
    g.eval_context().sync_clients(self, state)
    return
    # var ls = phys_old.back()
    # sup = {}
    # if OS.get_ticks_msec() - last_got_hit < 50:
    #   request_sync([3,"hit recently"])
    # # full client sync
    # var s_diff = OS.get_ticks_msec() - last_s_sync
    # if (not (s.on_pyra or s.above_pyra)) and s.side_touching != ls.side_touching:
    #   request_sync([5, "side touch"])
    # if above_pyra and Vector3(lv.x,0,lv.z).length() > 2:
    #   request_sync([4,"above pyra"])
    # if s.on_pyra:
    #   request_sync([4, "pyra"])
    # # if (ls.on_floor != s.on_floor) and vv > 0:
    # if (ls.on_floor != s.on_floor) or s.jump_count > ls.jump_count:
    #   request_sync([9,"jump"])
    # if (g.t() - last_impulse_t < 50):
    #   request_sync([9,"impulse"])
    # # if s_diff> syncticks:
    # #   request_sync([9, "sync"])
    # # if s.turning_center != phys_old[-1].turning_center:
    # #   request_sync([9, "sync"])
    # # if s.av != phys_old[-1].av:
    # #   request_sync([9, "sync"])
    # # if s.lv != phys_old[-1].lv:
    # #   request_sync([9, "sync"])

    # var reliable = false
    # var force = false
    # var after = 0
    # if not sync_reqs.empty():
    #   var mask = 0
    #   for sr in sync_reqs:
    #     mask = mask|sr[0]
    #   reliable = mask&1
    #   force = mask&8
    #   if mask&2:
    #     after = 10
    #   elif mask&4:
    #     after = 10
    #   sync_clients(state, sup)
    # var do_up = false
    # do_up = s.turning_center != phys_old[-1].turning_center and abs(s.av) > 0
    # do_up = do_up or (abs(s.av) == 0 and lv.length() != phys_old[-1].lv.length())
    # if do_up:
    #   request_sync([9, "sync"])
    # # if not sup.empty() and s_diff > after and (force or (sup["p"] != last_s_update[1]["p"] or sup["r"] != last_s_update[1]["r"])):
    # if  not sup.empty() and do_up:
    #   last_s_update[1] = sup
    #   last_s_sync = OS.get_ticks_msec()
    #   sup["st"] = last_s_sync
    #   g.report('do sync', [sync_reqs], 1, 2000, {"only":false})
    #   sync_reqs = []
    #   for i in sup:
    #     s_state[i] = sup[i]
    #   net.rset(self, "sup", sup, {"reliable":reliable, "short_path":true})
    #   sm = [null,null]
    #   net_buffer["sp"] = []
    #   net_buffer["tp"] = []
    #   return
    # # only update input1000
    # # quick_sync()
    # return
    # if  OS.get_ticks_msec() - last_s_update[0] > 0:
    #   last_s_update[0] = OS.get_ticks_msec()
    #   var new_sm = [0,0]
    #   new_sm[1] = int(g.avg(net_buffer["tp"], turning_percent) * 10000)
    #   net_buffer["tp"] = []
    #   new_sm[0] = int(g.avg(net_buffer["sp"], speed_percent) * 10000)
    #   net_buffer["sp"] = []
    #   if sm != new_sm:
    #     sm = new_sm
    #     net.rset(self, "sm", sm, {"reliable":reliable, "short_path":true})
    # else:
    #   net_buffer["sp"].append(speed_percent)
    #   net_buffer["tp"].append(turning_percent)


func quick_sync():
  var new_sm = [0,0]
  new_sm[1] = int(round(turning_percent * 1000))
  new_sm[0] = int(round(speed_percent * 1000))
  if (sm != new_sm):
#    g.report("new sm", [sm,new_sm], 0 , -1, {"only":false})
    sm = new_sm
    # net.rset(self, "sm", sm, {"reliable":true, "short_path":true})

# func request_sync(req):
#   g.scrn_dbg("rqsync_" + req[1], [g.t()])
#   if not sync_reqs.has(req):
#     sync_reqs.append(req)


# func sync_clients(state, sup, flags=["motion", "input", "time"]):
#   g.report("sync clients", [OS.get_ticks_msec(), flags], 1 ,5000)
#   if "time" in flags:
#     pass
#   if "motion" in flags:
#     sup['lv'] = state.get_linear_velocity()
#     sup['av'] = angvel
#     sup["r"] = body_rotation
#     sup["p"] = state.get_transform().origin
#   if "input" in flags:
#     sup["j"] = phys.jumping


#func predict_position(t=0.5):
#  if is_node_master:
#    return
  #var l = g.deep(net.sync_table, [int(get_name()), "latency"])
#  if g.is_null(l):
#    return
#  t = l / 1000.0
#  var yplus = 0.7
#  var lv = get_linear_velocity()
#  var fpos = Vector3()
#  var pos = get_translation()
#  if phys["on_floor"]:
#    fpos = pos + lv * t
#    fpos.y = fpos.y + yplus
#  elif not phys["resting"]:
#    fpos.x = pos.x + lv.x * t
#    fpos.z = pos.z + lv.z * t
#    fpos.y = yplus + pos.y + lv.y * t + (-9.8 * t)
#  else:
#    fpos = pos
#    fpos.y = fpos.y + yplus
##    lagmate_pos = fpos
#  var cam = get_viewport().get_camera()
#  var pos1 = cam.unproject_position(pos);
#  var pos2
#  if freeze_lagmate:
#    pos2 = cam.unproject_position(lagmate_pos);
#  else:
#    pos2 = cam.unproject_position(fpos);
#    lagmate_pos = fpos
#  var d3d = (gsvar.me.get_translation() - pos).length()
#  var d2d = (pos2 - pos1).length()
#  if  d2d < 20 or cam.is_position_behind(pos):
#    get_node("lag_mate").hide()
    #g.report("hide lag mate", [get_name(),d2d,d3d], 1 , 1000, {"only":false})
#    return
#  else:
#    get_node("lag_mate").show()
    #get_node("lag_mate").set_scale(Vector2(20.0/d3d, 20.0/d3d))
    #g.report("show lag mate", [get_name(),d2d,d3d], 1 , 1000, {"only":false})
#
#  get_node("lag_mate").set_pos(Vector2(pos2.x, pos2.y - 5))
#  var rot = -(pos2 - pos1).angle_to(Vector2(1,0))
#  get_node("lag_mate").set_rot(rot)
#  get_node("projected_pos").set_translation(fpos - pos)
  #g.report("projected pos", [pos,fpos, t], 1 , 5000, {"only":false})
#  return fpos


func get_grouped_collisions(state):
  var groups = {0:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}, 1:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}}
  for i in range(state.get_contact_count()-1,-1,-1):
    var shape=state.get_contact_local_shape(i)
    if not groups.has(shape):
      groups[shape] = {"StaticBody":{}, "RigidBody":{}}
    var collider = state.get_contact_collider_object(i)
    if not collider:
      continue
    var colpos = state.get_contact_local_pos( i ).rotated(Vector3(0,1,0), body_rotation)
    var collider_colpos = state.get_contact_collider_pos( i ).rotated(Vector3(0,1,0), body_rotation)
    var local_collider = state.get_contact_local_shape(i)
    var type
    for t in ["StaticBody", "RigidBody", "KinematicBody"]:
      if collider.is_type(t):
        type = t
        break
    if not groups[shape][type].has(collider):
      groups[shape][type][collider] = []
    groups[shape][type][collider].append({"pos":colpos, "norm":state.get_contact_local_normal( i ), "collider_pos":collider_colpos})
  return groups


func get_body_collisions(body, local_shape=0, type ='StaticBody'):
  return g.deep(col_groups, [local_shape,type, body])


func is_touching_pyra(groups):
  var onp = false
  for body in groups["StaticBody"]:
    if body.get_name().begins_with('BZPyramid'):
      # body.set_friction(1)
      onp = true
      for col in groups["StaticBody"][body]:
        if col["pos"].y > 0.05:
          # gsvar.announce(["nooooope"], 1)
          onp = false
          break
      if onp:
        break
  return onp


func is_top_touching(groups):
  var topt = false
  # var h = tank_size.y * 1.9
  var h = tank_size.y
  for body in groups["StaticBody"]:
    if body.get_name().begins_with('BZPyramid'):
      for col in groups["StaticBody"][body]:
        topt = true
        if col["pos"].y < (h):
          topt = false
          break
      if topt:
        return topt
    var tri_col = (groups["StaticBody"][body].size() == 3)
    if groups["StaticBody"][body].size() > 2:
      topt = true
      var m = Matrix3(Vector3(), Vector3(1,1,1), Vector3())
      var c = 0
      for col in groups["StaticBody"][body]:
        if col["pos"].y < (h):
          topt = false
          break
        if tri_col:
          m.x[c] = col["pos"].x
          m.z[c] = col["pos"].z
          c += 1
      topt =  topt and ((m.determinant() > 0.1 or not tri_col))
      return topt


func is_on_floor(groups):
  touching_bodies['bottom'] = []
  var onf = false
  var b
  var bonf = false
  for body in groups["StaticBody"]:
    if groups["StaticBody"][body].size() > 2:
      bonf = true
      b = body
      for col in groups["StaticBody"][body]:
        if (col['norm'].y < 0.999) or (col["pos"].y > 0.0):
          bonf = false
          break
      onf = onf or bonf
      if bonf:
        if not touching_bodies['bottom'].has(b):
            touching_bodies['bottom'].append( b)
      else:
        touching_bodies['bottom'].erase( b)
  return onf


func is_side_touching(groups):
  touching_bodies['sides'] = []
  var st = false
  for body in groups["StaticBody"]:
    if not body in touching_bodies['bottom']:
      if body.get_name().find("Pyr") != -1:
        st = true
        g.report("side touch pyra", [],5 , 100)
        touching_bodies['sides'].append(body)
      else:
        for col in groups["StaticBody"][body]:
          if col["pos"].y < tank_size.y * 3 and col["pos"].y > 0:
            g.report("side touch", [col],5 , 100)
            st = true
            touching_bodies['sides'].append(body)
            break
  return st


func dying_think():
  if (!is_dying or !(is_node_master or is_bot)):
    return;
  if (gsvar.world.time < dying_time+gsvar.spawn_delay):
    return;
  net.rset(self, "health", 100.0);
  g.eval_context().spme(randi())
  phys.lv = Vector3()
  phys.av = 0
#  net.rset(self, "is_dying", false);
  net.rpc_sync(self, "set_is_dying", [false])
#  net.rset(self, "max_speed_mod", 1.0);

func set_is_dying(val, src=0):
  is_dying = val
  if val:
    get_node("body/wound_particles8").show()
    g.w_set(self, "max_speed_mod", "is_dying", 0.3, 2)
  else:
    get_node("body/wound_particles8").hide()
    g.w_unset(self, "max_speed_mod", "is_dying")

func rcallv(fn, args= [], src=0):
  callv("fn", args)

func can_shoot():
#  if (is_dying || !(is_node_master or is_bot) || (not is_bot and g.ball().owner == net.uid)):
  if (is_dying || !(is_node_master or is_bot)):
    return false;
#  g.report("1", [], 0 , 1000, {"only":false})
  if (ammo.size() >= shots_limit or gsvar.world.time < next_shoot):
    return false;
  return true

func shoot_think(meta={}):
#  g.report("0", [], 0 , 1000, {"only":false})
###  if (is_dying || !is_aiming || !is_node_master):
#  if (is_dying || !(is_node_master or is_bot)):
#    return;
##  g.report("1", [], 0 , 1000, {"only":false})
#  if (ammo.size() >= shots_limit or gsvar.world.time < next_shoot):
#    return;
  if not can_shoot():
    return
#  g.report("2", [], 0 , 1000, {"only":false})
  var pos = get_node("body/shoot_pos").get_global_transform().origin;
  var rot = body_rotation
  if not phys.on_floor:
    rot = body_rotation
  # var impulse = (Vector3(sin(rot),0,cos(rot)) * g.sg("shot_base_speed", 180)) + Vector3(cur_vel.x,0,cur_vel.z)/2;
  var impulse = (Vector3(sin(rot),0,cos(rot)) * g.sg("shot_base_speed", 180)) + Vector3(phys.lv.x,0,phys.lv.z);
  var speed = impulse.length()
  g.report("shot speed", [speed], 0 , 0, {"only":false})
  var mid = randi();
  # ammo.append({"mid":mid, "time":g.rticks(), "meta":meta})
  ammo.append({"mid":mid, "time":g.t(), "meta":meta})
  update_ammo(true)
  #ui_ammo.set_text(str(shots_limit - ammo.size()) + "/" + str(shots_limit))
#  ammo.append(OS.get_ticks_msec())
###  ui_ammo.set_text(str(shots_limit - ammo.size()) + "/" + str(shots_limit))
  # request_sync([9, "shoot"])
  last_shot_params.push_front([get_name().to_int(), pos, mid , impulse, speed])
  if last_shot_params.size() > 5:
    last_shot_params.pop_back()
  net.rpc_sync(self,"spawn_missile", [get_name().to_int(), pos, mid , impulse, speed], {'channel':4, 'reliable':true});
  next_shoot = gsvar.world.time+0.01;
  last_shot = mid
  g.time_since_up(self,"last_repeat_shoot")
#  g.report("shot id", [mid], 0 , 0, {"only":false})
#  gsvar.change_focus("GNC")
#  gsvar.temp_pause_after( 0.5, 3.0)
  return mid


func spawn_missile(owner, pos, mid, impulse, speed, src=0):
  var out = [];
# OS.execute("date", ["+%s%3N"], true, out)
#  var inst = missile_scene.instance();
  var inst = load("res://prefabs/bullet/bullet.tscn").instance();
  inst.set_name("missile");
  inst.owner = owner;
  inst.speed = speed
  inst.missile_id = mid;
  inst.initial_velocity = impulse
  gsvar.missiles[mid] = inst;
  inst.set_global_transform(Transform(Matrix3(), pos));
  inst.apply_impulse(Vector3(), impulse);
  get_node("body/fire_particles").set_emitting(true)
#  var ball = get_node("/root/world/env/Ball")
  g.ball() and inst.connect("missile_hit", g.ball(), "player_got_hit");
  gsvar.world.env.add_child(inst, true);


func shake_camera(mul=1.5, cam=null):
#  g.console_exec("/shake_camera()")
  var default_mul = 1.5
  cam = get_node("camera/cam")
  var timer_name = "shake_camera_timer"
  if not g.object_timer_active(timer_name, self):
    g.store_set("shake_mul", mul)
    g.store_set("shake_cam_count", randi()%2-1)
    g.object_timer( timer_name, self, "shake_camera", false, 0.04, [mul])
  g._store["shake_cam_count"] += 1
  var count = g._store["shake_cam_count"]
  var max_count = 14
  var shake_power = (2 + pow((max_count - count) / float(max_count), 0.3)) * g.store_get("shake_mul", default_mul)
  g.report("shake power", [shake_power], 0 , -1, {"only":false})
  cam.set_h_offset((count%2 - 0.5)*randf()*shake_power*1.2)
  cam.set_v_offset((count%2 - 0.5)*randf()*shake_power)
  if count > max_count:
    g.report("done shaking", [], 0 , 1000, {"only":false})
    g.timers[self][timer_name].set_active(false)
    cam.set_h_offset(0)
    cam.set_v_offset(0.5)
    g.store_set("shake_mul", default_mul)


func get_killed(killed_by, pos, mid):
  g.report("got hit in player", [is_blocking_signals(),killed_by,pos,mid], 1 , 1000, {"only":false})

  gsvar.player_by_id(pid).die(killed_by)
  shake_camera(0.3)
  create_explosion(pos,mid)
#  g.report("killershot", [mid], 0 , 0, {"only":false})
  net.rpc(self, "create_explosion", [pos, mid]);


func die(attacker,dmg=100):
  # request_sync([9, "hit"])
  if (is_dying):
    return;
  health = health-dmg
  if (health <= 0.0):
    dying_time = gsvar.world.time;
    deaths.append(OS.get_ticks_msec())
#    is_dying = true
#    max_speed_mod = 0.33
    if is_node_master or is_bot:
      net.rpc_sync(self, "set_is_dying", [true])
#      net.rset(self, "is_dying", true);
#      net.rset(self, "max_speed_mod", 0.3);
    var attacker_name = gsvar.player_by_id(attacker).get_object_name()
    var my_name = gsvar.player_by_id(own_id).get_object_name()
    net.rpc(self, "announce_kill",[my_name ,attacker_name] )
#    gsvar.chatmgr.add_message("you were wrecked by " + attacker_name);
    gsvar.announce("you were wrecked by " + attacker_name, 4, "2")

func announce_kill(killed, killer, src=0):
  # gsvar.chatmgr.add_message(killed + " is wrecked by " + killer);
  gsvar.announce(killed + " is wrecked by " + killer, 4, "2")


func create_explosion(pos,mid,src=0):
  var inst = explosion_scene.instance();
  inst.set_name("expl");
  inst.set_global_transform(Transform(Matrix3(), pos));
  gsvar.world.env.add_child(inst, true);
  if gsvar.missiles.has(mid):
    gsvar.missiles[mid].queue_free();
    gsvar.missiles.erase(mid);



#func set_request_sync():
#  request_sync = true

func phys_conf(n):
  print(g.pretty_str(n))
  var confs = {
    1:{"max_speed":50.0, "world_gravity":9.8, "jump_velocity": 12.5, "normal_jump": 12.5, "pad_jump": 18 },
    2:{"max_speed":50.0, "world_gravity":9.8 * 2, "jump_velocity": 12.5 * 1.2, "normal_jump": 12.5 * 1.2, "pad_jump": 18 * 1.1},
    3:{"max_speed":50.0, "world_gravity":9.8 * 2, "jump_velocity": 12.5 * 1.2, "normal_jump": 12.5 * 1.2, "pad_jump": 18 * 1.4},
    4:{"max_speed":90.0, "world_gravity":9.8 * 2, "jump_velocity":12.5 * 0.8, "normal_jump": 12.5 * 0.8, "pad_jump": 18 * 1.4, "normal_max_speed":90, "max_turning": 1.0},
    5:{"max_speed":90.0, "world_gravity":9.8 * 2, "jump_velocity":12.5 * 0.8, "normal_jump": 15.5 * 0.8, "pad_jump": 15.5 * 0.8, "normal_max_speed":90, "max_turning": 1.0},
  }
#  for i in [1,2,3,4]:
#    var p = gsvar.player_by_id(i)
  for v in confs[n]:
    set(v, confs[n][v])