tool

extends Spatial

var trajectory_shapes = []
var max_speed = 100
var jump_velocity = 30
var world_gravity = -9.8

func _ready():
  print(6)
  create_jump_trajectory_shapes()
  create_ig(Vector3(), trajectory_shapes[0])
  get_node("cube").set_scale(Vector3(1,1 + randf() + 2,1))
  set_process(true)

func _process(delta):
  pass 
# print(2)
 # trajectory_shapes = []
#  create_jump_trajectory_shapes()
#  create_ig(Vector3(), trajectory_shapes[0])
#  print(trajectory_shapes)
#  get_node("cube").set_scale(Vector3(1,1 + randf() / 10,1))

func create_jump_trajectory_shapes():
  var shape
  for i in range(4,7,1):
    shape = ConcavePolygonShape.new()
    shape.set_faces(create_base_trajectory(i))
    trajectory_shapes.append(shape)


func create_base_trajectory(t):
  var z
  var y
  var traj=[]
  for i in range(0, (t+1)*10, 1):
    var j = i/10.0
    z = max_speed * j
    y = jump_velocity * j + (-world_gravity * j * j / 2)
    y += 1
    traj.append(Vector3(0,y,z))
    if i > t*10 - 1 :
      break
    if i != 0 and i%2 == 0:
      traj.append(Vector3(0,y,z))
  traj.invert()
  return Vector3Array(traj)

func array_range(array, start,end):
  if end < 0:
    end = array.size() + end
  end = end + 1
  if start < 0:
    start = array.size() + start
  if end < 0 or start < 0:
    return []
  start = clamp(start, 0 , array.size())
  end = clamp(end, 0 , array.size())
  var order = 1
#  if end <= start:
#    order = -1
##    start =  start - 1
#    end = end - 2
  var new_array = []
  for i in range(start,end, order):
    new_array.append(array[i])
  return new_array

func create_trajectory_ig(shape):
#  var ig = ImmediateGeometry.new()
  var ig = get_node("ig")
  var verts = shape.get_faces()
#  ig.set_material_override(trajectory_mat)
  ig.begin(VS.PRIMITIVE_LINE_LOOP  ,null)
  for v in array_range(verts,1,-1):
    ig.set_color(Color(1,0,0))
    ig.add_vertex(v)
  ig.end()
  var t = ig.get_transform()
#  t = t.rotated(Vector3(0,1,0), -body_rotation).scaled(Vector3(1,1,speed_percent * 1))
  var rot = PI #g.vec3rot(get_linear_velocity().normalized())
#  if speed_percent < 0:
#    rot = 2*PI - rot
  var speed_percent = 1
  t = t.rotated(Vector3(0,1,0), -rot).scaled(Vector3(1,1, abs(speed_percent)))
  ig.set_global_transform(t)
  return ig

func create_ig(pos, shape):
  var ig = create_trajectory_ig(shape)
#  ig.set_translation(get_translation() - inst.get_translation())

func _enter_tree():
  print(333)
