extends Control

export(DynamicFont) var font;
export(Color) var text_color;
export(Color) var red_color;
export(NodePath) var objects_node;

var objects = [];
var objects_visible = [];
var margin = Vector3(0, 3.3, 0);
var off= false
var extra_enabled = true
onready var gsvar = get_node("/root/gamestate")
onready var net = get_node("/root/net")
onready var me = gsvar.me
onready var g = get_node("/root/global")

func _ready():
	if (typeof(objects_node) == TYPE_NODE_PATH && !objects_node.is_empty()):
		objects_node = get_node(objects_node);
#	net.connect("client_disconnected", self, "remove_object");

	set_process(true);

func _process(delta):
	if (!is_visible() || !get_viewport().get_camera()):
		return;

	objects.clear();
	var cam = get_viewport().get_camera()
	g.report("ui objs", [objects_visible], 1 , 1000, {"only":false})
#	for i in objects_node.get_children():
	# for i in objects_visible:
	for i in get_tree().get_nodes_in_group("objects_visible"):

		if (!i.has_method("get_object_name")):
			continue;
		if cam.is_position_behind(i.get_global_transform().origin):
			continue
		var name = i.get_object_name();
		var color = text_color
		if i.is_dying:
			color = red_color
		if (name == ""):
			continue;
#		var latency = net.sync_table[int(i.get_name())]
		var latency = g.deep(net.sync_table, [int(i.get_name()), "latency"])
		if not g.is_null(latency):
			var latency_labels = ["a+","a", "b+","b", "c+","c","d+","d","e+","e","f+","f"]
			var ll = int(latency / 40)
			if ll < latency_labels.size():
				ll = latency_labels[ll]
			else:
				ll = "f-"
	#		var ll = latency_labels[latency / 40]
			name = name + "(" + ll + ")"
#		if(i.get_node("VisibilityNotifier").is_on_screen()):
		var pos = cam.unproject_position(i.get_global_transform().origin+margin);
		g.report(["objname", i.get_name()], [pos, name],3 , 10000)
		name += str(i.ammo.size())

#		for extra in g.store_get(["tank_info_extra", i.pid], {}):
#			name += "-"
#			name += str(extra)
		if extra_enabled:
			var extra = g.store_get(["tank_info_extra", i.pid], {})
			if not extra.empty():
				name += "-"
				name += str(extra)
		g.store_set(["tank_info_extra", i.pid], {})
		var distance = 1
		if not g.is_null(gsvar.me):
			distance = (i.get_global_transform().origin - gsvar.me.get_global_transform().origin).length()
			var sc = max(distance / g.store_get("sc", 235.0), 1.2)
#			i.get_node("body/Tank/Tank/MeshInstance").set_scale(Vector3(sc,sc,sc))
#			i.get_node("body/Tank/Tank/MeshInstance").set_translation(Vector3(0,sc - 1,0))

		objects.append({'pos': pos, 'name': name, 'distance':distance, 'color':color});

	update();

func _draw():
	# if off:
	# 	return
	for i in objects:
		var n = 0.0
#		var k = Vector2
		var r = font.get_string_size( i.name)
		var col = i.color
		var a = min(175.0 / i.distance, 1.0)
		col.a = int(a * 10) / 10.0
#		g.report("label", [col.a], 0 , 1000, {"only":true})
		draw_string(font, Vector2(i.pos.x-r[0]/2.0, i.pos.y-r[1]), i.name, col);
#		for c in i.name:
#			n += draw_char(font, Vector2(i.pos.x+n, i.pos.y), c,'', text_color);
			#n += draw_char(font, Vector2(i.pos.x+n, i.pos.y), i.name, text_color);
#func add_object(cam, obj):
func add_object(obj):
	g.report("ui add obj", [obj, objects_visible], 0 , 0, {"only":false})
#	g.r([cam, obj])
	# objects_visible.append(obj)
	obj.add_to_group("objects_visible")

#func remove_object(cam, obj):
func remove_object(obj):
	if typeof(obj) == 2:
		obj = gsvar.player_by_id(obj)
	g.report("ui remove obj", [obj, objects_visible], 0 , 0, {"only":false})

	# objects_visible.erase(obj)
	obj.remove_from_group("objects_visible")