extends RigidBody

var owner;
var models;
var run_time;
var shotline;
var shotline2
var missile_id;
var last_collider;
var last_collision_time = 0;
var ray_res = {}
var ray_res_valid = false
var speed = 0
var last_lv = Vector3()
var shotline_mat
var colliding_tanks = []
var inside_shooter_hit_area = false
var cur_state
var cur_collider
var bullet_speed = 150
var initial_velocity
onready var gsvar = get_node("/root/gamestate")
onready var net = get_node("/root/net")
onready var me = gsvar.me
onready var pfb_rico = load("res://prefabs/ricochet.tscn");
onready var global = get_node("/root/global")
var g = Globals.g

signal missile_hit(owner, pos, mid)


func _init():
  owner = -1;
  missile_id = -1;
  run_time = 0.0;
  last_collider = null;


func _ready():
  net.path_ht[String(get_path()).hash()] = get_path()
  models = get_node("bullet");
  shotline = get_node("shotline3");
  shotline2 = get_node("shotline2");
  adjust_shotline(initial_velocity)
  g.sounds.play("gunshot3")
#  shotline2.set_hidden(false)
#  shotline2.call_deferred( "set_hidden", false)

#  shotline.set_material_override(shotline.get_material_override().duplicate())
#  shotline_mat = shotline.get_material_override()
  if me:
    me.connect("player_got_hit", self, "player_hit")
    set_process(true);
    set_fixed_process(true);


func player_hit(shooter):
  g.report("missile acks player hit:" + String(missile_id), [shooter], 0 , 1000, {"only":false})


func _process(delta):
  run_time += delta;
  if (run_time > 1.0):
#    emit_signal("exploded", owner, get_global_transform().origin, missile_id);
    queue_free();
    gsvar.missiles.erase(missile_id);
    return;


func _fixed_process(delta):
  predict_collision()


func predict_collision():
#  if ray_res.empty() and (not last_collider or (OS.get_ticks_msec() - last_collision_time) > 10):
#  if ray_res.empty():
  if not ray_res_valid and (not last_collider or (OS.get_ticks_msec() - last_collision_time) > 10):
    var bullet = self
    var pos = bullet.get("transform/translation")
    var target = pos + bullet.get_linear_velocity().normalized() * 500
    g.report("rayres not valid", [pos,target, bullet.get_linear_velocity().normalized()], 0 , -1, {"only":false})
    ray_res = get_world().get_direct_space_state().intersect_ray(pos, target, [], 2147483647, 1);
    if not ray_res.empty():
      ray_res_valid = true
      g.store_set("bul_ray", ray_res)
      g.report("rayres result", [ray_res], 1 , 1000, {"only":false})
      last_lv = get_linear_velocity()
  else:
    g.report("rayresnotempty", [ray_res], 0 , 300, {"only":false})


func _integrate_forces(state):
  if not me:
    return
  adjust_shotline(state.get_linear_velocity())
  shotline2.set_hidden(false)
  shotline.set_hidden(false)
  if not colliding_tanks.empty():
    for t in colliding_tanks:
      hit_tank(state, t)
  colliding_tanks = []
  var lv = state.get_linear_velocity();
  var missed_collision = lv.length() < 50
#  if (state.get_contact_count() > 0):
#    for i in range(state.get_contact_count()):
#      var collider = state.get_contact_collider_object(i);
#      if collider.get_type() == "StaticBody":
#        if handle_ricochet(state, collider, i):
#          return
#  if missed_collision and not ray_res.empty():
#    handle_ricochet(state,ray_res.collider )
  if not ray_res.empty():
    if (abs(get_translation().distance_to(ray_res.position)) < g.store_get('bullet_col_margin')):
      g.report("ricochet!", [ray_res, ray_res.collider.get_path()], 0 , -1, {"only":false})
      handle_ricochet(state,ray_res.collider )

func adjust_shotline(lv):
#  var lv = state.get_linear_velocity();
#  var transform = state.get_transform();
  var lvn = lv.normalized();
#  shotline.set_rotation(Vector3(0,  -Vector2(lvn.z,lvn.x).angle(),Vector2(lvn.y, PI/2.0).angle()));
#  g.report("shotline2", [shotline2], 0 , 1000, {"only":false})
  shotline2.set_rotation(Vector3(0,  -Vector2(lvn.z,lvn.x).angle(),Vector2(lvn.y, PI/2.0).angle()));
#  shotline.set_rotation(Vector3(0,  -Vector2(lvn.z,lvn.x).angle(),Vector2(lvn.y, PI/2.0).angle()));
  shotline.look_at_from_pos(get_translation(), get_translation() + lv, Vector3(0,1,0))
#  shotline.set_rotation(Vector3())
#  var colcomp = clamp(1 - abs(me.get_translation().y - get_translation().y) / 30.0, 0.5, 1)
#  shotline_mat.set_shader_param( "colcomp" , colcomp * 5 )
#  g.report('radar range', sqrt(me.current_zoom), 5 ,500 )
#  shotline_mat.set_shader_param( "scale" , pow(me.current_zoom, 0.8) * 10)


func handle_ricochet(state, collider, col_idx=null):
#  var lv = state.get_linear_velocity();
#  var transform = state.get_transform();
#  var lvn = lv.normalized();
#  var is_rb_collider = collider.get_type() == "RigidBody"
  #var is_char_collider = is_rb_collider and collider.get_mode() == MODE_CHARACTER
#  if is_char_collider:
  if collider.get_type() == "RigidBody":

#      g.report("missile hit character" + collider.get_name(), [collider], 0 , 1000, {"only":false})
    #var col_shape = state.get_contact_collider_shape(col_idx)
#      if col_shape != 0:
#        return false
    #var not_direct_self_hit = last_collider or (collider != gsvar.player_by_id(owner))
    #var self_is_hit = collider.is_node_master or collider.is_bot
#    if not_direct_self_hit and self_is_hit:
      #emit_signal("missile_hit", owner, get_global_transform().origin, missile_id);
      #collider.get_killed(owner, get_global_transform().origin, missile_id)
#      var impulse = lv;
      #collider.apply_impulse(state.get_contact_local_pos( col_idx ) , Vector3(lvn.x * 100, 5, lvn.z * 100));
#      collider.last_got_hit = OS.get_ticks_msec()
      return true
  else: # static body col
    var ln
    var lp
    if last_collider != collider and not ray_res.empty():
      if  (abs(get_translation().distance_to(ray_res.position)) < g.store_get("bullet_col_margin")):
        var hit_back_arch = collider.get_path() == "/root/world/env/Plane8/Arch2/StaticBody"
        hit_back_arch = hit_back_arch and (sign(ray_res.normal.z) == sign(ray_res.position.z) )
        if not hit_back_arch:

          ln = ray_res.normal
          lp = ray_res.position
      else:
        return false
        if col_idx:
          print("exception")
          ln = state.get_contact_local_normal(col_idx)
          lp = state.get_contact_local_pos(col_idx )
      last_collision_time = OS.get_ticks_msec()
      if typeof(ln) == TYPE_VECTOR3:
        state.set_linear_velocity(ln.reflect(last_lv).normalized() * speed);
        create_ricochect_effect(lp, ln)
        last_collider = collider;

#        ray_res = {}
        g.report("invalidate ray res", [], 0 , 1000, {"only":false})
        ray_res_valid = false
        predict_collision()
        # handle self propelling rico shot
        if inside_shooter_hit_area:
          hit_tank(state, me)
        return true


func add_tank_collider(collider):
  colliding_tanks.append(collider)


func hit_tank(state, collider):
#  gsvar.pause(true)
  g.report("hit tank!!", [], 0 , -1, {"only":false})
  cur_state = state
  cur_collider = collider
  var lv = state.get_linear_velocity();
  var transform = state.get_transform();
  var lvn = lv.normalized();
  #var col_shape = state.get_contact_collider_shape(col_idx)
#      if col_shape != 0:
#        return false
  var not_direct_self_hit = last_collider or (collider != gsvar.player_by_id(owner))
  var self_is_hit = collider.is_node_master or collider.is_bot
  if not_direct_self_hit and self_is_hit:
    var rot = Vector3(0, atan2(lv.x, lv.z) ,0)
    create_tank_ricochect_effect(get_translation(), rot)
    emit_signal("missile_hit", owner, get_global_transform().origin, missile_id,collider.pid);
    collider.get_killed(owner, get_global_transform().origin, missile_id)

    var impulse = lv;
#    collider.apply_impulse(state.get_contact_local_pos( col_idx ) , Vector3(lvn.x * 100, 5, lvn.z * 100));
    collider.apply_impulse(Vector3(0,0,0) , Vector3(lvn.x * 100, 5, lvn.z * 100));
    collider.last_got_hit = OS.get_ticks_msec()


func create_ricochect_effect(pos, norm,scale=1.0):
  g.report("rico", [], 0 , -1, {"only":false})
  var inst = pfb_rico.instance();
  inst.set_scale(Vector3(scale,scale,scale))
  inst.set_name("rico");
  inst.look_at_from_pos(pos, pos+norm, Vector3(0,1,0));
  gsvar.world.env.add_child(inst, true);

func create_tank_ricochect_effect(pos,rot):
  g.report("tank rico", [], 0 , -1, {"only":false})
  var inst = pfb_rico.instance();

  inst.set_name("rico");
  inst.look_at_from_pos(pos, Vector3(), Vector3(0,1,0));
  inst.set_scale(Vector3(10,10,10))
  inst.set_rotation(rot)
  gsvar.world.env.add_child(inst, true);
  return inst