extends Node

var gsvar
var own_id
var me
var net
var g
var timer
var pstor = []
var debug = false
var num_bots = 1
var event_times = {"last_spread":0}
var env
var gs
signal thread_finish(fname,thr_id, out)

func m1():
  return ball().leader_ball.motion_path

func _init():
  env=env()
  pass


func reset_vars():
  gsvar = get_node("/root/gamestate")
  me = gsvar.me
  net = get_node("/root/net")
  g = get_node("/root/global")
  gs = g._store


func _ready():
  runfp()
  # gs = g._store


func _fixed_process(delta):
  pass


func runfp(val=true):
  set_fixed_process(val)


func map(obj_ary, fn):
  var out = []
  for obj in obj_ary:
    out.append(obj.call(fn))
  return out


func mapfn(obj_ary, fn):
  var out = []
  for obj in obj_ary:
    out.append(self.callv(fn,[obj]))
  return out
func iter_info(ary, args=false):
  var out = ""
  for i in ary:
    out = out + i.name
    if args:
      out = out + "\t" + str(i.args)
    out = out + "\n"
  return out


func methods(obj, args=false):
  return iter_info(obj.get_method_list(), args)


func vars(obj):
  var out = ""
  for i in obj.get_property_list():
    out = out + i.name + "\t" + str(obj.get(i.name)) + "\n"
  return out


func get_conf(name=null):
  if name:
    return gsvar.config[name]
  else:
    return gsvar.config


func set_conf(name, value):
  gsvar.config[name] = value


func fstore_var(file,v):
  var f = File.new();
  var fn  = "user://vstor_" + file
  f.open(fn, f.WRITE);
  f.store_var(v)
  f.close()

func fget_var(file, default=null):
  var f = File.new();
  var fn  = "user://vstor_" + file
  if (!f.file_exists(fn)):
    fstore_var(file,default)
  f.open(fn, f.READ);
  var v = f.get_var()
  f.close()
  return v

func pstor_append(cat, line):
  var cur_lines = g.get_pstor_lines(cat)
  cur_lines.append(line)
  g.new_pstor(cat, cur_lines)

func remember_pos():
  var p = me.get_translation()
  g.store_set("quick_pos", {"pos":[p.x,p.y,p.z], "rot":me.body_rotation})

func restore_pos():
  var line = g.store_get("quick_pos")
  var p = line.pos
  me.new_spawn = {"pos":Vector3(float(p[0]),float(p[1]),float(p[2])), "rot":line.rot}

func save_pos(label=""):
  var cur_lines = g.get_pstor_lines("positions")
  var max_slot = 0
  for i in cur_lines:
    max_slot = max(i["slot"], max_slot)
  var p = me.get_translation()
  cur_lines.append({"pos":[p.x,p.y,p.z], "rot":me.body_rotation, "slot":max_slot+1, "label":label})
  g.new_pstor("positions", cur_lines)

func list_pos():
  return g.get_pstor_lines("positions")

func load_pos(slot):
  var cur_lines = g.get_pstor_lines("positions")
  var line
  for i in cur_lines:
    if i.slot == slot:
      line = i
      break
  if not g.is_null(line):
    me.get_node("col_capsule").set_rotation(Vector3(0, float(line.rot),0));
    var p = line.pos
    me.new_spawn = {"pos":Vector3(float(p[0]),float(p[1]),float(p[2])), "rot":line.rot}
  return line


func save_botcase(label="default"):
  var cur_lines = g.get_pstor_lines("botcases")
  var max_slot = 0
  for i in cur_lines:
    max_slot = max(i["slot"], max_slot)
  var line = {"slot":max_slot+1, "label":label}
  var idx = -1
  for b in bots():
    idx += 1
    var botkey = "bot#" + str(idx)
    line[botkey] = {}
    var p = b.get_translation()
    line[botkey]["pos"] = [p.x,p.y,p.z]
    line[botkey]["rot"] = b.body_rotation
  cur_lines.append(line)
  g.new_pstor("botcases", cur_lines)

func list_botcases():
  return g.get_pstor_lines("botcases")

func load_botcase(slot,is_idx=false):
  var cur_lines = g.get_pstor_lines("botcases")
  if is_idx:
    slot = cur_lines[slot].slot
  var line
  for i in cur_lines:
    if i.slot == slot:
      line = i
      break
  if not g.is_null(line):
    for idx in line:
      if idx.begins_with("bot#"): # int
        if not g.is_null(bot(int(idx))):
          positioner(bot(int(idx)), line[idx].pos, line[idx].rot)
  return line


func positioner(player, pos, rot):
  player.get_node("col_capsule").set_rotation(Vector3(0, float(rot),0));
  var p = pos
  player.new_spawn = {"pos":g.arytovec3(pos), "rot":rot}


func t1():
  load_botcase(-1,true)


func t2():
  load_botcase(-1, true)
  var instructions = [
    ["save"],
    ["wait", 100],
    ["shoot"],
    ["stick_y", 120],
    ["stick_x", -120],
    ["wait", 200],
    ["shoot"],
    ["wait", 200],
    ["shoot"],
    ["stop"],
    ["reset"]
    ]
  timer("send bot instructions", "bot_instructions", true, 0.1, [instructions])


func t3():
  clear_position_marks()
  load_botcase(-1, true)
  var numshots1 = 3
  var shootdelay1 = 500
  var turn0 = -1
  var turn1 = -1
  var speed0 = 1
  var speed1 = 0
  var visualize = true
  var fake = false
  var instructions0 = [
    ["save"],
    ["fn", "clear_recorded_positions", "bot0pos"],
    ["stick_y", g.f2stick(speed0)],
    ["stick_x", g.f2stick(turn0)],
    ["repeat", 1],
    ["wait", 1000],
    ["fn", "record_position", "bot0pos"],
    ["end"],
    ["wait", 1000],
    ["stop"],
    ["reset"]
    ]
  var instructions1 = [
    ["save"],
    ["fn", "clear_recorded_positions"],
    ["stick_x", g.f2stick(turn1)],
    ["repeat", numshots1],
    ["shoot"],
    ["wait", shootdelay1],
    ["end"],
    ["stop"],
    ["reset"]
    ]
  timer("send bot instructions0", "bot_instructions", true, 0.1, [0,instructions0, visualize, fake])
  timer("send bot instructions1", "bot_instructions", true, 0.1, [1,instructions1, visualize, fake])


func t4():
  clear_position_marks()
  load_botcase(22)
  var visualize = true
  var fake = false
  var r1 = randsign()
  var r2 = randsign()
  g.report("r1,r2", [r1,r2], 0 , 0, {"only":true})
  var instructions0 = [
    ["save"],
    ["stick_y", g.f2stick(-1)],
    ["stick_x", g.f2stick(-1)],
    ["wait", 1000],
    ["stick_y", g.f2stick(r1)],
    ["stick_x", g.f2stick(r2)],
    ["wait", 1000],
    ["stop"],

    ]
  var instructions1 = [
    ["save"],
    ["stick_x", g.f2stick(1)],
    ["shoot"],
    ["wait", 700],
    ["shoot"],
    ["stick_x", g.f2stick(1)],
    ["wait", 200],
    ["shoot"],
    ["stop"],
    ["reset"]
    ]
  timer("send bot instructions0", "bot_instructions", true, 0.1, [0,instructions0, visualize, fake])
  timer("send bot instructions1", "bot_instructions", true, 0.1, [1,instructions1, visualize, fake])


func t5():
  clear_position_marks()
  load_botcase(24)
  var visualize = true
  var fake = false
  var r1 = g.randsign(1)
  var r2 = g.randsign(1)
  g.report("r1,r2", [r1,r2], 0 , 0, {"only":true})
  var instructions0 = [
    ["save"],
    ["speed", -1],
    ["turn", -1],
    ["wait", 1000],
    ["speed", r1],
    ["turn", r2],
    ["wait", 1000],
    ["stop"],

    ]
  var instructions1 = [
    ["save"],
    ["turn", 1],
    ["shoot"],
    ["wait", 700],
    ["shoot"],
    ["turn", 1],
    ["wait", 200],
    ["shoot"],
    ["stop"],
    ["reset"]
    ]
  timer("send bot instructions0", "bot_instructions", true, 0.1, [0,instructions0, visualize, fake])
  timer("send bot instructions1", "bot_instructions", true, 0.1, [1,instructions1, visualize, fake])


func t6():
  clear_position_marks()
  load_botcase(24)
  var visualize = true
  var fake = false
  var r1 = g.randsign(1)
  var r2 = g.randsign(1)
  g.report("r1,r2", [r1,r2], 0 , 0, {"only":true})
  var instructions0 = [
    ["save"],
    ["speed", -1],
    ["turn", 0],
    ["wait", 1000],
    ["speed", r1],
    ["turn", r2],
    ["wait", 1000],
    ["stop"],

    ]
  var instructions1 = [
    ["save"],
    ["turn", 1],
    ["shoot"],
    ["wait", 700],
    ["shoot"],
    ["turn", 1],
    ["wait", 200],
    ["shoot"],
    ["stop"],
    ["reset"]
    ]
  timer("send bot instructions0", "bot_instructions", true, 0.1, [0,instructions0, visualize, fake])
  timer("send bot instructions1", "bot_instructions", true, 0.1, [1,instructions1, visualize, fake])


func t7():
  clear_position_marks()
  load_botcase(24)
  var visualize = true
  var fake = false
  var instructions0 = [
    ["save"],
    ["speed", 1],
    ["turn", 1],
    ["wait", 2000],
    ["stop"],

    ]
  timer("send bot instructions0", "bot_instructions", true, 0.1, [0,instructions0, visualize, fake])


func sitbuf():
  return bot().situation_buffer

func sb0():
  return sitbuf()[0]


func randsignf(x=1.0):
  return g.randsign(randf() * x)
func delayed_cb():
  timer("catch ball", "cb", true, 0.5, [])

func cb():
  ball().catch(net.uid, true)


func new_shot():
  var start_t = 0
  if g._store.has('last_goal_time'):
    var goal_t = g.store_get('last_goal_time')
    if not g._store.has('replays_times'):
      g.store_set('replays_times', [])
    if g._store.has('new_shot_time'):
      start_t = g.store_get('new_shot_time')
    if goal_t > start_t:
      g.store_get('replays_times').append([start_t, goal_t])
  g.store_set('new_shot_time', g.t())
  var d = 120 + randi() % 70
  var a = randsignf(PI/2.0)
  var pos = Vector3(d * sin(a), 0, 330 - d * cos(a))
  var trot = -a + randsignf(0.1)
  pos = Vector3(0, 2, 206)
  trot = 0
  gsvar.me.new_spawn = {'pos' : pos, 'rot' : trot}
  delayed_cb()


func netem():
  var latency = "200"
  var contents = "echo "  + str(OS.get_process_ID()) +  " > /sys/fs/cgroup/net_cls/foobar/tasks\n"
  contents += "tc qdisc change dev lo parent 1:2 handle 10:  netem delay " + latency + "ms 10ms\n"
  g.file_write("res://netemwatch/netem.sh", contents)

func st():
  return net.sync_table



func toggle_radar():
  var radar_node = get_node("/root/world/radar_bg3")
  var shown = radar_node.is_visible()
  radar_node.set_hidden(shown)

func fullscreen_toggle():
  OS.set_window_fullscreen(not OS.is_window_fullscreen())

func clipboard_console_exec():
  var txt = OS.get_clipboard()
  return g.console_exec("/" + txt.strip_edges())

func quit():
  OS.kill(OS.get_process_ID())

func remote_console_exec(m="/owntmp()"):
  net.rpc(g,"console_exec", [m])

func rce(m="/owntmp()"):
  remote_console_exec(m)

func owntmp(swap=false):
  self.callv("tmp" + str(net.uid), [swap])

func tmp1(swap=false):
  print("i'm number 1")

func tmp2(swap=false):
  return cb()
  if swap:
    tmp3(false)
    return
  positioner(gsvar.me, Vector3(-80,1,100), -PI/8)
  gsvar.me.stick_x = g.f2stick(-1.0)
  gsvar.me.stick_y = g.f2stick(1.0)

func tmp3(swap=false):
  return cb()
  if swap:
    tmp2(false)
    return
  gsvar.me.stick_x = g.f2stick(0)
  gsvar.me.stick_y = g.f2stick(0)
  positioner(gsvar.me, Vector3(-50,1,0), PI/8)

func replay_load(fn='test'):
  var datastr = g.file_read("../replays/" + fn + ".replay")
  if datastr.empty():
    return null
  return str2var(datastr)

func replay_save(fn='test', data=null):
  if data == null:
    data = net.data_log
  g.file_write("../replays/" + fn + ".replay", var2str(data))
  pass

func replay_save_multi(type="goals"):
  if type == "shots" and not g._store.has('replays_times'):
    return null
  if type == "goals" and g.store_get("goal_times", []).empty():
    return null
  var data = []
  var times
  if type == "shots":
    times = g._store['replays_times']
  elif type == "goals":
    var t0 = 0
    times = []
    for t in g.store_get("goal_times"):
      times.append([t0, t])
      t0 = t
  var ut = OS.get_unix_time()
  var idx = 0
  for l in net.data_log:
    if times[idx][0] - l[0] < 200:
      data.append(l)
    if times[idx][1] - l[0] < 200:
      replay_save(str(ut) + '_' + str(idx), data)
      data = []
      idx += 1
      if idx == times.size():
        return str(ut)

func replay_play_multi(startwith='1554592898', save=false, fromidx=null):
  var data = []
  var idx = 0
  if not g.is_null(fromidx):
    idx = fromidx
  var start_at = 0
  while(true):
    var single_data = replay_load(startwith + '_' + str(idx))
    if g.is_null(single_data):
      break
    var offset = start_at - single_data[0][0]
    g.report("offset", [offset], 0 , 0, {"only":false})
    single_data = shift_replay_data(single_data, offset)
    data += single_data
    start_at = single_data[-1][0] + 4000
    idx += 1
  if save:
    replay_save(startwith + '_combined', data)
  net.replay_init(data)


func shift_replay_data(data, offset):
  var rdata= []
  for d in data:
    g.report("d", d[0], 0 , 1000, {"only":false})
    d[0] += offset
    rdata.append(d)
  return rdata

func toggle_freecam():
  var yes = false
  if not get_node("/root/world/env").has_node("camera"):
    yes = true
  elif not get_node("/root/world/env/camera").is_processing_input():
    yes = true
  if yes and gsvar.active_focus == "GC":
    gsvar.change_secondary_focus("FC")
    fcam()
  elif gsvar.active_focus == "FC":
    gsvar.restore_focus(true)
    unfreecam()

func freecam():
  if not get_node("/root/world/env").has_node("camera"):
    gsvar.setup_freecam()
  get_node("/root/world/env/camera/cam").make_current()
  var camera = get_node("/root/world/env/camera")
  me.is_aiming = false
  me.get_node('body/Tank').set_hidden(false)
  me.set_process_input(false)
  me.ui_crosshair_tex.hide()
  me.get_node("/root/world/gui/crosshair").hide()
  camera.set_process_input(true);
  camera.set_fixed_process(true);

func unfreecam():
  me.camera_instance.make_current()
  me.is_aiming = true
  me.set_process_input(true)
  me.get_node("/root/world/gui/crosshair").show()
  var camera = get_node("/root/world/env/camera")
  camera.set_process_input(false);
  camera.set_fixed_process(false);
  Input.set_mouse_mode(Input.MOUSE_MODE_HIDDEN)

func fcam_adjust(spd, sns, lerpf):
  get_node("/root/world/env/camera/").set("speed", spd)
  get_node("/root/world/env/camera/").set("sensitivity", sns)
  get_node("/root/world/env/camera/").set("lerpf", lerpf)

func highlights(fcam=false, idx=null):
  var startwith
  if g._store.has('hlfn'):
    startwith = g.store_get("hlfn")
  else:
    startwith = replay_save_multi()
  if not g.is_null(startwith):
    g.store_set('hlfn', startwith)
    replay_play_multi(startwith, false, idx)


func fcam():
  freecam()
  fcam_adjust(50.0,0.1, 0.05)
  fcam_adjust(70.0,0.05, 0.05)
  fcam_adjust(150.0,0.1, 0.1)

func replay_from_file(fn='test'):
  net.replay_init(replay_load(fn))

func sync_tst():
  gsvar.timescale_adjusted_time = g.t() / 1000.0

func pause_():
  for n in [me, ball()]:
    n.pause()

func pause():
  get_tree().set_pause(!get_tree().is_paused())

func action_bind(action, combos):
  if not InputMap.has_action(action):
    InputMap.add_action(action)
  for old_event in InputMap.get_action_list(action):
    if old_event.type == InputEvent.KEY:
      InputMap.action_erase_event(action, old_event)
  var event
  for combo in combos:
    event = InputEvent()
    event.type = InputEvent.KEY
    event.scancode = combo[0]
    InputMap.action_add_event(action, event)

func action_bind_mouse(action, combos):
  if not InputMap.has_action(action):
    InputMap.add_action(action)
  for old_event in InputMap.get_action_list(action):
    if old_event.type == InputEvent.MOUSE_BUTTON:
      g.report("old mouse action", [action,old_event], 0 , -1, {"only":false})
      InputMap.action_erase_event(action, old_event)
  var event
  for combo in combos:
    event = InputEvent()
    event.type = InputEvent.MOUSE_BUTTON
    event.device = 0
    event.button_index = combo[0]
    InputMap.action_add_event(action, event)

func rebind():
  var bindmap = {
    "slowmo":[[KEY_Q ]],
    "slowmo2":[],

    "shoot":[[KEY_W], [KEY_X] ],
    "repeat_shoot":[[KEY_E]],
    "aim":[[KEY_SPACE]],
    "jump":[[KEY_TAB] ],
    "kb_step_motion": [[KEY_Z]],
    "throw": [[KEY_D], [KEY_L]],
    "pass_ball": [[KEY_S]],
  }

  var mouse_bindmap = {
    "jump":[],
  }

  var joy_bind_map = {
    "jump" : [[0]]
  }
  for a in bindmap:
    action_bind(a, bindmap[a])
  for a in mouse_bindmap:
    action_bind_mouse(a, mouse_bindmap[a])
  for a in joy_bind_map:
    g.action_bind_joy(a, mouse_bindmap[a])

func swap_tab_rmb():
  action_bind("aim", [[KEY_TAB]])
  action_bind_mouse("aim", [])
  action_bind("jump", [])
  action_bind_mouse("jump", [[BUTTON_RIGHT]])

func t22():
  var B2basket = (Vector3(0,0,330) - me.get_translation())
  var dist = B2basket.length()
  var me_rot = me.body_rotation
  var ret = g.uniform_angle(me_rot - g.vec3rot(B2basket))
  g.chreport("return", [ret], 0 , 0, {"only":false})



func color_obj(obj, color):
  var diffuse = obj.get("colors/diffuse")
  if not g.is_null(diffuse):
    obj.set("colors/diffuse", color)
    return true
  return false

func color_mat_override(obj, color):
  var mat
  if obj.has_method("get_material_override"):
    mat = obj.get_material_override()
    if not g.is_null(mat):
      g._store["ni"] = mat
      mat.set_parameter(0, color)
      return true
  return false

func color_mesh(obj, color):
  var mesh
  var mat
  if obj.has_method("get_mesh"):
    mesh = obj.get_mesh()
    if not g.is_null(mesh):
      var surfs = mesh.get_surface_count()
      if surfs > 0:
        mat = mesh.surface_get_material(0)
        mat.set_parameter(0, color)
        return true
  return false

func color_children(obj, color, all=true):
  for child in obj.get_children():
    if colorify_object(child, color):
      if !all:
        return true
  return false

func colorify_object(obj,color):
  var success = false
  if obj.is_type("Spatial"):
    success = (color_obj(obj, color) or
    color_mat_override(obj, color) or
    color_mesh(obj, color) or
    color_children(obj,color))
  return success

func reset_bot_ammo():
  bot().ammo = []

class BotActionManager:
  extends Node
  var g = Globals.g
  var bot
  var col_cache = {}
  var cache = {"col":{}, "bs":{}}
  var current = null # the current action
  var actions = {
    "A_default":null, "A_face":null ,"A_trap2":null,"A_trap":null, "A_trap_chase":null, "A_cut":null, "A_threat":null, "A_thwart":null, "A_catch":null, "A_surround":null,
    "D_default":null, "D_Elude":null, "D_Dodge":null
  }
  var ordered_actions = []
  func _init(b):
    bot = b
    b.event_times["last_fire"] = 0
    b.event_times["last_ammo"] = 0
    g.report("bot", [bot], 0 , 1000, {"only":false})
    var bot_action = load("res://scripts/bot_action.gd")
    for an in actions:
      add_action(an, bot_action.get(an).new())
    ordered_actions = actions.keys()
    ordered_actions.sort_custom(self, "action_order")

  func add_action(an, inst):
    actions[an] = inst
    actions[an].manager = self
    actions[an].set_name(an)
    self.add_child(actions[an])
    actions[an].bot = bot

  func action_order(a,b):
    g.report("a,b", [a,b], 0 , -1, {"only":false})
    return actions[a].order < actions[b].order

  func select_action(s=null,force=false):
    if force:
      g.report("blahblah", [bot.situation.P], 0 , -1, {"only":false})
    var action
    var ratings = {}
    var sel
    cache.col = {}
    for an in actions:
      action = actions[an]
      action.assess(s)
      ratings[an] = action.rating
    if g.is_null(sel):
      var idx = _max(ratings.values())
      sel = ratings.keys()[idx]
    current = sel
    action = actions[current]
    action.move(s)
    action.fire(s)
    return sel

  func force_action(action, hard=false):
    if hard or not current_action().dominant :
      current = action.get_name()

  func current_action():
    return actions[current]
  func _max(ary):
    if ary.size() == 0:
      return null
    var idx = 0
    for i in range(ary.size()):
      if ary[i] > ary[idx]:
        idx = i
    return idx

func bot_shoot3():
  bot().shoot_think()

func bs():
  return bot().situation

func pbs():
  print(g.pretty_str(bs()))

func setup_trap():
  gsvar.me.new_spawn = {'pos':Vector3(10,0,0), 'rot':0 }
  bot().new_spawn = {'pos':Vector3(-100,0,200), 'rot':PI*0.5 }
  if not g.is_null(bot(1)):
    bot(1).new_spawn = {'pos':Vector3(100,0,200), 'rot':PI*-0.5 }

func gts():
  return g.timers[bot().action_manager.current_action()].delayed_fire

func act(n=0):
  return bot(n).control.action_manager.current_action()

func acts(n=0):
  return bot(n).control.action_manager.actions


func man(n=0):
  return act(n).manager

func sit(n=0):
  return bot(n).control.situation

func rel(prop, prop2=null):
  return bot().rel_change(prop, prop2)

func tmp4():
  return bot().action_manager.bot_action_root

func rpc_server_bot():
  net.rpc_id(1, self, "server_bot", [])

func rpc_exec(cmd):
  net.rpc_sync(g, "console_exec", [cmd])

func server_bot():
  g.report("alosad", [], 0 , -1, {"only":false})
  var manager = BotActionManager.new(me)
  manager.set_name("ActionManager")
  get_node("/root/world").add_child(manager)
  var an = manager.select_action(me.build_situation())
  me.action_manager = manager
  var action = manager.actions[an]

func match():
  gsvar.match_start()

func rpc_match():
  rpc_exec("/match()")

func phys_conf1():
  for i in [1,2,3,4]:
    var p = gsvar.player_by_id(i)
    net.rset(p, "max_speed", 50.0 )
    net.rset(p, "world_gravity", 9.8 )
    net.rset(p, "jump_velocity", 12.5 )
    net.rset(p, "normal_jump", 12.5 )
    net.rset(p, "pad_jump", 18 * 1.1)


func phys_conf(n):
  print("ooya")
  print(n)
  var confs = {
    1:{"max_speed":50.0, "world_gravity":9.8, "jump_velocity": 12.5, "normal_jump": 12.5, "pad_jump": 18 },
    2:{"max_speed":50.0, "world_gravity":9.8 * 2, "jump_velocity": 12.5 * 1.2, "normal_jump": 12.5 * 1.2, "pad_jump": 18 * 1.1},
    3:{"max_speed":50.0, "world_gravity":9.8 * 2, "jump_velocity": 12.5 * 1.2, "normal_jump": 12.5 * 1.2, "pad_jump": 18 * 1.4},
    4:{"max_speed":70.0*1.32 * 1.2, "world_gravity":9.8 * 5 * 1.4, "jump_velocity": 12.5 * 2.2 * 1.1, "normal_jump": 12.5 * 2.2 * 1.1, "pad_jump": 17 * 2.8 * 1.05 * 1.15, "max_turning": 1.0, "base_turning_speed":1.05},
    5:{"max_speed":70.0*1.32 * 1.2*1.4*0.85 *0.7, "world_gravity":9.8 * 5 * 1.4, "jump_velocity": 12.5 * 2.2 * 1.1*0.9, "normal_jump": 12.5 * 2.2 * 1.1 * 1.29*0.89, "pad_jump": 12.5 * 2.2 * 1.1 * 1.29*0.93*1.1 , "max_turning": 1.0+0.15-0.03, "base_turning_speed":1.05+0.25},
    6:{"max_speed":70.0*1.32 * 1.2 * 1.5 *0.6 * 0.9,
    "world_gravity":9.8 * 5 * 1.4*1.5 * 0.5 * 1.2*1.0*0.7,
    "jump_velocity": 12.5 * 2.2 * 1.1,
    "normal_jump": 12.5 * 2.2 * 1.1 * 1.29*0.93 * 0.5 * 1.3 * 1.3*0.9*0.8,
    "pad_jump": 12.5 * 2.2 * 1.1 * 1.29*0.93 * 0.84, "max_turning": 1.0, "base_turning_speed":1.05},
    7:{"max_speed":124 + 20 - 10 , "world_gravity":9.8 * 5 * 1.4, "jump_velocity": 25, "normal_jump": 25, "pad_jump": 25 , "max_turning": 1.0+0.15-0.03, "base_turning_speed":1.05+0.125},
    8:{"max_speed":124 + 20 - 10 - 100 + 6 , "world_gravity":9.8 * 3, "jump_velocity": 40, "normal_jump": 50, "pad_jump": 50 , "max_turning": 1.0+0.15-0.03 - 0.1, "base_turning_speed":1.05+0.125},
    # 9:{"max_speed":70 , "world_gravity":9.8 * 3, "jump_velocity": 58, "normal_jump": 42, "pad_jump": 50 , "max_turning": 1.0+0.15-0.03 - 0.1, "base_turning_speed":0.8},
    9:{"max_speed":70+10 , "world_gravity":9.8 * 3.2, "jump_velocity": 61, "normal_jump": 42, "pad_jump": 50 , "max_turning": 1.0, "base_turning_speed":0.8+0.1},
  }
  confs[n]["normal_max_speed"] = confs[n].max_speed
  confs[6]["pad_jump"] = confs[6].normal_jump
  confs[6]["jump_velocity"] = confs[6].normal_jump
  for i in [1,2,3,4]:
    var p = gsvar.player_by_id(i)
    if not g.is_null(p):
      for v in confs[n]:
        print(v, ' ', confs[n][v])
        net.rset(p, v, confs[n][v])
        if v == "normal_max_speed":
          gsvar.normal_max_speed = confs[n][v]
          net.rset(gsvar, "normal_max_speed", confs[n][v])


func rec_throw(t=ball().prev_throw):
  g.store_set("rec_throw", t)

func save_throw():
  var t = g.store_get("rec_throw")
  var throws = fget_var("test", [])
  throws.append(t)
  fstore_var("test", throws)

func rand_throw(delayed=false):
  var cur = fget_var("test", [])
  var t =  cur[randi()%cur.size()]
  rec_throw(t)
  re_throw(delayed)

func pick_throw(idx=-1):
  var cur = fget_var("test", [])
  var t =  cur[idx]
  rec_throw(t)

func fix_saved_throws():
  var cur = fget_var("test", [])
  var fixed = []
  for t in cur:
    if t[1].z < 0:
      g.report("bad throw", [t], 0 , -1, {"only":false})
      t[1] = -1 * t[1]
      t[0] = -1 * t[0]
    if t[0].y < 0:
      t[0].y = -1 * t[0].y
      t[1].y = -1 * t[1].y
    fixed.append(t)
  fstore_var("test", fixed)

func re_throw(delayed=false, delay=1):
  var t = g.store_get("rec_throw")
  if g.is_null(t):
    pick_throw()
  if delayed:
    g.create_mark({"pos":t[0] , "arrow":false, "label":"re_throw"}, "re_throw", true)
    g.object_timer("re_throw", self, "re_throw", true, delay)
    return
  if g._store.has("rec_throw"):
    if gsvar.active_game_mode == "basketball":
      pass
    var t = g.store_get("rec_throw")
    ball().throw(t[0], t[1])

func rec_re_throw():
  rec_throw()
  re_throw()

func split_screen():
  if get_tree().get_root().has_node("split_screen"):
    return get_node("/root/split_screen")
  g.report("create split screen", [], 0 , 1000, {"only":false})
  var ss = load("res://scenes/split_screen.tscn").instance();
  var world = get_node("/root/world")
  ss.set_name("split_screen");
  ss.get_node("hbox/split1/vport1").set_world(world.get_node("env"))
  ss.get_node("hbox/split2/vport2").set_world(world.get_node("env"))
  get_tree().get_root().call_deferred("add_child", ss);
  ss = get_node("/root/split_screen")
  gsvar.me.camera_instance = ss.camera_instance
  gsvar.me.camera_instance = ss.camera_instance
  gsvar.me.active_camera_instance = ss.active_camera_instance
  gsvar.me.camera_instance.make_current()
  return ss

func split_screen2():
  if get_tree().get_root().has_node("split_screen"):
    return get_node("/root/split_screen")
  g.report("create split screen", [], 0 , 1000, {"only":false})
  var ss = load("res://scenes/split_screen2.tscn").instance();
  get_tree().get_root().call_deferred("add_child", ss);
  return ss

func create_local_player(nid=3001, bot=false):
  if (!net.is_primary):
    return;
  if not g.is_null(gsvar.player_by_id(nid)):
    g.report("existing player, not creating new one", [nid], 0 , -1, {"only":false})
    return gsvar.player_by_id(nid)
  var player = gsvar.add_local_player(nid)
  if not bot:
    player.is_node_master = true
  else:
    player.is_bot = true
    gsvar.bots.append(player)
    g.activate_bot(player)

  return gsvar.player_by_id(nid)

func pf(ye=true):
  gsvar.pause_freeze = ye

func create_players(n, bot=false):
  var positions = [Vector3(10,1,0),Vector3(0,1,10),Vector3(20,1,0),Vector3(0,1,20),Vector3(0,1,50),]
  if n > 5:
    return
  for i in range(n):
    var player = create_local_player(3001 + i, bot)
    player.new_spawn = {"pos":positions[i], "rot":0}
    if bot:
      g.report("append player to bots", [player], 0 , -1, {"only":false})


func remove_bots():
  for b in gsvar.bots:
    gsvar.remove_player(b.pid)
  gsvar.bots = []
  g.report("bots should be empty", [gsvar.bots], 0 , -1, {"only":false})

func setup():
  if net.is_primary:
    g.remove_bots()
  else:
    er("/g.remove_bots()")
  g.object_timer("setup2", self, "setup2", true, 0.5)


func setup2():
  if net.is_primary:
    g.create_players(1, true)
  else:
    er("/g.create_players(1, true)")
  return

func repeat_shot():
  var idx = g.store_get("repeat_shot_idx", 0)
  if idx == 2 and not g.time_since(self, "last_spread", 3000, true):
    return
  print(idx)
  g.store_set("repeat_shot_idx", (idx + 1) % 3)
  var shot = me.last_shot_params[idx]
  net.rpc_sync(me,"spawn_missile", [1, shot[1], randi(), shot[3], shot[4]], {'channel':4, 'reliable':true});

func shake_camera(cam=null):
  cam = me.get_node("camera/cam")
  var timer_name = "shake_camera_timer"
  if not g.object_timer_active(timer_name, self):
    g.store_set("shake_cam_count", randi()%2-1)
    g.object_timer( timer_name, self, "shake_camera", false, 0.04)
  g._store["shake_cam_count"] += 1
  var count = g._store["shake_cam_count"]
  var max_count = 14
  var shake_power = (2 + pow((max_count - count) / float(max_count), 0.3)) * 0.3
  g.report("shake power", [shake_power], 0 , -1, {"only":false})
  cam.set_h_offset((count%2 - 0.5)*randf()*shake_power*1.2)
  cam.set_v_offset((count%2 - 0.5)*randf()*shake_power)
  if count > max_count:
    g.report("done shaking", [], 0 , 1000, {"only":false})
    g.timers[self][timer_name].set_active(false)
    cam.set_h_offset(0)
    cam.set_v_offset(0)


func set_timescale(ts):
  OS.set_time_scale(ts)
  er("/OS.set_time_scale(" + str(ts) + ")")
  me.set('max_turning', 1.0)
  er("/me.set('max_turning', 1.0)")

func rest_ball():
  var b = ball()
  var t = b.get_transform()
  t.origin = Vector3(0,5,0)
  b.set_transform(t)
  b.velocity = Vector3()
  b.resting = true
  b.uncatch()

func shrk():
  return get_node("/root/world/env/shrknlw")

func cap(save=false):
  if save:
    var capture = get_viewport().get_screen_capture()
    capture.save_png("user://screenshot-"+ str(OS.get_unix_time()) +".png")
    return
  get_viewport().queue_screen_capture()
  g.object_timer("screen_capture", self, "cap", true, 1, [true])

func get_aim(p=gsvar.me):
  return Vector3(sin(p.body_rotation),0,cos(p.body_rotation))

func calc_deviation(duration):
  var d = sin((duration + randf()/3)/38.0)/25
  return d

func mod_pass(throw): # pass while jump is held
  var lv = me.get_linear_velocity()
  var p_rot = me.body_rotation
  var p_dir = Vector3(sin(p_rot),0,cos(p_rot))
  var p_pos = me.get_translation()
  var elev = p_pos.y
  throw = 10*p_dir + lv*Vector3(0.8, 1, 0.8) + Vector3(0,-2,0)
  throw = 25*p_dir + lv*Vector3(0.8, 0, 0.8) + Vector3(0,6- elev*0.2,0)
  throw = 25*p_dir + lv*Vector3(0.1, 0, 0.1) + Vector3(0,12- elev*0.92,0)
  throw = 5*p_dir  + Vector3(0,5+10,0)
  throw = (50-20) * throw.normalized()
  throw +=  5*lv*Vector3(0.1, 0.1, 0.1)
  return throw

func ball_follow(pid, max_power=-1):
  var b = ball()
  var p = gsvar.player_by_id(pid)
  var v3 = p.get_translation() - b.get_translation()
  var d = v3.length()
  if d > 0:
    if gsvar.active_game_mode == "basketball":
      ball_follow_basketball(pid, max_power)
    else:
      ball_follow_football(pid, max_power)
    return

  var bv = b.velocity
  var throw = ((v3).reflect(bv).normalized() * bv.length() * 0.3) + (p.get_linear_velocity() * 1.3)
  g.scrn_dbg("blep", [ "T",throw,"BV", bv,"V3", v3])
  var throw_pos = b.get_translation() + Vector3(0,1,0)
  ball().catch(pid,false,true)
  g.callv_later(ball(), "throw", [throw_pos, throw], 0.035 , false, "delayed_throw")
func ball_follow_pass(pid, max_power=-1):
  var b = ball()
  var p = gsvar.player_by_id(pid)
  var v3 = p.get_translation() - b.get_translation()
  var d = v3.length()
  var exppos = b.get_translation() + v3.normalized() * -0
  exppos += p.get_linear_velocity()/4
  g.create_effect(exppos,"balltouch")
  net.rpc(g, "create_effect", [exppos, "balltouch"]);
  var base_speed = 150 + 30 - 5 - 20 + 30 - 20 + 5 + 10 - 25 - 5  + 80 + 23 - 40 - 6 - 20#150

  var sp_s = sign(p.speed_percent)
  if sp_s < 0:
    sp_s = sign(p.get_linear_velocity().dot(get_aim(p)) )
  var sp = (g.xz(p.get_linear_velocity()).length() / p.normal_max_speed) * sp_s
  var speed_var = (0.8-0.2)*g.s_pow(sp+sp_s,(2 -0.45))/(4+0.5)+0.2-0.08+0.1
  g.scrn_dbg("sssp", sp)
  var target_pos = p.get_translation() + (get_aim(p) * (100 + randi() % 50)  )
  target_pos.y = 0
  var lv = (target_pos - b.get_translation()) * 0.5
  var pv = p.get_linear_velocity()
  var throw = lv + Vector3(0,30 + (target_pos - b.get_translation()).length() * 0.2,0)
  var throw_pos = b.get_translation() + Vector3(0,1-1.2,0)
  throw *= (0.88)
  if (max_power > -1) and (throw.length() > max_power):
    throw = throw.normalized() * min(throw.length(), max_power)
    throw_pos.y = 10
  var voice = ball().sounds.play("SFX_BasketBall_0009" )
  var scdb = (throw.length()/12 - 7)
  var pcdb = (throw.length()/120 )
  ball().sounds.voice_set_pitch_scale(voice, 0.5)
  ball().mute_next_catch = true
  ball().catch(pid,false,true)
  g.callv_later(ball(), "throw", [throw_pos, throw], 0.035 * 0.5 , false, "delayed_throw")


func ball_follow_football(pid, max_power=-1):
  var b = ball()
  var p = gsvar.player_by_id(pid)
  var v3 = p.get_translation() - b.get_translation()
  var d = v3.length()
  var exppos = b.get_translation() + v3.normalized() * -0
  exppos += p.get_linear_velocity()/4
  g.create_effect(exppos,"balltouch")
  net.rpc(g, "create_effect", [exppos, "balltouch"]);
  var bydist = pow(75 / (p.get_translation() - b.get_translation()).length(), 0.2) * 1.1 * 1.1 * 1.5  * 1.4#pow(60 / (gsvar.me.get_translation() -
  var base_speed = 150 + 30 - 5 - 20 + 30 - 20 + 5 + 10 - 25 - 5  + 80 + 23 - 40 - 6 - 20 - 10#150

  var sp_s = sign(p.speed_percent)
  if sp_s < 0:
    sp_s = sign(p.get_linear_velocity().dot(get_aim(p)) )
  var sp = (g.xz(p.get_linear_velocity()).length() / p.normal_max_speed) * sp_s
  var speed_var =  0.22 - 0.15 + g.s_pow(sp+sp_s,(1.55 + 0.2))/(4.5 / 0.6)
  g.scrn_dbg("sssp", sp)
  var target_pos = p.get_translation() + (get_aim(p) * base_speed * speed_var * 0.4 )
  target_pos.y = 0
  var lv = (target_pos - b.get_translation()) * bydist * 0.7
  var pv = p.get_linear_velocity()
  var throw = (pv*0.3) + lv + Vector3(0,-3*abs(sp) + (1.5+0.2+0.05+0.1+0.4 + 0.5 + 0.3)*(abs(pv.y * 0.6)) + 50-13-0-2+2+3,0)
  throw.y *= (sign(pv.y+0.01)*(1))
  var throw_pos = b.get_translation() + Vector3(0,1-1.2,0)
  throw *= (0.88)
  if (max_power > -1) and (throw.length() > max_power):
    throw = throw.normalized() * min(throw.length(), max_power)
    throw_pos.y = 10
  var voice = ball().sounds.play("SFX_BasketBall_0009" )
  var scdb = (throw.length()/12 - 7)
  var pcdb = (throw.length()/120 )
  ball().sounds.voice_set_pitch_scale(voice, 0.5)
  ball().mute_next_catch = true
  ball().catch(pid,false,true)
  if d < 20:
    if not p.phys.resting:
      p.pending_impulse.append( ((ball().velocity - pv)/10)-throw/(4*1.5))
    else:
      p.pending_impulse.append( -g.xnz(throw)/3)
  if p.phys.jump_count > 0:
    p.phys.jump_count -= 1
  g.callv_later(ball(), "throw", [throw_pos, throw], 0.035 * 0.5 , false, "delayed_throw")

func ball_follow_basketball(pid, max_power=-1):
  ball().mute_next_catch = true
  ball().catch(pid,false,true)
  var voice = ball().sounds.play("SFX_BasketBall_0009" )
  ball().sounds.voice_set_pitch_scale(voice, 0.15)
  ball().sounds.voice_set_volume_scale_db(voice, -30)
  g.callv_later(self, "ball_follow_basketball_real", [pid, max_power], 0.08 + 0.02 , false, "delayed_throw")

func ball_follow_basketball_real(pid, max_power=-1):
  var b = ball()
  var p = gsvar.player_by_id(pid)
  var bpos = b.get_translation()
  if (p.get_translation() - bpos).length() > 30:
    bpos = g.xnz(p.get_translation(),10)
  var v3 = p.get_translation() - bpos
  var d = v3.length()
  var exppos = bpos + v3.normalized() * -0
  exppos += p.get_linear_velocity()/4
  g.create_effect(exppos,"balltouch")
  net.rpc(g, "create_effect", [exppos, "balltouch"]);
  var bydist = pow(45 / (p.get_translation() - bpos).length(), 0.2) * 1.1 * 1.1 * 1.5 * 1.05#pow(60 / (gsvar.me.get_translation() -
  g.scrn_dbg("byydst", bydist)
  var base_speed = 150 + 30 - 5 - 20 + 30 - 20 + 5 + 10 - 25 - 5 - 10 -15-5-10+30#150
  var pv = p.get_linear_velocity()
  var sp_s = sign(p.speed_percent)
  if sp_s < 0:
    sp_s = sign(p.get_linear_velocity().dot(get_aim(p)) )
  var sp = (g.xz(p.get_linear_velocity()).length() / p.max_speed) * sp_s
  var speed_var = (0.8)*g.s_pow(sp+sp_s,(2-1 ))/(4+0.5)+0.2-0.08
  g.scrn_dbg("sssp", [sp,p.speed_percent])
  speed_var = sp*0.6
  speed_var = 1 + max(sp_s/(1.5), 0)
  if not p.phys.resting:
    speed_var *= 0.7 - 0.1
  base_speed = abs(pow(g.xnz(pv).length(), 0.68 - 0.1065 )) * sp_s * 3.2 * 1.2 * 1.15 * 1.05
  g.scrn_dbg("base_speeds", [base_speed,g.xnz(pv).length()])
  var target_pos = p.get_translation() + (get_aim(p) * base_speed * speed_var * 0.4 )
  target_pos.y = 0
  var lvh = g.xnz((target_pos - (p.get_translation()+(bpos*(4+1-4+0.65)))/(5+1-4+0.65)) * bydist)
  var lvv = ((target_pos - (p.get_translation()+(bpos*(1.5)))/2.5) * bydist).y
  var lv = g.xnz(lvh, lvv)
  g.scrn_dbg("prrlv", [lv])
  lv.y = lv.y / (5+8-2-1)
  lv.y *= 0.5
  # gsvar.announce("lvv " + str(lv.y), 1)
  var throw = lv + Vector3(0,-20+1+60-(6.2 *0.9)*abs(min(sp,0.9)*0.28) - (2.05 + 0.5 + 0.2 + 0.3 - 0.2 - 0.5)*((pv.y*(-0.2+0.1-0.1)) + 10 +0.7-1+1 - 0.5),0)
  var throw_pos = bpos + Vector3(0,1-2+1,0)
  throw *= (0.88 )
  throw.y *= -2.4 + 0.12 - 0.3 - 0.05
  g.scrn_dbg("prrthrow", [throw])
  if (max_power > -1) and (throw.length() > max_power):
    throw = throw.normalized() * min(throw.length(), max_power)
    throw.y *= 2.5
    throw_pos.y = 10
  ball().throw(throw_pos, throw)

func muted_throw(throw_pos, throw):
  ball().mute_next_catch = true
  ball().catch(ball().last_owner,false,true)
  ball().throw(throw_pos, throw)

func set_game_speed(gspd):
  OS.set_time_scale(gspd)

func refreshnode(n):
  var newn = n.duplicate()
  n.replace_by(newn)

func refn(name=null):
  var nodes
  if gsvar.active_game_mode == "basketball":
    nodes = {"mear":me.get_node("Area"), "hs":hs(), "hn":hn(), "jp1":get_node("/root/world/env/jumppad"),"jp2":get_node("/root/world/env/jumppad2"),} # "ba":get_node("/root/world/env/BoundsArea"),
  else:
    nodes = {"mear":me.get_node("Area")}

  if g.is_null(name):
    for n in nodes.values():
      refreshnode(n)
  else:
    refreshnode(nodes[name])

func toglb():
  pass
  var lb = ball().leader_ball
  lb.set_hidden(not lb.is_hidden())

func ann_bvy(should,when):
  if sign(should) != sign(ball().velocity.y):
    gsvar.announce(['arrrgh', g.sg("lastsimpt", [])], 5)

func ang_diff(a,b,target=0):
  var ad = fmod(a.angle_to(b), PI)
  var ret =  min(ad, PI-ad)
  # sd("adiff", ret*180/PI)
  return abs(ret - target)

func t80():
  ang_diff(Vector3(0,0,1), Vector3(0,1,1))

func update_camera(p, delta):
  var r = p.dist * 9.01;
  r = p.dist * 4.01;
  var tankeye = p.follow_player.get_node("body/shoot_pos3").get_global_transform().origin;
  if p.is_aiming:
    tankeye = p.follow_player.get_node("body/shoot_pos").get_global_transform().origin + Vector3(0,0,0)
  if not p.is_aiming and gsvar.active_game_mode == "hix":
    tankeye = p.follow_player.get_node("body/shoot_pos").get_global_transform().origin + Vector3(0,0,0)
  var switch_sp = 10 #10
  if (p.is_aiming):
    p.active_camera_instance.set_orthogonal(1000/4,0.1,4000)
    r = 3.2 + g.store_get("behind_cam_range", 60)
    switch_sp = 10 #25
  else:
    p.active_camera_instance.set_perspective ( 60, 0.1, 4000 )
    tankeye.y += g.sg("cam_eye_extra_y", 10)
  switch_sp = g.store_get("cam_switch_spd", 10)
  tankeye.y = tankeye.y
  var target_yaw = p.yaw
  p.camera_range = lerp(p.camera_range, r, switch_sp*delta);
  if gsvar.active_game_mode == "hix":
    p.camera_range = 30
    p.camera_range = 1
    # p.camera_range = 1000
    # p.camera_range = 90
  if p.is_aiming and abs(target_yaw - p.cam_yaw) > 300:
    p.cam_yaw = (abs(p.cam_yaw) - 360) * sign(p.cam_yaw)
  var look_from = tankeye;
  look_from.y = tankeye.y + 10
  var mul = 1.0
  if ball() and not p.is_aiming:
    var relvec = p.balls[0].get_translation() - p.get_translation()
    if p.balls[0].owner == p.pid:
      target_yaw = p.yaw
    elif relvec.length() < 50:
      target_yaw = p.yaw
    else:
      target_yaw = ((rad2deg(g.vec3rot(relvec)) ))
    p.cam_yaw = g.closest_angle_rep_deg(target_yaw,p.cam_yaw)
  if p.is_aiming:
    mul = 5
    if p.phys.on_floor:
      mul -= pow(abs(target_yaw-  p.cam_yaw), 0.35)
    if gsvar.active_game_mode == "hix":
      mul *= 10
  else:
    if gsvar.active_game_mode == "hix":
      mul = 40
      p.camera_range = 12.0
      tankeye = p.follow_player.get_node("body/shoot_pos").get_global_transform().origin + Vector3(0,0,0)
      look_from.y  = p.follow_player.get_node("body/shoot_pos").get_global_transform().origin.y
  if p.phys.on_floor:
    p.cam_yaw = lerp(p.cam_yaw, target_yaw, 1)
  else:
    p.cam_yaw = lerp(p.cam_yaw, target_yaw, 1)

  look_from.x -= p.camera_range*sin(deg2rad(p.cam_yaw));
  look_from.z -= p.camera_range*cos(deg2rad(p.cam_yaw));
  if p.is_aiming and gsvar.active_game_mode == "hix":
    look_from.y = tankeye.y + 100*4
  p.active_camera_instance.look_at_from_pos(look_from, tankeye, Vector3(0,1,0));
  arrow_follow_target()
  if p.force_pause:
    get_tree().set_pause(true)


func update_ball_camera():
  if not ball():
    return
  var p = gsvar.me
  var b = ball()
  var pos = p.get_translation()
  var ball_pos = b.get_translation()
  if b.owner != -1:
    ball_pos = gsvar.player_by_id(b.owner).get_translation()
  var dir = (ball_pos - pos).normalized()
  var d = g.xnz(ball_pos - pos).length()
  var from = pos  - g.xnz(dir)*300  + Vector3(0,100,0)

  from.y = clamp(from.y, 15, 200)
  var target =  pos + (ball_pos - pos) #/1.2 # (pos+ball_pos) / 2
  var xf = b.camera.get_global_transform()
  xf.origin += 0.02*(from - xf.origin)
  var xf2 = xf.looking_at(target , Vector3(0,1,0))
  var w = 1.3
  xf.basis = basis_interpolate(xf.basis, xf2.basis,w)
  b.camera.set_global_transform(xf)
func basis_interpolate(b1,b2, w=1.0,only_basis=true):
  b1.x += w*(b2.x-b1.x)
  b1.y += w*(b2.y-b1.y)
  b1.z += w*(b2.z-b1.z)
  return b1

func setcam(params={}):
  if params.has("d"):
    g.store_set('cam_dist', params.d) #20) #30)
  if params.has("dm"):
    g.store_set('cam_dist_mod', params.dm)
  if params.has("e"):
    g.store_set("cam_elevation", params.e) #20) #28)
  if params.has("em"):
    g.store_set("cam_elevation_mod", params.em)


func obj_set_mat_res(obj):
  var shaderres = load("shaders/Basketball Hoop shader.tres").duplicate()
  obj.get_material_override().set_shader(shaderres)

func set_cam():
  var cam = me.get_node("camera/cam")
  g.store_set("behind_cam_range", 50+0+0)
  cam.set_perspective ( 100-0, 0.01, 2500 )
  cam.set_keep_aspect_mode(0)

func set_bg_p(p,v):
  env().set_background_param( p, v )

func env():
  return get_node("/root/world/env").get_environment()

func save_t_set():
  g.store_get("temp_settings_inst").save_settings()

func setup3():

  setup3_common()
  if gsvar.active_game_mode == "football":
    setup3_football()
  elif gsvar.active_game_mode == "basketball":
    setup3_basketball()
  elif gsvar.active_game_mode == "hix":
    setup3_hix()

func pretty_str(v, line_max=70, indent=0):
  var ind = ""
  for i in range(indent):
    ind += ""
  var out = str(v)
  if out.length() < line_max and indent > 0:
    return ind + out + "\n"
  else:
    out = ""
    if typeof(v) == TYPE_DICTIONARY:
      for i in v:
        out += ind + str(i)
        out += " -> " + pretty_str(v[i], line_max, indent+1) #+ "\n"
    elif typeof(v) == TYPE_ARRAY:
      out += "<<<"
      var n = 0
      for i in v:
        out += "\n----------- " + "item" + str(n) + " -----------\n"
        # out += ind  +  pretty_str(i, line_max, indent) #+ "\n"
        out += ind  +  pretty_str(i, line_max, indent+1) #+ "\n"

        n += 1
      out += ">>>"
    else:
      out += ind + str(v)
  return out

func pp(v, line_max=70, indent=0):
  get_node("/root/world/console").write(pretty_str(v, line_max, indent))

func pr(v, line_max=70, indent=0):
  g.report("pr", pretty_str(v, line_max, indent), -1,-1)

func prch(v, line_max=70, indent=0):
  g.report("prch", pretty_str(v, line_max, indent), -1,-1,{"changed":true})

func t62():
  pp(g.t())
  for i in range(10):
    me.col_groups[1]["StaticBody"].hash()
  pp(g.t())

func _f2(_arg):
  return {"relpos":xz(_arg.relpos)}

func _f1(_arg):
  return {"relpos":collect(_arg, "_f2")}

func collect(ary, fn, sortem=false):
  var out = []
  for i in ary:
    out.append(self.callv(fn, [i]))
  if sortem:
    out.sort_custom(self,"_sort_first_elem")
  return out

func __abs(val):
  return abs(val)

func __mul(val1,val2):
  return val1 * val2

func __fetch(d,k):
  return d[k]
func chain_call(fns, inp):
  for ary in fns:
    var args = ary
    var fn = ary[0]
    args.pop_front()
    args.push_front(inp)
    g.report("rest", [fn,args], -1,-1)
    inp = callv(fn, args)
  g.report("resto", [inp], -1,-1)
  return inp

func t63():
  var out = []
  for collider in me.col_groups[0]["StaticBody"]:
    var k = collider.get_path()
    out.append({k:[]})
    for col in me.col_groups[0]["StaticBody"][collider]:
      out[-1][k].append([xz(col.pos + me.get_translation()),
        col.relpos,
         col.norm,
         xz(col.relpos.abs() - me.tank_size).length()
         ])
    out[-1][k].sort_custom(self,"_sort_num_arrays")
  pp(out)

func t64():
  me.get_node("col_capsule").set_trigger(true)
  return me.get_node("col_capsule").is_trigger()

func t69():
  var a = [1,2,3]

func t67(state):
  pass

func gg(v):
  return g.sg(v)

func t71():
  var re = []
  for i in gg("last_cols").collide:
    re.append((i - me.get_translation()).rotated(Vector3(0,1,0), me.body_rotation))
  return re

func t72():
  var x = me.get_transform()
  x.origin.y += 100
  var xx = me.get_transform()
  g.chreport([x.origin.y, xx.origin.y])
# func binarySearch(array, x, low, high):
#     # Repeat until the pointers low and high meet each other
#   while low <= high:
#     mid = low + (high - low)//2
#     if array[mid] == x:
#       return mid
#     elif array[mid] < x:
#       low = mid + 1
#     else:
#       high = mid - 1
#   return -1


# func binarySearch(array, x, low, high):
#   if high >= low:
#     mid = low + (high - low)//2
#     # If found at mid, then return it
#     if array[mid] == x:
#       return mid
#     # Search the left half
#     elif array[mid] > x:
#       return binarySearch(array, x, low, mid-1)
#     # Search the right half
#     else:
#       return binarySearch(array, x, mid + 1, high)
#   else:
#     return -1

func search_time_to_collide_any(state,pos, rot,t_vel, t_avel,tmin,tmax,hard_excl=[],splits=-1):
  return search_time_to_collide_any_p({"state":state, "pos":pos, "rot":rot, "t_vel":t_vel, "t_avel":t_avel, "tmin":tmin, "tmax":tmax, "hard_excl":hard_excl, "splits":splits})

func me_dir():
  var a = me.body_rotation
  pp(Vector3(sin(a),0,cos(a)))

func search_time_to_collide_any_p(p={}):
  # {"state":state, "pos":pos, "rot":rot, "t_vel":t_vel, "t_avel":t_avel, "tmin":tmin, "tmax":tmax, "hard_excl":hard_excl, "splits":splits}
  var defaults = {"state":null, "splits":-1, "hard_excl":[], "coltypes":["any"]}
  p = g.mergedicts(defaults, p)
  var cols
  if p.splits == -1:
    var pos_max = p.pos + p.t_vel * p.tmax
    var rot_max = p.rot + p.t_avel * p.tmax
    cols = check_collisions(p.state, pos_max, rot_max,p.hard_excl)
    # g.ss("last_cols", cols)
    # if not (cols.is_colliding.side or cols.is_colliding.incline):
    if not (cols.is_colliding.any):
      g.ss("last_cols", cols)
      # g.scrn_dbg("tmax")
      return p.tmax
    # else:
    #   return 0.0
  cols = check_collisions(p.state, p.pos , p.rot ,p.hard_excl)
  # if cols.is_colliding.side or cols.is_colliding.incline:
  if cols.is_colliding.any:
    g.ss("last_cols", cols)
    # qann("omg")
    # g.scrn_dbg("final cols", [cols.collide.size(),tmin,g.t()])
    return p.tmin
  p.splits += 1

  var max_split = 5
  var min_d = 0.01
  # if gg("last_cols").is_colliding.incline and not gg("last_cols").is_colliding.bottom:
  #   max_split = 3
  # if p.splits > max_split:
  #   # g.ss("last_cols", cols)
  #   # var pos_f = tank.get_translation() + t_vel * tmin
  #   # var rot_f = tank.body_rotation + t_avel * tmin
  #   # # test before returning
  #   # var fcols = check_collisions(state, pos_f, rot_f)
  #   # g.scrn_dbg("final cols", [fcols.collide.size(),tmin,g.t()])
  #   # if tmax - tmin > 0.000001:
  #   sd("biggish tmin", p.tmax - p.tmin)
  #   return p.tmin

    # return -0.01

  var tmid =  (p.tmax + p.tmin)/2
  var pos_mid = p.pos + p.t_vel * tmid
  var rot_mid = p.rot + p.t_avel * tmid
  # g.scrn_dbg("triez##", [splits, tmin,tmax,pos_mid])
  var cols = check_collisions(p.state, pos_mid, rot_mid,p.hard_excl)


  # If found at mid, then return it
  # if array[mid] == x:
    # return mid
  # Search the left half
  # elif array[mid] > x:
  # if array[mid] > x:
  # if cols.is_colliding.side or cols.is_colliding.incline:
  var found = false
  for ct in p.coltypes:
    if cols.is_colliding[ct]:
      found = true
      g.ss("last_cols", cols)
      break
  sd("hard", p.hard_excl)
  if found and p.hard_excl.has(cols.colinfo[0].rid):
    var sidecol = cols.colinfo[0]
    # var norm = (sidecol.normal).snapped(0.001)
    var norm = (sidecol.normal)
    var pt2d = me.active_camera_instance.unproject_position(sidecol.point)
    # g.create_mark({ "timeout":0.2,"update":true,"pos":sidecol.point + Vector3(0,0.01,0),"arrow":true,"arrow_rot":atan2(norm.x, norm.z), "label":str([atan2(norm.x, norm.z), norm]), "label_pos":pt2d}, "vpoint" + str([sidecol.rid.get_id()]), true,false)
    sd("ploooo", [p])
    return -1
  # var cur_d = (pos_mid - p.pos).length()
  # sd("curd", [p.splits,tmid - p.tmin])
  # if p.splits > max_split or (tmid > 0 and tmid - p.tmin < 0.001):
  if p.splits > max_split:
    # g.ss("last_cols", cols)
    # var pos_f = tank.get_translation() + t_vel * tmin
    # var rot_f = tank.body_rotation + t_avel * tmin
    # # test before returning
    # var fcols = check_collisions(state, pos_f, rot_f)
    # g.scrn_dbg("final cols", [fcols.collide.size(),tmin,g.t()])
    # if tmax - tmin > 0.000001:
    sd("biggish tmin", p.tmax - p.tmin)
    return p.tmin

  if found:

    p.tmax = tmid
    return search_time_to_collide_any_p(p)
  # Search the right half
  else:
    # g.scrn_dbg("hope", g.t(),false)

    p.tmin = tmid
    return search_time_to_collide_any_p(p)
# ________________________________
# func search_time_to_collide_side(array, x, low, high):
# func search_time_to_collide_bottom(state,tank,t_vel, t_avel,tmin,tmax,splits=-1):
# func search_time_to_collide_side(state,tank,t_vel, t_avel,tmin,tmax,splits=-1):
#   if splits == -1:
#     var pos_max = tank.get_translation() + t_vel * tmax
#     var rot_max = tank.body_rotation + t_avel * tmax
#     var cols = check_collisions(state, pos_max, rot_max)
#     # g.ss("last_cols", cols)
#     if not (cols.is_colliding.side or cols.is_colliding.incline):
#       g.ss("last_cols", cols)
#       return tmax
#     # else:
#     #   return 0.0
#     cols = check_collisions(state, tank.get_translation() , tank.body_rotation )
#     if cols.is_colliding.side or cols.is_colliding.incline:
#       g.ss("last_cols", cols)
#       # g.scrn_dbg("final cols", [cols.collide.size(),tmin,g.t()])
#       return tmin
#   splits += 1



#   if splits > 6:
#     # g.ss("last_cols", cols)
#     # var pos_f = tank.get_translation() + t_vel * tmin
#     # var rot_f = tank.body_rotation + t_avel * tmin
#     # # test before returning
#     # var fcols = check_collisions(state, pos_f, rot_f)
#     # g.scrn_dbg("final cols", [fcols.collide.size(),tmin,g.t()])
#     return tmin
#     # return -0.01

#   var tmid = tmin + (tmax - tmin)/2
#   var pos_mid = tank.get_translation() + t_vel * tmid
#   var rot_mid = tank.body_rotation + t_avel * tmid
#   # g.scrn_dbg("triez##", [splits, tmin,tmax,pos_mid])
#   var cols = check_collisions(state, pos_mid, rot_mid)


#   # If found at mid, then return it
#   # if array[mid] == x:
#     # return mid
#   # Search the left half
#   # elif array[mid] > x:
#   # if array[mid] > x:
#   if cols.is_colliding.side or cols.is_colliding.incline:
#     g.ss("last_cols", cols)
#     return search_time_to_collide_side(state,tank,t_vel, t_avel, tmin, tmid,splits)
#   # Search the right half
#   else:
#     g.scrn_dbg("hope", g.t())
#     return search_time_to_collide_side(state,tank,t_vel, t_avel, tmid, tmax,splits)


# func search_time_to_collide_side(state,tank,t):
#   var pos_t
#   var rot_t
#   check_collisions(state, pos_t, rot_t)
#   if colliding:
#     var new_t = t/2
#     find_max_time_to_collide(state,tank,t)
#   else:
#     var new_t = t/2

#   return t

func lcs():
  return gg("last_cols")

func check_collisions(state, pos, rot, hard_excl=[]):
  return check_collisions_p({"state":state, "pos":pos, "rot":rot, "hard_excl":hard_excl})

func check_collisions_p(params={}):
  # var state
  # {"state":state, "pos":pos, "rot":rot, "hard_excl":hard_excl}
  var defaults = {"state":null, "exts":me.tank_size, "hard_excl":[]}
  params = g.mergedicts(defaults, params)
  var state = params.state
  var pos = params.pos
  var rot = params.rot
  var exts = params.exts
  # var hard_excl = params.hard_excl
  var hard_excl = []
  # if not hard_excl.empty():
  # if not hard_excl.empty():
  # if not hard_excl.empty():
  #   prch(hard_excl)
  # pp(ceil(1 / state.get_step()) )
  g.si("checkcolcount")
  if get_tree().is_paused():
    # gr("okkkkk")
    return {}
  # var ret = {}
  # var
  var t0 = g.t()
  var spsq = g.sg("spsq", PhysicsShapeQueryParameters.new())
  var tank_box_shape = g.sg("tank_box_shape", BoxShape.new())
  tank_box_shape.set_extents(me.tank_size)
  spsq.set_shape(tank_box_shape)
  spsq.set_object_type_mask( 1 )
  spsq.set_exclude([])
  var prev_t = spsq.get_transform()
  # var t = spsq.get_transform()
  var t = Transform(Vector3(1,0,0),Vector3(0,1,0),Vector3(0,0,1), Vector3())
  # t = t.rotated(Vector3(0,1,0), -me.body_rotation)
  t = t.rotated(Vector3(0,1,0), -rot)
  # t.origin = me.get_transform().origin
  t.origin = pos
  # t.origin.y  += 2.913867
  # t.origin.y  += me.tank_size.y
  spsq.set_transform(t)

  # var spsq = setup_tank_col_psq(pos, rot)
  if not g._store.has("world"):
    g.store_set("world", me.get_world())
  var ri2 = me.get_world().get_direct_space_state().intersect_shape(spsq) # get all points of inntersection
  var ri = me.get_world().get_direct_space_state().collide_shape(spsq) # get a list of colliding shapes
  var last_colliders = {}
  for ri_coll in ri2:
    # last_colliders.append(ri_coll)
    last_colliders[ ri_coll.collider_id] = ri_coll.collider
    g.ss("ri_rids", last_colliders)
  var excl = []
  for i in hard_excl:
    excl.append(i)
  spsq.set_exclude(excl)
  var ri3 = me.get_world().get_direct_space_state().get_rest_info(spsq)

  # var excl = hard_excl
  # var col_info = {}
  var col_info = []
  # while not ri3.empty() and ri3.normal.snapped(0.0001) == Vector3(0,1,0):
  # var side_colliding = false
  # var bottom_colliding = false
  # var top_colliding = false
  var is_colliding = {"top":false, "bottom":false,"side":false,"any":false,"incline":false, "inside":false}
  while not ri3.empty():
    # if ri3.noraml.y < 1:
      # g.chreport("heheh")
    # if not ri3.has('normal'):
    #   g.scrn_dbg("ri3", ri3)
    # if ri3.normal.y < 1:
    #   g.chreport("heheh")
    # if ri3.normal.y < 0.1:
    # if abs(ri3.normal.y) > 0:
    ri3["collider"] = last_colliders[ri3.collider_id]
    if ri3.collider.is_in_group("bzw_teleporter_col"):
      is_colliding.inside = true
    else:
      is_colliding.any = true
      if  ri3.normal.y > 0.999:
        # bottom_colliding = true
        is_colliding.bottom = true
      elif  ri3.normal.y > 0.001:
        is_colliding.incline = true
      # elif ri3.normal.y < -0.999:
      elif ri3.normal.y < -0.001:
        is_colliding.top = true

      if abs(ri3.normal.y) < 0.999:
        # side_colliding = true
        is_colliding.side = true
        # sd("cur collider", ri3.collider)
        # g.ss("catchcol", ri3.collider)

    # elif  ri3.normal.y > 0:
    #   bottom_colliding = true
    # else:
    #   top_colliding = true
    # how do u know if something is passsing through penetrable object
    # is colliding, and collisionpoint is inside tank? it's always inside!
    # is colliding and penetrated object is penetrable such as tele
    # how do u label an object penetrable? have an array of penetrable types

    # col_info[ri3.collider_id] = ri3
    if not ri3.collider.is_in_group("bzw_teleporter_col"):
      col_info.append(ri3)
    excl.append(ri3.rid)
    spsq.set_exclude(excl)
    ri3 = me.get_world().get_direct_space_state().get_rest_info(spsq)
    # if not ri3.empty():
    #   sd()
    if not ri3.empty() and excl.has(ri3.rid):
      sd("daaaaaang")
    # pp("onga")
  # dbg_excl_rids(excl, col_info)
  # if col_info.keys().size() > 1:
  # if col_info.size() > 1:
  #   sd("big info", col_info.keys())
    # sd("hard_excl", [hard_excl,mapfn(hard_excl, "get_rid_id")])
  spsq.set_exclude([])
  # spsq.set_exclude(hard_excl)
  # var ri4 = []
  # for i in range(10):

  #   # var rin = me.get_world().get_direct_space_state().cast_motion(spsq, Vector3(-0,-10.0/(i+1),-0))
  #   var rin = me.get_world().get_direct_space_state().cast_motion(spsq, Vector3(-0,-10.0/(i+1),-0))
  #   if not rin == [1.0,1.0] and not rin.empty():
  #     ri4.append(rin[0])
  # if not ri4.empty():
  #   g.ss("ri_cast", [ri4,g.t()-t0])

  # if not ri.empty():
  #   # setup_tank_col_psq(me.get_translation(), rot)
  #   # spsq.set_transform(g.sg("ri").t[0])
  #   # var rin = me.get_world().get_direct_space_state().cast_motion(spsq, pos - me.get_translation() )
  #   g.ss("ri", {"collide":ri, "intersect":ri2,"restinfo":ri3, "colinfo":col_info,"time_taken":g.t()-t0, "t":[t,prev_t]})
  # g.ss("ri", {"collide":ri, "intersect":ri2,"restinfo":ri3, "colinfo":col_info,"time_taken":g.t()-t0, "t":[t,prev_t], "side_colliding":side_colliding})
  # return {"collide":ri, "intersect":ri2,"restinfo":ri3, "colinfo":col_info,"time_taken":g.t()-t0, "t":[t,prev_t], "is_colliding":is_colliding}
  col_info.sort_custom(self,"_sort_bottom_up")
  var re = []
  for i in ri:
    re.append((i - pos).rotated(Vector3(0,1,0), rot))
  return {"collide":re, "colinfo":col_info,"time_taken":g.t()-t0, "is_colliding":is_colliding}

  # g.sg("ri", {"collide":[], "intersect":[],"restinfo":{}, "colinfo":[],"time_taken":0})
func gr(id,extra=[]):
  g.report(id, extra, -1, 0)

func _sort_bottom_up(a0, a1):
  sd("compare normals", [a0.normal.snapped(0.001),a1.normal.snapped(0.001)])
  return a0.normal.y > a1.normal.y
  # qann([a0.normal.y , a1.normal.y])
func setup_tank_col_psq(pos, rot):
  var spsq = g.sg("spsq", PhysicsShapeQueryParameters.new())
  var tank_box_shape = g.sg("tank_box_shape", BoxShape.new())
  tank_box_shape.set_extents(me.tank_size*1)
  spsq.set_shape(tank_box_shape)
  spsq.set_object_type_mask( 1 )
  spsq.set_exclude([])
  var t = spsq.get_transform()
  # t = t.rotated(Vector3(0,1,0), -me.body_rotation)
  t = t.rotated(Vector3(0,1,0), -rot)
  # t.origin = me.get_transform().origin
  t.origin = pos
  spsq.set_transform(t)
  return spsq

func t68():
  qff([self,"t67",[]])


func t70():
  qff([self,"t70_",[]])

func t70_(state):
  pp(ceil(1 / state.get_step()) )

func qff(args):
  queue_fixed_func(args)

func queue_fixed_func(args):
  g.sg("fixed_func_queue").append(args)

func set_ips(ips):
  OS.set_iterations_per_second(ips)
func get_grouped_collisions(state, tank):
  var groups = {0:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}, 1:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}}
  for i in range(state.get_contact_count()-1,-1,-1):
    var shape=state.get_contact_local_shape(i)
    if not groups.has(shape):
      groups[shape] = {"StaticBody":{}, "RigidBody":{}}
    var collider = state.get_contact_collider_object(i)
    if not collider:
      continue
    var relcolpos = state.get_contact_local_pos( i ).rotated(Vector3(0,1,0), tank.body_rotation)
    var colpos = state.get_contact_local_pos( i )
    var collider_colpos = state.get_contact_collider_pos( i )
    var col_diff = state.get_contact_collider_pos( i ) - state.get_contact_local_pos( i )
    var local_collider = state.get_contact_local_shape(i)
    var type
    for t in ["StaticBody", "RigidBody", "KinematicBody"]:
      if collider.is_type(t):
        type = t
        break
    if not groups[shape][type].has(collider):
      groups[shape][type][collider] = []
    groups[shape][type][collider].append({"relpos":relcolpos,"pos":colpos, "norm":state.get_contact_local_normal( i ), "collider_pos":collider_colpos, "col_diff" :col_diff } )
  return groups

func moveme(s=Vector3(0,10.1,0)):
  me.new_spawn = {'pos':s + me.get_translation(), 'rot':me.body_rotation }

# func spme(s=Vector3(0,30.1,10)):
func spme(s=0):
  var stored = [
    [Vector3(0,30,00), 0],
    [Vector3(0,10,800), 0],
    [Vector3(800,10,0), PI/2],
    [Vector3(0,10,-800), PI],
    [Vector3(-800,10,0), -PI/2],

  ]
  var inf = stored[s % stored.size()]
  # me.new_spawn = {'pos':s , 'rot':me.body_rotation }
  me.new_spawn = {'pos':inf[0] , 'rot':inf[1]}

func col00():
  pass
  return g.deep(me.col_groups[0]["StaticBody"].values(), [0,0])

func _sort_first_elem(a0, a1):
  return a0[0] < a1[0]

func _sort_0_then_1_elem(a0, a1):
  if abs(a0[0] - a1[0]) < 0.0001:
    return a0[1] < a1[1]
  return a0[0] < a1[0]

func _sort_num_arrays(a0, a1):
  var idx = 0
  for i in range(a0.length()):
    if abs(a0[i] - a1[i]) > 0.0001:
      idx = i
      break
  return a0[idx] < a1[idx]

func t66():
  for i in range(10):
    g.chreport(i)

func _f0(arg_):
  return [arg_, arg_.get_name()]

func check_floor_collisions(tank):
  pass



func real_movement(state, tank):

  # real_movement2(state, tank)
  real_movement_clean(state, tank)
  return
  if gsvar.cl_name == "server":
    g.report("moving", [tank.stick_x, tank.stick_y], 1 , 1000, {"only":false})
  var s = tank._phys # empty state
  var phys = tank.phys # empty state
  var pending_impulse = tank.pending_impulse
  var body = tank.body
  s.jumping = phys.jumping # init some state vars
  s.falling = phys.falling
  s.abilities = g.sg("abilities", [])
  s.jump_count = phys.jump_count
  if not pending_impulse.empty() and OS.get_ticks_msec() - tank.last_impulse_t > 50:
    g.report("impulse", pending_impulse,0,0)
    tank.last_impulse_t = OS.get_ticks_msec()
    state.apply_impulse(Vector3(),pending_impulse.pop_front())
  var angle_diff =  tank.turning_percent * tank.base_turning_speed * (state.get_step() * 60)
  g.scrn_dbg("angdiff", [angle_diff, state.get_step()])
  g.scrn_dbg("step", state.get_step() )
  g.scrn_dbg("pos", [tank.get_translation(), tank.body_rotation] )
  var t_yaw = fmod(tank.yaw+(angle_diff), 360.0);
  var t_halfyaw = fmod(tank.yaw+(angle_diff/2), 360.0);
  var t_body_rotation = deg2rad(t_yaw);
  var t_half_body_rotation = deg2rad(t_halfyaw);
  var dir = Vector3();
  var aim = Vector3(sin(t_half_body_rotation),0,cos(t_half_body_rotation))
  dir += aim * tank.speed_percent;
  dir.y = 0;
  dir = dir.normalized();
  var lv = phys.lv
  var grav = Vector3(0,-tank.world_gravity,0);
  var delta = state.get_step();
  var up = -grav.normalized() # (up is against gravity)
  var vv = up.dot(lv)
  var hv = g.xnz(lv) # Horizontal velocity
  var hdir = hv.normalized() # Horizontal direction
  var hspeed = hv.length() # Horizontal speed
  var just_jumped = phys.just_jumped
  phys.just_jumped = false
  g.report('hspeed', hspeed, 5 , 1000)
  s.above_pyra = tank.check_above_pyra()
  var tspeed = tank.max_speed * abs(tank.speed_percent);
  var old_col_groups = tank.col_groups
  tank.col_groups = get_grouped_collisions(state, tank)
  var col_groups0 = tank.col_groups[0]
  var col_groups0sb = col_groups0["StaticBody"].values()
  col_groups0sb.sort()
  g.scrn_dbg("cola01", collect(col_groups0["StaticBody"].keys(), "_f0", true))
  var col_groups1 = tank.col_groups[1]["StaticBody"].keys()
  col_groups1.sort()
  if col_groups1 != g.sg("col_groups1", col_groups1):
    # pr(["col1",col_groups1 ])
    g.ss("col_groups1", col_groups1)
    if col_groups1.size() > 0:
      OS.set_iterations_per_second(60)
  var jump_attempt =  (tank.local_input[0] or tank.try_jump_once or (Input.is_action_pressed("jump") and s.resting )) && !tank.is_dying;
  if jump_attempt:
    tank.set_axis_lock(0)
    g.chreport(["jooo", tank.get_axis_lock()])
  if (state.get_contact_count() > 0):
    s.touching = not col_groups0["StaticBody"].empty()
    s.on_floor = tank.is_on_floor(col_groups0)
    s.touching_pyra = tank.is_touching_pyra(col_groups0)
    s.on_pyra = not s.on_floor and s.touching_pyra
    s.resting = s.on_floor or s.on_pyra
    s.top_touching = not s.resting and tank.is_top_touching(col_groups0)
    s.side_touching = tank.is_side_touching(col_groups0)
    if s.resting  and not ( phys.jumping):
      pass
      tank.set_axis_lock(2)
    else:
      tank.set_axis_lock(0)
    var num_calls = 0
    for i in col_groups0["StaticBody"]:
      col_groups0["StaticBody"][i].sort()
    for i in col_groups0["StaticBody"]:
      for col in col_groups0["StaticBody"][i]:
        if not old_col_groups[0]["StaticBody"].has(i):
          num_calls += 1
        if old_col_groups[0]["StaticBody"].has(i) and old_col_groups[0]["StaticBody"][i][0].norm.y != col_groups0["StaticBody"][i][0].norm.y:
          g.chreport(["weird col", old_col_groups[0]["StaticBody"][i][0].norm.y,col_groups0["StaticBody"][i][0].norm.y])
        var edge_land = false
        if xz(col.relpos.abs() - tank.tank_size).length() < 0.001 and col.norm.y > 0.999 and col_groups0["StaticBody"][i].size() < 3:
          edge_land = true
        if  true and not (old_col_groups[0]["StaticBody"].has(i) ) and not edge_land:
          var _xf = state.get_transform()
          var col_dir = (phys.xform.origin - _xf.origin)
          var space_state = me.get_world().get_direct_space_state()
          var result = space_state.intersect_ray( tank.phys_old[-1].xform.origin + col.pos, _xf.origin + col.pos, [tank], 2147483647, 1)
          if (not result.empty() and  result.normal != Vector3() ):
            var ray_based_pos = result.position - col.pos
            var ray_col_diff = ray_based_pos - _xf.origin
            g.chreport("buhoo4", pretty_str([{"ray":result.position }], 70), -1, 1000, {})
            _xf.origin =   ray_based_pos - (ray_col_diff.normalized() * Vector3(0,1,0)) * 0.00001
            state.set_transform(_xf)
            return
            break
    if num_calls > 0-1:
      g.scrn_dbg("num_calls", num_calls)
  else:
    tank.col_groups = {0:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}, 1:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}}


  if not s.resting:
    if not s.jumping:
      s.falling = true
    lv += grav*delta # Apply gravity
    vv = up.dot(lv) # Vertical velocity
    g.scrn_dbg("vv", [vv,grav*delta])
  elif not s.jumping: # resting and not jumping
    vv = 0
  if s.on_pyra and not phys.on_pyra:
    gsvar.announce(["land on pyra", state.get_transform().origin], 0.5)
    g.chreport("onpyr info", [state.get_transform().origin.y], -1, 0, {})
    vv = 0
    var _tr = state.get_transform()
    _tr.origin = ( _tr.origin + 9*tank.phys_old[-1].xform.origin) / 10
  if tank.local_input[0]:
    gsvar.announce("jaaa", 0.1)
  var target_dir = dir
  if tank.check_in_2pts_on_rest and s.resting:
    tank.check_in_2pts_on_rest = false
    tank.in_2pts_area = false
  if not s.resting: # bug? does this stop double jumps? no, cause we already have jump_attempt set beforehand
    tank.try_jump_once = false
  if  (phys.jump_count < g.sg("max_jump_count", 2)  ): # do jumps
    if jump_attempt:
      s.jump_count += 1
      tank.try_jump_once = false
    if ( jump_attempt): # start handling jumps
      gsvar.announce(["juuump"], 1)
      var voice = tank.sounds.play("jump_1")
      tank.sounds.voice_set_volume_scale_db(voice, -10)
      tank.sounds.voice_set_pitch_scale( voice, 1.0)
      tank.set_axis_lock(0)
      s.just_jumped = true
      if s.jump_count == 1: # full jump velocity on first jump

        vv = tank.jump_velocity
      else: # add half jump verlocity on each subsequent jump
        vv += tank.jump_velocity*0.5
      s.jumping = true
  if (s.resting and not s.just_jumped): # here goes resting motion
    if s.falling: # just rested
      s.jump_count = 0
      s.jumping = false
      s.falling = false
    if g.sg("noacc", false):
      hspeed = tspeed;
      hdir = target_dir;
    else:

      if (dir.dot(lv) >= 0): # velocity dir same as input. ie, not sliding
        g.report(["accelerate"], [dir, dir.length()],5 , 3000)
        hdir = target_dir;
        if (hspeed < tspeed):
          hspeed = min(hspeed+(tank.accel*delta), tspeed);
        else:
          hspeed = tspeed;
        s.moving = true;
      else:
        var lvsnd = g.sg("brake_speed_sounds", [170,90,60])
        if lv.length() < lvsnd[2] or abs(lv.y) > 10:
          stop_sound(tank.sounds, "217542__medartimus__car-breaking-skid-01")
          stop_sound(tank.sounds, "430626__juandamb__brake")
        elif lv.length() > lvsnd[0]:
          play_sound_one(tank.sounds, "217542__medartimus__car-breaking-skid-01")
        elif lv.length() > lvsnd[1]:
          play_sound_one(tank.sounds, "430626__juandamb__brake")

        g.report(["deaccelerate"], [dir, dir.length()],5 , 3000)
        hspeed -= tank.deaccel*delta;
        if (hspeed < 0):
          hspeed = 0;
    hv = hdir*hspeed;



  if s.top_touching and vv > 0:
    var xform = state.get_transform()
    hv = Vector3(0,0,0);
    vv = 0.0
    gsvar.announce("hoppa", 1)
    tank.t_turning_percent = 0.0
    tank.turning_percent = 0.0
    tank.frozen_turn = 0.0
    var lpos = xform.origin
    xform.origin = (Vector3(lpos.x, lpos.y - 0.1, lpos.z))
    state.set_transform(xform)
  if (s.jumping and vv < 0):
    s.jumping = false;
    s.falling = true
  elif  s.side_touching: # focus
    var xfrm = body.get_transform()
    var sidecol = tank.get_body_collisions(tank.touching_bodies['sides'][0])[0]

    var col_motion_vec = Vector3()
    var col_angle = sidecol['pos'].normalized().rotated(Vector3(0,1,0), -PI/2 *   sign(tank.turning_percent)  )
    g.scrn_dbg("col point", [sidecol, g.t()])
    if col_angle.dot(sidecol['norm']) < 0.0:
      var old_ty = t_yaw
      t_yaw = tank.yaw
      if not s.resting:
        tank.frozen_turn = 0.0
        tank.t_turning_percent = tank.frozen_turn
        g.report("ft,fs", [tank.frozen_turn,tank.frozen_speed, t_yaw, tank.yaw], 5 ,100)
      g.scrn_dbg("sidez", [{"tps":sign(tank.turning_percent), "n":sidecol['norm'], "nyaw":g.unify_angle(deg2rad(old_ty)
), "rot":tank.body_rotation}])
    if sidecol['norm'] != Vector3() and hdir.dot(sidecol['norm']) < 0:
      g.scrn_dbg("omword", [hv, hv + hv * sidecol['norm']])
      hv -= hv.dot(sidecol['norm']) * sidecol['norm']
    if s.on_pyra and not phys.on_pyra:
      vv = 0
      hv = Vector3()
      tank.speed_percent = 0.0
  if tank.get_linear_velocity().y > 5:
    tank.get_node("body/wound_particles5").show()
  else:
    tank.get_node("body/wound_particles5").hide()
  lv = hv + up*vv;
  var t = OS.get_ticks_msec()
  s.tick = t
  s.lv = lv
  s.av = (t_yaw - tank.yaw) * delta * 60
  if g.time_since(self,'phys_keep', 1,true):
    tank.phys_old.pop_front()
    tank.phys_old.append(phys)
  state.set_linear_velocity(Vector3());

  s.xform = state.get_transform()
  s.xform.origin += lv*state.get_step()
  state.set_transform(s.xform)
  g.report("__S__", [s], 1 , 1000, {"only":false})
  tank.phys = s
  g.report("__PHYS__", [s], 1 , 1000, {"only":false})
  g.scrn_dbg("rlmov_lv", lv)
  tank.angvel = (t_yaw - tank.yaw) * delta * 60
  tank.yaw = t_yaw
  t_body_rotation = deg2rad(t_yaw);
  tank.body_rotation = g.unify_angle(t_body_rotation)
  tank.phys.rotation = tank.body_rotation
  tank.get_node("col_capsule").set_rotation(Vector3(0, tank.body_rotation,0));
  tank.get_node("col_capsule2").set_rotation(Vector3(0, tank.body_rotation,0));
  if (tank.phys_old.back().resting != s.resting) and s.resting:
    play_sound_one(tank.sounds, "land")
    if s.on_floor:
      tank.create_tank_ripple()
  if (tank.phys_old.back().on_floor != phys.on_floor) and s.jumping:
    g.report("on floor changed", [tank.phys_old.back().on_floor,phys.on_floor], 1 , 0)
  if (tank.is_node_master or tank.is_bot) and net.replay_state != net.REPLAY_PLAYING:
    sync_clients(tank, state)
    return

func t73():
  var ph = me.state_log
  # var obj = Node.new()
      # obj.set_meta("t" , {0:[1]})
      # # obj.t =  {0:[1]}
      # var ot = obj.get_meta("t")[0]
      # ot.append(2)
      # pp( [obj.get_meta("t"), ot])
      # return
  # # pp(_me.phys)
  # ph.in_air = true
  # ph.abilities.append("oop")
  # ph.abilities = [2]
  ph.append("lola")
  pp([me._phys.hash(), ph.hash()])
  # pp([me._phys.abilities ,ph.abilities])
  pp([me.state_log ,ph])
  # var h0 = {"s":{0:[]}}
  # var h1 = {"s":{0:[]}}
  # var h1 = g.copyvar( h1)
  # # h1["d"] = 0
  # h1["s"][0].append(3)
  # pp([h0.hash(), h1.hash()])
  # pp([h0, h1])
  # var s1 = h0.s
  # # pp(h1)
  # # h1[2] = [0]
  # s1[0].append(1)
  # # h1["1"].append(2)
  # pp(h0)
  # pp(s1)
  # # return h1

func rotate_point_on_circle2(point, center, angle):
  var rotated_x = (point.x - center.x) * cos(angle) - (point.y - center.y) * sin(angle)
  var rotated_y = (point.x - center.x) * sin(angle) + (point.y - center.y) * cos(angle)
  return Vector2(rotated_x + center.x, rotated_y + center.y)

func rotate_point_on_circle(point, center, angle):
  var v2=rotate_point_on_circle2(Vector2(point.z,point.x),Vector2(center.z,center.x), angle)
  # var rotated_x = (point.x - center.x) * cos(angle) - (point.z - center.z) * sin(angle)
  # var rotated_z = (point.x - center.x) * sin(angle) + (point.z - center.z) * cos(angle)
  return Vector3(v2.y,point.y, v2.x)


func rotpc(p,c,a):
  return rotate_point_on_circle(p,c,a)

func t74():
  var v = (gg("scols").colinfo.values()[0].point - tr()).rotated(Vector3(0,1,0), me.body_rotation)
  return v.abs() - me.tank_size

func t75():
  qff([self,"t75_",[]])

func t75_(state):
  var dbg = gg("dbgcols")
  var col_t = search_time_to_collide_any(state,dbg.p, 0,dbg.tv, 0, 0.0,dbg.t)
  g.ss("dbgres", [col_t, dbg.tv.y * col_t, dbg.p.y+dbg.tv.y * col_t])
  pp(gg("dbgcols"))
  pp(gg("dbgres"))

func sd(a,v=[g.t()],show=true):
  g.scrn_dbg(a,v,show)

func dbg_excl_rids(ary, colinfo):
  # var new_a = []
  # for i in ary:
  #   new_a.append(i.get_id())
  if not colinfo.keys().empty():
    # sd("excl rids", [new_a, colinfo.values()[0].rid.get_id()])
    # sd("excl rids", [new_a, colinfo.keys()])
    # sd("excl rids", [new_a, mapfn(colinfo.values(), "get_colinf_rid")])
    sd("excl rids", [mapfn(ary, "get_rid_id"), mapfn(colinfo.values(), "get_colinf_rid")])

func get_colinf_rid(inf):
  return inf.rid.get_id()

func get_rid_id(rid):
  return rid.get_id()

func qann(what, duration=0.1,where="2"):
  gsvar.announce(what, duration, where)

func create_tank_trace(tank):
  var dir = tank.phys.lv
  if dir.length() < 3:
    return
  var inst
  var numpool = 200
  if g.store_get("ttpool", []).size() < numpool:
    inst = tank.tank_trace_scene.instance()
    inst.set_name("ttrace");
    gsvar.world.env.add_child(inst, true);
    g.store_get("ttpool").append(inst)
    # inst.get_node("Plane").set_scale(Vector3(1.59,1.5,0.7) * g.sg("trace_scale", 1) )
    inst.get_node("Plane").set_scale(Vector3(1.59+ 0.5,1.5,0.7+0.3) * g.sg("trace_scale", 1) )
  else:
    inst = g.store_get("ttpool")[g.store_inc('ttpoolnext', 1, numpool)]
    inst.reset()
    # inst.get_node("Plane").set_scale(Vector3(1.59+ 0.5,1.5,0.7+0.3) * g.sg("trace_scale", 1) )
  inst.set_global_transform(Transform(Matrix3(), tank.get_translation() - Vector3(0,tank.tank_size.y - 0.2,0)));
  # inst.set_global_transform(Transform(Matrix3(), tank.get_translation() ));
  var aaa = g.store_get("trackdivisor", 100)
#  if dir.length() > (2*aaa/5.0):
#    inst.get_node("Quad3").show()
#    inst.get_node("Quad4").show()
#  if dir.length() > (3*aaa/5.0):
#    inst.get_node("Quad5").show()
#    inst.get_node("Quad6").show()
#  if dir.length() > (4*aaa/5.0):
#    inst.get_node("Quad5").show()
#    inst.get_node("Quad6").show()
  inst.activate()
#  inst.get_node("arrow").set_scale(Vector3(1.0,1.0* pow(dir.length()/25.0, 0.4),1.0) )
  if dir.length() == abs(dir.y):
#    g.report("vertical", [], 0 , 1000, {"only":true})
    inst.set_rotation(Vector3(sign(dir.y) * PI/2,0,0))
    return inst
#  inst.look_at(get_translation() - 3*dir.normalized(), Vector3(0,1,0))
#  g.report("tread rot", [inst.get_rotation()], 0 , 100, {"only":false})
  var physoldidx = round(g.store_get("physoldidx", -5) / max(abs(tank.speed_percent),0.5))
  # inst.set_rotation(Vector3(0,phys_old[-1].rotation,0))
  inst.set_rotation(Vector3(0,tank.body_rotation,0))
  inst.set_translation(inst.get_translation() - dir.normalized() * 7)
  return inst

func tproc(reload=false):
  var out = []
  OS.execute("ruby" , ["/home/mohamed/rc/git/bzmapmaker/gdexporter/tp_hix.rb"], true, out)
  pp(out)
  if reload or not g.sg("apr", false) or is_deleted_object(gg("apr")):
    var add_primitives = load("res://addons/add_primitives/src/myAddPrimitives.gd")
    var apr = add_primitives.new()
    add_child(apr)
    g.ss("apr", apr)
    if get_node("/root/world/env/hix_map/Spatial") != null:
      get_node("/root/world/env/hix_map/Spatial").queue_free()
  gg("apr").runrun('tp_hix.gd')
  get_node("/root/world/env/tpcontainer/map").set_scale(Vector3(3.2,3.2,3.2))
  save_world()
  return gg("apr")

func save_world():
  for n in get_node("/root/world/env/tpcontainer/map").get_children():
    n.set_owner(get_node("/root/world/env/tpcontainer/map"))
    for sn in n.get_children():
      sn.set_owner(get_node("/root/world/env/tpcontainer/map"))
  var packed_scene = PackedScene.new()
  packed_scene.pack(get_node("/root/world/env/tpcontainer/map"))
  ResourceSaver.save( "res://scenes/tp_hix.tscn", packed_scene )

func real_movement_clean(state, tank):
  # gr("ooook")
  if get_tree().is_paused():
    # gr("okkkkk")
    return
  real_movement2(state, tank)
  # if gsvar.cl_name == "server":
  #   g.report("moving", [tank.stick_x, tank.stick_y], -1 , 1000, {"only":false})
  # g.scrn_dbg("start pos", [tank.get_translation(), tank.body_rotation] )
  # g.scrn_dbg("start vel", tank.phys.lv )
  var s = tank._phys # empty state
  var phys = tank.phys # empty state
  var pending_impulse = tank.pending_impulse
  var body = tank.body
  var do_up = false
  if (g.t() - tank.spawn_time) < 150:
    do_up = true
    # qann("up spawn", 4)
  s.jumping = phys.jumping # init some state vars
  s.falling = phys.falling
  # s.resting = phys.resting
  s.on_floor = phys.on_floor
  # s.on_pyra = phys.on_pyra
  s.abilities = g.sg("abilities", [])
  s.jump_count = phys.jump_count
  s.xform = state.get_transform()
  var delta = state.get_step();
  var up = Vector3(0,1,0)

  var rot_delta = phys.av * delta
  if phys.resting:
    # p()
    rot_delta =  tank.turning_percent * tank.base_turning_speed * delta
  var t_rot = fmod(tank.body_rotation+(rot_delta), 2*PI);
  var t_yaw = rad2deg(t_rot)
  var t_avel = g.uniform_angle(rot_delta) / delta
  var t_vel = phys.lv
  # qann(t_vel,1)
  var t_dir = g.xnz(t_vel).normalized()
  if phys.resting:
    # qann("rest")
    var t_body_rotation_half = fmod(tank.body_rotation+(rot_delta*0.5), 2*PI);
    t_body_rotation_half = t_rot
    t_dir = Vector3(sin(t_body_rotation_half),0,cos(t_body_rotation_half))
    t_vel = t_dir * tank.speed_percent *tank.max_speed;
  # t_vel.y  = phys.lv.y - tank.world_gravity * delta
  t_vel.y  = t_vel.y - tank.world_gravity * delta
  var t_vel_start = t_vel
  # sd("tvel_Y", t_vel.y)
  # t_vel.y  -= tank.world_gravity * delta
  var just_jumped = false
  # var just_jumped = phys.just_jumped
  # phys.just_jumped = false
  s.above_pyra = tank.check_above_pyra()
  var impulsed = false
  if not pending_impulse.empty() and OS.get_ticks_msec() - tank.last_impulse_t > 50:
    impulsed = true
    s.resting = false
    g.report("impulse", pending_impulse,0,0)
    tank.last_impulse_t = OS.get_ticks_msec()
    # qann(pending_impulse, 5)
    # state.apply_impulse(Vector3(),pending_impulse.pop_front())
    t_vel += pending_impulse.pop_front()
  OS.set_iterations_per_second(120)
  var jump_attempt =  ( (Input.is_action_pressed("jump") and phys.resting )) && !tank.is_dying;

  if jump_attempt:
    if phys.on_pyra:
      t_vel = Vector3()
    t_vel.y = tank.jump_velocity

    s.resting = false
    s.on_pyra = false
    s.on_floor = false
    do_up = true
    just_jumped = true
    var voice = tank.sounds.play("jump_1")
    tank.sounds.voice_set_volume_scale_db(voice, -10)
    tank.sounds.voice_set_pitch_scale( voice, 1.0)
    # qann("jump now")
  # if t_vel.y > 5:
  #   tank.get_node("body/wound_particles5").show()
  # else:
  #   tank.get_node("body/wound_particles5").hide()
  tank.col_groups = {0:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}, 1:{"StaticBody":{}, "RigidBody":{}, "KinematicBody":{}}}
  g.ss("checkcolcount", 0)
  # var pos_cur = tank.get_translation()
  var pos_cur = state.get_transform().origin
  var rot_cur = tank.body_rotation
  var pos_start = pos_cur
  var rot_start = rot_cur
  var tries = -1
  var tleft = state.get_step()
  var hard_excl = []
  var static_cols

  static_cols = check_collisions(state, pos_cur, rot_cur)
  if static_cols.is_colliding.inside:
    s.is_inside = true
    s.inside_obs = static_cols.colinfo
    # qann("ooona")
  g.ss("scols",static_cols )
  if static_cols.is_colliding.any:
    # p()
    g.si("clamped_tries")
    # qann("ooo")
    # gr("scols", static_cols)
    gr("oopos", [pos_cur])
    # pp(static_cols)
    # return
  else:
    g.ss("clamped_tries", 0)
  # UNCOMMENT LATER START
  if  not jump_attempt and not impulsed:
    var floor_cols = check_collisions(state, pos_cur - Vector3(0,0.0012,0), rot_cur)
    # var floor_cols = check_collisions(state, pos_cur - Vector3(0,t_vel.y * delta ,0), rot_cur)
  #   sd("floor_check val", t_vel.y * delta)
    if phys.resting and not (floor_cols.is_colliding.bottom or floor_cols.is_colliding.incline):
      s.resting = false
      s.on_floor = false
      s.on_pyra = false
      # qann(["soooo",t_vel.y * delta])
    elif phys.resting:
      t_vel.y = 0
      s.resting = phys.resting
      s.on_floor = phys.on_floor
      s.on_pyra = phys.on_pyra
      # qann(["not soooo",t_vel.y * delta])
    else:
      pass
      # qann(["un soooo",t_vel.y * delta])
  #   if floor_cols.is_colliding.incline:
  #     pass
  #     # qann("o")
  #     # t_vel.y = 0
  #     # s.resting = true
  #   if true:
  #     pass
  #   elif floor_cols.is_colliding.bottom:
  #     # sd("before we tested the floor!", [g.t(), t_vel])
  #     t_vel.y = 0
  #     var sidecol = floor_cols.colinfo[0]
  #     pos_cur.y = sidecol.point.y + tank.tank_size.y + 0.0001
  #     hard_excl.append(sidecol.rid)
  #     s.on_floor = true
  #     s.resting = true
  #     # sd("tvel_Y", t_vel.y)
  #     # qann("popop")
  #     # sd("we tested the floor!", [g.t(), sidecol.point.y + tank.tank_size.y, t_vel])
  #     # sd("bottomless0",[floor_cols])
  #   elif floor_cols.is_colliding.incline:
  #     var sidecol = floor_cols.colinfo[0]
  #     s.resting = true
  #     t_vel.y = 0
  #     # pos_cur.y = sidecol.point.y + tank.tank_size.y + 0.0001
  #     # qann("po")
  #   else:
  #     # sd("tvel_Y", t_vel.y)
  #     pass
  #     # sd("bottomless",[floor_cols])
  # UNCOMMENT LATER END
  # qann("rr")
  var expel = false
  # if gg("clamped_tries") > 0:
  if static_cols.is_colliding.any:
    # for collider_id in gg("scols").colinfo:
    # gr("expel", ["11"])
    qann("expel")
    expel = true
    # p()
    for sidecol in gg("scols").colinfo:
      # var sidecol = gg("scols").colinfo[collider_id]
      # gsvar.announce("expel", 0.1, "2")
      # pass
      # # pos_cur += g.xnz(sidecol.normal) * 0.01
      pos_cur += sidecol.normal * 0.1
      # pos_cur.y += 0.1

  var check_colliding = true
  # var implist = []
  tries = -1
  # var hard_excl = []
  var stop_turning = false
  var running_into_pyra = false
  # sd("orig tleft", [tleft])
  while( not expel and not impulsed and tleft > 0 and check_colliding):
    tries += 1
    # qann([t_vel, tries], 1)
    var col_t = search_time_to_collide_any(state,pos_cur, rot_cur,t_vel, t_avel, 0.0,tleft, hard_excl)
    if col_t < 0:
      pos_cur = pos_start
      t_rot = rot_start
      # t_vel = Vector3()
      sd("minus",[g.t(), t_avel, "tvel", t_vel, t_dir, tries])
      stop_turning = true
      t_avel = 0
      t_vel = Vector3()
      pos_cur += g.xnz(gg("last_cols").colinfo[0].normal) * 0.1
      break
    var colnum = gg("last_cols").colinfo.size()
    if tries == 0:
      pass
    if tries == 1:
      pass
    var pos_before = pos_cur
    var rot_before = rot_cur
    pos_cur +=  t_vel * col_t

    # var rot_cur = tank.body_rotation + t_avel * col_t
    rot_cur = rot_cur + t_avel * col_t
    t_rot = rot_cur
    # t_dir = Vector3(sin(t_rot),0,cos(t_rot))
    # t_vel = t_dir * t_vel.length() * sign(tank.speed_percent);
    var now_cols = check_collisions(state, pos_cur, rot_cur)
    if now_cols.is_colliding.any:
      qann("wtg")
      return
      pass
    if gg("last_cols").is_colliding.top and t_vel.y > 0: # hti our head
      t_rot = rot_cur
      t_avel = 0
      stop_turning = true
      t_vel = Vector3(0,-0.0,0)
    # if gg("last_cols").is_colliding.bottom:
    #   # qann("oom")
    #   s.on_floor = true
    var colidx = -1

    for sidecol in gg("last_cols").colinfo:
      colidx += 1
      # if colidx > 0:
      #   qann(["2nd get out", sidecol.normal])
        # break
      # if gg("last_cols").is_colliding.inside:
      #   # sd("pesky cols", gg("last_cols").colinfo)
      #   qann(["omgd",sidecol.collider.get_path()])
      # #   if sidecol.collider.is_in_group("bzw_teleporter_col"):
      # #     gr("omgd", g.t())
      # # # if gg("last_cols").is_colliding.inside:
      # #     qann("aaaa")
      # #     break

      hard_excl.append(sidecol.rid) # don't try same obstacle again
      t_dir = Vector3(sin(t_rot),0,cos(t_rot))
      var norm = (sidecol.normal)

      var point = (sidecol.point - pos_cur)
      # if norm.y < 1:
      #   pass
      #   # sd("here")
      #   var adiff = ang_diff(g.xnz(norm), t_dir,PI/2)
      #   sd("maycaught", [adiff*180/PI, g.t()])
      #   if adiff * 180 / PI < 2:

      #     norm = t_dir.rotated(Vector3(0,1,0), sign(point.rotated(Vector3(0,1,0), t_rot).x)*PI/2)
      #     sd("caughtt", [g.t()])
      #     var pt2d = me.active_camera_instance.unproject_position(sidecol.point)
      #     g.create_mark({ "timeout":0.2,"update":true,"pos":sidecol.point + Vector3(0,0.01,0),"arrow":true,"arrow_rot":atan2(norm.x, norm.z), "label":str([atan2(norm.x, norm.z), norm]), "label_pos":pt2d}, "vpoint2" + str([sidecol.rid.get_id()]), true,false)
      #   else:
      #     sd("notcaught")
      #     # t_vel = t_dir * t_vel.length()
      # # var point = (sidecol.point - pos_cur)
      # # var norm = (sidecol.normal).snapped(0.001)

      var hnorm = g.xnz(norm).normalized()
      # if hnorm == Vector3():
      #   # qann(["wackk", norm])
      #   sd("bad norm", [t_vel_start, g.t()])
      # var htvel_r = g.xnz(t_vel).normalized().rotated(Vector3(0,1,0), PI)
      var vnorm = Vector3(0,sign(norm.y),0)
      # var vpoint = (t_vel + (t_avel  * Vector3(0,1,0)).cross(point)).normalized()


      var t_vel_before = t_vel
      t_vel -= t_vel.dot(vnorm) * vnorm # cancel y component of vel if on something
      t_vel -= t_vel.dot(hnorm) * hnorm
      # t_dir = Vector3(sin(t_rot),0,cos(t_rot))
      sd("anggg", g.xz(t_vel).angle_to(g.xz(t_dir)))

      if norm.y > 0.9999:
        s.on_floor = true
      elif norm.y < 0.9999:
    # objectToWallVector = wallPosition - objectPosition
    # dotProduct = objectDirection.dot(objectToWallVector)
        # var rpoint = point.rotated(Vector3(0,1,0), t_rot)
        var nnorm = hnorm.rotated(Vector3(0,1,0), -PI/2)
        sd("normxavel", [point, nnorm, point.dot(nnorm), t_avel])
        if sign(t_avel) == sign(point.dot(nnorm)):
          stop_turning = true
          t_avel = 0
          t_rot = rot_cur
          # qann("poo")
        else:
          pass
          # qann("yaaa")

        if point.y < 0 and abs(norm.y) > 0:
          # if norm.y < 0:
          #   qann(["buy how", norm, point], 3)
          if not phys.on_floor:
            s.on_pyra = true
            stop_turning = true
            t_avel = 0
            t_rot = rot_cur
          s.resting = true
          if not phys.on_floor and t_vel_before.dot(hnorm) < 0:
            running_into_pyra = true
            t_vel = Vector3(0,t_vel.y,0)
        # qann("doool")
        var rel_point = point.rotated(Vector3(0,1,0), t_rot)
        sd("impact rel_point", [rel_point, hnorm, t_vel,t_vel_before, "norm",norm,g.t()])
        if abs(rel_point.z) < tank.tank_size.z - 0.001 :
          # qann(["poo", abs(rel_point.z)])
          var t_vel_h = t_dir * t_vel.length() * sign(tank.speed_percent);
          t_vel = g.xnz(t_vel_h, t_vel.y)
          # qann(["pp,", point.rotated(Vector3(0,1,0), t_rot), norm.y - 1])
        var pt2d = tank.active_camera_instance.unproject_position(pos_cur)
        # g.create_mark({ "timeout":0.2,"update":true,"pos":pos_cur + Vector3(0,0.01,0),"arrow":true,"arrow_rot":atan2(t_vel.x, t_vel.z), "label":str([g.xz(t_vel).angle_to( g.xz(t_dir)), t_vel]), "label_pos":pt2d}, "tvel" + str([]), true,false)
        # tank.body_rotation

      if s.on_floor and norm.y < 0.999:
        var pushpercent = abs(hnorm.dot(t_vel_before.normalized()))
        var pushbackval =  t_vel_before.length() * 0.01 * hnorm * 0.6
        pos_cur += pushbackval * pushpercent

        sd("pushbacl", [hnorm.dot(t_vel_before.normalized())])

      if abs(t_vel.y) < 0.00001:
        if not phys.resting:
          g.ss("dbgcols", {"t":tleft, "colt":col_t,"tv":t_vel_before, "p":pos_before , "w1":pos_before.y + (t_vel_before.y * (tleft - col_t)), "scol":sidecol} )
      if norm.y > 0:
        s.resting = true
        t_vel.y = 0
    tleft -= col_t
    sd("tleft", [tleft,col_t])

  # Now Do Teleportation!
  if g.weighted_setters[tank].max_speed_mod.has("boost"):
    if abs(t_vel.y) > 0:

      g.w_unset(tank, "max_speed_mod", "boost")
      tank.max_speed = gsvar.normal_max_speed * tank.max_speed_mod
      t_vel = t_dir * tank.speed_percent *tank.max_speed;
      # qann(["alro", t_vel,tank.speed_percent,tank.max_speed], 3)
  var just_teleported = false
  if  not g.is_null(phys.xform):
    # intersect line of motion at tank bottom - if collision occurs with tele, the collision point is the tank bottom
    var tele_cols = tank.get_world().get_direct_space_state().intersect_ray(phys.xform.origin - Vector3(0,tank.tank_size.y,0), pos_cur - Vector3(0,tank.tank_size.y,0), [tank.get_rid()])
    # var tele_cols = tank.get_world().get_direct_space_state().intersect_ray(phys.xform.origin - Vector3(0,tank.tank_size.y, 0), pos_cur - Vector3(0,tank.tank_size.y, 0), [tank.get_rid()])
    if not tele_cols.empty() and tele_cols.collider.get_parent().has_meta("links"):
      g.ss("tele_cols", tele_cols)
      sd("tele cols",tele_cols)
      var telein_rot = tele_cols.collider.get_parent().get_rotation().y
      var face_enter = max(sign((pos_cur - phys.xform.origin).dot(Vector3(cos(telein_rot), 0 ,sin(telein_rot)))), 0)
      # get relative enter position to tele
      var telein = tele_cols.collider.get_parent()
      # assuming we are on ground, tank bottom is zero percent of tele height
      # reality is tank pos.y is zero + half tank height
      # tele pos.y is zero + half tele height
      # (tank_pos.y - (tank_height/2)) / (tele_pos.y - (tele_height/2))
      # var tele_rel_enter_pos = g.xnz((tele_cols.position - telein.get_global_transform().origin).rotated(Vector3(0,1,0), telein_rot), tele_cols.position.y)
      # var telein = {"pos":Vector3(), "aabb":null, }

      var telein_aabb = telein.get_transformed_aabb().size
      var telein_pos = telein.get_global_transform().origin - Vector3(0,telein_aabb.y*0.5,0)
      var telein_rel_enter_pos = (tele_cols.position - telein_pos).rotated(Vector3(0,1,0), telein_rot)
      # qann(["enter pos", telein_rel_enter_pos.y, telein_pos], 3)
      var enter_y_percent = (tele_cols.position.y ) / (2*telein_aabb.y)
      # var enter_y_percent = (tele_cols.position.y ) / (telein_aabb.y)
      # telein_rel_enter_pos.y -= telein.get_transformed_aabb().size.y / 2 -tank.tank_size.y
      # get out tele
      var out_tele_idx = -1
      var leave_face = -1
      # qann([(tele_cols.position - pos_cur)], 2)
      for l in telein.get_meta("links"):
        if l[0] == face_enter:
          out_tele_idx = l[1]
          leave_face = l[2]
      if out_tele_idx > -1:
        var teleout = get_tree().get_nodes_in_group("bzw_teleporter")[out_tele_idx]
        var teleout_aabb = teleout.get_transformed_aabb().size
        var teleout_pos = teleout.get_global_transform().origin - Vector3(0,teleout_aabb.y*0.5,0)
        var tele_scale = teleout_aabb  / telein_aabb
        # qann(["tscale", tele_scale], 2)
        # qann(["enter face", face_enter], 2)
        # qann(["out face", out_tele_idx, leave_face], 2)
        # get new position
        var out_pos = teleout_pos
        if face_enter == leave_face:
          var teleout_rel_pos = telein_rel_enter_pos.rotated(Vector3(0,1,0), -teleout.get_rotation().y) * tele_scale
          out_pos -= g.xnz(teleout_rel_pos, -teleout_rel_pos.y)
          # t_rot += PI
          t_rot = fmod(t_rot + PI, 2*PI);
          t_vel = t_vel.rotated(Vector3(0,1,0), PI)
          # t_vel = Vector3()
          # qann("smootch")
        else:
          out_pos += telein_rel_enter_pos.rotated(Vector3(0,1,0), -teleout.get_rotation().y) * tele_scale
          # if in relpos = [0,10,0], tscale = [1,0.5,1]

        # align the y component of the tank bottoms relative to the tele
        # out_pos.y -=  teleout.get_transformed_aabb().size.y
        # out_pos.y +=  enter_y_percent * teleout.get_transformed_aabb().size.y * 2

        # out_pos.y -=  out_tele.get_transformed_aabb().size.y / 2 -tank.tank_size.y
        # var tele_out_pos = out_tele.get_global_transform().origin + tele_rel_enter_pos.rotated(Vector3(0,1,0), -out_tele.get_rotation().y)
        # tele_out_pos.y -=  out_tele.get_transformed_aabb().size.y / 2 -tank.tank_size.y
        out_pos.y += tank.tank_size.y
        pos_cur = out_pos
        # gr("poscur", out_pos)
        # qann(["posout", out_pos], 3)
        just_teleported = true
        # if out_face    == face_enter: # mirror

      # p()
    # sd("tele cols", tele_cols)
  var t = OS.get_ticks_msec()
  s.tick = t
  s.lv = t_vel
  # if impulsed:
  #   qann(["final vel", t_vel],5)
  if !just_teleported:
    s.av = (t_rot - tank.body_rotation) / delta
  if stop_turning:
    sd("stop_turning")
    s.av = 0
  # s.av = t_avel
  t_yaw = rad2deg(t_rot);
  tank.yaw = t_yaw
  tank.body_rotation = t_rot
  state.set_linear_velocity(Vector3(0,0,0));
  # g.scrn_dbg("final t_vel", t_vel)

  # s.xform.origin = pos_cur + t_vel*tleft
  s.xform.origin = pos_cur
  # g.scrn_dbg("final pos", s.xform.origin)
  if not g.is_null(phys.xform):
    sd("whole motion", [phys.xform.origin, s.xform.origin])
  state.set_transform(s.xform)
  if g.time_since(tank,'phys_keep', 1,true):
    tank.phys_old.pop_front()
    tank.phys_old.append(phys)
  tank.phys = s

  # g.report("__S__", [s], 1 , 1000, {"only":false})
  # tank.phys = s
  g.report("__PHYS__", [s], 1 , 1000, {"only":false})
  # g.scrn_dbg("rlmov_lv", lv)
  # tank.angvel = (t_yaw - tank.yaw) * delta * 60
  # tank.yaw = t_yaw
  # t_body_rotation = deg2rad(t_yaw);
  # tank.body_rotation = g.unify_angle(t_body_rotation)
  # tank.phys.rotation = tank.body_rotation
  # tank.get_node("col_capsule").set_rotation(Vector3(0, tank.body_rotation,0));
  # tank.get_node("col_capsule2").set_rotation(Vector3(0, tank.body_rotation,0));
  if (tank.phys_old.back().resting != s.resting) and s.resting:
    play_sound_one(tank.sounds, "land")
    if s.on_floor:
      tank.create_tank_ripple()
  if (tank.phys_old.back().on_floor != phys.on_floor) and s.jumping:
    g.report("on floor changed", [tank.phys_old.back().on_floor,phys.on_floor], 1 , 0)
  if (tank.is_node_master or tank.is_bot) and net.replay_state != net.REPLAY_PLAYING:
    sync_clients(tank, state, do_up)
    return
  # THE END OF MPVEMENT

  # return
  # var static_cols = check_collisions(state, tank.get_translation() - up * 0.001, tank.body_rotation)
  # # var static_cols = check_collisions(state, tank.get_translation() , tank.body_rotation)
  # # if static_cols.is_colliding.bottom:
  # s.resting = (static_cols.is_colliding.bottom or static_cols.is_colliding.incline) and not phys.lv.y > 0
  # if s.resting:
  #   t_vel.y = 0
  # # this  is another  simple test
  # g.ss("scols",static_cols )
  # var tcol = search_time_to_collide_side(state,tank,t_vel, t_avel, 0.0,state.get_step())
  # var cols = g.sg("last_cols")
  # if true:
  #   s.touching = cols.is_colliding.any
  #   s.on_floor = cols.is_colliding.bottom
  #   s.touching_pyra = cols.is_colliding.incline and cols.is_colliding.bottom
  #   s.on_pyra = cols.is_colliding.incline and not cols.is_colliding.bottom
  #   # s.resting = (cols.is_colliding.bottom or cols.is_colliding.incline) and not phys.lv.y > 0
  #   s.top_touching = cols.is_colliding.top
  #   s.side_touching = cols.is_colliding.side

  # g.scrn_dbg("local0", [Input.is_action_pressed("jump"), s.resting])
  # var jump_attempt =  (tank.local_input[0] or tank.try_jump_once or (Input.is_action_pressed("jump") and s.resting )) && !tank.is_dying;
  # if s.resting:
  #   s.jump_count = 0
  # if not s.resting: # in air
  #   if not s.jumping:
  #     s.falling = true
  #   t_vel.x = phys.lv.x
  #   t_vel.z = phys.lv.z
  #   # lv += grav*delta #  gravity
  #   # vv = up.dot(lv)
  #   # g.scrn_dbg("vv", [vv,grav*delta])
  # # if s.resting and not s.jumping: # resting and not jumping
  # #   # vv = 0
  # #   t_vel.y = 0
  # #   p()
  # # if tank.local_input[0]:
  # #   gsvar.announce("jaaa", 0.1)
  # # var target_dir = dir
  # if not s.resting: # bug? does this stop double jumps? no, cause we already have jump_attempt set beforehand
  #   tank.try_jump_once = false
  # # if jump_attempt:

  #   # g.chreport("jump attempt", [ g.t()])
  # if  (s.jump_count < g.sg("max_jump_count", 2)  ): # do jumps
  #   if jump_attempt:
  #     s.jump_count += 1
  #     tank.try_jump_once = false
  #   if ( jump_attempt): # start handling jumps
  #     gsvar.announce(["juuump"], 1)
  #     var voice = tank.sounds.play("jump_1")
  #     tank.sounds.voice_set_volume_scale_db(voice, -10)
  #     tank.sounds.voice_set_pitch_scale( voice, 1.0)
  #     tank.set_axis_lock(0)
  #     s.just_jumped = true
  #     if s.jump_count == 1: # full jump velocity on first jump
  #       t_vel.y = tank.jump_velocity
  #     else: # add half jump verlocity on each subsequent jump
  #       t_vel.y += tank.jump_velocity*0.5
  #     s.jumping = true
  # if (s.resting and not s.just_jumped): # here goes resting motion
  #   if s.falling: # just rested
  #     s.jump_count = 0
  #     s.jumping = false
  #     s.falling = false
  # var h_correction = Vector3()
  # # if not phys.resting and  cols.is_colliding.incline:
  # #   g.scrn_dbg("moveto pyra" ,[g.t()])
  # #   t_vel.y = -0.1
  # var tleft = state.get_step()
  # if cols.is_colliding.side or cols.is_colliding.incline: # fast  forward to the collision point when we hit an obstacle
  #   # tcol *= 0.1
  #   # (lcs().colinfo.values()[0].point - me.get_translation()).rotated(Vector3(0,1,0),me.body_rotation) - me.tank_size
  #   tleft -=  tcol
  #   if tleft < 0.01:
  #     g.scrn_dbg("tleft", [tcol,tleft, g.t()])
  #     p()
  #   # if tleft > 0.1:
  #   #   g.scrn_dbg("tleft", [tleft, g.t()])
  #   # var xform = state.get_transform()
  #   # var pos_col = xform.origin + t_vel * tcol
  #   var pos_col = tank.get_translation()+ g.xnz(t_vel) * tcol
  #   var rot_col = tank.body_rotation + t_avel * tcol
  #   g.scrn_dbg("pos_col", pos_col)
  #   # t_yaw = rad2deg(rot_col )
  #   s.xform.origin = pos_col
  #   # state.set_transform(xform)
  #   # var free_cols = check_collisions(state, pos_col, rot_col)
  #   # g.scrn_dbg("free cols", [free_cols.collide.size(), g.t()])
  #   # if free_cols.collide.size() == 8:
  #   #   g.scrn_dbg("good free cols", [free_cols.collide.size(), g.t()])
  #   # if tcol > 0:
  #   #   g.scrn_dbg("time2col", [tcol, g.t()])
  # # g.scrn_dbg("ri3", cols.colinfo)
  # var y_correction = 0
  # for collider_id in cols.colinfo:
  #   # if cols.colinfo[collider_id].normal.y > 0.999: #bottom col
  #   if  (cols.colinfo[collider_id].normal.y > 0.0 and not cols.is_colliding.bottom) or (cols.colinfo[collider_id].normal.y > 0.999 and not cols.is_colliding.incline): #bottom col
  #   # if cols.colinfo[collider_id].normal.y > 0.999 or (cols.colinfo[collider_id].normal.y > 0.0 and not cols.is_colliding.bottom): #bottom col
  #   # if cols.colinfo[collider_id].normal.y > 0.999 : #bottom col
  #     # var xform = state.get_transform()
  #     # y_correction = (tank.get_translation().y - tank.tank_size.y) -cols.colinfo[collider_id].point.y + 0.0001
  #     # we want to snap to collision y
  #     # assum ground 0
  #     y_correction = (tank.get_translation().y - tank.tank_size.y) -cols.colinfo[collider_id].point.y + 0.000
  #     # if s.touching_pyra:
  #     #   y_correction = 0
  #     g.scrn_dbg("ya", [g.t(),y_correction])
  #     # if y_correction > 0.01:
  #     #   g.chreport([y_correction, tank.get_translation().y - y_correction])
  #     # if not s.just_jumped:
  #     # if not t_vel.y > 0:
  #     # # if  t_vel.y > 0:
  #     #   # g.scrn_dbg("here")
  #     #   t_vel.y = 0
  #     # else:
  #     #   g.scrn_dbg("here")
  #   if abs(cols.colinfo[collider_id].normal.y) < 0.999:
  #     # g.scrn_dbg("omaha", g.t())
  #     var vpoint = Vector3()
  #     var sidecol = cols.colinfo[collider_id]
  #     var point = (sidecol.point - tank.get_translation())
  #     # υ/ω= r ->
  #     var vpoint = t_vel + (t_avel  * Vector3(0,1,0)).cross(point)
  #     g.scrn_dbg("vpoint", [t_vel, vpoint])
  #     # -PI+atan2(vpoint.z, vpoint.x)
  #     g.create_mark({"update":true,"pos":sidecol.point + Vector3(0,10,0),"arrow":true,"arrow_rot":atan2(vpoint.x, vpoint.z), "label":"hii", "label_pos":Vector2(400,300)}, "vpoint", true,false)
  #     var hnorm = g.xnz(sidecol.normal).normalized()
  #     if   vpoint.normalized().dot(hnorm) < -0.0075:
  #       if abs(cols.colinfo[collider_id].normal.y) > 0.0 and not jump_attempt and not cols.is_colliding.bottom: # on inclined surface
  #         pass
  #         # t_vel.y = -0.01
  #         t_vel = Vector3(0, -0.0, 0)
  #         # t_yaw = tank.yaw
  #         t_body_rotation = tank.body_rotation
  #         g.scrn_dbg("all pyr", [g.t()])
  #       else:
  #         var t_norm_ang = (xz(t_dir).angle_to(xz(sidecol.normal)) - PI/2)
  #         g.scrn_dbg("t norm angle", t_norm_ang)
  #         # var rot_col = tank.body_rotation + t_avel * max(tcol,0.02 * tank.speed_percent*pow(abs(sin(tnorm_h_ang) ), 1)) #*sin(tnorm_h_ang)
  #         # var t_new_rot = tank.body_rotation + t_avel * max(0,0.02 * tank.speed_percent*pow(abs(sin(t_norm_ang) ), 1)) #*sin(tnorm_h_ang)
  #         var t_new_rot = tank.body_rotation + t_avel * max(0,0.02 * (t_vel.length() / tank.max_speed)*pow(abs(sin(t_norm_ang) ), 1)) #*sin(tnorm_h_ang)
  #         # var t_new_rot = tank.body_rotation + t_avel * max(0,0.02 *pow(abs(sin(t_norm_ang) ), 1)) #*sin(tnorm_h_ang)
  #         # var rot_col = tank.body_rotation + t_avel * tcol
  #         # var rot_col = tank.body_rotation + t_avel * max(tcol,0.0)  #*sin(tnorm_h_ang)
  #         # t_yaw = fmod(rad2deg(rot_col ), 360.0)
  #         t_body_rotation = fmod(t_new_rot , 2*PI)
  #         # hv -= hv.dot(hnorm) * hnorm * 1.0
  #         t_vel -= g.xnz(t_vel.dot(hnorm) * hnorm * 1.0)
  #         g.create_mark({"update":true,"pos":sidecol.point + Vector3(0,10,0),"arrow":true,"arrow_rot":atan2(t_vel.x, t_vel.z), "label":"hi3i", "label_pos":Vector2(400,300)}, "vresult", true,false)
  #       var t_rot_diff = g.unify_angle((t_body_rotation - tank.body_rotation))
  #       # var xform = state.get_transform()
  #       var new_o = rotpc(s.xform.origin, sidecol.point, t_rot_diff)# + sidecol.normal * 1
  #       g.scrn_dbg("debug rotpc" , [s.xform.origin, sidecol.point, t_rot_diff, new_o])
  #       var last_colinf = cols.colinfo.keys()
  #       last_colinf.sort()
  #       var new_cols = check_collisions(state, new_o, t_body_rotation)
  #       var new_colinf = new_cols.colinfo.keys()
  #       new_colinf.sort()
  #       # xform.origin += abs(expel_d) * sidecol.normal
  #       if new_cols.is_colliding.side and (new_colinf != last_colinf):
  #         g.scrn_dbg("zomg", [last_colinf, new_colinf, g.t()])
  #         t_body_rotation = tank.body_rotation
  #         # t_yaw = tank.yaw
  #       else:
  #         pass
  #         # g.ss("last_cols", new_cols)
  #         tank.frozen_turn =( t_rot_diff*delta)
  #         g.scrn_dbg("new frozen_turn", [tank.frozen_turn, g.t()])
  #         s.xform.origin.x = new_o.x
  #         s.xform.origin.z = new_o.z
  #         # state.set_transform(xform)
  #       g.scrn_dbg("newo", [new_o,t_rot_diff, g.t()])
  # # if y_correction > 0.0 or h_correction != Vector3():
  # #   # p()
  # #   if y_correction > 0.5 and s.resting and not phys.resting:
  # #     g.chreport([y_correction, tank.get_translation().y - y_correction])
  # #     # g.scrn_dbg("y_correction", y_correction)
  # #     var xform = state.get_transform()
  # #     # p()
  # #   # xform.origin += h_correction
  # #     xform.origin.y -= y_correction
  # #     state.set_transform(xform)
  # if s.top_touching and t_vel.y > 0:
  #   # var xform = state.get_transform()
  #   t_vel = Vector3(0,0,0);
  #   # t_vel.y = 0.0
  #   gsvar.announce("hoppa", 1)
  #   tank.t_turning_percent = 0.0
  #   tank.turning_percent = 0.0
  #   tank.frozen_turn = 0.0
  #   var lpos = s.xform.origin
  #   s.xform.origin = (Vector3(lpos.x, lpos.y - 0.1, lpos.z))
  #   # state.set_transform(xform)
  # if (s.jumping and t_vel.y < 0):
  #   s.jumping = false;
  #   s.falling = true

  # if tank.get_linear_velocity().y > 5:
  #   tank.get_node("body/wound_particles5").show()
  # else:
  #   tank.get_node("body/wound_particles5").hide()
  # # lv = hv + up*t_vv;
  # var t = OS.get_ticks_msec()
  # # g.scrn_dbg("actual delta", [(g.t() - phys.tick)])
  # s.tick = t
  # # s.xform = state.get_transform()
  # # var after_cols = check_collisions(state, s.xform.origin + t_vel*tleft, t_body_rotation)
  # # if after_cols.is_colliding.side:
  # #   g.scrn_dbg("wth!!!!!!!!!!", [g.t(),
  # #     t_body_rotation - tank.body_rotation,
  # #     t_vel*tleft
  # #     ])
  # #   # p()
  # #   # return
  # #   # lv = phys.lv
  # #   # t_body_rotation = tank.body_rotation

  # s.lv = t_vel
  # g.scrn_dbg("lv", [t_vel.length(), tank.get_linear_velocity().length(),tleft])
  # # tank.angvel = (t_yaw - tank.yaw) * delta * 60

  # # t_body_rotation = deg2rad(t_yaw);
  # t_yaw = rad2deg(t_body_rotation);
  # # s.av = (t_yaw - tank.yaw) * delta * 60
  # # s.av = (t_body_rotation - tank.body_rotation) * delta * 60
  # s.av = (t_body_rotation - tank.body_rotation) / delta
  # if not s.resting:
  #   g.scrn_dbg("want frozen turn", s.av / (state.get_step()))
  #   # tank.frozen_turn =  s.av / (state.get_step())
  # s.rotation = g.unify_angle(t_body_rotation)
  # tank.angvel = s.av
  # # tank.body_rotation = g.unify_angle(t_body_rotation)
  # tank.yaw = t_yaw
  # tank.body_rotation = s.rotation
  # # tank.phys.rotation = tank.body_rotation
  # if g.time_since(self,'phys_keep', 1,true):
  #   tank.phys_old.pop_front()
  #   tank.phys_old.append(phys)
  # state.set_linear_velocity(Vector3());

  # # s.xform = state.get_transform()
  # # s.xform.origin += lv*state.get_step()
  # # s.xform.origin += t_vel*tleft
  # s.xform.origin += t_vel*state.get_step()
  # # if y_correction > 0.01:
  # s.xform.origin.y -= y_correction
  # var after_cols = check_collisions(state, s.xform.origin , t_body_rotation)
  # if after_cols.is_colliding.side:
  #   g.scrn_dbg("wth!!!!!!!!!!", [g.t(),
  #     s.av,
  #     s.xform.origin - phys.xform.origin
  #     ])
  #   # p()
  #   # return
  #   # lv = phys.lv
  #   # t_body_rotation = tank.body_rotation
  # state.set_transform(s.xform)
  # # state.set_transform(s.xform)

  # g.report("__S__", [s], 1 , 1000, {"only":false})
  # tank.phys = s
  # g.report("__PHYS__", [s], 1 , 1000, {"only":false})
  # # g.scrn_dbg("rlmov_lv", lv)
  # # tank.angvel = (t_yaw - tank.yaw) * delta * 60
  # # tank.yaw = t_yaw
  # # t_body_rotation = deg2rad(t_yaw);
  # # tank.body_rotation = g.unify_angle(t_body_rotation)
  # # tank.phys.rotation = tank.body_rotation
  # tank.get_node("col_capsule").set_rotation(Vector3(0, tank.body_rotation,0));
  # tank.get_node("col_capsule2").set_rotation(Vector3(0, tank.body_rotation,0));
  # if (tank.phys_old.back().resting != s.resting) and s.resting:
  #   play_sound_one(tank.sounds, "land")
  #   if s.on_floor:
  #     tank.create_tank_ripple()
  # if (tank.phys_old.back().on_floor != phys.on_floor) and s.jumping:
  #   g.report("on floor changed", [tank.phys_old.back().on_floor,phys.on_floor], 1 , 0)
  # if (tank.is_node_master or tank.is_bot) and net.replay_state != net.REPLAY_PLAYING:
  #   sync_clients(tank, state)
  #   return


func real_movement2(state, tank):
  for fun in g.sg("fixed_func_queue", []):
    fun[0].callv(fun[1], [ state] + fun[2])
  g.ss("fixed_func_queue", [])
  # var dt = state.get_step()
  # var target_velocity = Vector3() # compute rotation after dt then (cos,sin) * target_speed
  # var target_position = Vector3()
  # var target_yaw = 0.0;
  # var s = tank._phys # empty state
  # var phys = tank.phys # empty state
  # var pending_impulse = tank.pending_impulse
  # var body = tank.body
  # s.jumping = phys.jumping # init some state vars
  # s.falling = phys.falling
  # s.abilities = g.sg("abilities", [])
  # s.jump_count = phys.jump_count
  # var angle_diff = tank.turning_percent * tank.base_turning_speed * (state.get_step() * 60)
  # var t_yaw = fmod(tank.yaw+(angle_diff), 360.0);
  # var t_body_rotation = deg2rad(t_yaw);
  # var dir = Vector3();
  # var aim = Vector3(sin(tank.body_rotation),0,cos(tank.body_rotation))
  # dir += aim * tank.speed_percent;
  # dir.y = 0;
  # dir = dir.normalized();
  # var lv = s.lv
  # var grav = Vector3(0,-tank.world_gravity,0);
  # var delta = state.get_step();
  # var up = -grav.normalized() # (up is against gravity)
  # var vv = up.dot(lv)
  # var hv = g.xnz(lv) # Horizontal velocity
  # var hdir = hv.normalized() # Horizontal direction
  # var hspeed = hv.length() # Horizontal speed
  # var tspeed = tank.max_speed * abs(tank.speed_percent);
  # var jump_attempt =  (tank.local_input[0] or tank.try_jump_once or (Input.is_action_pressed("jump") and s.resting )) && !tank.is_dying;
  # if jump_attempt:
  #   tank.set_axis_lock(0)
  # if (s.resting ):
  #   if g.sg("noacc", false):
  #     hspeed = tspeed;
  #     hdir = dir;
  # var t = OS.get_ticks_msec()


func setup3_common():

  itc()
  t43()
  get_node("/root/world/env/sun2").set_parameter(3,0.4-0.3+0.3)
  set_fxp(1,0.65+0.0)
  set_bg_p(4,0.25 + 0.0)
  set_bg_p(5,2.075 -1 + 0.03)
  g.ss("aimxdiv", 150.0)
  g.ss("down_ypos_param", 200)
  g.store_set("ball_speed_mul", 1.38-0.01+0.3+0.05-0.1 - 0.1+0.25 -1 + 1 - 0.1  )
  g.store_set("ball_col_net_slow_factor", 0.3)
  g.store_set("netshaderparam", Vector3(0.635,-0.25 - 0.05 ,0.635))
  OS.set_keep_screen_on(true)
  g.store_set("jumpcoundpchsc", 1)
  g.ss("jump_jet_sound", "512815__mostyxs__good-jetpack-sound-loop")
  g.ss("jump_jet_sound", "SFX_Car_Movements_0012")
  g.ss("jump_sound", "431174__highpixel__fireball-explosion")
  g.ss("fire_sound", "fire")
  g.store_set("obpos", Vector3(0,15.59,-4.73))
  g.store_set("brake_speed_sounds", [170+10,90+40+30,60+30+10])
  set_cam()
  t30() # mod tanks
  # g.ss("brake_speed", 0.125)
  g.store_set("ball_col_slow_factor", 0.7+0.02+0.15-0.05-0.05 +0.1)
  g.store_set("bboard_damp", 1.1)
  g.store_set("highthrow", 7)
  g.store_set("highthrowbackunits", -3 - 7)
  g.store_set("physoldidx", -5)
  g.store_set("d2pmul", 1.25)
  g.store_set("charge_voice_pitch", 2.55 )
  g.store_set("stripspd", 300)
  g.store_set("tracksdrawintv", 80)
  g.store_set("trackdivisor", 100)
  g.store_set("tank_tracks_spd", 0.2)
  g.store_set("camyawspdair", 0.7)
  g.store_set("camyawspdgrnd", 5-2-1)
  g.store_set("behind_cam_range", 50)
  g.store_set("behind_cam_height", 11)
  g.store_set("behind_cam_range", 10)
  g.store_set("behind_cam_height", 12)
  g.store_set("behind_cam_range", 40+10-5) # 100
  g.store_set("behind_cam_height", 27+5) #42
  g.store_set("behind_cam_range", 70 + 10 - 5) # 100
  g.store_set("behind_cam_height", 42+2 ) #42
  g.store_set("cam_switch_spd", 4-0.5-1.5)
  g.ss("tripple_scin", 13+2+15-10)
  g.ss("tripple_scmul", 16-2+23-15)
  g.ss("tripple_dur", 0.55 - 0.1+0.2)
  g.ss("bripple_scin", 1)
  g.ss("bripple_scmul", 10)
  g.ss("bripple_dur", 0.55 + 0.2)
  me.get_node("body/shoot_pos3").set_translation(Vector3(0,0,0))
  setcam({"d":75-20-20-10-20+10+35-20-20 +15,"dm":2.6-0.5-1-2+1,"e":200-30-70+200+100-100-150-120+130-50+100+50+50 - 250, "em":5-3.5+2-2})
  pf(false) #true) #false

func setup3_football():
  me.normal_max_speed = 140
  gsvar.normal_max_speed = 90
  ball().get_node("body/basketball").hide()
  ball().get_node("body/football").show()
  t26() # mod ball
  t53() # color ball
  t60()
  g.store_set("jumpcoundvolsc", 5)
  phys_conf(6+1)
  g.store_set("releasepassduration" ,140)
  g.ss("airturn_lerp", 15)
  g.ss("elev_area_scal", 1.2-0.4)
  g.ss("vvcoldamp",0.32+0.03 -0.1 + 0.1)
  g.store_set("ball_col_slow_factor", 0.9)
  g.ss("cam_eye_extra_y", 10)
  g.store_set("behind_cam_range", 40+10-5 +20 + 10)
  g.store_set("behind_cam_height", 22+2) #42

func setup3_basketball():
  ball().get_node("body/basketball").show()
  get_node("/root/world/env/hoopsouth/Torus3").set_scale(Vector3(0.1+0.15,0.4,0.1+0.15))
  t9()
  t25() # mod hoop
  t26() # mod ball
  t53() # color ball
  g.store_set("jumpcoundvolsc", 5-2)
  g.store_get("jumpjetcoundpchsc", 1.0)
  phys_conf(5)
  g.store_set("releasepassduration" ,140-40-10)
  g.ss("airturn_lerp", 15+10-15+10)
  g.ss("airturn_lerp", 30)
  g.ss("cam_eye_extra_y", 30)
  g.ss("elev_area_scal", 1.2-0.4 + 0.4 + 0.3)

  g.ss("vvcoldamp",0.15-0.01)
  g.ss("vvcoldamp",0.2)

func rehix():
  # p()
  # reload_obj(get_node("/root/world/env/hix_map"),{"res":"res://scenes/hix_map.tscn"})
  reload_obj(get_node("/root/world/env/hix_map"),{"res":"res://testtest.tscn"})

func setup3_hix():
  runfp(true)
  # get_node("/root/world/env/honeycomb5").set_scale(Vector3(1500,1500,1500))
  # get_node("/root/world/env/honeycomb5").hide()
  var cam = me.get_node("camera/cam")
  cam.set_perspective ( 0, 0.1, 4000 )
  # cam.set_orthogonal(600,0.1,4000)
  g.store_set("jumpcoundvolsc", 5-2)
  g.store_get("jumpjetcoundpchsc", 1.0)
  g.ss("airturn_lerp", 15+10-15)
  g.ss("cam_eye_extra_y", 0)
  g.ss("elev_area_scal", 1.2-0.4 + 0.4 + 0.3)

  g.ss("vvcoldamp",0.15-0.01)
  g.ss("trace_scale",0.7)
  me.body.set_translation(Vector3(0,0,0))
  var wscal = 3.2
  # var wscal = 1
  get_node("/root/world/env/Plane10").set_scale(Vector3(wscal*16,1,wscal*16))
  get_node("/root/world/env/worldwalls").set_scale(Vector3(wscal,10,wscal))
  get_node("/root/world/env/worldwalls2").set_scale(Vector3(wscal,1,wscal))
  # get_node("/root/world/env/hix_map").set_scale(Vector3(wscal,wscal,wscal))
  get_node("/root/world/env/tpcontainer/map").set_scale(Vector3(wscal,wscal,wscal))
  get_node("/root/world/gui/ThrowMeter").hide()
  get_node("/root/world/gui/ThrowMeter2").hide()
  get_node("/root/world/gui/spower").hide()
  # qann(["all players before scale", gsvar.all_players().size()], 3)
  for b in gsvar.all_players():
    # scale_tank(b,1.4)
    scale_tank(b,1.28)
    b.body.set_translation(Vector3(0,0,0))
  if true:
    g.ss("shot_base_speed", 300)
    me.is_aiming = false
    g.ss("airturn_enabled", false)
    g.ss("boost_enabled", true)
    g.ss("max_jump_count", 1)
    g.ss("noacc", true)
    me.get_node("body/TestCube").hide()
    me.get_node("body/TestCube4").show()
    phys_conf(9)

func get_d(o1,o2):
  if typeof(o1) == 18: #Object
    o1 = o1.get_translation()
  if typeof(o2) == 18:
    o2 = o2.get_translation()
  return (o1 - o2).length()

func find_closest_to_ball(players):
  var d
  var min_ = 100000
  var res
  for player in players:
    d = get_d(player, ball())
    if not player.is_dying and  d < min_:
      min_ = d
      res = player
  return res

func find_mate_id(player=me):
  var t = gsvar.teams[player.tank_color]
  var ids = t.keys()
  ids.erase(player.pid)
  return ids[0]

func p_prop_after(obj, prop, t=1):
  g.object_timer("pprop", self, "p_prop", true, t, [obj, prop])

func p_prop(obj,prop):
  print(obj.get(prop))

func t8(param):
  var hoop = get_node("/root/world/env/hoopsouth")
  var rel_pos = param
  var hoop1= hoop.get_node("Basketball Hoop/Hoop2")
  hoop.get_node("Basketball Hoop/Hoop2").get_material_override().set_shader_param("ball_pos", rel_pos)

func t9():
  var hoop = get_node("/root/world/env/hoopsouth")
  var hoop1= hoop.get_node("Basketball Hoop/Hoop2")
  var shaderres = ResourceLoader.load("shaders/Basketball Hoop shader.tres", "", true).duplicate()
  hoop1.get_material_override().set_shader(shaderres)
  return shaderres.get_vertex_code()

func unbindjs():
  var joy_bind_map = {
    "jump" : [[1]], #[ [1], [7]],
    "shoot" : [ [0]], # [],
    "repeat_shoot" : [[3]], #[[2]],
    "aim" : [[2]], #[[6]],
    "throw" : [],# [ [0]],
    "pass_ball" : [], # [[3]],
    "slowmo" : [[7]], #[[3]] ,#[[4]],
    "slowmo2" : [[1]] #[[5], [7]],
  }
  if g.jsenabled:
    for a in joy_bind_map:
      g.action_bind_joy(a, joy_bind_map[a])
  else:
    g.report("unbinding js", [], 0 , 1000, {"only":false})
    for a in joy_bind_map:
      g.action_unbind(a, joy_bind_map[a],InputEvent.JOYSTICK_BUTTON)



func add_ball():
  var new_ball = ball().duplicate()
  var new_leader_ball = ball().leader_ball.duplicate()
  new_ball.paused = true
  g.store_set("new_ball", new_ball)
  g.store_set("new_lball", new_leader_ball)
  get_node("/root/world/env").call_deferred("add_child", new_ball)
  get_node("/root/world/env").call_deferred("add_child", new_leader_ball)

func set_bind_maps_and_rebind():
  var kbbm2 = {
    "slowmo":[[KEY_Z]],
    "radarzoom_close":[],
    "slowmo2":[ [KEY_X]],# [KEY_A]], #[[KEY_Q]], [KEY_SPACE],

    "shoot":[ [KEY_C]], #[KEY_S], [KEY_D] ],
    "repeat_shoot": [ [KEY_V]], # [[KEY_W]],
    "aim":[[KEY_SHIFT]], #[KEY_Z], [KEY_SUPER_L  ]], #[[KEY_SPACE]],
    "jump": [[KEY_SPACE]] , #[[KEY_TAB], [KEY_SHIFT] ],
    "kb_step_motion": [], #[[KEY_Z]],
    "throw": [ [KEY_F]], # [KEY_E]], # [[KEY_D], [KEY_L]],
    "pass_ball": [], #[[KEY_S]],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  var kbbm3 = {
    "slowmo":[[KEY_S], [KEY_SHIFT]],
    "radarzoom_close":[],
    "slowmo2":[ [KEY_C], [KEY_Z]],# [KEY_A]], #[[KEY_Q]], [KEY_SPACE],

    "shoot":[ [KEY_V]], #[KEY_S], [KEY_D] ],
    "repeat_shoot": [ [KEY_B]], # [[KEY_W]],
    "aim":[[KEY_X]], #[KEY_Z], [KEY_SUPER_L  ]], #[[KEY_SPACE]],
    "jump": [[KEY_SPACE]] , #[[KEY_TAB], [KEY_SHIFT] ],
    "kb_step_motion": [[KEY_Z]], #[[KEY_Z]],
    "throw": [ [KEY_F]], # [KEY_E]], # [[KEY_D], [KEY_L]],
    "pass_ball": [], #[[KEY_S]],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  var kbbm4 = {
    "slowmo":[[KEY_D]],
    "radarzoom_close":[],
    "slowmo2":[ [KEY_S]],# [KEY_A]], #[[KEY_Q]], [KEY_SPACE],

    "shoot":[ [KEY_C]], #[KEY_S], [KEY_D] ],
    "repeat_shoot": [ [KEY_C]], # [[KEY_W]],
    "aim":[[KEY_SPACE]], #[KEY_Z], [KEY_SUPER_L  ]], #[[KEY_SPACE]],
    "jump": [[KEY_SHIFT]] , #[[KEY_TAB], [KEY_SHIFT] ],
    "kb_step_motion": [], #[[KEY_Z]],
    "throw": [ [KEY_F]], # [KEY_E]], # [[KEY_D], [KEY_L]],
    "pass_ball": [], #[[KEY_S]],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  var kbbmok = {
    "jump": [[KEY_TAB]] ,
    "slowmo2":[ [KEY_Q]],
    "slowmo":[[KEY_SHIFT], [KEY_A], [KEY_W]],
    "shoot":[ [KEY_S], [KEY_D]],
    "repeat_shoot": [ [KEY_S]],
    "aim":[[KEY_SPACE]],
    "throw": [ [KEY_R]],
    "radarzoom_close":[],
    "kb_step_motion": [],
    "pass_ball": [],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  var kbbm_3 = {
    "jump": [[KEY_S]] ,
    "slowmo2":[ [KEY_E]],
    "slowmo":[[KEY_D]],
    "shoot":[ [KEY_F]],
    "repeat_shoot": [ [KEY_G]],
    "aim":[[KEY_SPACE]],
    "throw": [ [KEY_R]],
    "radarzoom_close":[],
    "kb_step_motion": [],
    "pass_ball": [],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  var kbbm = {
    "boost": [[KEY_D]],
    "jump": [[KEY_Q]] ,
    # "slowmo2":[ [KEY_W], [KEY_ALT]],
    "slowmo2":[ [KEY_W]],
    "slowmo":[],
    "shoot":[ [KEY_SPACE]], #, [KEY_1]
    "repeat_shoot": [ [KEY_S]], # , [KEY_2]
    "aim":[[KEY_2]],
    "throw": [ [KEY_E]],
    "radarzoom_close":[],
    "radarzoom_far":[],
    "kb_step_motion": [],
    "pass_ball": [],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  if gsvar.active_game_mode == "hix":
    kbbm = {
      # "boost": [[KEY_A]],
      "boost": [[KEY_S]],
      # "jump": [[KEY_TAB]] ,
      "jump": [[KEY_Q]] ,
      # "slowmo2":[ [KEY_W], [KEY_ALT]],
      # "slowmo2":[ [KEY_Q]],
      # "slowmo2":[ [KEY_Q]],
      "slowmo2":[ [KEY_W]],
      "slowmo":[],
      # "shoot":[ [KEY_W]], #, [KEY_1]
      "shoot":[ [KEY_E]], #, [KEY_1]
      # "repeat_shoot": [ [KEY_E]], # , [KEY_2]
      "repeat_shoot": [ [KEY_D]], # , [KEY_2]
      "aim":[[KEY_SPACE]],
      # "throw": [ [KEY_E]],
      "radarzoom_toggle":[[KEY_X]],
      # "radarzoom_far":[[KEY_S]],
      "switch_ball_cam":[[KEY_Z]],
      # "radarzoom_close":[[KEY_TAB]],
      "radarzoom_close":[[KEY_2]],
      # "radarzoom_close":[],
      "radarzoom_far":[[KEY_3]],
      "radarzoom_normal":[[KEY_1]],
      "kb_step_motion": [],
      "pass_ball": [],
      "cancel_throw": [],
      "left": [[KEY_LEFT]],
      "right": [[KEY_RIGHT]],
      "forward": [[KEY_UP]],
      "backward": [[KEY_DOWN]],
      "vsync_toggle": []
    }
    # kbbm["shoot"] = [ [KEY_E]]
    kbbm["throw"] = []

  var kbbmwasd= {
    "jump": [[KEY_SPACE]] ,
    "boost": [[KEY_W]] ,
    "slowmo2":[ [KEY_D]],
    "slowmo":[[KEY_D]],
    "shoot":[ [KEY_E]], #, [KEY_1]
    "repeat_shoot": [ [KEY_A]], # , [KEY_2]
    "aim":[[KEY_2]],
    "throw": [ [KEY_S]],
    "radarzoom_close":[],
    "radarzoom_far":[],
    "kb_step_motion": [],
    "pass_ball": [],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  var kbbm_alt = {
    "slowmo":[[KEY_S]],
    "radarzoom_close":[],
    "slowmo2":[  [KEY_F]],# [KEY_A]], #[[KEY_Q]], [KEY_SPACE],

    "shoot":[ [KEY_E]], #[KEY_S], [KEY_D] ],
    "repeat_shoot": [[KEY_G]], # [[KEY_W]],
    "aim":[[KEY_SHIFT]], #[KEY_Z], [KEY_SUPER_L  ]], #[[KEY_SPACE]],
    "jump": [[KEY_D]] , #[[KEY_TAB], [KEY_SHIFT] ],
    "kb_step_motion": [], #[[KEY_Z]],
    "throw": [[KEY_R]], # [KEY_E]], # [[KEY_D], [KEY_L]],
    "pass_ball": [], #[[KEY_S]],
    "cancel_throw": [],
    "left": [[KEY_LEFT]],
    "right": [[KEY_RIGHT]],
    "forward": [[KEY_UP]],
    "backward": [[KEY_DOWN]],
    "vsync_toggle": []
  }
  for a in kbbm:
    gsvar.kb_bind_map[a] = []
    for b in kbbm[a]:
      gsvar.kb_bind_map[a].append(b)
      gsvar.kb_bind_map[a].append(b + ["shift"])
      gsvar.kb_bind_map[a].append(b + ["alt"])
  gsvar.joy_bind_map = {
    "jump" : [[4], [1]], #[ [1], [7]],
    "shoot" : [[3]], # [],
    "repeat_shoot" : [[5]], #[[2]],
    "aim" : [[2]], #[[6]],
    "throw" : [[0]],# [ [0]],
    "pass_ball" : [], # [[3]],
    "slowmo" :  [[6], [7]], #[[3]] ,#[[4]],
    "slowmo2" : [  [6], [7]], #[[5], [7]],
    "ui_cancel" : [[9]]
  }
  gsvar.rebind()

func ttex():
  var inst = me
  var tank_color = inst.tank_color
  var tank = inst.get_node("body/Tank/Tank")
  var tank_mat = tank.get_material_override()
  print(tank_color)
  var tex = ResourceLoader.load("res://sprites/tanktex-" + tank_color + ".png", "", true)
  tank_mat.set_texture(0, tex)



func update_set_custom_ground(col, info=null):
  print(col)

func update_set_deadzone_size(dzs, info=null):
  gsvar.me.deadzone_bounds = dzs
  gsvar.me.create_mousebox()

func update_set_brightness(v, info=null):
  g.ss('brightness', v)
  t42()

func update_set_srgb(v, info=null):
  fx(7,v)

func update_set_contrast(v, info=null):
  g.ss('contrast', v)
  t42()

func update_set_saturation(v, info=null):
  g.ss('saturation', v)
  t42()

func update_set_enabled_fx(v, info=null):
  print("HORRA",v)
  print("HORRA",v)
  print("HORRA",v)
  for f in range(8):
    fx(f, v.has(f))

func setup_once():
  for i in g.store_get("temp_settings_inst").lines:
    g.conf_update(i.value, i)

func vs():
  OS.set_use_vsync(not OS.is_vsync_enabled())
  get_node("/root/world/gui/fps/vs").set_hidden(not OS.is_vsync_enabled())

func update_set_game_speed(sp, info=null, src=0):
  if not(net.is_primary or src==1):
    return
  if net.is_primary:
    net.rpc(self, 'update_set_game_speed', [sp])
  var norm_player_speed = me.normal_max_speed
  var norm_bvpi = 1/105.0
  gsvar.normal_max_speed = norm_player_speed * sp/ 100.0
  print(norm_player_speed * sp/ 100.0)
  for b in g.store_get("balls", []):
    b.ball_vel_per_iter = norm_bvpi * sp/ 100.0
    b.leader_ball.ball_vel_per_iter = norm_bvpi * sp/ 100.0
  OS.set_time_scale(1.0)

func update_set_mousebox_size(mbs, info=null):
  gsvar.me.motion_bounds = mbs
  gsvar.me.create_mousebox()

func t11():
  load_menu()

func load_menu(name="ingame_menu"):
  var menus_inst = g.store_get("menus_inst")
  var cc = menus_inst.get_node("CenterContainer")
  cc.show()
  for m in cc.get_children():
    m.hide()
  var menu = cc.get_node(name)
  menu.show()
  button_group_focus_index(menu, -1)
  return menu

func get_active_menu():
  var menus_inst = g.store_get("menus_inst")
  var cc = menus_inst.get_node("CenterContainer")
  for m in cc.get_children():
    if not m.is_hidden():
      return m

func button_group_focus_index(bg, idx=-1):
  if idx==-1 and g.is_null(bg.get_pressed_button_index()):
    idx = bg.get_pressed_button_index()
  else:
    idx = 0
  bg.get_button_list()[idx].grab_focus()

func hide_menus():
  var menus_inst = g.store_get("menus_inst")
  var cc = menus_inst.get_node("CenterContainer")
  for m in cc.get_children():
    m.hide()
  cc.hide()

func create_menus():
  if g._store.has("menus_inst"):
    g.store_get("menus_inst").queue_free()
    g._store.erase("menus_inst")
    call_deferred("create_menus")
    return
  var scn = load("scenes/menutests.tscn")
  var inst = scn.instance()
  g.store_set("menus_inst", inst)
  var menus = populate_ingame_menus()
  var gui = get_node("/root/world/gui")
  gui.add_child(inst)
  for m in menus:
    var m_group = ButtonGroup.new()
    m_group.set_name(m)
    inst.get_node("CenterContainer").add_child(m_group)
    m_group.hide()
    for i in menus[m]["_order_"]:
      var button = Button.new()
      m_group.add_child(button)
      button.set_text(i)
      button.set_toggle_mode(false)
      button.connect("pressed", self, menus[m][i][0], menus[m][i][1])
      var sep = HSeparator.new()
      m_group.add_child(sep)


func populate_menus():
  var menus = {}
  var main_menu = {
    "Join Server": ["load_menu", ["join_server_menu"]],
    "Start Server": ["load_menu", ["start_server_menu"]],
    "Practice": ["start_practice",[]],
    "Options" : ["settings_screen_menu", [true]],
    "Quit" : ["quit_game",[]],
    "_order_" : ["Join Server","Start Server","Practice","Options","Quit"]
  }
  menus["main_menu"] = main_menu
  var join_server_menu = {
    "London": ["start_game_remote", []],
    "Local": ["start_game_local", []],
    "Enter Address": ["load_menu" ,["enter_game_address_menu"]],
    "Return" : ["load_menu", ["main_menu"]],
    "_order_" : ["London","Local","Enter Address", "Return"]
  }
  menus["join_server_menu"] = join_server_menu
  return menus


func populate_ingame_menus():
  var menus = {}
  var ingame_menu = {
    "Resume": ["escape_pressed", []],
    "Fullscreen": ["fullscreen_toggle", []],
    "Options" : ["settings_screen_menu", [true, "ingame_menu", true]],
    "Check for Updates" : ["check_up",[]],
    "Leave Server" : ["leave_server",[]],
    "Quit" : ["quit_game",[]],
    "_order_" : ["Resume","Fullscreen","Options", "Check for Updates", "Leave Server", "Quit"]
  }
  menus["ingame_menu"] = ingame_menu
  return menus

func quit_game():
  gsvar.request_quit(false)

func leave_server():
  gsvar.request_quit()

func escape_pressed():
  gsvar.escape_pressed()

func action_click(action):
  Input.action_press(action)
  g.callv_later(self, "action_release", [action], 0.5)

func action_release(action):
  print("release")
  print(action)
  Input.action_release(action)

func join_array(a, d=''):
  var s = ""
  var n = -1
  for i in a:
    n+=1
    s += str(i)
    if n < a.size()-1:
      s += d
  return s



func settings_screen_menu(b=true, return_menu="main_menu", ingame_only=false):
  if b:
    if ingame_only:
      g.dbgentries.show()
    hide_menus()
    var tsi = g.store_get("temp_settings_inst")
    tsi.get_node("close_button").grab_focus()
    tsi.get_node("close_button").disconnect("pressed", self, "settings_return_to_menu")
    tsi.get_node("close_button").connect("pressed", self, "settings_return_to_menu", [return_menu])
    g.store_get("temp_settings_inst").show()
    gsvar.change_focus("GNC")

func settings_return_to_menu(menu_name):
  g.dbgentries.hide()
  g.store_get("temp_settings_inst").hide()
  load_menu(menu_name)

func load_settings_screen(show=false):
  if g._store.has("temp_settings_inst"):
    g.store_get("temp_settings_inst").queue_free()
    g._store.erase("temp_settings_inst")
    call_deferred("load_settings_screen")
    return
  var scn = load("scenes/settings.tscn")
  var inst = scn.instance()
  g.store_set("temp_settings_inst", inst)
  inst.set_name("settings_test")
  var gui = get_node("/root/world/gui")
  gui.add_child(inst)
  if not show:
    inst.hide()
  print(inst)

func t10():
  return g.store_get("temp_settings_inst")

func t12():
  var chatmsgs = get_node("/root/world/gui/chatBox/bg/chatMessages")
  chatmsgs.append_bbcode(parse_bbcode("\n[b]Hi[/b]"))
  return parse_bbcode(chatmsgs.get_bbcode())

func t13():
  reload_script(get_node("/root/world/gui/chatBox"))

func t14():
  g.store_set("ball_col_slow_factor", 0.65)

func t15():
  OS.dump_resources_to_file("resource_dump.txt")

func t16():
  mk_humus_cbm()

func t17():
  mk_cbm("mp_velcor")

func t18(arg=null):
  print("t18 called")
  var w = load("res://scenes/emptyworld.tscn").instance();
  g.call_deferred("store_set", "newworld", w)
  print(w)
  return w

func t18x(thr_id):
  print(["thrid is", thr_id])
  var output = [randi(), g.t()]
  OS.delay_msec(2000)
  call_deferred("emit_signal", "thread_finish", "t18x",thr_id, output)

func t18x_finish(out):
  print("in thread callback")
  print( out)

func in_thread_connect():
  self.connect( "thread_finish", self, "thread_finish_cb")

func itc():
  in_thread_connect()

func in_thread(fname="t18x"):
  var thr = Thread.new()
  var tid = randi()
  g.store_get( fname + "_thread_pool", {})[tid] = thr
  thr.start(self, fname, tid, 1)

func inth(fn="t18x"):
  in_thread(fn)

func thread_finish_cb(fname,thr_id, out):
  g.store_get( fname + "_thread_pool")[thr_id].wait_to_finish()
  g.store_get( fname + "_thread_pool").erase(thr_id)
  callv(fname + "_finish", [out])

func mock_get_up(commit="0827ca76e79cd6cbea7cafd265c688e30f257718"):
  gsvar.announce("fetching data..", 5, "2")
  var http_request = HTTPRequest.new()
  add_child(http_request)
  http_request.connect("request_completed", self, "_http_request_completed_get_upgg")
  http_request.set_download_file("update.zip")
  http_request.set_use_threads ( true)
  var error = http_request.request("http://45.32.180.51:8002/?commit=" + commit)

func _http_request_completed_get_upgg(result, response_code, headers, body):
  if result == 0:
    gsvar.announce("applying update!", 5, "2")

  else:
    gsvar.announce(["errrz",result, response_code, headers], 10)
  pass

func get_up(commit):
  gsvar.announce("fetching data..", 5, "2")
  var http_request = HTTPRequest.new()
  add_child(http_request)
  http_request.connect("request_completed", self, "_http_request_completed_get_up")
  http_request.set_download_file("update.zip")
  http_request.set_use_threads(true)
  var error = http_request.request("http://45.32.180.51:8002/?commit=" + commit)
func _http_request_completed_get_up(result, response_code, headers, body):
  if result == 0:
    gsvar.announce("applying update!", 5, "2")
    OS.execute("7za", ["x","-y", "update.zip"], true)

    g.file_write("commit_id", g.file_read("latest_commit"))
    var dir = Directory.new()
    dir.remove("latest_commit")
    dir.remove("update.zip")
    call_deferred("tmp")
    gsvar.announce("restart game for update to take effect\nF8 to dismiss", 0)
  else:
    gsvar.announce(["errrz"], 2)
  pass

func check_up(thr_id=null):
  var http_request = HTTPRequest.new()
  add_child(http_request)
  http_request.connect("request_completed", self, "_http_request_completed_check_up")
  gsvar.announce("checking for updates..", 5, "2")
  var error = http_request.request("http://45.32.180.51:8002/latest")
func _http_request_completed_check_up(result, response_code, headers, body):
  var cur = g.file_read("commit_id").strip_edges()
  var latest = body.get_string_from_ascii( ).strip_edges()
  if cur == "":
    gsvar.announce("not configured to receive updates", 2, "2")
    return
  elif cur != latest:
    if latest.length() != 40:
      gsvar.announce("error occurred - aborting", 5, "2")
      return
    g.file_write("latest_commit", latest)
    get_up(cur)
  else:
    # qann([latest,latest.length()], 5)
    gsvar.announce("no updates found!", 5, "2")
  pass



func t20():
  var sph =  get_node("/root/world/env/honeycomb5/Icosphere")
  return sph.get_material_override().get_shader_param("modulate")

func t21(reload=false):
  var cubemaps1 = ["ely_mountain", "ely_snow", "mp_impaler", "mp_midnight", "mp_nwo", "mp_petesoasis", "mp_plains", "mp_sorbin", "mp_utc", "sb_frozen", "ame_darkgloom", "ame_desert", "ame_rocky", "ame_siege", "darkskies", "ely_cloudtop", "ely_darkcity", "ely_hills", "ely_peaks", "hw_sahara", "ame_ash"]
  var cubemaps2 = ["mp_utc", "ame_darkgloom", "mp_midnight", "mp_nwo", "mp_petesoasis", "sb_frozen", "ame_desert", "ame_rocky", "ame_siege", "darkskies", "ely_cloudtop", "ely_darkcity", "ely_hills", "hw_sahara", "ame_ash", "ely_mountain"]
  var cubemps3 = ["mp_utc", "mp_midnight", "mp_nwo", "mp_petesoasis", "sb_frozen", "ame_desert", "ame_siege", "darkskies", "ely_hills", "hw_sahara"]
  var cubemaps4 = ["mp_utc", "mp_midnight", "mp_petesoasis", "ame_desert", "ame_siege", "darkskies", "hw_sahara"]
  var cubemaps = ["mp_nwo", "mp_utc", "mp_midnight", "mp_petesoasis", "ame_desert", "ame_siege", "hw_sahara","ely_darkcity","ely_cloudtop","darkskies","mp_sorbin"]

  var cubemaps6 = ["mp_utc", "mp_midnight", "ame_desert"]
  var nextidx = g.store_get("curcbm", -1)
  if reload and nextidx == -1:
    nextidx = 0
  if not reload:
    g.store_inc("curcbm", 1, cubemaps.size())
  select_cubemap(cubemaps[nextidx])

func anim_select_cubemap(cbmn="hw_sahara"):
  var d = 0.5
  if g.is_null(g.sg("cmtween")):
    var ntween = Tween.new()
    get_node("/root/world/env").call_deferred("add_child", ntween)
    g.ss("cmtween", ntween)
  var tween = g.sg("cmtween")
  tween.interpolate_property(get_node("/root/world/env").get_environment(), "background/energy", 0.25, 0.05, d, Tween.TRANS_LINEAR, Tween.EASE_OUT,0)
  tween.interpolate_callback ( self, d, "select_cubemap", cbmn)
  tween.interpolate_property(get_node("/root/world/env").get_environment(), "background/energy", 0.05, 0.25, d, Tween.TRANS_QUAD, Tween.EASE_IN,d)
  tween.start()
  pass

func select_cubemap(cbmn):
  print('loading cubemap : ', cbmn)
  OS.set_clipboard(cbmn)
  var cbm = load("res://cubemap/" + cbmn + ".cube")
  get_node("/root/world/env").get_environment().set_background_param ( 3, cbm )
  # get_node("/root/world/env/Spatial/Circle2").get_material_override().set_shader_param("reflect_map", cbm)
  pass

func nxgcol():
  var nextidx = g.store_get("curgcol", 0)
  var list = {
 "SeaGreen2": [Color(0,0.40625,0.244385,0.476196),1],
 "SteelBlue": [Color(0.299225,0.514249,0.722656,0.353765),2],
 "LightBrown": [Color(0.704688,0.658337,0.4,0.235373),5],
 "DarkRed": [Color(0.808594,0.142136,0.142136,0.353765),6],

  }
  var color = list.keys()[nextidx]
  # if list.keys().has(color):
  #   g.change_color_mesh(get_node("/root/world/env/Plane3"), list[color][0], true, 1,true)
  g.store_inc("curgcol", 1, list.size())

func newenv():
  var remaining = g.sg("remcolcombs", [])
  var tested = g.sg("testedcolcombs", {})
  if not g.is_null(g.sg("curenvcomb", null)):
    var lastcomb = g.sg("curenvcomb")
    tested[lastcomb[0]] = g.t() - lastcomb[1]
  var cubemaps = ["mp_nwo", "mp_utc", "mp_midnight", "mp_petesoasis", "ame_desert", "ame_siege", "hw_sahara","ely_darkcity","ely_cloudtop","darkskies","mp_sorbin"]
  var collist = g.opt_color_list()
  if remaining.empty():
    for cm in cubemaps:
      for col in collist:
        remaining.append([cm,col])
  var comb = remaining[randi() % remaining.size()]
  select_cubemap(comb[0])
  # g.change_color_mesh(get_node("/root/world/env/Plane9"), collist[comb[1]][0], true, 1,true)
  g.ss("curenvcomb", [comb, g.t()])
  remaining.erase(comb)

func testwr():
  var combs =  [
  ["mp_petesoasis", "SeaGreen"],
  ["ame_desert", "Navy"],
  ["mp_utc", "SeaGreen2"],

  ["ame_siege", "SeaGreen2"],
  ["mp_nwo", "DarkRed"],
  ["ely_darkcity", "Navy"],
  ["mp_sorbin", "Navy"],
  ["darkskies", "Purple"],
  ["mp_sorbin", "DarkOrange"],
  ["mp_midnight", "Black"],
  ]
  print(["combs cound", combs.size()])
  var res = {}
  var comb
  for i in range(100000):
    var selrange = pow(randf() , 0.5) * combs.size()
    comb = combs[randi() % min(combs.size(), 1 + int(selrange))]
    if not res.has(comb):
      res[comb] = 0
    res[comb] += 1
  print(g.pretty_str(res))

func getcombs():
  var combs
  if gsvar.active_game_mode == "basketball":
    combs = [
    ["ely_cloudtop", "LightBrown"],
    ]
  else:
    combs = [
    # ["darkskies", "LightBrown"],
    # ["hw_sahara", "LightBrown"],
    ["ely_cloudtop", "LightBrown"],
    # ["ame_siege", "LightBrown"],
    # ["ely_cloudtop", "LightBrown"],
    ]
  return combs

func rgenv(comb=null): # rand good env
  var combs =  getcombs()
  if g.is_null(comb):
    var selrange = pow(randf() , 0.35) * combs.size()
    comb = combs[randi() % min(combs.size(), 1 + int(selrange))]
  elif typeof(comb) == 2:
    comb = combs[comb]
  elif comb == "next":
    var cur = g.sg("curenvcomb2",-1)
    cur = (cur+1) % combs.size()
    comb = combs[cur]
    g.ss("curenvcomb2", cur)
  elif comb == "nextrand":
    var cur = g.sg("curenvcomb3",-1)
    if cur == combs.size() - 1:
      g.ss("randenvcombs", aryrandomize(combs))
    var list = g.sg("randenvcombs", aryrandomize(combs))
    cur = (cur+1) % combs.size()
    comb = list[cur]
    g.ss("curenvcomb3", cur)
  var collist = g.opt_color_list()

  print(comb)
  anim_select_cubemap(comb[0])
  var col = collist[comb[1]][0]
  # g.change_color_mesh(get_node("/root/world/env/Plane3"), col, true, 1,true)
func aryrandomize(ary):
  var tmp = []
  var r = []
  for i in ary:
    tmp.append([i,randi()])
  tmp.sort_custom(self,"randsort")
  for i in tmp:
    r.append(i[0])
  return r

func randsort(a,b):
  return a[1] < b[1]

func t23():
  return get_node("/root/world/env").get_environment().get_background_param(3)

func t24():
  cb()
  var t= [me.get_translation(), Vector3(-11.745366, 32.240334, -56.632698)]
  ball().throw(t[0], t[1])

func t25():
  var hoopsc = 2.21 # 1.21 # 1.4 #0.9 # 0.78
  hoopsc = 1.35 + 0.4 - 0.1 - 0.05  - 0.1 - 0.03 -0.1 - 0.15 - 0.051 + 0.3#1.21 # 1.21 # 1.4 #0.9 # 0.78
  get_node("/root/world/env/hoopsouth").set_scale(Vector3(hoopsc,hoopsc,hoopsc))
  get_node("/root/world/env/hoopnorth").set_scale(Vector3(hoopsc,hoopsc,hoopsc))

func t60():
  var hoopsc = 2.21 # 1.21 # 1.4 #0.9 # 0.78
  hoopsc = 1.0 - 0.05#0.9 # 0.78
  get_node("/root/world/env/tut1/goal").set_scale(Vector3(hoopsc,1-0.2,1))
  get_node("/root/world/env/tut1/goal2").set_scale(Vector3(hoopsc,1-0.2,1))

func t61():
  var hoopsc = 2.21 # 1.21 # 1.4 #0.9 # 0.78
  hoopsc = 2#0.9 # 0.78
  get_node("/root/world/env").set_scale(Vector3(hoopsc,hoopsc,hoopsc))
  get_node("/root/world/env").set_scale(Vector3(hoopsc,hoopsc,hoopsc))


func roundf(f, n=2, x=10):
    f *= (10.0/x)
    var r = round(pow(10,n)*f) * 1.0 / pow(10,n)
    r = r/(10.0/x)
    return r

func roundfvec3(vec,n=2,x=10):
  return Vector3(roundf(vec.x,n,x),roundf(vec.y,n,x),roundf(vec.z,n,x))

func t26():
  var sc = 2.5#3.2 # 2.2
  if gsvar.active_game_mode == "basketball":
    sc = 2.2 + 0.5 - 0.05 - 0.05 + 0.4 - 0.4 -0.2 - 0.05 + 0.05 - 0.2 -0.1 -0.1 + 0.5# 2.2
    sc = 3
  else:
    sc = 2.2 + 0.5 - 0.05 - 0.05 - 0.32 -0.025 - 0.2 -0.2 - 0.2 - 0.125 # 2.2
    sc = 2
  ball().get_node("body").set_scale(Vector3(3.2,3.2,3.2))
  ball().set_scale(Vector3(sc,sc,sc))
  ball().leader_ball.set_scale(Vector3(sc,sc,sc))
  ball().leader_ball.hide()
  ball().ball_h_slowdown = 0 # 0.09
  ball().leader_ball.ball_h_slowdown = ball().ball_h_slowdown
  if gsvar.active_game_mode == "basketball":
    ball().ball_gravity = Vector3(0,-80+15 + 10 - 5 + 5 - 5 + 4 -5 - 10,0)
  else:
    ball().ball_gravity = Vector3(0,-80+15 + 10 - 5 + 5,0)
  ball().leader_ball.ball_gravity = ball().ball_gravity

func t27():
  return g.rangediv2(240,120)

func t28():
  var r = []
  r.append(g.time_elapsed(ball(), "last_throw"))
  r.append(ball().ball_hit_floor)
  return r

func t29():
  return get_node("/root/world/env/hoopsouth").get_translation()

func t30():
  return
  var sc = 0.12 + 0.05 + 1.43 + 0.07 - 0.05 - 0.05#1.4 # 1.5 # 1.35
  if gsvar.active_game_mode == "basketball":
    sc = 0.12 + 0.05 + 1.43 + 0.07 - 0.05  + 0.1#1.4 # 1.5 # 1.35
    sc = 1.3
  else:
    sc = 0.12 + 0.05 + 1.43 + 0.07 - 0.05 - 0.1 #1.4 # 1.5 # 1.35
    sc = 1.0
    sc = Vector3(3.2/4,3.2/4,1)
    # sc = Vector3(1,1,1)
    # sc = 1.0
  scale_tank(me,sc)
  for b in gsvar.all_players():
    scale_tank(b,sc)


func scale_tank(t,sc):
  pp(["scaling tank", t.get_path(),sc])
  sc = Vector3(3.2/4, 3.2/4,1) * sc
  var body_sc = Vector3(0.768952*0.9, 0.768952 * 0.8, 0.768952) * sc
  var col_sc = Vector3(2.18827, 2.22735, 4.68916) * sc
  var hit_sc = Vector3(2*4/3.2,2,2) * sc * 1.15
  var area_sc = Vector3(1, 1.1, 1) * sc
  t.body.set_scale(body_sc)
  t.get_node("col_capsule").set_scale(col_sc)
  t.get_node("hit_area").set_scale(hit_sc)
  t.get_node("Area").set_scale(area_sc)
  t.tank_size = t.get_node("col_capsule").get_scale() * t.get_node("col_capsule").get_shape().get_extents()

func tr(obj=me):
  return obj.get_translation()

func trg(obj=me):
  return obj.get_global_transform().origin

func tg(obj=me):
  return obj.get_global_transform()

func hn():
  return get_node("/root/world/env/hoopnorth")

func hs():
  return get_node("/root/world/env/hoopsouth")

func last_ball_pos():
  ball().set_translation(ball().prev_throw[0])

func mod_throw_input():
  var b = ball()
  if b.owner != net.uid:
    return
  reset_mod_throw()
  if Input.is_action_pressed("jump"):
    b.throw_high=true
  if Input.is_action_pressed("slowmo2"):
    b.throw_low = true
  if Input.is_action_pressed("jump"):
    b.pass_far=true


func reset_mod_throw():
  var b = ball()
  b.throw_high=false
  b.throw_low=false
  b.pass_far=false
  b.pass_near=false

func calc_my_throw(power):
  mod_throw_input()
  var p
  var b = ball()
  if b.owner == -1:
    p = me
  else:
    p = gsvar.player_by_id(ball().owner)
  var p_rot = p.body_rotation
  var p_dir = Vector3(sin(p_rot),0,cos(p_rot))
  var p_pos = p.get_global_transform().origin
  var lv = p.get_linear_velocity()
  var high = Input.is_action_pressed("jump") and p.stick_y > 0
  var low = Input.is_action_pressed("jump") and p.stick_y < 0
  return calc_throw(lv, p_pos, p_dir, power, b.throw_high, b.throw_low, p.in_2pts_area, p.in_key_area)

func calc_throw(v0, pos0, dir0, power, high=false, low=false, in_arc=false, in_key=false):
  power *= (1.15*0.65)
  var add_p_vel = (v0 * Vector3(0.3,0.9,0.3))
  add_p_vel.y = clamp(add_p_vel.y, -6,6)
  power = pow(power, 0.59)
  power *= 1.1
  if low:
    power = power * 1.6 #1.65 # 1.7 #2.3
  elif in_key:
    power = power * 0.9 * 0.9 * 0.9
  elif in_arc:
    power = power * 1

  var throw = Vector3(dir0.x,1.5+0.25,dir0.z).normalized()*Vector3(1,1,1).length() * power * 6
  throw += add_p_vel*2
  var a = Vector3(1,1.5+0.1+0.1,1).normalized()*Vector3(1,1,1).length()
  if high:
    throw *= a
  if low:
    throw *= Vector3(1,0.45,1).normalized()*Vector3(1,1,1).length()
  var t_pos = pos0  + Vector3(0,7,0) + dir0 * 5
  t_pos.x = min(t_pos.x, 399.9)
  t_pos.z = min(t_pos.z, 399.9)
  if high:
    t_pos += g.store_get("highthrowbackunits", -3) *dir0
    t_pos += Vector3(0,2.2+0.3,0)
  return [t_pos,throw]

func rs():
  ball().ball_reset()
  ball().resync_motion()

func mp():
  var lb = ball().leader_ball
  return [lb.motion_path, lb.remote_motion_path, ball().motion_path_cursor]

func syt(v=400):
  me.syncticks=v

func rotate_ball():
  var b = ball()
  var rmod
  if b.velocity.y == 0:
    rmod = 0.009 * pow(b.velocity.length(), 0.4) * 0.07 * 15
  else:
    rmod = b.spindir * min(pow(b.velocity.length(), 0.7), 500) / ((5-1) * 270)
  var axis = Vector3(0,1,0).cross(b.velocity).normalized()
  if axis.length() == 0:
    return
  b.get_node("body").global_rotate(-axis,PI*rmod)
func calc_ball_motion(base_motion, sim=false, t=null):
  if gsvar.active_game_mode == "football":
    return calc_ball_motion_football(base_motion, sim,t)
  else:
    return calc_ball_motion_basketball(base_motion, sim,t)

func calc_ball_motion_football(base_motion, sim=false, t=null):
  var v = base_motion[1]
  var b = ball()
  if sim:
    b = b.leader_ball
  if g.is_null(t):
    t = (g.t() - base_motion[2]) / 1000.0
  t = int(t*1000)
  if   sim:
    t = 30 * (t/30) ## this made HUGE difference ## 17
  t = t / 1000.0
  t *= g.store_get("ball_speed_mul", 1.3)
  t *= OS.get_time_scale()
  if sim:
    t *= 2
  var bg =  b.ball_gravity.y

  var ha = -10 +7 #-0
  var rolling_change = false
  if b.rolling or  (abs(v.y) < 10 and base_motion[0].y < 7):
    bg= 0
    if not b.rolling:
      rolling_change = true
    b.rolling = true
    ha = -80 + 30 + 25 -10 # -35
    ha = -20
    v.y = 0
  if b.rolling:
    g.scrn_dbg("izrollin"+ str(sim), 1)
  else:
    g.scrn_dbg("izrollin"+ str(sim), 0)
  var hdir = atan2(v.z, v.x)
  g.scrn_dbg("hhdir", hdir)
  var nv = Vector3(
  v.x+ha*t*cos(hdir), v.y + bg*t, v.z+ha*t*sin(hdir)
  )
  if sign(nv.x) != sign(v.x):
    nv.x = 0
  if sign(nv.z) != sign(v.z):
    nv.z = 0

  var m = Vector3(
    v.x*t + 0.5*ha*t*t*cos(hdir),
    v.y*t + 0.5*bg*t*t,
    v.z*t + 0.5*ha*t*t*sin(hdir)
  )
  g.scrn_dbg("newmotiont", m)
  if b.rolling:
    m[1] += 0.05
  var motion = [roundfvec3(base_motion[0]+m,1), roundfvec3(nv,1)]
  if not sim:
    var last_calc_motion = g.sg("last_calc_motion", motion)
  return motion


func calc_ball_motion_basketball(base_motion, sim=false, t=null):
  var v = base_motion[1]

  if g.is_null(t):
    t = (g.t() - base_motion[2]) / 1000.0
  t = int(t*1000)
  if   sim:
    t = 30 * (t/30) ## this made HUGE difference ## 17
  t = t / 1000.0
  t *= g.store_get("ball_speed_mul", 1.3)
  t *= OS.get_time_scale()
  if sim:
    t *= 2
  var bg =  ball().ball_gravity.y

  var ha = 0 #-0
  if abs(v.y) < 10 and base_motion[0].y < 10:
    bg= 0
    ball().rolling = true
    ha = -25
    v.y = 0

  var hdir = atan2(v.z, v.x)
  g.scrn_dbg("hhdir", hdir)
  var m = Vector3(
    v.x*t + 0.5*ha*t*t*cos(hdir),
    v.y*t + 0.5*bg*t*t,
    v.z*t + 0.5*ha*t*t*sin(hdir)
  )

  var nv = Vector3(
  v.x+ha*t*cos(hdir), v.y + bg*t, v.z+ha*t*sin(hdir)
  )
  var motion = [roundfvec3(base_motion[0]+m,1), roundfvec3(nv,1)]
  if not sim:
    var last_calc_motion = g.sg("last_calc_motion", motion)
  return motion

func check_facing(dir, pos):
  return dir.dot(pos) > 0

func throw_vis_hoop():
  pass

func throw_vis_point():
  pass


func throw_vis(power, label="basket", target_point=null):
  var th = ball().calc_my_throw(power)
  th.append(g.t())
  var t_pos = th[0]
  var throw = th[1]
  if g.is_null(target_point):
    var hoop_s = get_node("/root/world/env/hoopsouth").get_translation() - Vector3(0,0,0.0)
    var hoop_n = get_node("/root/world/env/hoopnorth").get_translation() + Vector3(0,0,0.0)
    var ang_s = abs(g.xz(hoop_s - me.get_translation()).angle_to(g.xz(throw)))
    var ang_n = abs(g.xz(hoop_n - me.get_translation()).angle_to(g.xz(throw)))
    g.scrn_dbg("angless", [ang_s, ang_n])
    target_point = hoop_s
    if ang_n < ang_s:
      target_point = hoop_n
  var v2 = g.xz(target_point - me.get_translation())
  g.scrn_dbg("throw angle", v2.angle_to(g.xz(throw)))

  var bg =  ball().ball_gravity.y
  var sss =  1 #120/105.0 #0.72 ? # 0.75 weak#0.77 weak
  var vy = throw.y * sss
  var vh = g.xz(throw).length()
  var p = (t_pos.y - (target_point.y - 1))
  var flight_t = (-vy -sqrt(pow(vy,2) - 2 * bg*p))/(bg)
  g.store_set("last_ft", flight_t)
  if flight_t > 10000:
    return
  flight_t /= (g.store_get("ball_speed_mul")*OS.get_time_scale())
  var motion = calc_ball_motion(th,false,flight_t)
  var h_disp = vh * flight_t
  h_disp = g.xz(motion[0]  - t_pos).length()

  var hoop_dist = g.xz(target_point - t_pos).length()
  var addx = hoop_dist * 2
  var gui_pos_x = 2 * (((h_disp+addx)/(hoop_dist+addx))-0.5) * 100
  get_node("/root/world/gui/spower/percent").set_value(gui_pos_x)
  if gui_pos_x > 104:
    get_node("/root/world/gui/spower/toomuch").show()
  else:
    get_node("/root/world/gui/spower/toomuch").hide()
  var diff = h_disp - hoop_dist #hoop_dist - h_disp
  if abs(v2.angle_to(g.xz(throw))) > 0.03:
    return
  if diff > -2 and (label != "basket" or diff < 10):
    print(['base throw', th])
    print(['flight t', flight_t])
    th.append(flight_t)
    var m = calc_ball_motion(th, false, flight_t)
    print(['motion at ty', m])
    print(['extra info', vh, hoop_dist, power, diff])
    g.time_since_up(ball(), "last_bang_" + label)

  print(["should bang", diff, h_disp])
  if diff > -14 and (label != "basket" or diff < 10 or (ball().owner != net.uid)):
    g.time_since_up(ball(), "last_pre_bang_" + label)
  g.ss("bang_diff", diff)

func soccer_goal(area):
  if area.get_path() == "/root/world/env/Ball/Ball2":
    g.scrn_dbg("goal_in time", [g.t()])
    var goingin = ball().velocity.dot(ball().get_translation()) > 0
    if goingin:
      soccer_goal_2(area)

func soccer_goal_2(area,cid=0):
  var b = ball()
  var st = b.st
  if not (net.is_primary or cid == 1):
    return
  g.store_set("last_goal_time", g.t())
  g.store_get("goal_times", []).append(g.t())
  if net.is_primary and  b.last_owner > -1:
    var scorer = gsvar.player_by_id(b.last_owner)
    var scorer_name = scorer.get_object_name()
    var pts = 1
    if not st.scorers.has(scorer_name):
      st.scorers[scorer_name] = 0
    if b.get_translation().z > 0:
      g.report("green score", [], 0 , 1000, {"only":false})
      st.green_score += pts
    else:
      st.red_score += pts
      g.report("red score", [], 0 , 1000, {"only":false})

    st.scorers[scorer_name] += pts
    var dunk = false
    net.rpc_sync(b, "update_scores", [st.red_score, st.green_score])
    net.rpc_sync(b, "announce_goal", [scorer_name, pts, st.scorers[scorer_name], dunk])


func t31():
  print( me.get_node("Area").get_scale())
func bown():
  return gsvar.player_by_id(ball().owner)

func t32():
  return bown().control.action_manager.current_action()

func t33():
  return ball().leader_ball.motion_path

func t34():
  return bot().control.action_manager.current_action()

func t35():
  var a = Vector3()
  var b = Vector3(a)
  b.x = 1
  return a.x

func t36():
  var ownedball = gsvar.player_by_id(ball().owner).get_node("body/ownball")
  return ownedball.get_translation()

func t37(delta=1/60.0, snds=null):
  if g.is_null(snds):
    snds = g.sounds
  if g.is_null(g.sg("tmpvoice")):
    g.ss("tmpvoice", snds.play("425268__77pacer__airplane-tank-engine-sound"))
    g.ss("tmpvoice_p", 0)
  var t = max((abs(gsvar.me.speed_percent) * 10.5 ), 0.7)
  var a = max(lerp(g.sg("tmpvoice_p"), t, delta * 10), 0.1) + randf() / 30
  g.ss("tmpvoice_p", a)
  snds.voice_set_pitch_scale(g.sg("tmpvoice"), a )

func t38(x=5):
  g.ss("tmpvoice", null)
  me.get_node("/root/world/StreamPlayer").set_volume_db(x)

func t39(player, delta):
  return
  var snds = player.engine_sound
  var spid = str(player.pid)
  if g.is_null(g.sg("tmpvoice" + spid)):
    g.ss("tmpvoice" + spid , snds.play("425268__77pacer__airplane-tank-engine-sound"))
    g.ss("tmpvoice_p" + spid, 0)
  var t = max((abs(player.speed_percent) * 0.91 * 0.2 ), 0.01)
  var a = max(lerp(g.sg("tmpvoice_p"+ spid), t, delta * 10), 0.1) + randf() / 30
  g.ss("tmpvoice_p"+ spid, a)
  snds.voice_set_pitch_scale(g.sg("tmpvoice"+ spid), a*0.7*0.55 )
  snds.voice_set_volume_scale_db(g.sg("tmpvoice"+ spid), -12 + 15 )

func t40():
  return me.camera_instance.unproject_position(ball().get_translation())
func arrow_follow_target(sw=false):
  var b
  if not g.is_null(g.sg("follow_target", null)):
    b = g.sg("follow_target")
  elif not g.sg("balls").empty():
    b = ball()
    if b.owner != -1:
      b = gsvar.player_by_id(b.owner)
  else:
    return
  var ball_pos = b.get_translation()
  var look_at = ball_pos
  var rel_p = me.camera_instance.unproject_position(look_at)
  var vprect = me.camera_instance.get_viewport().get_rect().end
  var behind = me.camera_instance.is_position_behind(look_at)
  if behind:
    rel_p = me.camera_instance_b.unproject_position(look_at)
    rel_p.y += vprect.y
    rel_p.x = vprect.x - rel_p.x

  var point = Vector2(clamp(rel_p.x,0,vprect.x), clamp(rel_p.y,0,vprect.y))
  var arrow = me.get_node("body/target_arrow")
  var orig = Vector3(0, 10, 8)
  arrow.set_translation(orig )
  arrow.global_translate(-g.vec3powv3(ball_vec(), Vector3(0.6, 0.5,0.5))/1.3)
  arrow.look_at(look_at, Vector3(0,1,0))
  var arrow_mat = arrow.get_node("Cone").get_mesh().surface_get_material(0)
  arrow_mat.set_fixed_flag(0,true)
  return [point, rel_p]

func ball_vec():
  return (me.get_translation() - ball().get_translation())

func pos2mulf(pos,f , vprect=null):
  var abspos = pos - vprect*0.5
  var absmul = abspos * f
  return absmul + vprect*0.5

func pivrot(obj=ball(), deg=PI, point=Vector3(), axis=Vector3(0,1,0)):
  pass
  var transform = obj.get_transform()
  var vec = obj.get_translation() - point
  var pivot_transform = Transform(transform.basis, point)
  transform = pivot_transform.rotated(axis, deg).translated(vec/obj.get_scale())
  obj.set_transform(transform)
  return [obj.get_translation(), transform.origin]

func t42():
  var env = get_node("/root/world/env").get_environment()
  var vals = [0.73,1.3,1.23]
  vals = [0.73,1.3,0.1]
  vals = [0.53,1.3,0.4]
  vals = [1.8,1.2,2.2]
  vals = [1.4,1.2,1.2]
  vals = [0.7,1.3,0.3] #
  vals = [0.6,1.1,1] #
  vals = [1.3,1.3,0.7] # no srgb
  vals = [g.sg('brightness',1),g.sg('contrast',1),g.sg('saturation',1)]
  env.fx_set_param( env.FX_PARAM_BCS_BRIGHTNESS, vals[0] )
  env.fx_set_param( env.FX_PARAM_BCS_CONTRAST, vals[1] )
  env.fx_set_param( env.FX_PARAM_BCS_SATURATION, vals[2] )
  return env

func t43():
  var group = get_node("/root/world/gui/on_screen_msg_group2")
  group.add_msg("t43" , 2)
  return group

func t44():
  var osm_obj = load("res://scenes/on_screen_msg.tscn")
  var inst = osm_obj.instance()
  inst.text = "test"
  inst.duration = 6
  return inst

func t45():
  var group = get_node("/root/world/gui/on_screen_msg_group")
  for c in group.layout.get_children():
    c.queue_free()

func get_color_mesh(obj):
  var mesh
  var mat
  if obj.has_method("get_mesh"):
    mesh = obj.get_mesh()
    if not g.is_null(mesh):
      var surfs = mesh.get_surface_count()
      if surfs > 0:
        mat = mesh.surface_get_material(0)
        if !g.is_null(mat):
          var col = mat.get_parameter(0)
          return col

func t46():
  print( get_color_mesh(get_node("/root/world/env/Plane9")))
  OS.set_clipboard( str(get_color_mesh(get_node("/root/world/env/Plane9"))))
  return get_color_mesh(get_node("/root/world/env/Plane9"))

func t47():
  get_node("/root/world/gui").set_opacity(1)
  return get_node("/root/world/gui").edit_get_state()

func t48():
  ball().leader_ball.velocity = Vector3()

func t49(idx=-1):
  me.follow_player = gsvar.get_players()[idx]

func t50():
  return (Vector3(5.204635, 34.71666, 342.874878) - Vector3(4.805259, 35.004017, 343.088379)).length()

func t51():
  var ln = Vector3(0, 1, 0)
  var vel = Vector3(23.045891, 64.671394, 28.540243)
  return vel - 2*(vel.dot(ln))*ln

func t52():
  var color = Color(randf(),randf()*2,randf()*8,1)
  print(color)
  OS.set_clipboard(str(color))
  color_ball(color)

func color_ball(color):
  color_mesh(ball().get_node("body").get_children()[0].get_children()[0], color)

func ws():
  OS.set_window_size(Vector2(1280,720))
  OS.set_window_position(Vector2(215,5))

func t53():
  var colors = [
 Color(0.805076,1.948665,0.657503,1),
 Color(0.663112,0.930086,0.180432,1),
 Color(0.877608,0.830636,2.343591,1),
]
  var idx = randi()%colors.size()
  gsvar.announce(["good iddx", idx], 4, "2")
  color_ball(colors[idx])

func t54():
  var output = []
  g.ss("output", output)
  var pid = OS.execute('../patch', ["--help"], false, output)

func t55(reload=false):
  var conf = g.sg("testconf",null)
  if reload or g.is_null(conf):
    conf = ConfigFile.new()
    var err = conf.load("res://defaults.cfg")
    g.ss("testconf", conf)
  return conf

func p():
  if g.sg("no_pause",false):
    get_tree().set_pause(false)
    return
  get_tree().set_pause(not get_tree().is_paused())

func py():
  get_tree().set_pause(true)

func nop():
  g.ss("no_pause", !g.sg("no_pause",false))
  if g.sg("no_pause"):
    get_tree().set_pause(false)
  # else:
  #   get_tree().set_pause(true)

func modify_msg(msg):
  var linesnum = msg.get_text().split("\n").size()
  msg.set_custom_minimum_size(Vector2(600,30 + linesnum*30))
  msg.set_tab_size(4)
  call_deferred("post_mod_msg", msg)

func post_mod_msg(msg):
  msg.get_node("panel").set_size(msg.get_size()*1)

func fxp(param):
  var env = get_node("/root/world/env").get_environment()
  return env.fx_get_param(param)

func set_fxp(param,v):
  var env = get_node("/root/world/env").get_environment()
  env.fx_set_param(param, v)

func player_list():
  for p in gsvar.get_players():
    get_node("/root/world/gui/chatBox").add_message(p.player_name)

func parse_bbcode(text):
  var parser = get_node("/root/world/gui/chatBox/bg/bbcode_parser")
  parser.set_bbcode(text)
  return parser.get_text()

func test_settings(y):
  if g._store.has("menus_inst"):
    if y:
      var center = load_menu()
    g.store_get("menus_inst").get_node("CenterContainer").set_hidden(!y)

func player_got_hit(pid, pos, mid, killed_pid):
  print([pid, pos, mid, killed_pid])
  var b = ball()
  if ! gsvar.is_local_player(killed_pid):
    return
  gsvar.player_by_id(killed_pid).sounds.play("boss_hit")
  if killed_pid != b.owner:
    return
  var shooter = gsvar.player_by_id(pid)
  var lv
  var killed = gsvar.player_by_id(killed_pid)
  if pid == killed_pid:
    lv = Vector3() - killed.get_translation()
  else:
    lv = shooter.get_translation() - killed.get_translation()
  g.report("hit diff", [pid, killed,shooter.get_translation(), killed.get_translation(), lv],1,0, {"only":false})
  var throw = lv
  g.sounds.play("ball_taken")
  b.throw(killed.get_translation() + Vector3(0,10,0), throw)

func clip():
  OS.set_clipboard( get_parent().history[1])

func play_ball_col_sound(motion, curvel):

  if ball().get_translation().y < 10 and not ball().rolling:
    var voice = play_ball_bounce_sound()
    var scdb = (motion[1].length()/(3.5 + 4) - 12 - 5 + 5)
    ball().create_ball_ripple(clamp(scdb/20, 1, 4))
    ball().sounds.voice_set_volume_scale_db(voice, scdb)
  if abs(abs(motion[0].z) - 340.7) < 0.5:
    var voice = g.sounds.play("bboard")
    g.sounds.voice_set_volume_scale_db(voice, -9)
  if abs(motion[0].y) < 42  and abs(motion[0].y) > 32 and abs(motion[0].z) < 340.5 and motion[1].length() > 20 and abs(curvel.y - motion[1].y ) > 30:
    var voice2 = ball().sounds.play("hit")
    var scdb = (curvel.length()/4 - 15)
    ball().sounds.voice_set_volume_scale_db(voice2, scdb )

func play_ball_bounce_sound():
  var num = g.sg("__sound_num",[0,0])
  if num[0] % 5 == 0:
    num[0] = 0
    num[1] = 1 + randi() % 50
  num[0] += 1
  num[1] = 48# 48 #39# 49 #10 #32 # 22
  var snds =  [10] #[27 17 22 , 31, 43, 49, 10]
  num[1] = snds[randi() % snds.size()]
  var n = "%02d" % [ 1 + randi() % 3]
  var v = ball().sounds.play("SFX_BasketBall_0009" )
  return v

func play_ball_touch_sound():
  var v = ball().sounds.play("swoosh" )
  return v
  var voice = ball().sounds.play("boss_hit_") # Explosion15 , Balloon Pop 1 , boss_hit_ bouncexxx
  ball().sounds.voice_set_volume_scale_db(voice, 10)
func mod_turning_percent(tank,a):

  if Input.is_action_pressed("slowmo2"):
    tank.turning_percent = lerp(tank.turning_percent, a, 0.3)
  else:
    tank.turning_percent = a

func mod_input(tank,delta):

  g.scrn_dbg("frozen_turn", tank.frozen_turn)
  g.scrn_dbg("live_tp", tank.turning_percent)
  g.scrn_dbg("elevation", tank.get_translation().y)
  tank.max_speed = gsvar.normal_max_speed * tank.max_speed_mod
  tank.speed_modifier = 1.0
  tank.t_speed_modifier = 1.0
  tank.s_speed_modifier = 1.0
  # if not tank.phys.resting:
  #   if abs(tank.turning_percent - tank.t_turning_percent) > 0.1:
  #     g.scrn_dbg("turning_percent2",[tank.turning_percent, tank.t_turning_percent, delta])
  #     var new_tp = lerp(tank.turning_percent, tank.t_turning_percent, delta * g.sg("airturn_lerp", 12))
  #     tank.turning_percent = new_tp

  #     if tank.turning_percent > 10:
  #       pass
  #     tank.frozen_turn =  tank.turning_percent /  -tank.max_turning
  if tank.is_bot:
    return
  if tank.phys.resting:
    tank.t_turning_percent = tank.turning_percent
    if Input.is_action_pressed("slowmo2"):
      tank.t_brake_mod -= 0.75 * delta
      tank.t_brake_mod = max(tank.t_brake_mod, 0.3)
      tank.t_brake_mod = min(tank.t_brake_mod, 0.8)
      # tank.t_brake_mod = 0.0
      # qann("boom")
    else:
      tank.t_brake_mod += 8 * delta
      tank.t_brake_mod = min(tank.t_brake_mod, 1.0)
    tank.t_speed_modifier *= tank.t_brake_mod
    if  Input.is_action_pressed("slowmo2"):
      if tank.s_brake_mod > 0.9:
        # tank.s_brake_mod = 0.9 - 0.5
        tank.s_brake_mod = 0.84
      tank.s_brake_mod -= g.sg("brake_speed", 0.75) * delta
      tank.s_brake_mod = max(tank.s_brake_mod, 0.4) #0.55)#0.65) # 0.3)
      # qann("boom")
    else:
      tank.s_brake_mod += 8 * delta
      tank.s_brake_mod = min(tank.s_brake_mod, 1.0)
    tank.s_speed_modifier *= tank.s_brake_mod
  tank.local_input[0] = tank.force_jump

func air_turn(tank,dir=0,delta=6.0/(10.0*OS.get_iterations_per_second())):
  delta=6.0/(10.0*OS.get_iterations_per_second())
  # gsvar.announce(["ara"], 1)
  if not g.sg("airturn_enabled", true):
    return
  var maxaerialturn = 3.5#8#6 #5 # 4
  if dir == 0 and abs(tank.stick_x) < tank.deadzone_bounds:
    return
  print("asdad")
  if dir == 0:
    dir = 1
    if tank.stick_x > 0:
      dir = -1
  var ownball=false
  if ownball:
    tank.t_turning_percent = dir * min(  1.5 / pow(tank.s_brake_mod, 3.5), 3)
    gsvar.announce(["ttp", tank.t_turning_percent],1)
  else:
    var orig_tp = tank.turning_percent
    if sign(dir) != sign(orig_tp):
      orig_tp *= 0.4
    tank.t_turning_percent = orig_tp + dir* delta  * 140 #120 #220#300#150 #150 #4 # 6
    tank.t_turning_percent = clamp(tank.t_turning_percent, -maxaerialturn, maxaerialturn)

func sync_tmp(src=0):
  print("sync tmp")
  tmp()

func compmot(idx=0):
  var v
  if lball().motion_path.size() < (idx+1):
    v = "motion path small"
  elif lball().remote_motion_path.size() < (idx+1):
    v = "remote path small"
  else:
    v = [lball().motion_path[idx][0],lball().remote_motion_path[idx][0]]
  gsvar.announce(["comps", str(v)], 1, "2")
  print(["comps", str(v)])


func compmotr(last=3):
  for i in range(last):
    compmot(i)
  print(["comps size", lball().motion_path.size(), lball().remote_motion_path.size()])

func pt():
  return ball().prev_throw

func wings():
  g.sg("abilities",[]).erase("W")
  g.sg("abilities",[]).append("W")

func impu(p=me):
  var v = p.sounds.play("431174__highpixel__fireball-explosion")
  p.sounds.voice_set_volume_scale_db(v, 0 )

func backjetemit(tank,t=0.3,src=0):
  var p = tank
  # if src == 0:
  #   p=me
  # else:
  #   p  = gsvar.player_by_id(src)
  p.get_node("body/wound_particles10behidn").show()
  p.get_node("body/wound_particles10behidn").set_emitting(true)
  p.get_node("body/wound_particles10behidn3").show()
  p.get_node("body/wound_particles10behidn3").set_emitting(true)
  var v = p.sounds.play("431174__highpixel__fireball-explosion")
  p.sounds.voice_set_volume_scale_db(v, 0 )

func is_deleted_object(obj):
  return weakref(obj).get_ref() == null

func boost_go(src=0): # rename to dash
  if not g.sg("boost_enabled", true):
    return
  var p
  # qann(src,2)
  if src == 0:
    p=me
    # pp(p.get_path())
  else:
    p  = gsvar.player_by_id(src)
  if not p.phys.resting:
    return
  if src == 0:
    var offtn = "boostoff" + str(me.pid)
    if g.deep_has(g.timers, [self, offtn]):
      if g.timers[self][offtn].get_time_left() > 0:
        return
    net.rpc(self, "boost_go", [])

  boooost(p, true)
  g.object_timer_p("boostoff" + str(p.pid), self, "boooost", {"one":true, "intv":0.75-0.05 - 0.05-0.2, "args":[p,false], "dispose":true})
  # g.object_timer("boostoff" + str(p.pid), self, "boooost", true, 0.75-0.05 - 0.05-0.2, [p,false])
func boooost(p, on=false, src=0):
  # g.log2f(["boooost",net.uid, p.get_path(), on])
  # if weakref(p).get_ref() == null:
  # if is_deleted_object(p):
  #   log2f(["abort! deleted player"])
  #   return
  if net.uid == 1:
    pass
    # g.log2f(["boooost1",net.uid, p, on, is_deleted_object(p)])
    # g.ss("badp", p)
    # return
  if on:
    # var v = p.sounds.play("420998__eponn__boost")
    var v = p.sounds.play("458669__jorgerosa__missile-launch")
    p.sounds.voice_set_volume_scale_db(v, 0 )
    # qann("boooooos")
    g.w_set(p, "max_speed_mod", "boost", p.max_speed_mod*1*(4+2 - 0.3 -0.3 - 0.2), 5)
    p.fixed_speed_percent = 1
    p.frozen_speed = 1
    p.create_tank_ripple()
    # p.pending_impulse.append( g.xnz(get_aim()* 25 * 1.2, 0.001) )
    # p.pending_impulse.append( g.xnz(get_aim()* 25 * 1.2*0, 15) )
    backjetemit(p,1)
    # net.rpc(self, "backjetemit", [p,1])
  else:
    p.fixed_speed_percent = null
    g.w_unset(p, "max_speed_mod", "boost")

func stop_sound(sndlib=me.sounds,sndname="430626__juandamb__brake"):
  var asnd = g.sg("active_sounds", {})
  if asnd.has([sndlib, sndname]):
    if sndlib.is_voice_active(asnd[[sndlib, sndname]]):
      sndlib.stop_voice(asnd[[sndlib, sndname]])

func play_sound_one(sndlib=me.sounds,sndname="430626__juandamb__brake"):
  var asnd = g.sg("active_sounds", {})
  if asnd.has([sndlib, sndname]):
    if sndlib.is_voice_active(asnd[[sndlib, sndname]]):
      return
    else:
      asnd.erase([sndlib, sndname])
  asnd[[sndlib, sndname]] = sndlib.play(sndname)

func tut1():
  var tut1 = load("res://scenes/tut1.tscn");
  get_node("/root/world/env").add_child(tut1.instance())

func randcatchsound():
  var list = ball().sounds.get_sample_library().get_sample_list( )
  list = [  "DM-CGS-26"] # , "DM-CGS-26", "grab", "swoosh", "DM-CGS-18", "DM-CGS-04", "Retro Impact Metal 36", "Explosion15"
  var sound = list[randi()%list.size()]
  OS.set_clipboard(sound)
  g.ss("catchsound", sound)


func t56():
  g.scrn_dbg("holabola", [gsvar.player_by_id(2).s_state.j, gsvar.player_by_id(1).phys.resting])

func t57():
  gsvar.announce(str(["Arta", get_node("/root/world/env/players/1/Area").overlaps_area(ball().get_node("Ball2"))]), 3, "2")

func t58():
  var orig = get_node("/root/world/env/players/1/Area")
  var inst = orig.duplicate(1)
  orig.replace_by(inst)
  gsvar.announce(str(["Arta", inst.get_path()]), 3, "2")

func t59():
  gsvar.announce(str(["Arta", ball().get_node("Ball2")]), 3, "2")

func shrink(v, mul=1000):
  if typeof(v) == 3:
    return int(v*mul)
  if typeof(v) == 7:
    return [int(v.x*mul),int(v.y*mul),int(v.z*mul) ]
  return v

func unshrink(v, mul=1000.0):
  if typeof(v) == 2:
    return v/mul
  if typeof(v) == 7:
    return Vector3(v.x/mul,v.y/mul,v.z/mul )
  if typeof(v) == 21 and v.size() == 3:
    return Vector3(v[0]/mul,v[1]/mul,v[2]/mul )

  return v

func sync_clients(tank,state,do_up=false):
    # if do_up:
    #   qann(["upping xero",state.get_transform().origin], 3)
    var ls = tank.phys_old.back()
    var s = tank.phys
    var sup = {}
    var sup2 = []
    # var do_up = false
    do_up = do_up or s.turning_center != ls.turning_center and abs(s.av) > 0 and (s.turning_center-ls.turning_center).length() > 0.02
    do_up = do_up or ( abs(g.xz(s.lv).length() - g.xz(ls.lv).length()) > 0.05)
    # do_up = do_up or ( abs(g.xz(s.lv-ls.lv).length() ) > 0.00001)
    do_up = do_up or (abs(s.av - ls.av)>0.0001)
    # do_up = do_up or (abs(g.xnz(s.av - ls.av).length())>0.00001)
    do_up = do_up or (s.jump_count != ls.jump_count)
    # do_up = do_up or (s.side_touching != ls.side_touching)
    do_up = do_up or OS.get_ticks_msec() - tank.last_got_hit < 100
    do_up = do_up or s.resting != ls.resting
    # do_up = do_up or g.time_since(tank, "last_slave_sync", 1000)
    g.scrn_dbg("lgh", OS.get_ticks_msec() -tank.last_got_hit < 500)
    var foce_up = (s.resting != ls.resting)  or (s.jump_count != ls.jump_count)
    g.scrn_dbg("ogga", [(s.turning_center-ls.turning_center).length(), s.lv.length()])
    if do_up:
      g.scrn_dbg("rqsync" , [g.t()])
      sup2 = [
      g.t(),
        # shrink(state.get_linear_velocity()),
        shrink(s.lv),
        # shrink(tank.angvel),
        shrink(s.av),
        shrink(tank.body_rotation),
        shrink(state.get_transform().origin),
        tank.phys.resting
        ]
    if  not sup2.empty() and do_up:
      tank.last_s_update[1] = sup
      tank.last_s_sync = OS.get_ticks_msec()
      # g.ss("sup2", sup2)
      net.rset(tank, "sup2", sup2, {"reliable":true, "short_path":true})
      # g.ss("sup2", [])
      # g.scrn_dbg( "sup_count", g.si("sup_count"))
    # if not g.sg("sup2", []).empty() :
    #   if foce_up or g.time_since(tank, "last_slave_sync", 20, true):
    #     net.rset(tank, "sup2", g.sg("sup2"), {"reliable":true, "short_path":true})
    #     g.ss("sup2", [])
    #     g.scrn_dbg( "sup_count", g.si("sup_count"))
        # qann("sync from")




func sync_slave(tank,state):
  # qann("sync to")
  if tank.sup2.empty():
    update_slave_motion(tank, state)
    return
  if tank.sup2[0] < tank.s_state.st:
    tank.sup2 = []
    update_slave_motion(tank, state)
    return

  var inps = [
  "st",
  "lv",
   "av",
   "r",
   "p",
   "resting"
  ]
  var shrunk = ["lv", "av", "r", "p"]
  for i in range(tank.sup2.size()):
    tank.s_state[inps[i]] = tank.sup2[i]
    if shrunk.has(inps[i]):
      tank.s_state[inps[i]] = unshrink(tank.sup2[i])

  tank.sup = {}
  tank.sup2 = []
  var transform = state.get_transform();
  sd("last slave transf b4", transform)
  var s_state = tank.s_state
  if true or (tank.get_translation() - s_state["p"]).length() > 5:
    g.scrn_dbg("update_pos", [g.t()])
    transform.origin = (s_state["p"] + tank.get_translation())/2
    state.set_transform(transform);
    sd("last slave transf af", transform)
  # state.set_linear_velocity(s_state["lv"])
  if typeof( s_state["av"]) == 3 and abs( s_state["av"]) < 1000000:

    tank.angvel = s_state["av"]
  tank.body_rotation = s_state["r"]
  tank.body.set_rotation(Vector3(0,tank.body_rotation,0))
  tank.yaw = rad2deg(s_state["r"])
  # s_state["p"] = Vector3()
  # s_state["lv"] = Vector3()
  # s_state["r"] = 0.0
  tank.synced = true

func update_slave_motion(tank, state):
  tank.body_rotation += tank.angvel*state.get_step()
  tank.body.set_rotation(Vector3(0,tank.body_rotation,0))
  tank.yaw = rad2deg(tank.body_rotation)
  # tank.body.rotate_y(-tank.angvel*state.get_step())
  # var v = state.get_linear_velocity().rotated(Vector3(0,1,0),-tank.angvel*state.get_step())#
  var v = tank.s_state.lv.rotated(Vector3(0,1,0),-tank.angvel*state.get_step())#
  # if abs(tank.s_state.lv.y) > 0:
  #   v += grav
  # qann(["slave velocity", tank.s_state.lv])
  if v.y > 5:
    tank.get_node("body/wound_particles5").show()
  else:
    tank.get_node("body/wound_particles5").hide()
  if not tank.s_state.resting:
    # qann("hii")
    v = tank.s_state.lv
    tank.phys.on_floor = false
    tank.phys.resting = false
    var grav = Vector3(0,-tank.world_gravity,0);
    var delta = state.get_step();
    v += grav*delta
  else:#
    tank.phys.on_floor = true
    tank.phys.resting = true
  tank.s_state.lv = v
  g.scrn_dbg("calcdnewlv", [v])
  var xform = state.get_transform()
  xform.origin += v * state.get_step()
  # if abs(v.length()) > 0:

    # qann(v * state.get_step(), 3)
  state.set_transform(xform)
  sd("last slave transf af2", tank.body.get_scale())
  # state.set_linear_velocity(v)

func tmp():
  g.ss("catchsound", "DM-CGS-26")
  create_menus()
  load_settings_screen()
  set_bind_maps_and_rebind()
  var bvpi = 1/105.0 #90.0 #120.0
  for b in g.store_get("balls", []):
    b.ball_vel_per_iter = bvpi
    b.leader_ball.ball_vel_per_iter = bvpi
  setup3()
  randomize()
  if not g.sg("initcomplete", false):
    refn()
    g.object_timer("rgenv", self, "rgenv", true, 1)
    ball() and  g.object_timer("net_sync_kin", ball(), "net_sync_kin", false, 1)
  g.ss("initcomplete", true)

  # var lightstrip = get_node("/root/world/env/lightstrip")
  # var lightstrip_shd = lightstrip.get_material_override()
  # var old_z = lightstrip.get_translation().z
  # var new_z = 0#-330#old_z + 10
  # if new_z > 400: #-220:
  #   new_z = -360
  # var uvx = 0.5 * ((-new_z))/(400) + 0.495
  # lightstrip.set_translation(Vector3(0,0,new_z))
  # lightstrip_shd.set_shader_param( "pos" , Vector3(uvx,0,0))
  return
  ball().ball_follow()
  return
  ball().pending_throw = [Vector3(0, 10, 0), me.get_translation()]
  return
  gsvar.announce("Hi!", 10)
  return
  return get_node("/root/world/gui/crosshair3/tex2")
  g.store_get("mb").l = 1.0
  g.store_get("mb").w = 10
  return
  me.turning_percent *= 2
  var sig = sign(me.turning_percent)
  me.turning_percent = min(abs(me.turning_percent), 2)
  me.turning_percent *= sig
  me.frozen_turn = - me.turning_percent
  ball().ball_h_slowdown = 0.095
  ball().leader_ball.ball_h_slowdown = 0.095
  reload_script(get_node("/root/world/env/shrknlw"))
  return

  return
  cap()
  return
  var a = {"x":Vector2()}
  var v = a.x
  v.x = 1
  return a
  print(ball().leader_ball.is_colliding())
  re_throw()
  return
  rest_ball()
  return
  var ret = []
  ret.append(["resting", ball().resting])
  ret.append(["leader resting", ball().leader_ball.resting])
  ret.append(["queue_resting",ball().queue_resting])
  ret.append(["motion_start", ball().motion_start])
  ret.append(["prev_throw", ball().prev_throw])
  ret.append(["rest reason", ball().resting_reason])
  ret.append(["leader ball owner", ball().leader_ball.owner])
  return ret
  replay_save_multi()
  return
  g.remove_bots()
  er("/g.remove_bots()")
  return
  var joy_bind_map = {
    "jump" : [[5], [1]],
    "shoot" : [[0]],
    "repeat_shoot" : [[3]],
    "aim" : [[6]],
    "throw" : [ [4]],
    "pass_ball" : [[2]],
    "slowmo" : [[7]],
    "slowmo2" : [[7]],
  }
  for a in joy_bind_map:
    g.action_bind_joy(a, joy_bind_map[a])
  re_throw()
  return
  g.object_timer( "repeat_shot" ,self, "repeat_shot", false, 0.15, [])
  return
  setup_3pts_pol()
  return
  add_draw_dest()
  test_draw_dest2()
  return
  test_draw_dest()
  return
  gsvar.announce("scorer_name" + " | +2 PTS 44", 5)
  return
  var bot = bot(0)
  var man = bot.control.action_manager
  var ctrl = bot.control
  var s = ctrl.situation
  var a = _act()
  return g.uniform_angle(s.B.dir2.angle_to(g.xz(a.dest_point - s.B.pos)))
  var far_from_zone = (bot.get_translation() - Vector3(0,0,330)).length() > 300
  return far_from_zone
  var player_heading_goal = min(abs(s.P.rot), PI-abs(s.P.rot)) < PI/4
  return abs(s.B.ang)
  return abs(s.B.ang) > PI/8 and s.dist < 110 and player_heading_goal
  return abs(s.ang_diff)
  return min(abs(s.P.rot), PI-abs(s.P.rot)) < PI/4
  return ctrl.situation
  return bot(0).control.action_manager.current_action()
  cb()
  ball().throw(Vector3(22.360096, 29.711191, -141.201935), Vector3(-6.504754, -52.519943, -117.152893))
  return
  phys_conf(3)
  return
  return
  ball().ball_state_update(true)
  return
  return get_node("/root/world/env/hoopsouth").get_translation()
  return
  gsvar.me.new_spawn = {'pos':Vector3(0,0,0), 'rot':0 }
  var a = {"x":{}}
  setup_trap()
  cb()
  for bot in bots(2):
    var bot_action = load("res://scripts/bot_action.gd")
    var manager = bot_action.BotActionManager.new(bot)
    manager.set_name("ActionManager")
    get_node("/root/world").add_child(manager)
    var an = manager.select_action(bot.build_situation())
    bot.action_manager = manager
    var action = manager.actions[an]
  return
  return g.deep_has({1:{2:{3:{4:5}}}},[1,2,3,4])
  sync_tst()
  OS.set_time_scale(1.0)
  fcam()
  highlights()
  return
  replay_from_file('1554658866_combined')
  return
  highlights()
  return
  net.replay_init(replay_load('1554591058_0'))
  return
  replay_save()
  var d = replay_load()
  print(d)
  return
  gsvar.me.follow_player = gsvar.player_by_id(1)
  return
  var ar = [gsvar.me.get_path()]
  var ar2 = [] + ar
  return [String(ar[0]).hash(), String(ar2[0]).hash()]
  return rce()
  var output = []
  var pid = OS.execute('xdotool', ['search', "--name", "Battle", "key", "--window", "%@",  'e'], true, output)
  return
  new_shot()
  return
  t7()
  return

  OS.set_iterations_per_second(120)

func setup_3pts_pol():
  var v2a = Vector2Array([Vector2(158.290283, 371.161469), Vector2(157.68219, 360.016815), Vector2(157.61734, 350.018494), Vector2(157.507614, 333.16925), Vector2(156.885727, 315.461151), Vector2(151.234909, 289.729553), Vector2(142.42128, 268.289307), Vector2(138.548676, 259.538818), Vector2(126.071838, 237.507568), Vector2(110.24324, 219.030334), Vector2(93.562637, 205.730209), Vector2(80.04686, 197.708084), Vector2(61.936855, 189.264084), Vector2(44.108746, 183.386597), Vector2(21.32201, 178.849152), Vector2(-2.6095, 177.293198), Vector2(-25.499454, 178.999802), Vector2(-48.00642, 185.337234), Vector2(-68.696609, 194.146744), Vector2(-82.725716, 201.830582), Vector2(-98.223061, 212.362778), Vector2(-110.732208, 223.854294), Vector2(-120.869164, 235.587769), Vector2(-132.413376, 251.046402), Vector2(-143.764374, 271.160248), Vector2(-151.47287, 293.014282), Vector2(-154.700378, 307.337952), Vector2(-156.184525, 322.168243), Vector2(-156.243195, 338.03891), Vector2(-156.296539, 353.239838), Vector2(-156.345673, 367.240692), Vector2(-156.384979, 378.441376)])
  get_node("/root/world/env/3point_area/colpol").set_polygon(v2a)
  get_node("/root/world/env/3point_area2/colpol").set_polygon(v2a)

func add_draw_dest():
  var dests = g.store_get("draw_dests", [])
  dests.append([me.get_translation(), me.body_rotation])

func test_draw_dest2():
  clear_position_marks()
  g.draw_destinations(g.store_get("draw_dests", []))

func test_draw_dest():
  var b = me
  var position = xz(b.get_translation())
  var angle = b.body_rotation
  var angular_velocities = [0.76829, -0.76829, 0.76829/2, -0.76829/2,0.001]
  angular_velocities = [0.76829, -0.76829, 0.001]
  angular_velocities = [1, -1, 0.001]
  clear_position_marks()
  var duration = 4.1
  var step = 0.2
  for v in angular_velocities:
    g.draw_destinations(
      g.gen_expected_destinations(position, angle, v, b.max_speed, duration,step)
    )
    g.draw_destinations(
      g.gen_expected_destinations(position, angle, v, -b.max_speed, duration,step)
    )


func clear_position_marks():
  if gsvar.records.has("position_marks"):
    for mark in gsvar.records["position_marks"]:
      mark.queue_free()
  gsvar.records["position_marks"] = []


func test_shapes():
  if not has_node("shapes"):
    var shapes = Node.new()
    shapes.set_name("shapes")
    add_child(shapes)
  var shapes = get_node("shapes")
  for sh in shapes.get_children():
    sh.queue_free()
  var script = load("res://addons/add_primitives/src/primitives/Arch.gd")
  var mesh_instance = MeshInstance.new()
  var builder = script.new()
  builder.update()
  mesh_instance.set_mesh(builder.get_mesh())
  mesh_instance.create_trimesh_collision()
  shapes.add_child(mesh_instance)
  var position = gsvar.me.get_translation()
  var angle = gsvar.me.body_rotation
  var t = mesh_instance.get_transform()
  t = t.rotated(Vector3(0,1,0), -angle).scaled(Vector3(30,10.5, abs(30)))
  t=t.rotated(Vector3(1,0,0), -PI/2)
  mesh_instance.set_global_transform(t)
  mesh_instance.set_translation(position)
  return mesh_instance

  var position = xz(bot().get_translation())
  var angle = bot().body_rotation
  var points = gen_expected_destinations(position, angle, 0.76829)
  var shape = ConvexPolygonShape.new()
  shape.set_points(points)
  shape.set_translation(position)
  shape.set_rotation(angle)
  return points


func chat_toggle():
  g.toggle_hidden(get_node("/root/world/gui/chatBox"))


func bot_instructions(idx, instructions, visualize, fake):
  bot(idx).call("set_instructions", instructions, visualize, fake)
func mc(b=bot()):
  var bhc = b.has_control
  b.take_control(!bhc)
  gsvar.me.set('kb_enabled', bhc)

func dump_obj_script(obj):
  var script = obj.get_script()
  var fn = obj.get_script().get_path()
  var file = File.new()
  file.open( fn, file.READ)
  var text = file.get_as_text()
  pp(text)

# func load_script(fn, input):
#   var script = GDScript.new()
#   var dir = self.get_script().get_path()
#   dir = str(dir).get_base_dir().plus_file( "cmd_data")
#   var file = File.new()
#   file.open(dir.plus_file( fn), file.READ)
#   var text = file.get_as_text()
#   text = text + "\n" + input
#   script.set_source_code(text)
#   script.reload()
#   return script


# func load_script_text(fn):
#   var fn = obj.get_script().get_path()
#   # pp(fn)
#   # g.report("fn", [fn], 0 , 1000, {"only":true})
#   var file = File.new()
#   file.open( fn, file.READ)
#   var text = file.get_as_text()
#   # print(text)
#   script.set_source_code(text)
#   script.reload(true)
#   # script.take_over_path(fn)
#   obj.set_script(script)
#   return script



func reload_script(obj):
  # var script = GDScript.new()
  var script = obj.get_script()
  # print(script.get_source_code())
  var fn = obj.get_script().get_path()
  # pp(fn)
  # g.report("fn", [fn], 0 , 1000, {"only":true})
  var file = File.new()
  file.open( fn, file.READ)
  var text = file.get_as_text()
  # print(text)
  script.set_source_code(text)
  script.reload(true)
  # script.take_over_path(fn)
  obj.set_script(script)
  return script

func rlblt():
  if gsvar.missiles.size() == 0:
    me.shoot_think()
    timer("rlblt", "rlblt", true, 0.5 , [])
    return
  var blt = gsvar.missiles.values()[0]
  reload_script(blt)

func reload_global():
  reload_script(g)
  g.gsvar = get_node("/root/gamestate")


func rl():
  reload_global()
  rlbots()
  rlball()


func bot(idx=0, xf=null):
  print(xf)
  if idx > num_bots :
    return
  var bot = bots()[idx]
  if not g.is_null(xf):
    bot.set_transform(xf)
  return bot

func bots(n=null):
  if g.is_null(n):
    n = num_bots
  if gsvar.bots.size() < n:
    add_bots(n - gsvar.bots.size())
  return gsvar.bots

func add_bots(n=1):
  for i in range(n):
    var inst = gsvar.add_bot()
    timer("add bot ui" + str(inst.pid), "add_bot_ui", true, 2 , [inst])

func add_bot_ui(inst):
  g.report("manual add ui", [inst.pid], 0 , -1, {"only":false})
  get_node("/root/world/gui/objectsname").add_object(inst)

func del_bot_ui(inst):
  get_node("/root/world/gui/objectsname").remove_object(inst)
func rlbots():
  bot().get_script().reload(true)
  var idx = -1
  for b in bots():
    idx += 1
    var xf = b.get_transform()
    b.radar_player.queue_free()
    get_node("/root/world/gui/objectsname").remove_object(b)
    b.queue_free()
    timer("add_bot" + str(idx), "bot", true, 1, [idx,xf])
  gsvar.bots = []
func ball():
  return g.store_get("recent_ball", false)

func lball():
  return g.store_get("recent_ball", get_node("/root/world/env/Ball")).leader_ball

func reload_obj(obj,params={}, stage=0):
  if stage == 0:
    obj.set_fixed_process(false)
    obj.set_process(false)
    params = g.mergedicts({"res":"","en_xf":true}, params)
    if params.en_xf:
      params["xf"] = obj.get_transform()
    params["parent"] = obj.get_parent()
    params["name"] = obj.get_name()
    timer("reload_obj"+params.name, "reload_obj", true, 0.2, [obj, params,1])
  elif stage == 1:
    var scr = obj.get_script()
    if not g.is_null(scr):
      obj.get_script().reload()
    obj.queue_free()
    timer("reload_obj"+params.name, "reload_obj", true, 0.2, [obj, params,2])
  elif stage == 2:
    var prefab = load(params.res);
    var inst = prefab.instance()
    inst.set_name(params.name)
    params.parent.add_child(inst)
    if params.en_xf:
      inst.set_transform(params.xf)
    if params.has("after"):
      callv(params.after, [inst])
    tmp()

func rats():
  print(g.pretty_str(g.sg("action_ratings", "")))

func tut():
  return get_node("/root/world/tutorial")

func rltut():
  reload_obj(get_node("/root/world/tutorial"),{"res":"res://scenes/tutorial.tscn", "en_xf":false} )

func rlbc(): # reload bot control
  for b in bots():
    b.set("new_spawn", {"pos":Vector3(),"rot":0})
    g.activate_bot(b)

func rlhoops():
  for h in [hs(), hn()]:
    reload_obj(h, {"res":"res://prefabs/hoop.tscn"})

func rlme():
  gsvar.me = null
  reload_obj(me, {"res":"res://prefabs/player2.tscn", "after":"rlme_finalize"})

func rlme_finalize(inst):
  print("pretty")
  me = inst
  gsvar.me = inst

func remove_ball():
  ball().set_fixed_process(false)
  ball().set_process(false)
  g.store_set("balls", [])
  ball().leader_ball.queue_free()
  ball().queue_free()

func rlball(real=false):
  var xf = ball().get_transform()
  g.store_get("balls").clear()
  ball().set_fixed_process(false)
  ball().set_process(false)
  ball().paused = true
  ball().leader_ball.paused = true
  if not real:
    timer("rlball", "rlball", true, 0.2, [true])
    return
  ball().get_script().reload()
  ball().leader_ball.get_script().reload()
  ball().leader_ball.queue_free()
  ball().queue_free()
  timer("add_ball", "new_ball", true, 0.2, [])


func new_ball(xf=null):
  var prefab_ball = load("res://prefabs/Ball.tscn");
  var inst = prefab_ball.instance()
  inst.set_name("Ball")
  get_node("/root/world/env").add_child(inst)
  var inst0 = prefab_ball.instance()
  inst0.set_name("leader_ball")
  get_node("/root/world/env").add_child(inst0)
  if not g.is_null(xf):
    inst.set_transform(xf)
  tmp()


func jump():
  me.force_jump = true
  print("sholda jumped")


func xz(v3):
  return Vector2(v3.x, v3.z)
func closest_angle_rep_deg(ang1,ang2):
  if abs(ang2 - ang1) < 180:
    return ang2
  var d = ang2 - ang1
  d = fmod((d+7200), 360)
  if d > 180:
    d =  d - 360
  return ang1 + d

func dir_contents(path):
    var dir = Directory.new()
    var files = []
    if dir.open(path) == OK:
        dir.list_dir_begin()
        var file_name = dir.get_next()
        while (file_name != ""):
            if dir.current_is_dir():
                pass
            else:
                files.append(file_name)
            file_name = dir.get_next()
    else:
        print("An error occurred when trying to access the path.")
    return files


func mk_humus_cbm(fn="Nalovardo"):
  var bn = '/home/mohamed/Downloads/cbm_new/'
  var path = bn + fn
  var map = {"negx":0, "posx":1, "negy":2, "posy":3, "negz":4, "posz":5}
  var list = dir_contents(path)
  print(list)
  var sides = {}
  for f in list:
    if f.ends_with(".jpg"):
      var img = Image(512,512,false,4)
      img.load(path + "/" + f)
      var s = f.substr(0,4)
      sides[map[s]] = img
  var cbm = CubeMap.new()
  cbm.set_storage(0)
  cbm.set_flags(7)
  for i in sides:
    cbm.set_side(i, sides[i])
  get_node("/root/world/env").get_environment().set_background_param ( 3, cbm )
  print(dir_contents(path))
  ResourceSaver.save("cubemap/" + fn + ".cbm", cbm)
  return [sides, cbm]
func mk_cbm(namedir="lmcity"):
  var path = "/home/mohamed/Downloads/cubemaps/" + namedir
  var map = {"lf":0, "rt":1, "dn":2, "up":3, "ft":4, "bk":5}
  var list = dir_contents(path)
  var sides = {}
  for f in list:
    if f.ends_with(".tga.jpg"):
      var img = Image(512,512,false,4)
      img.load(path + "/" + f)
      var s = f.substr(f.length() - 10,2)
      sides[map[s]] = img
  var cbm = CubeMap.new()
  cbm.set_storage(0)
  cbm.set_flags(7)
  for i in sides:
    cbm.set_side(i, sides[i])
  get_node("/root/world/env").get_environment().set_background_param ( 3, cbm )
  print(dir_contents(path))
  ResourceSaver.save("cubemap/" + namedir + ".cbm", cbm)
  return [sides, cbm]
func old_phys(prop="on_floor"):
  var out = []
  for i in me.phys_old:
    out.append(i[prop])
  return out


func lightload_scene(somevar, scene_path):
  pass

func align_bot(idx=0):
  bot(idx).new_spawn = {"pos":me.get_translation(), "rot":me.body_rotation}


func timer(tn, fn, one=false, intv=3, args = []):
  var existing = has_node(tn)
  if existing:
    print("timer exists")
    get_node(tn).queue_free()
  timer = Timer.new()
  timer.set_name(tn)
  timer.set_one_shot(one)
  timer.set_timer_process_mode(0)
  timer.set_wait_time(intv)
  timer.connect("timeout", self, fn, args)
  add_child(timer)
  timer.start()

func cursit():
  return bot().rel_enemy_motion[-1]



















func ss():
  get_node("/root/net").start_server()

func cs():
  get_node("/root/net").connect_to_server()

func sp():
  net.start_auto_proxy(true)

func cnx():
  print(net.cnx_summary())
  return net.cnx_summary()

func tbx():
  return get_node("/root/world/env/mapcontainer/Spatial/BZBox112").set("geometry/cast_shadow",0)

func tnt(moo=22):
  if net.uid == -1:
    cs()
    return
  if not net.is_server:
    net.start_proxy(5000)
    return
  net.rpc(net,"hi", [moo])

func rpc(doh='23'):
  net.rpc(net,"hi", [doh])

func pa():
  net.rpc(net,"ping_all", [])

func j(id, st=true):
  net.rset(gsvar.player_by_id(id), "force_jump", st, {"target":id})
func ja(st):
  for i in net.servers:
    j(i, st)

func er(m):
  net.rpc(g,"console_exec", [m])


func ltr():
  net.rpc(g,"console_exec", ["lt"])

func shtmp():
  me.col_groups[0]["StaticBody"].keys()[0].get_parent().get_mesh().surface_set_material(0, me.radarbox_shader)

func bcs(i=0):
  var body = g.deep(me.touching_bodies, ['sides', i])
  return [body.get_name(), me.get_body_collisions(body)]

func cols():
  return me.col_groups[0]['StaticBody']

func alcols():
  return me.col_groups

func fxaa(on=null):
  if g.is_null(on):
    on = !fx(1)
  fx(1, on)
func fxt(_fx):
  var on = !fx(_fx)
  fx(_fx, on)

func fx(_fx, on=null):
  print("set FX", _fx, on)
  if on==null:
    print(get_node("/root/world/env").get_environment().is_fx_enabled(_fx))
    return get_node("/root/world/env").get_environment().is_fx_enabled(_fx)
  else:
    get_node("/root/world/env").get_environment().set_enable_fx(_fx, on)
func bt():
  var ball = get_node("/root/world/env/Ball")
  net.rpc_sync(ball, "throw", [100])
  return ball

func fw():
  get_node("/root/world/env/hoopsouth/fireworks").set_emitting( true )

func imp():
  var rel_pos = get_node("/root/world/env/hoopsouth").get_translation() - me.get_translation()
  var d = rel_pos.length()
  var imp = rel_pos * -1
  imp = 10 * imp / d
  imp.y = - imp.y
  me.pending_impulse =  [Vector3(0,5,0), imp]
func npl():
  var gs = load("scripts/newgamestate.gd")
  var nn = load("scripts/net.gd")
  var nnode = Node.new()
  nnode.set_script(nn)
  var gsnode = Node.new()
  gsnode.set_script(gs)
  gsnode.net = nnode
  gsnode.g = get_node("/root/global")
  gsnode.load_config()
  g.report("gsn conf", [gsnode.config], 0 , 1000, {"only":false})
  gsnode.set_name("gsn")
  get_node("/root/world").add_child(gsnode)
  gsnode.join_game("127.0.0.1", 6969)
func bmv(x=null,y=null):
  if g.is_null(x):
    x = g.randsign(0 + randi() % 120)
  if g.is_null(y):
    y = g.randsign(60 + randi() % 60)
  bot().set("stick_x", x)
  bot().set("stick_y", y)
